(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)





























Print["CGS package includes routines which calculate comprehensive Groebner System and related features for polynomials whose coefficients have unknown parameters. All Rights Reserved, Copyright (C)Kosaku Nagasaka, Kobe University 2006-2007. Kousaku Nagasaka makes no warranty of this software,and takes no responsibility to any result arising from your use of this software."]\
;



BeginPackage["CGS`",{"Utilities`FilterOptions`"}];



\!\(\(GroebnerSystem::"\<usage\>" = \*"\"\<GroebnerSystem[{\!\(poly\_1\),\!\(poly\_2\),\[Ellipsis],\!\(poly\_n\)},{\!\(x\_1\),\!\(x\_2\),\[Ellipsis],\!\(x\_r\)}] computes the Groebner system with unknown parameters of the given ideal {\!\(poly\_1\),\!\(poly\_2\),\[Ellipsis],\!\(poly\_n\)} w.r.t. the given lex-order of {\!\(x\_1\),\!\(x\_2\),\[Ellipsis],\!\(x\_r\)}.\>\"";\)\)

Options[GroebnerSystem]={Debug\[Rule]False,TimeDebug\[Rule]False,
      Verbose\[Rule]False,MonomialOrder\[Rule]Lexicographic,
      ZRadical\[Rule]False,Reduced\[Rule]True,RawOutput\[Rule]False,
      ConditionSimplify\[Rule]True,ElementSimplify\[Rule]False,
      FractionFree\[Rule]True};

ConditionSimplify::"usage"="";

CNFSimplify::"usage"="";

DNFSimplify::"usage"="";

Assumption::"usage"="";















\!\(\(SingularityEquation::"\<usage\>" = \*"\"\<SingularityEquation[poly,{\!\(x\_1\),\!\(x\_2\),\[Ellipsis],\!\(x\_r\)}] gives an ideal {poly,\!\(\[PartialD]poly\/\[PartialD]x\_1\),\!\(\[PartialD]poly\/\[PartialD]x\_2\),\[Ellipsis],\!\(\[PartialD]poly\/\[PartialD]x\_r\)} for the given polynomial and variables.\>\"";\)\)



\!\(\(NonDegeneracyCondition::"\<usage\>" = \*"\"\<NonDegeneracyCondition[{{condition,{\!\(base\_1\),\!\(base\_2\),...,\!\(base\_n\)}},...}] gives ...\>\"";\)\)

\!\(\(DegeneracyCondition::"\<usage\>" = \*"\"\<DegeneracyCondition[{{condition,{\!\(base\_1\),\!\(base\_2\),...,\!\(base\_n\)}},...}] gives ...\>\"";\)\)



Begin["`Private`"];



AnyVariables[f_]:=
  Union@Select[Cases[f,_Symbol,Infinity],(Context[#]=!="System`")&]

headcoef[f_,vars_,opts___]:=
  Internal`DistributedTermsList[f,vars,opts][[1,1,2]]

monomialreduce[f_,h_?NumericQ,vars_,opts___]:=Expand[f/h]

monomialreduce[f_,h_,vars_,opts___]:=
  Function[#[[1,1]]+Expand[Last[#]/h]][PolynomialReduce[f,{h},vars,opts]]

reducedmonomials0[flist_,eli_List,vars_,opts___]:=
  Map[monomialreduce[#,
        Function[Cancel[#/PolynomialGCD[#,Times@@eli]]][
          headcoef[#,vars,opts]],vars,opts]&,flist]

reducedmonomials[flist_,eli_List,vars_,opts___]:=Module[{gb,pfgb,hts,i,j,mx},
    gb=reducedmonomials0[flist,eli,vars,opts];
    pfgb=Select[gb,NumericQ[headcoef[#,vars,opts]]&];
    gb=Complement[gb,pfgb];
    (* \:6975\:5c0f\:5316 *)
    
    hts=Map[(Internal`DistributedTermsList[#,vars,opts][[1,1,1]])&,pfgb];
    mx=Length[pfgb];
    For[i=1,i\[LessEqual]mx,i++,
      If[pfgb[[i]]===Null,Continue[]];
      For[j=1,j\[LessEqual]mx,j++,
        If[j\[Equal]i||pfgb[[j]]===Null,Continue[]];
        If[MapThread[Max,hts[[{i,j}]]]\[Equal]hts[[j]],pfgb[[j]]=Null];
        ];
      ];
    pfgb=DeleteCases[pfgb,Null];
    Return[Union[pfgb,gb]];
    ]

eliminationIdeal[flist_List,vars_List,newvars_List,opts___]:=Module[{myG},
    myG=GroebnerBasis[flist,
        Join[Select[vars,Not[MemberQ[newvars,#]]&],newvars],opts];
    Return[
      Select[myG,
        SameQ[Intersection[Complement[Variables[#],newvars],vars],{}]&]];
    ]

eliminationSet[flist_List,newvars_List]:=
  
  Select[flist,SameQ[Complement[Variables[#],newvars],{}]&]

eliminationSetComplement[flist_List,newvars_List]:=
  
  Select[flist,UnsameQ[Complement[Variables[#],newvars],{}]&]

zerodimradicalQ[flist_,pars_,False,opts___]:=Module[{vars,uvar,mg},
    vars=Reverse[pars];uvar=First[vars];
    mg=eliminationSet[flist,{uvar}];
    If[Length[mg]=!=1,Return[False],mg=First[mg]];
    If[PolynomialGCD[mg,D[mg,uvar]]=!=1,Return[False]];
    vars=Rest[vars];
    While[UnsameQ[vars,{}],
      uvar=First[vars];
      mg=eliminationIdeal[flist,pars,{uvar},opts];
      If[Length[mg]=!=1,Return[False],mg=First[mg]];
      If[PolynomialGCD[mg,D[mg,uvar]]=!=1,Return[False]];
      vars=Rest[vars];
      ];
    Return[True];
    ]

zerodimradicalQ[flist_,pars_,True,opts___]:=Module[{vars,uvar,mg},
    stime=TimeUsed[];
    vars=Reverse[pars];uvar=First[vars];
    mg=eliminationSet[flist,{uvar}];
    If[Length[mg]=!=1,
      zrQtime+=(TimeUsed[]-stime);zrQcount++;Return[False],mg=First[mg]];
    If[PolynomialGCD[mg,D[mg,uvar]]=!=1,
      zrQtime+=(TimeUsed[]-stime);zrQcount++;Return[False]];
    vars=Rest[vars];
    While[UnsameQ[vars,{}],
      uvar=First[vars];
      mg=eliminationIdeal[flist,pars,{uvar},opts];
      If[Length[mg]=!=1,Return[False],mg=First[mg]];
      If[PolynomialGCD[mg,D[mg,uvar]]=!=1,
        zrQtime+=(TimeUsed[]-stime);zrQcount++;Return[False]];
      vars=Rest[vars];
      ];
    zrQtime+=(TimeUsed[]-stime);zrQcount++;
    Return[True];
    ]

radicalmemberQ[flist_,f_,pars_,False,opts___]:=Module[{y},
    y=Unique[];
    eli=eliminationIdeal[Append[flist,1-y*f],Append[pars,y],pars,opts];
    Remove[y];
    Return[And@@Map[NumericQ,eli]];
    ]

radicalmemberQ[flist_,f_,pars_,True,opts___]:=Module[{y,eli},
    stime=TimeUsed[];
    y=Unique[];
    eli=eliminationIdeal[Append[flist,1-y*f],Append[pars,y],pars,opts];
    Remove[y];
    eli=And@@Map[NumericQ,eli];
    rmQtime+=(TimeUsed[]-stime);rmQcount++;
    Return[eli];
    ]

vofhinvofSHQ[h_,SH_,pars_,False,opts___]:=
    Catch[Scan[
        If[Last[PolynomialReduce[First[#],{h},pars,opts]]===0,Throw[True]]&,
        SH];False];

vofhinvofSHQ[h_,SH_,pars_,True,opts___]:=Module[{ret},
    stime=TimeUsed[];
    ret=Catch[
        Scan[If[Last[PolynomialReduce[First[#],{h},pars,opts]]===0,
              Throw[True]]&,SH];False];
    voQtime+=(TimeUsed[]-stime);voQcount++;
    Return[ret]]



CGSOptMain[flist_,vars_,pars_,False,opts___]:=Module[{myG,hs,hlcm,eli,hsid},
    If[fdebug,Print["---> a branch starts <---"];
      Print[" finished single varieties : ",mySH];
      Print[" the latest added generator : ",Last[flist]]];
    myG=GroebnerBasis[flist,Join[vars,pars],opts];
    If[MemberQ[myG,1],Return[{{eliminationSet[flist,pars],{1},{1}}}]];
    (* \:5206\:5c90 *)
    
    hs=Union@Map[headcoef[#,vars,opts]&,
          Select[myG,UnsameQ[Complement[Variables[#],pars],{}]&]];
    hs=Union@@Map[(Rest[FactorList[#]][[All,1]])&,hs];
    If[fdebug,Print[" head coefficients : ",hs]];
    If[UnsameQ[hs,{}],
      hlcm=PolynomialLCM@@hs,
      hlcm=1
      ];
    eli=eliminationSet[myG,pars];
    hsid={};
    If[radicalmemberQ[eli,hlcm,pars,False,opts],
      If[fdebug,
        Print[" - a lcm of head coefficients is an element of elimination sets."]\
];
      If[fzr&&zerodimradicalQ[eli,pars,False,opts],
        If[fdebug,Print[" - an elimination set is a radical."]];
        Return[{}],
        If[fdebug,Print[" - an elimination set is NOT a radical."]];
        hs=Select[hs,Not[vofhinvofSHQ[#,mySH,pars,False,opts]]&];
        If[fdebug,Print[" reduced head coefficients : ",hs]];
        Return[Join@@Map[CGSOptMain[Append[myG,#],vars,pars,False,opts]&,hs]]
        ],
      If[fdebug,
        Print[" - a lcm of head coefficients is NOT an element of elimination sets."]\
];
      hlcm=Last[PolynomialReduce[hlcm,eli,pars,opts]];
      If[fzr&&zerodimradicalQ[eli,pars,False,opts],
        If[fdebug,Print[" - an elimination set is a radical."]];
        If[Length[eli]\[Equal]1,AppendTo[mySH,eli]];
        If[fverbose,Print["New constructible set : ",{eli,{}}]];
        Return[{{eli,{},
              If[freduce,
                reducedmonomials[eliminationSetComplement[myG,pars],eli,vars,
                  opts],eliminationSetComplement[myG,pars]]}}],
        If[fdebug,Print[" - an elimination set is NOT a radical."]];
        hs=Select[hs,Not[vofhinvofSHQ[#,mySH,pars,False,opts]]&];
        If[fdebug,Print[" reduced head coefficients : ",hs]];
        If[Length[eli]\[Equal]1,AppendTo[mySH,eli]];
        If[fverbose,Print["New constructible set : ",{eli,{hlcm}}]];
        Return[
          
          Join[{{eli,{hlcm},
                If[freduce,
                  reducedmonomials[eliminationSetComplement[myG,pars],eli,
                    vars,opts],eliminationSetComplement[myG,pars]]}},
            Join@@Map[CGSOptMain[Append[myG,#],vars,pars,False,opts]&,hs]]
          ]
        ]
      ];
    ]

CGSOptMain[flist_,vars_,pars_,True,opts___]:=Module[{myG,hs,hlcm,eli,hsid},
    If[fdebug,Print["---> a branch starts <---"];
      Print[" finished single varieties : ",mySH];
      Print[" the latest added generator : ",Last[flist]]];
    stime=TimeUsed[];
    myG=GroebnerBasis[flist,Join[vars,pars],opts];
    myGtime+=(TimeUsed[]-stime);myGcount++;
    stime=TimeUsed[];
    If[MemberQ[myG,1],Return[{{eliminationSet[flist,pars],{1},{1}}}]];
    (* \:5206\:5c90 *)
    
    hs=Union@Map[headcoef[#,vars,opts]&,
          Select[myG,UnsameQ[Complement[Variables[#],pars],{}]&]];
    hs=Union@@Map[(Rest[FactorList[#]][[All,1]])&,hs];
    sqrtime+=(TimeUsed[]-stime);sqrcount++;
    stime=TimeUsed[];
    If[fdebug,Print[" head coefficients : ",hs]];
    If[UnsameQ[hs,{}],
      hlcm=PolynomialLCM@@hs,
      hlcm=1
      ];
    eli=eliminationSet[myG,pars];
    hsid={};
    If[radicalmemberQ[eli,hlcm,pars,True,opts],
      If[fdebug,
        Print[" - a lcm of head coefficients is an element of elimination sets."]\
];
      If[fzr&&zerodimradicalQ[eli,pars,False,opts],
        If[fdebug,Print[" - an elimination set is a radical."]];
        Return[{}],
        If[fdebug,Print[" - an elimination set is NOT a radical."]];
        hs=Select[hs,Not[vofhinvofSHQ[#,mySH,pars,True,opts]]&];
        If[fdebug,Print[" reduced head coefficients : ",hs]];
        Return[Join@@Map[CGSOptMain[Append[myG,#],vars,pars,True,opts]&,hs]]
        ],
      If[fdebug,
        Print[" - a lcm of head coefficients is NOT an element of elimination sets."]\
];
      hlcm=Last[PolynomialReduce[hlcm,eli,pars,opts]];
      If[fzr&&zerodimradicalQ[eli,pars,True,opts],
        If[fdebug,Print[" - an elimination set is a radical."]];
        If[Length[eli]\[Equal]1,AppendTo[mySH,eli]];
        If[fverbose,Print["New constructible set : ",{eli,{}}]];
        Return[{{eli,{},
              If[freduce,
                reducedmonomials[eliminationSetComplement[myG,pars],eli,vars,
                  opts],eliminationSetComplement[myG,pars]]}}],
        If[fdebug,Print[" - an elimination set is NOT a radical."]];
        hs=Select[hs,Not[vofhinvofSHQ[#,mySH,pars,True,opts]]&];
        If[fdebug,Print[" reduced head coefficients : ",hs]];
        If[Length[eli]\[Equal]1,AppendTo[mySH,eli]];
        If[fverbose,Print["New constructible set : ",{eli,{hlcm}}]];
        Return[
          
          Join[{{eli,{hlcm},
                If[freduce,
                  reducedmonomials[eliminationSetComplement[myG,pars],eli,
                    vars,opts],eliminationSetComplement[myG,pars]]}},
            Join@@Map[CGSOptMain[Append[myG,#],vars,pars,True,opts]&,hs]]
          ]
        ]
      ];
    ]

CGSOpt[flist_,vars_,False,opts___?(Head[#]===Rule||Head[#]===RuleDelayed&)]:=
  Block[{myG,hs,hlcm,pars,eli,mySH},
    (* \:30d1\:30e9\:30e1\:30fc\:30bf\:306e\:6c7a\:5b9a *)
    
    pars=Complement[Union@@Map[Variables,flist],vars];
    myG=GroebnerBasis[flist,Join[vars,pars],opts];
    If[MemberQ[myG,1],Return[{{{},{1},{1}}}]];
    (* \:5e83\:57df\:5909\:6570\:306e\:521d\:671f\:5316 *)
    mySH={};
    (* \:5206\:5c90 *)
    
    hs=Union@Map[headcoef[#,vars,opts]&,
          Select[myG,UnsameQ[Complement[Variables[#],pars],{}]&]];
    hs=Union@@Map[(Rest[FactorList[#]][[All,1]])&,hs];
    If[fdebug,Print[" head coefficients : ",hs]];
    If[UnsameQ[hs,{}],
      hlcm=PolynomialLCM@@hs,
      hlcm=1
      ];
    eli=eliminationSet[myG,pars];
    If[UnsameQ[eli,{}],
      If[Length[eli]\[Equal]1,AppendTo[mySH,eli]];
      If[fverbose,Print["New constructible set : ",{{},eli}]];
      If[fzr&&zerodimradicalQ[eli,pars,False,opts],
        If[fdebug,Print[" - an elimination set is a radical."]];
        If[fverbose,Print["New constructible set : ",{eli,{}}]];
        Return[{{{},eli,{1}},{eli,{},
              If[freduce,
                reducedmonomials[eliminationSetComplement[myG,pars],eli,vars,
                  opts],eliminationSetComplement[myG,pars]]}}],
        If[fdebug,Print[" - an elimination set is NOT a radical."]];
        If[fverbose,Print["New constructible set : ",{eli,{hlcm}}]];
        Return[
          
          Union[{{{},eli,{1}},{eli,{hlcm},
                If[freduce,
                  reducedmonomials[eliminationSetComplement[myG,pars],eli,
                    vars,opts],eliminationSetComplement[myG,pars]]}},
            Join@@Map[CGSOptMain[Append[myG,#],vars,pars,False,opts]&,hs]]
          ]
        ],
      If[fverbose,Print["New constructible set : ",{eli,{hlcm}}]];
      Return[
        Union[{{eli,{hlcm},
              If[freduce,
                reducedmonomials[eliminationSetComplement[myG,pars],eli,vars,
                  opts],eliminationSetComplement[myG,pars]]}},
          Join@@Map[CGSOptMain[Append[myG,#],vars,pars,False,opts]&,hs]]
        ]
      ];
    ]

CGSOpt[flist_,vars_,True,opts___?(Head[#]===Rule||Head[#]===RuleDelayed&)]:=
  Block[{myG,hs,hlcm,pars,eli,mySH},
    myGtime=0;myGcount=0;
    sqrtime=0;sqrcount=0;
    zrQtime=0;zrQcount=0;
    rmQtime=0;rmQcount=0;
    voQtime=0;voQcount=0;
    stime=TimeUsed[];
    (* \:30d1\:30e9\:30e1\:30fc\:30bf\:306e\:6c7a\:5b9a *)
    
    pars=Complement[Union@@Map[Variables,flist],vars];
    myG=GroebnerBasis[flist,Join[vars,pars],opts];
    myGtime+=(TimeUsed[]-stime);myGcount++;
    stime=TimeUsed[];
    If[MemberQ[myG,1],Return[{{{},{1},{1}}}]];
    (* \:5e83\:57df\:5909\:6570\:306e\:521d\:671f\:5316 *)
    mySH={};
    (* \:5206\:5c90 *)
    
    hs=Union@Map[headcoef[#,vars,opts]&,
          Select[myG,UnsameQ[Complement[Variables[#],pars],{}]&]];
    hs=Union@@Map[(Rest[FactorList[#]][[All,1]])&,hs];
    sqrtime+=(TimeUsed[]-stime);sqrcount++;
    stime=TimeUsed[];
    If[fdebug,Print[" head coefficients : ",hs]];
    If[UnsameQ[hs,{}],
      hlcm=PolynomialLCM@@hs,
      hlcm=1
      ];
    eli=eliminationSet[myG,pars];
    If[UnsameQ[eli,{}],
      If[Length[eli]\[Equal]1,AppendTo[mySH,eli]];
      If[fverbose,Print["New constructible set : ",{{},eli}]];
      If[fzr&&zerodimradicalQ[eli,pars,True,opts],
        If[fdebug,Print[" - an elimination set is a radical."]];
        If[fverbose,Print["New constructible set : ",{eli,{}}]];
        Return[{{{},eli,{1}},{eli,{},
              If[freduce,
                reducedmonomials[eliminationSetComplement[myG,pars],eli,vars,
                  opts],eliminationSetComplement[myG,pars]]}}],
        If[fdebug,Print[" - an elimination set is NOT a radical."]];
        If[fverbose,Print["New constructible set : ",{eli,{hlcm}}]];
        Return[
          
          Union[{{{},eli,{1}},{eli,{hlcm},
                If[freduce,
                  reducedmonomials[eliminationSetComplement[myG,pars],eli,
                    vars,opts],eliminationSetComplement[myG,pars]]}},
            Join@@Map[CGSOptMain[Append[myG,#],vars,pars,True,opts]&,hs]]
          ]
        ],
      If[fverbose,Print["New constructible set : ",{eli,{hlcm}}]];
      Return[
        Union[{{eli,{hlcm},
              If[freduce,
                reducedmonomials[eliminationSetComplement[myG,pars],eli,vars,
                  opts],eliminationSetComplement[myG,pars]]}},
          Join@@Map[CGSOptMain[Append[myG,#],vars,pars,True,opts]&,hs]]
        ]
      ];
    ]





GroebnerSystem[polyset_List,varset_List,options___]:=
  Block[{cgs,fdebug,fverbose,ftimeshow,freduce,fzr,myCondtime,myGtime,
      myGcount,sqrtime,sqrcount,zrQtime,zrQcount,rmQtime,rmQcount,voQtime,
      voQcount,stime},
    fdebug=Debug/.{options}/.Options[GroebnerSystem];
    fverbose=Verbose/.{options}/.Options[GroebnerSystem];
    ftimeshow=TimeDebug/.{options}/.Options[GroebnerSystem];
    fzr=ZRadical/.{options}/.Options[GroebnerSystem];
    freduce=Reduced/.{options}/.Options[GroebnerSystem];
    If[fdebug,fverbose=True];
    If[fverbose,Print["Input PolynomialSet: ",polyset]];
    If[fverbose,Print["Variables: ",varset]];
    If[fverbose,
      Print["Parameters: ",Complement[Union@@Map[Variables,polyset],
          varset]]];
    cgs=CGSOpt[polyset,varset,ftimeshow,
        FilterOptions[GroebnerBasis,options]];
    If[ftimeshow,
      Print["Timing data: "];
      Print[" computing groebner bases             : ",myGtime," sec (",
        myGcount,"), ave: ",If[myGcount>0,myGtime/myGcount,"NA"]];
      Print[" factoring head coefficients          : ",sqrtime," sec (",
        sqrcount,"), ave: ",If[sqrcount>0,sqrtime/sqrcount,"NA"]];
      Print[" checking whether 0-dim radical or not: ",zrQtime," sec (",
        zrQcount,"), ave: ",If[zrQcount>0,zrQtime/zrQcount,"NA"]];
      Print[" checking whether false constructible : ",rmQtime," sec (",
        rmQcount,"), ave: ",If[rmQcount>0,rmQtime/rmQcount,"NA"]];
      Print[" checking whether already done variety: ",voQtime," sec (",
        voQcount,"), ave: ",If[voQcount>0,voQtime/voQcount,"NA"]];
      ];
    myCondtime=0;
    If[FractionFree/.{options}/.Options[GroebnerSystem],
      cgs=Map[{#[[1]],#[[2]],Map[Numerator[Together[#]]&,#[[3]]]}&,cgs];
      ];
    If[ElementSimplify/.{options}/.Options[GroebnerSystem],
      stime=TimeUsed[];
      cgs=Map[{#[[1]],#[[2]],Simplify[#[[3]]]}&,cgs];
      myCondtime+=(TimeUsed[]-stime);
      ];
    If[Not[RawOutput/.{options}/.Options[GroebnerSystem]],
      cgs=Map[{ToConditionForm[#[[1]],#[[2]]],#[[3]]}&,cgs];
      If[ConditionSimplify/.{options}/.Options[GroebnerSystem],
        stime=TimeUsed[];
        cgs=Map[{ConditionSimplify[#[[1]]],#[[2]]}&,cgs];
        myCondtime+=(TimeUsed[]-stime);
        ];
      
      ];
    If[ftime&&(myCondtime=!=0),
      Print[" simplifying constructible sets       : ",stime," sec (",1,"), ave: ",
          stime/1];
      ];
    Return[Union[cgs]];
    ]



SingularityEquation[equation_,variables_List]:=
  Prepend[Map[(D[equation,#])&,variables],equation]



NonDegeneracyCondition[gs_List,vars_List,options___]:=
  Module[{target,zerorule,zerouneq,pars,n,i},
    zerorule=Map[Rule[#,0]&,vars];
    zerouneq=Map[Unequal[#,0]&,vars];
    pars=Complement[Union@@Map[Variables,Flatten[gs]],vars];
    target=
      Select[gs,(Length[
                FindInstance[
                  And[And@@Map[Equal[(#/.zerorule),0]&,#[[2]]],#[[1]]],pars]]>
              0)&];
    target=
      Select[target,(Length[
                FindInstance[
                  And[And@@Map[Equal[#,0]&,#[[2]]],#[[1]],Or@@zerouneq],
                  Join[vars,pars]]]\[Equal]0)&];
    If[Length[target]>0,
      target=First[Transpose[target]];
      If[(Debug/.{options}/.Debug\[Rule]False)===True,Print[Or@@target]];
      target=ConditionSimplify[Or@@target];
      Return[target],
      Return[False]
      ];
    ]

DegeneracyCondition[gs_List,vars_List,options___]:=
  Module[{target,zerorule,zerouneq,target2,pars,n,i},
    zerorule=Map[Rule[#,0]&,vars];
    zerouneq=Map[Unequal[#,0]&,vars];
    pars=Complement[Union@@Map[Variables,Flatten[gs]],vars];
    target=
      Select[gs,(Length[
                FindInstance[
                  And[And@@Map[Equal[(#/.zerorule),0]&,#[[2]]],#[[1]]],pars]]>
              0)&];
    target=
      Select[target,(Length[
                FindInstance[
                  And[And@@Map[Equal[#,0]&,#[[2]]],#[[1]],Or@@zerouneq],
                  Join[vars,pars]]]\[Equal]0)&];
    target2=
      Select[gs,(Length[
                FindInstance[And[And@@Map[Equal[#,0]&,#[[2]]],#[[1]]],
                  Join[vars,pars]]]>0)&];
    If[Length[target]>0,
      target=First[Transpose[target]];
      target=Complement[First[Transpose[target2]],target];
      If[(Debug/.{options}/.Debug\[Rule]False)===True,Print[Or@@target]];
      target=ConditionSimplify[Or@@target];
      Return[target],
      Return[False]
      ];
    ]



ConditionSimplify[condin_Or,options___]:=
  Block[{$RecursionLimit=Infinity},DNFSimplify[condin,0,options]]

ConditionSimplify[condin_And,options___]:=
  Block[{$RecursionLimit=Infinity},CNFSimplify[condin,0,options]]

ConditionSimplify[condin_,options___]:=condin

CNFSimplify[condin_And,rpt_Integer:0,options___]:=
  Module[{cond,asm,hd,leaves,maxrpt,debug,gb},
    (*--- assumptions ---*)
    
    asm=Assumption/.{options}/.Assumption\[Rule]True;
    maxrpt=
      RecursionLimit/.{options}/.RecursionLimit\[Rule]
          Min[LeafCount[condin],255];
    debug=Debug/.{options}/.Debug\[Rule]False;
    If[debug,Print[StringJoin@@Table[" ",{rpt}],">CNF:",rpt,": ",condin];
      Print[StringJoin@@Table[" ",{rpt}]," ASM: ",asm];
      ];
    If[rpt>maxrpt,Return[ToMultiplicationForm[condin]]];
    (*--- simplification ---*)
    
    cond=Simplify[condin,asm,ComplexityFunction\[Rule]Depth];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===Or,Return[DNFSimplify[cond,rpt+1,options]],
      If[hd=!=And,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<CNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- pseudo canonical form ---*)
    cond=ToSeparationForm[cond];
    cond=cond//.And[other1___,Or[mainA_,mainB___],other2___]\[RuleDelayed]
          Or[And[other1,mainA,other2],And[other1,Or[mainB],other2]];
    cond=Sort[cond,Less[LeafCount[#1],LeafCount[#2]]&];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===Or,Return[DNFSimplify[cond,rpt+1,options]],
      If[hd=!=And,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<CNF:",rpt,":",cond]];
        Return[cond]]];
    (* groebner basis *)
    
    gb=Cases[List@@cond,_Equal]/.Equal[lhs_,rhs_]\[RuleDelayed]lhs-rhs;
    cond=DeleteCases[cond,_Equal];
    gb=GroebnerBasis[gb,AnyVariables[gb],
        MonomialOrder\[Rule]DegreeReverseLexicographic];
    If[gb==={1},cond=False;
      If[debug,Print[StringJoin@@Table[" ",{rpt}],"<CNF:",rpt,":",cond]];
      Return[cond]];
    cond=ToSeparationForm[And[cond,And@@Map[Equal[#,0]&,gb]]];
    cond=cond//.And[other1___,Or[mainA_,mainB___],other2___]\[RuleDelayed]
          Or[And[other1,mainA,other2],And[other1,Or[mainB],other2]];
    cond=Sort[cond,Less[LeafCount[#1],LeafCount[#2]]&];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===Or,Return[DNFSimplify[cond,rpt+1,options]],
      If[hd=!=And,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<CNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- leaf check ---*)
    leaves=LeafCount[cond];
    (*--- inner condition simplification ---*)
    
    cond=Map[DNFSimplify[#,rpt+1,UnequalGrouping\[Rule]False,
            EqualGrouping\[Rule]False,options]&,cond];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===Or,Return[DNFSimplify[cond,rpt+1,options]],
      If[hd=!=And,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<CNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- structual simplifications ---*)
    (* A&&A => A *)
    
    cond=cond//.And[other1___,Unequal[lhs_,rhs_],other2___,Unequal[lhs_,rhs_],
            other3___]\[RuleDelayed]And[other1,other2,Unequal[lhs,rhs],
            other3];
    cond=cond//.And[other1___,Equal[lhs_,rhs_],other2___,Equal[lhs_,rhs_],
            other3___]\[RuleDelayed]And[other1,other2,Equal[lhs,rhs],other3];
    (* !A&&A => False *)
    
    cond=cond//.And[other1___,Unequal[lhs_,rhs_],other2___,Equal[lhs_,rhs_],
            other3___]\[RuleDelayed]False;
    cond=cond//.And[other1___,Equal[lhs_,rhs_],other2___,Unequal[lhs_,rhs_],
            other3___]\[RuleDelayed]False;
    (* Equal[var,num]&... => Equal[var,num]&&(../.var\[Rule]num) *)
    
    cond=cond//.And[other1___,Equal[lhsv_Symbol,0],
            other2___]\[RuleDelayed]And[
              And@@(List@other1/.lhsv\[RuleDelayed]0),Equal[lhsv,0],
              And@@(List@other2/.lhsv\[RuleDelayed]0)]/;
            Or[Not[FreeQ[List@other1,lhsv]],Not[FreeQ[List@other2,lhsv]]];
    cond=cond//.And[other1___,Equal[lhsv_Symbol+lhsn_?NumberQ,0],
            other2___]\[RuleDelayed]And[
              And@@(List@other1/.lhsv\[RuleDelayed]-lhsn),Equal[lhsv+lhsn,0],
              And@@(List@other2/.lhsv\[RuleDelayed]-lhsn)]/;
            Or[Not[FreeQ[List@other1,lhsv]],Not[FreeQ[List@other2,lhsv]]];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===Or,Return[DNFSimplify[cond,rpt+1,options]],
      If[hd=!=And,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<CNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- logical simplifications ---*)
    (* (A||B)&&!A => B&&!A *)
    
    cond=cond//.And[other1___,Or[otherA1___,mainA_,otherA2___],other2___,
            mainB_,other3___]\[RuleDelayed]
          And[other1,Or[otherA1,otherA2],other2,mainB,other3]/;
            TimeConstrained[Simplify[mainA,mainB&&asm],1,True]===False;
    cond=cond//.And[other1___,mainB_,other2___,
            Or[otherA1___,mainA_,otherA2___],
            other3___]\[RuleDelayed]And[other1,mainB,other2,
              Or[otherA1,otherA2],other3]/;
            TimeConstrained[Simplify[mainA,mainB&&asm],1,True]===False;
    (* A&&B => A if A implies B *)
    
    cond=cond//.And[other1___,mainA_,other2___,mainB_Unequal,
            other3___]\[RuleDelayed]And[other1,mainA,other2,other3]/;
            TimeConstrained[Simplify[mainB,And[mainA,asm]],1,False]===True;
    cond=cond//.And[other1___,mainB_Unequal,other2___,mainA_,
            other3___]\[RuleDelayed]And[other1,other2,mainA,other3]/;
            TimeConstrained[Simplify[mainB,And[mainA,asm]],1,False]===True;
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===Or,Return[DNFSimplify[cond,rpt+1,options]],
      If[hd=!=And,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<CNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- leaf count check ---*)
    If[rpt<maxrpt&&LeafCount[cond]<leaves,
      Return[CNFSimplify[cond,rpt+1,options]]];
    (*--- final procedure ---*)
    cond=ToMultiplicationForm[cond,options];
    If[debug,Print[StringJoin@@Table[" ",{rpt}],"<CNF:",rpt,":",cond]];
    Return[cond];
    ]

CNFSimplify[condin_Or,rpt_Integer:0,options___]:=
  DNFSimplify[condin,rpt,options]

CNFSimplify[condin_,rpt_Integer:0,options___]:=condin

DNFSimplify[condin_Or,rpt_Integer:0,options___]:=
  Module[{cond,asm,hd,leaves,maxrpt,allelm,targetcond,restcond,elm,target,
      debug},
    (*--- assumptions ---*)
    
    asm=Assumption/.{options}/.Assumption\[Rule]True;
    maxrpt=
      RecursionLimit/.{options}/.RecursionLimit\[Rule]
          Min[LeafCount[condin],255];
    debug=Debug/.{options}/.Debug\[Rule]False;
    If[debug,Print[StringJoin@@Table[" ",{rpt}],">DNF:",rpt,": ",condin];
      Print[StringJoin@@Table[" ",{rpt}]," ASM: ",asm];
      ];
    If[rpt>maxrpt,Return[ToMultiplicationForm[condin]]];
    (*--- simplification ---*)
    
    cond=Simplify[condin,asm,ComplexityFunction\[Rule]Depth];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===And,Return[CNFSimplify[cond,rpt+1,options]],
      If[hd=!=Or,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<DNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- pseudo canonical form ---*)
    cond=ToSeparationForm[cond];
    cond=cond//.Or[other1___,And[other21___,Or[mainA_,mainB___],other22___],
            other3___]\[RuleDelayed]
          Or[other1,And[other21,mainA,other22],And[other21,Or[mainB],other22],
            other3];
    cond=Sort[cond,Less[LeafCount[#1],LeafCount[#2]]&];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===And,Return[CNFSimplify[cond,rpt+1,options]],
      If[hd=!=Or,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<DNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- leaf check ---*)
    leaves=LeafCount[cond];
    (*--- inner condition simplification ---*)
    
    cond=Map[CNFSimplify[#,rpt+1,UnequalGrouping\[Rule]False,
            EqualGrouping\[Rule]False,options]&,cond];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===And,Return[CNFSimplify[cond,rpt+1,options]],
      If[hd=!=Or,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<DNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- structual simplifications ---*)
    (* !A||A => True *)
    
    cond=cond//.Or[Equal[lhs_,rhs_],Unequal[lhs_,rhs_]]\[Rule]True;
    cond=cond//.Or[Unequal[lhs_,rhs_],Equal[lhs_,rhs_]]\[Rule]True;
    (* !A||A => True *)
    
    cond=cond//.Or[other1___,Equal[lhs_,rhs_],other2___,Unequal[lhs_,rhs_],
            other3___]\[RuleDelayed]Or[other1,other2,other3];
    cond=cond//.Or[other1___,Unequal[lhs_,rhs_],other2___,Equal[lhs_,rhs_],
            other3___]\[RuleDelayed]Or[other1,other2,other3];
    (*  (!A1&&B)||(!A2&&B)||(A1&&A2) => B||(A1&&A2) *)
    (* 
      general cases need a lot of computation time hence not implemented \
though I've not tried *)
    
    cond=cond//.Or[other1___,And[other21___,Equal[lhs1_,rhs1_],other22___],
            other3___,And[other21___,Equal[lhs2_,rhs2_],other22___],other4___,
            And[Unequal[lhs1_,rhs1_],Unequal[lhs2_,rhs2_]],
            other5___]\[RuleDelayed]Or[other1,And[other21,other22],other3,
            other4,And[Unequal[lhs1,rhs1],Unequal[lhs2,rhs2]],other5];
    cond=cond//.Or[other1___,And[other21___,Equal[lhs1_,rhs1_],other22___],
            other3___,And[Unequal[lhs1_,rhs1_],Unequal[lhs2_,rhs2_]],
            other4___,And[other21___,Equal[lhs2_,rhs2_],other22___],
            other5___]\[RuleDelayed]Or[other1,And[other21,other22],other3,
            other4,And[Unequal[lhs1,rhs1],Unequal[lhs2,rhs2]],other5];
    cond=cond//.Or[other1___,And[Unequal[lhs1_,rhs1_],Unequal[lhs2_,rhs2_]],
            other3___,And[other21___,Equal[lhs1_,rhs1_],other22___],other4___,
            And[other21___,Equal[lhs2_,rhs2_],other22___],
            other5___]\[RuleDelayed]Or[other1,And[other21,other22],other3,
            other4,And[Unequal[lhs1,rhs1],Unequal[lhs2,rhs2]],other5];
    cond=cond//.Or[other1___,And[other21___,Equal[lhs1_,rhs1_],other22___],
            other3___,And[other21___,Equal[lhs2_,rhs2_],other22___],other4___,
            And[Unequal[lhs2_,rhs2_],Unequal[lhs1_,rhs1_]],
            other5___]\[RuleDelayed]Or[other1,And[other21,other22],other3,
            other4,And[Unequal[lhs1,rhs1],Unequal[lhs2,rhs2]],other5];
    cond=cond//.Or[other1___,And[other21___,Equal[lhs1_,rhs1_],other22___],
            other3___,And[Unequal[lhs2_,rhs2_],Unequal[lhs1_,rhs1_]],
            other4___,And[other21___,Equal[lhs2_,rhs2_],other22___],
            other5___]\[RuleDelayed]
          Or[other1,And[other21,other22],other3,other4,
            And[Unequal[lhs1,rhs1],Unequal[lhs2,rhs2]],other5];
    cond=cond//.Or[other1___,And[Unequal[lhs2_,rhs2_],Unequal[lhs1_,rhs1_]],
            other3___,And[other21___,Equal[lhs1_,rhs1_],other22___],other4___,
            And[other21___,Equal[lhs2_,rhs2_],other22___],
            other5___]\[RuleDelayed]Or[other1,And[other21,other22],other3,
            other4,And[Unequal[lhs1,rhs1],Unequal[lhs2,rhs2]],other5];
    If[debug,Print[StringJoin@@Table[" ",{rpt}],"(after structual)"];
      Print[StringJoin@@Table[" ",{rpt}],"current: ",cond]];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===And,Return[CNFSimplify[cond,rpt+1,options]],
      If[hd=!=Or,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<DNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- common part recursion ---*)
    
    targetcond=Select[List@@cond,(Head[#]===And)&];
    cond=Select[cond,(Head[#]=!=And)&];
    allelm=Union[Flatten[Map[(List@@#)&,targetcond],1]];
    While[Length[allelm]>0,
      elm=First[allelm];allelm=Rest[allelm];
      target=Select[targetcond,MatchQ[#,And[___,elm,___]]&];
      If[Length[target]>1,
        restcond=Select[targetcond,Not[MatchQ[#,And[___,elm,___]]]&];
        target=
          target//.List[other1___,And[mainA___,elm,mainB___],
                other2___]\[RuleDelayed]List[other1,And[mainA,mainB],other2];
        target=
          DNFSimplify[Or@@target,rpt+1,
            Assumption\[Rule]Simplify[And[elm,asm]],
            UnequalGrouping\[Rule]False,EqualGrouping\[Rule]False,options];
        If[Head[target]===Or,
          targetcond=Union[restcond,Map[And[elm,#]&,List@@target]],
          targetcond=Union[restcond,{And[elm,target]}]
          ];
        ];
      ];
    cond=Or[cond,Or@@targetcond];
    If[debug,Print[StringJoin@@Table[" ",{rpt}],"(after common part)"];
      Print[StringJoin@@Table[" ",{rpt}],"current: ",cond]];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===And,Return[CNFSimplify[cond,rpt+1,options]],
      If[hd=!=Or,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<DNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- logical simplifications ---*)
    (* !A||A => True *)
    
    cond=cond//.Or[otherA_,otherB_]\[RuleDelayed]
          True/;Simplify[Or[otherA,otherB],asm]===True;
    cond=cond//.Or[other1___,otherA_,other2___,otherB_,
            other3___]\[RuleDelayed]
          Or[other1,other2,other3]/;Simplify[Or[otherA,otherB],asm]===True;
    (* (!A&&B)||A => B||A *)
    
    cond=cond//.Or[other1___,And[other41___,otherA_,other42___],other2___,
            otherB_,other3___]\[RuleDelayed]Or[other1,And[other41,other42],
              other2,otherB,other3]/;Simplify[Or[otherA,otherB],asm]===True;
    cond=cond//.Or[other1___,otherB_,other2___,
            And[other41___,otherA_,other42___],
            other3___]\[RuleDelayed]Or[other1,And[other41,other42],other2,
              otherB,other3]/;Simplify[Or[otherA,otherB],asm]===True;
    (* (!A&&B)||(A&&C) => B||(A&&C) if A&&B\[NotEqual]False and A&&
            B implies C *)
    
    cond=cond//.Or[other1___,And[other41___,otherA_,other42___],other2___,
            And[other51___,otherB_,other52___],
            other3___]\[RuleDelayed]Or[other1,And[other41,other42],other2,
              And[other51,otherB,other52],other3]/;
            TimeConstrained[
              Simplify[Or[otherA,otherB],asm]===True&&
                Reduce[And[otherB,other41,other42,asm]]=!=False&&
                Simplify[And[other51,other52],
                    And[otherB,other41,other42,asm]]===True,1,False];
    cond=cond//.Or[other1___,And[other51___,otherB_,other52___],other2___,
            And[other41___,otherA_,other42___],
            other3___]\[RuleDelayed]Or[other1,And[other41,other42],other2,
              And[other51,otherB,other52],other3]/;
            TimeConstrained[
              Simplify[Or[otherA,otherB],asm]===True&&
                Reduce[And[otherB,other41,other42,asm]]=!=False&&
                Simplify[And[other51,other52],
                    And[otherB,other41,other42,asm]]===True,1,False];
    (* A||B => B if A implies B *)
    
    cond=cond//.Or[other1___,other2_,other3___,other4_,
            other5___]\[RuleDelayed]
          Or[other1,other3,other4,other5]/;
            Simplify[other4,And[other2,asm]]===True;
    cond=cond//.Or[other1___,other2_,other3___,other4_,
            other5___]\[RuleDelayed]
          Or[other1,other2,other3,other5]/;
            Simplify[other2,And[other4,asm]]===True;
    If[debug,Print[StringJoin@@Table[" ",{rpt}],"(after logical)"];
      Print[StringJoin@@Table[" ",{rpt}],"current: ",cond]];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===And,Return[CNFSimplify[cond,rpt+1,options]],
      If[hd=!=Or,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<DNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- not threading recursion ---*)
    
    cond=cond/.Or[mainA_,
            others___]\[RuleDelayed]Or[mainA,
              DNFSimplify[Or[others],rpt+1,
                Assumption\[Rule]Simplify[And[Not[mainA],asm]],
                UnequalGrouping\[Rule]False,EqualGrouping\[Rule]False,
                options]]/;
            LeafCount[mainA]+LeafCount[asm]<LeafCount[List@others];
    If[debug,Print[StringJoin@@Table[" ",{rpt}],"(after threading)"];
      Print[StringJoin@@Table[" ",{rpt}],"current: ",cond]];
    (*--- branch ---*)
    hd=Head[cond];
    If[hd===And,Return[CNFSimplify[cond,rpt+1,options]],
      If[hd=!=Or,
        If[debug,Print[StringJoin@@Table[" ",{rpt}],"<DNF:",rpt,":",cond]];
        Return[cond]]];
    (*--- leaf count check ---*)
    If[rpt<maxrpt&&LeafCount[cond]<leaves,
      Return[DNFSimplify[cond,rpt+1,options]]];
    (*--- final procedure ---*)
    cond=ToMultiplicationForm[cond,options];
    If[debug,Print[StringJoin@@Table[" ",{rpt}],"<DNF:",rpt,":",cond]];
    Return[cond];
    ]

DNFSimplify[condin_And,rpt_Integer:0,options___]:=
  CNFSimplify[condin,rpt,options]

DNFSimplify[condin_,rpt_Integer:0,options___]:=condin

ToSeparationForm[condin_]:=Module[{cond=condin},
    (* transform equal condition into separation form *)
    
    cond=cond/.Equal[lhs_,rhs_]\[RuleDelayed]Equal[lhs-rhs,0]/;rhs=!=0;
    cond=cond/.Equal[lhs_,0]\[RuleDelayed]
          Or@@Map[Equal[#,0]&,
              Select[First[Transpose[FactorList[lhs]]],Not[NumericQ[#]]&]];
    cond=cond//.Or[other1___,Equal[lhs_,rhs_],other2___,Equal[lhs_,rhs_],
            other3___]\[RuleDelayed]Or[other1,other2,Equal[lhs,rhs],other3];
    
    (* transform unequal condition into separation form *)
    
    cond=cond/.Unequal[lhs_,rhs_]\[RuleDelayed]Unequal[lhs-rhs,0]/;rhs=!=0;
    cond=cond/.Unequal[lhs_,0]\[RuleDelayed]
          And@@Map[Unequal[#,0]&,
              Select[First[Transpose[FactorList[lhs]]],Not[NumericQ[#]]&]];
    cond=cond//.And[other1___,Unequal[lhs_,rhs_],other2___,Unequal[lhs_,rhs_],
            other3___]\[RuleDelayed]
          And[other1,other2,Unequal[lhs,rhs],other3];
    
    Return[cond];
    ]

ToMultiplicationForm[condin_,options___]:=Module[{cond=condin},
    (* transform unequal condition into multiplication form *)
    
    If[(UnequalGrouping/.{options}/.UnequalGrouping\[Rule]True)===True,
      cond=
          cond//.And[other1___,Unequal[lhs1_,0],other2___,Unequal[lhs2_,0],
                other3___]\[RuleDelayed]
              And[other1,Unequal[lhs1*lhs2,0],other2,other3];
      ];
    
    (* transform equal or condition into multiplication form *)
    
    If[(EqualGrouping/.{options}/.EqualGrouping\[Rule]True)===True,
      cond=
          cond//.Or[other1___,Equal[lhs1_,rhs1_],other2___,Equal[lhs2_,rhs2_],
                other3___]\[RuleDelayed]
              Or[other1,Equal[(lhs1-rhs1)(lhs2-rhs2),0],other2,other3];
      ];
    
    (* transform common parts into multiplication form *)
    
    If[(EqualGrouping/.{options}/.EqualGrouping\[Rule]True)===True,
      cond=
          cond//.Or[other1___,And[mainA___,Equal[lhs1_,rhs1_],mainB___],
                other2___,And[mainA___,Equal[lhs2_,rhs2_],mainB___],
                other3___]\[RuleDelayed]
              Or[other1,And[mainA,Equal[(lhs1-rhs1)(lhs2-rhs2),0],mainB],
                other2,other3];
      ];
    
    Return[cond];
    ]

ToConditionForm[zeroset_,nonzeroset_]:=
  Simplify[And@@Union[Map[Equal[#,0]&,zeroset],Map[Unequal[#,0]&,nonzeroset]]]









SetAttributes[{CGSOptMain,CGSOpt,AnyVariables,headcoef,monomialreduce,
      reducedmonomials,eliminationIdeal,eliminationSet,
      eliminationSetComplement,zerodimradicalQ,radicalmemberQ,
      vofhinvofSHQ},{Protected,ReadProtected,Locked}];



End[];



SetAttributes[{GroebnerSystem,ConditionSimplify,CNFSimplify,DNFSimplify,
      NonDegeneracyCondition,DegeneracyCondition,
      SingularityEquation},{Protected,ReadProtected,Locked}];



EndPackage[]



































