(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.1'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    535570,      13179]*)
(*NotebookOutlinePosition[    624867,      15616]*)
(*  CellTagsIndexPosition[    621677,      15496]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["SNAP`", "Chapter"],

Cell[CellGroupData[{

Cell["Introduction", "Section",
  CellTags->"c:1"],

Cell[CellGroupData[{

Cell["Overview", "Subsection",
  CellTags->{"b:0.0", "c:2"}],

Cell["\<\
This package provides various type of symbolic numeric algebraic operations \
for polynomials. We note that Kosaku NAGASAKA has the copyright of this \
package, and this package is partly helped by Grants-in-Aid for Scientific \
Research, Ministry of Education, Culture, Sports, Science and Technology, \
JAPAN.\
\>", "Text",
  CellTags->"b:0.0"],

Cell["\<\
Everybody who wants to use this package has to accept the license agreement \
of this package. We do NOT allow you to use this package if you do NOT accept \
the license even if the license is not included in this package (In this \
case, you have to contact us).\
\>", "Text",
  CellTags->"b:0.0"],

Cell["\<\
Read the following, prior to using this software: 
If you agree to the following, you are permitted to use this software.
Agreement on use of this software
1.Copyright of this software is reserved by Kosaku Nagasaka at Kobe \
University <nagasaka@main.h.kobe-u.ac.jp>.
2.You can use this software freely only for non-commercial use. But you shall \
not gain any right to the copyright of this software by your use of this \
software.
3.You are prohibited from extending or modifying this software.
4.Kosaku Nagasaka makes no warranty of this software, and takes no \
responsibility to any result arising from your use of this software.\
\>", "FramedBox",
  CellTags->"b:0.0"],

Cell["This loads the package.", "MathCaption",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[1]:=",
  CellTags->"b:0.0"],

Cell[TextData[Cell[BoxData[GridBox[{
        {Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .40092 
%%ImageSize: 218 88 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.00460829 -0.00460829 0.00460829 [
[ 0 0 0 0 ]
[ 1 .40092 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .40092 L
0 .40092 L
closepath
clip
newpath
% Start of colorimage (RGB)
p
0 -0.00461 translate
1.00461 .40553 scale
654 string
218 88 8 [218 0 0 88 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  false 3 Mcolorimage
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF4040FF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF
7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF2020FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF1010FF4040FF4040FF4040FF4040FF4040FF1010FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FF
7070FF9999FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF
BFBFFF8F8FFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF7F7FFFAFAFFFBFBFFF
EFEFFFFFFFFFFFFFFFFFFFFFCCCCFFBFBFFF8F8FFF6666FF2020FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FFDFDFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF9999FF3333FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF8F8FFF2020FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF3333FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
BFBFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8FFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFBFBFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF3333FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFFF1010FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF
1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
AFAFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFEFEFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6666FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFDFDFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF1010FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFEFEFFFBFBFFFBFBFFFBFBFFFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFDFDFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFEFEFFF
BFBFFFBFBFFFBFBFFFBFBFFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
EFEFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFDFDFFF7070FF
2020FF0000FF0000FF0000FF0000FF0000FF1010FF7070FFEFEFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF8F8FFF3333FF0000FF
0000FF0000FF0000FF0000FF0000FF3333FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFCCCCFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFDFDFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF8F8FFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFEFEFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7FFF7F7FFF7F7FFF
7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF
DFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FFEFEFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFCCCCFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8F8FFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFCCCCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFEFEFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF7070FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFCCCCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF8F8FFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFAFAFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF7070FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8FFF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF2020FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5050FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
BFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFAFAFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
BFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3333FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF2020FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
7070FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
DFDFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFDFDFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFDFDFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6666FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFCCCCFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FF
EFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF2020FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF3333FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FF9999FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF3333FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFAFAFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF1010FF7070FFAFAFFFBFBFFFBFBFFF7070FF
1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFEFEFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FF
6666FF8080FF9999FF8080FF8080FF3333FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF8F8FFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFDFDFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFCCCCFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8F8FFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF1010FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFCCCCFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF7070FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF3333FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFEFEFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
CCCCFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF1010FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF3333FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFCCCCFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
8F8FFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF7070FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFEFEFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF1010FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFAFAFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF1010FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF3333FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFEFEFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFEFEFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF1010FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF3333FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFBFBFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF3333FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF6666FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFDFDFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF7070FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF8F8FFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF1010FF7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF3333FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FF9999FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFEFEFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFEFEFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF6666FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
BFBFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF3333FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF5050FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF3333FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFDFDFFF7F7FFF2020FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FF7F7FFF
DFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFEFEFFF9999FF6666FF3333FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF2020FF5050FF8F8FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF8F8FFF4040FF2020FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF2020FF5050FF7F7FFFCCCCFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF1010FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFFBFBFFFBFBFFFDFDFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFDFDFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
2020FFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF6666FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFBFBFFFBFBFFFBFBFFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FFAFAFFFFFFFFFFFFFFF
FFFFFFFFFFFFBFBFFF7070FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF1010FF4040FF4040FF4040FF2020FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
AFAFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5050FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF2020FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6666FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF3333FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFDFDFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF1010FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6666FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFEFEFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF1010FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FFEFEFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF2020FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFBFBFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF7F7FFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF6666FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFEFEFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF3333FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF4040FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFCCCCFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF2020FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF6666FF1010FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF5050FFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFEFEFFFAFAFFF6666FF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF1010FF4040FF7F7FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF7F7FFF4040FF
1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FF7070FFAFAFFF
EFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFFBFBFFFBFBFFFBFBFFFBFBFFFBFBFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFCCCCFFBFBFFFBFBFFFBFBFFFBFBFFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
pop
P
% End of image
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
            ImageSize->{218, 88},
            ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003J0000F2000`400?l00000o`00003ofP000?l0
0=X0003o003J0000o`00fP000?l009h0003o00<0@43o07moo`1oOol03@1oOol00`0P8?l0003o0000
o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o02T0003o002N0000
o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0:@000?l009h0003o00<0P83o0?ooo`3o
ool03@3oool00`10@?l0003o0000o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`030410
o`000?l0003o02T0003o002N0000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0:@00
0?l009h0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0Y0000o`00WP000?l00`20
P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o02T0003o002N0000o`030820o`3oool0oooo00d0
oooo00<0@43o0000o`000?l0:@000?l009h0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o
0000o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o02T0003o002N
0000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0:@000?l009h0003o00<0P83o0?oo
o`3oool03@3oool00`10@?l0003o0000o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`03
0410o`000?l0003o02T0003o002N0000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0
:@000?l009h0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0Y0000o`0040000?l0
0`0@4?l0@43o0410o`030410o`03010@o`000?l0003o08D0003o00<0P83o0?ooo`3oool03@3oool0
0`10@?l0003o0000o`0Y0000o`002`000?l0100P8?l0L73o09VIo`3<c?l80?ooo`040>o_o`2o_ol0
Shoo051@oh<0003o00<0P83o0?ooo`3oool03@3oool01`10@?l0003o0000o`1oOol0[joo0;noo`3_
kol00`3oool01@3<c?l0_koo08n?o`1VI_l0823o01d0003o00090000o`0306IVo`3Ogol0oooo0100
oooo00<0VIWo03<co`000?l04@000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0
003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0
oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0
003o0000o`0<0?ooo`030=oOo`2?Sol0823o01X0003o00090000o`030820o`3oool0oooo0180oooo
00<0_koo03<co`000?l03`000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o
3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo
0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o
0000o`0?0?ooo`030;noo`10@?l0003o01L0003o00090000o`030820o`3oool0oooo01@0oooo00<0
Shoo0000o`000?l03@000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3o
ool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?oo
o`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000
o`0A0?ooo`030;noo`0P8?l0003o01D0003o00090000o`030820o`3oool0oooo01D0oooo00<0c<co
010@o`000?l030000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool0
0`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>
0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0C
0?ooo`03071`o`000?l0003o01<0003o00090000o`030820o`3oool0oooo01H0oooo00<0knoo03<c
o`000?l02`000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o
_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?oo
o`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0D0?oo
o`030:n_o`0@4?l0003o0180003o00090000o`030820o`3oool0oooo01L0oooo00<0c<co010@o`00
0?l02P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0
003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`03
0820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0E0?ooo`03
0<c<o`0@4?l0003o0140003o00090000o`030820o`3oool0oooo01P0oooo00<0[joo0000o`000?l0
2@000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o
0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820
o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0F0?ooo`030<c<
o`0@4?l0003o0100003o00090000o`030820o`3oool0oooo01T0oooo00<0IVKo0000o`000?l02000
0?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000
o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`00
0?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0G0?ooo`030<c<o`0@
4?l0003o00l0003o00090000o`030820o`3oool0oooo01T0oooo00<0knoo010@o`000?l020000?l0
0`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`06
0000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0
003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0H0?ooo`0309VIo`000?l0
003o00h0003o00090000o`030820o`3oool0oooo01X0oooo00<0P83o0000o`000?l01`000?l00`20
P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000
o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o
00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0I0?ooo`0306IVo`000?l0003o
00d0003o00090000o`030820o`3oool0oooo01X0oooo00<0gmoo0000o`000?l01`000?l00`20P?l0
oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`03
0410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0
003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0I0?ooo`030>o_o`0@4?l0003o00d0
003o00090000o`030820o`3oool0oooo01/0oooo00<0<c?o0000o`000?l01P000?l00`20P?l0oooo
0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410
o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o
00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0J0?ooo`0309VIo`000?l0003o00`0003o
00090000o`030820o`3oool0oooo01/0oooo00<0P83o0000o`000?l01P000?l00`20P?l0oooo0?oo
o`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3o
ool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0
P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0K0?ooo`03020Po`000?l0003o00/0003o0009
0000o`030820o`3oool0oooo01/0oooo00<0_koo0000o`000?l01P000?l00`20P?l0oooo0?ooo`0=
0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0
oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o
0?ooo`3oool03@3oool00`10@?l0003o0000o`0K0?ooo`0309VIo`000?l0003o00/0003o00090000
o`050820o`3oool0oooo0?ooo`3_kol00`2o_ol00`3<c?l0oooo0?ooo`0C0?ooo`030=oOo`000?l0
003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`080000o`l0oooo00<0_koo
0000o`000?l01P000?l00`10@?l0oooo0?ooo`0?0?ooo`l0003o00<0_koo0?ooo`3oool03P3oool0
0`20P?l0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l00P3oool0
0`3_kol0_koo0;noo`020;noo`030>o_o`3oool0oooo0140oooo00<0knoo0000o`000?l02`000?l0
00T0003o00@0P83o0=oOo`1`L?l0823o1@000?l00`0@4?l0L73o0>o_o`0C0?ooo`P0003o00<0P83o
0?ooo`3oool03@3oool00`10@?l0003o0000o`080000o`l0oooo00<0_koo0000o`000?l01P000?l0
0`10@?l0oooo0?ooo`0?0?ooo`l0003o00<0_koo0?ooo`3oool03P3oool00`20P?l0003o0000o`06
0000o`030820o`3oool0oooo00d0oooo00D0@43o0000o`000?l0Shoo03<co`060000o`0303<co`2I
VOl0oooo0140oooo00<0D53o0000o`000?l02P000?l000T0003o00<0413o0000o`000?l020000?l0
0`0@4?l0c<co0?ooo`0A0?ooo`P0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`08
0000o`l0oooo00<0_koo0000o`000?l01P000?l00`10@?l0oooo0?ooo`0?0?ooo`l0003o00<0_koo
0?ooo`3oool03P3oool00`20P?l0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o
0000o`000?l02P000?l00`0c<ol0gmoo0?ooo`0?0?ooo`0308n?o`000?l0003o00X0003o000E0000
o`03010@o`3_kol0oooo0100oooo20000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o
00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`1oOol00`3O
gol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10
@?l0003o0000o`0;0000o`03020Po`3_kol0oooo00h0oooo00<0c<co0000o`000?l02P000?l001H0
003o00<0Shoo0?ooo`3oool03`3oool80000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`00
0?l020000?l?0?ooo`030;noo`000?l0003o00H0003o00<0@43o0?ooo`3oool0;`3oool00`20P?l0
003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l030000?l00`10@?l0
oooo0?ooo`0>0?ooo``0003o000F0000o`030820o`3oool0oooo00l0oooo20000?l00`20P?l0oooo
0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410
o`3oool0oooo02l0oooo00<0P83o0000o`000?l01P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410
o`000?l0003o00d0003o00<0c<co0?ooo`3oool03@3oool00`10@?l0003o0000o`090000o`005P00
0?l00`20P?l0oooo0?ooo`0>0?ooo`030>o_o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3o
ool00`10@?l0003o0000o`080000o`l0oooo00<0_koo0000o`000?l01P000?l00`10@?l0oooo0?oo
o`0_0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000
o`0=0000o`03071`o`3oool0oooo00d0oooo00<0@43o0000o`000?l02@000?l001H0003o00<0c<co
0?ooo`3oool03P3oool00`2o_ol0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o
0000o`000?l020000?l?0?ooo`030;noo`000?l0003o00H0003o00<0@43o0?ooo`3oool0;`3oool0
0`20P?l0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l03@000?l0
0`10@?l0oooo0?ooo`0=0?ooo`0306IVo`000?l0003o00T0003o000E0000o`03020Po`3oool0oooo
00l0oooo00<0Shoo0000o`000?l01P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o
00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo02l0oooo00<0P83o0000
o`000?l01P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00d0003o00<0<c?o0?oo
o`3oool03@3oool00`20P?l0003o0000o`090000o`005@000?l00`2_[ol0oooo0?ooo`0?0?ooo`03
051@o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`080000o`l0
oooo00<0_koo0000o`000?l01P000?l00`10@?l0oooo0?ooo`0_0?ooo`030820o`000?l0003o00H0
003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0=0000o`03020Po`3oool0oooo00d0
oooo00<0P83o0000o`000?l02@000?l001@0003o00<0@43o0?ooo`3oool0403oool90000o`030820
o`3oool0oooo00d0oooo00<0@43o0000o`000?l020000?l?0?ooo`030;noo`000?l0003o00H0003o
00<0@43o0?ooo`3oool0;`3oool00`20P?l0003o0000o`060000o`03071`o`3oool0oooo00d0oooo
00<0L73o0000o`000?l03@000?l00`10@?l0oooo0?ooo`0=0?ooo`030820o`000?l0003o00T0003o
000D0?ooo`03020Po`000?l0003o00l0003o00<0IVKo0?ooo`3oool01`3oool00`20P?l0003o0000
o`0=0000o`030;noo`3oool0oooo00P0oooo3`000?l00`10@?l0oooo0?ooo`060?ooo`030;noo`00
0?l0003o02l0003o00<0P83o0?ooo`3oool01P3oool00`2o_ol0003o0000o`0=0000o`0306IVo`3o
ool0oooo00d0oooo00<0Shoo0000o`000?l03@000?l00`2_[ol0oooo0?ooo`090?ooo`004`3oool0
0`1`L?l0003o0000o`0@0000o`030;noo`3oool0oooo00L0oooo00<0VIWo0000o`000?l03@000?l0
0`2o_ol0oooo0?ooo`080?ooo`l0003o00<0P83o0?ooo`3oool01P3oool00`2o_ol0003o0000o`0_
0000o`030820o`3oool0oooo00H0oooo00<0_koo0000o`000?l03@000?l00`0P8?l0oooo0?ooo`0=
0?ooo`03051@o`000?l0003o00d0003o00<0_koo0?ooo`3oool02@3oool00180oooo00<0_koo0000
o`000?l040000?l00`10@?l0oooo0?ooo`080?ooo`030;noo`000?l0003o00d0003o00<0P83o0?oo
o`3oool01`3oool00`2_[ol0003o0000o`0=0000o`030820o`3oool0oooo00H0oooo00<0_koo0000
o`000?l0;`000?l00`20P?l0oooo0?ooo`070?oooa00003o00<0VIWo0?ooo`3oool02`3oool00`3O
gol0003o0000o`0>0000o`030>o_o`3oool0oooo00T0oooo000B0?ooo`03020Po`000?l0003o0100
003o00<0gmoo0?ooo`3oool0203oool00`2o_ol0003o0000o`0=0000o`030410o`3oool0oooo00L0
oooo00<0IVKo0000o`000?l03@000?l00`20P?l0oooo0?ooo`060?ooo`030;noo`000?l0003o02l0
003o00<0P83o0?ooo`3oool01`3oool00`0P8?l0003o0000o`0=0000o`03010@o`3oool0oooo00/0
oooo00<0<c?o0000o`000?l03@000?l00`0P8?l0oooo0?ooo`0:0?ooo`004@3oool00`20P?l0003o
0000o`0@0000o`03071`o`3oool0oooo00T0oooo00<0gmoo0000o`000?l03P000?l00`2o_ol0oooo
0?ooo`050?ooo`030=oOo`0@4?l0003o00h0003o00<0VIWo0?ooo`3oool01P3oool00`2o_ol0003o
0000o`0_0000o`030820o`3oool0oooo00L0oooo00<0D53o0000o`000?l03P000?l00`0c<ol0gmoo
0?ooo`090?ooo`0306IVo`000?l0003o00h0003o00<0IVKo0?ooo`3oool02P3oool00100oooo00<0
c<co0000o`000?l040000?l00`0@4?l0knoo0?ooo`0;0?oooa00003o00<0823o0<c<o`3oool01@3o
ool00`0c<ol0003o0000o`0>0000o`030;noo`3oool0oooo00H0oooo00<0_koo0000o`000?l0;`00
0?l00`20P?l0oooo0?ooo`070?ooo`0309VIo`000?l0003o00l0003o00<0413o09VIo`3oool01P3o
ool00`2o_ol0<c?o0000o`0@0000o`0309VIo`3oool0oooo00X0oooo000@0?ooo`0303<co`000?l0
003o0100003o00<0[joo0?ooo`3oool02`3oool00`10@?l0003o0000o`0>0000o`03010@o`1`L?l0
[joo0080_koo00<0L73o010@o`000?l040000?l90?ooo`030;noo`000?l0003o02l0003o00<0P83o
0?ooo`3oool01`3oool00`3_kol0003o0000o`0A0000o`04010@o`1VI_l0P83o09VIo`80P83o00<0
<c?o0000o`000?l04@000?l00`3_kol0oooo0?ooo`0:0?ooo`003`3oool00`2?Sol0003o0000o`0@
0000o`030410o`3oool0oooo00`0oooo00<0P83o0000o`000?l09@000?l00`10@?l0oooo0?ooo`07
0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0
oooo00P0oooo00<0D53o0000o`000?l0:@000?l00`1VI_l0oooo0?ooo`0;0?ooo`003`3oool00`0@
4?l0003o0000o`0?0000o`03010@o`3Ogol0oooo00d0oooo00<0c<co0000o`000?l09@000?l00`2?
Sol0oooo0?ooo`070?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000
o`030820o`3oool0oooo00P0oooo00<0_koo0000o`000?l0:@000?l00`2o_ol0oooo0?ooo`0;0?oo
o`003P3oool00`20P?l0003o0000o`0@0000o`0308n?o`3oool0oooo00h0oooo00<0823o0000o`00
0?l08`000?l00`0@4?l0knoo0?ooo`080?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0
003o0000o`0>0000o`030820o`3oool0oooo00T0oooo00<0<c?o0000o`000?l09`000?l00`10@?l0
oooo0?ooo`0<0?ooo`003P3oool00`0@4?l0003o0000o`0?0000o`0303<co`3oool0oooo00l0oooo
00<0VIWo0000o`000?l08`000?l00`1VI_l0oooo0?ooo`080?ooo`030;noo`000?l0003o00l0003o
3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0oooo00T0oooo00<0_koo0000o`000?l0
9`000?l00`3<c?l0oooo0?ooo`0<0?ooo`003@3oool00`2IVOl0003o0000o`0@0000o`030;noo`3o
ool0oooo0100oooo00<0823o0000o`000?l08P000?l00`3Ogol0oooo0?ooo`080?ooo`030;noo`00
0?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0oooo00X0oooo00<0
L73o0000o`000?l09@000?l00`1`L?l0oooo0?ooo`0=0?ooo`003@3oool00`0P8?l0003o0000o`0?
0000o`0306IVo`3oool0oooo0140oooo00<0VIWo0000o`000?l08@000?l00`20P?l0oooo0?ooo`09
0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0
oooo00X0oooo00<0knoo03<co`000?l090000?l00`0c<ol0knoo0?ooo`0>0?ooo`00303oool00`3<
c?l0003o0000o`0?0000o`03010@o`3_kol0oooo01<0oooo00<0@43o0000o`000?l07`000?l00`0c
<ol0knoo0?ooo`0:0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000
o`030820o`3oool0oooo00/0oooo00<0c<co010@o`000?l08P000?l00`0@4?l0c<co0?ooo`0?0?oo
o`00303oool00`2?Sol0003o0000o`0?0000o`03071`o`3oool0oooo01<0oooo00<0knoo010@o`00
0?l07P000?l00`0@4?l0c<co0?ooo`0;0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0
003o0000o`0>0000o`0308n?o`3oool0oooo00`0oooo00<0_koo0000o`000?l08@000?l00`2_[ol0
oooo0?ooo`0?0?ooo`00303oool00`10@?l0003o0000o`0?0000o`030=oOo`3oool0oooo01@0oooo
00<0c<co010@o`000?l07@000?l00`2IVOl0oooo0?ooo`0;0?ooo`030;noo`000?l0003o00l0003o
3`3oool00`10@?l0003o0000o`0>0000o`030;noo`3oool0oooo00d0oooo00<0VIWo010@o`000?l0
7`000?l00`2IVOl0oooo0?ooo`0@0?ooo`00303ooolA0000o`0303<co`3oool0oooo01H0oooo00<0
c<co010@o`000?l06`000?l00`2IVOl0oooo0?ooo`0<0?ooo`030>o_o`000?l0003o00l0003o00<0
knoo0?ooo`3oool0303oool00`0@4?l0003o0000o`0>0000o`030;noo`3oool0oooo00h0oooo00<0
c<co010@o`000?l070000?l00`0@4?l0_koo0?ooo`0B0?ooo`002`3oool00`3Ogol0003o0000o`0?
0000o`030820o`3oool0oooo01L0oooo00<0c<co03<co`000?l060000?l00`0@4?l0_koo0?ooo`0?
0?oooa40003o00<0_koo0?ooo`3oool02`3oool00`3_kol0003o0000o`0?0000o`030;noo`3oool0
oooo00l0oooo00<0gmoo0410o`000?l06P000?l00`0c<ol0gmoo0?ooo`0C0?ooo`002`3oool00`2o
_ol0003o0000o`0?0000o`030820o`3oool0oooo01P0oooo00<0knoo06IVo`000?l05P000?l00`10
@?l0gmoo0?ooo`0@0?ooo`03010@o`000?l0003o00h0003o00<0L73o0?ooo`3oool02`3oool00`2_
[ol0003o0000o`0?0000o`030=oOo`3oool0oooo0140oooo00<0Shoo010@o`000?l05P000?l00`0@
4?l0Ogoo0?ooo`0E0?ooo`002`3oool00`2o_ol0003o0000o`0?0000o`030820o`3oool0oooo01X0
oooo00<0_koo03<co`000?l04P000?l00`0P8?l0VIWo0?ooo`0B0?ooo`030410o`000?l0003o00h0
003o00<0413o0>o_o`3oool02`3oool00`10@?l0003o0000o`0?0000oaD0oooo00<0knoo06IVo`00
0?l050000?l00`1VI_l0gmoo0?ooo`0F0?ooo`002`3oool00`2o_ol0003o0000o`0?0000o`030410
o`3oool0oooo01`0oooo00<0_koo051@o`000?l03P000?l00`0c<ol0VIWo0?ooo`0D0?ooo`03071`
o`000?l0003o00l0003o00<0D53o0?ooo`3oool02@3oool00`2IVOl0003o0000o`0?0000o`0303<c
o`3oool0oooo01D0oooo00<0gmoo07moo`0P8?l03`000?l00`0P8?l0Ogoo0=oOo`0I0?ooo`002`3o
ool00`2o_ol0003o0000o`0@0000o`030;noo`3oool0oooo01d0oooo00@0knoo09VIo`1VI_l0<c?o
1`000?l0100P8?l0D53o08n?o`3OgolG0?ooo`0309VIo`000?l0003o0100003o00<0IVKo0?ooo`3o
ool01`3oool00`2IVOl0003o0000o`0@0000o`0306IVo`3oool0oooo01P0oooo00@0c<co08n?o`10
@?l0823o1`000?l0100P8?l0D53o07moo`3<c?lL0?ooo`002`3oool00`2o_ol0003o0000o`0@0000
o`03010@o`2o_ol0oooo02<0oooo00@0c<co0;noo`2o_ol0gmoo703oool00`3Ogol0003o0000o`0A
0000o`03020Po`2_[ol0oooo00@0oooo00<0gmoo06IVo`000?l04P000?l00`2IVOl0oooo0?ooo`0N
0?ooo`<0_koo00<0gmoo0?ooo`3oool07`3oool000`0oooo50000?l00`1VI_l0[joo0?ooo`030?oo
o`030;noo`1`L?l0c<co03`0oooo00<0823o0000o`000?l04P000?l01@0@4?l0@43o0410o`10@?l0
823o01D0003o00<0gmoo0?ooo`3oool0@`3oool000`0oooo00<0823o0000o`000?l06@000?l00`2o
_ol0oooo0?ooo`0j0?ooo`03071`o`000?l0003o02/0003o00<0@43o0?ooo`3oool0A03oool000`0
oooo00<0IVKo0000o`000?l06@000?l00`2o_ol0oooo0?ooo`0j0?ooo`030=oOo`000?l0003o02/0
003o00<0VIWo0?ooo`3oool0A03oool000`0oooo00<0[joo0000o`000?l06@000?l00`2o_ol0oooo
0?ooo`0k0?ooo`03051@o`000?l0003o02T0003o00<0823o0?ooo`3oool0A@3oool000d0oooo00<0
413o0000o`000?l060000?l00`2o_ol0oooo0?ooo`0k0?ooo`030;noo`000?l0003o02T0003o00<0
VIWo0?ooo`3oool0A@3oool000d0oooo00<0P83o0000o`000?l060000?l00`2o_ol0oooo0?ooo`0l
0?ooo`0306IVo`000?l0003o02L0003o00<0<c?o0?ooo`3oool0AP3oool000d0oooo00<0gmoo010@
o`000?l060000?l00`2o_ol0oooo0?ooo`0l0?ooo`030>o_o`0@4?l0003o02L0003o00<0c<co0?oo
o`3oool0AP3oool000h0oooo00<0P83o0000o`000?l05`000?l00`2o_ol0oooo0?ooo`0m0?ooo`03
0;noo`000?l0003o02D0003o00<0Shoo0?ooo`3oool0A`3oool000l0oooo00<0<c?o0000o`000?l0
5P000?l00`2o_ol0oooo0?ooo`0n0?ooo`0309VIo`000?l0003o02<0003o00<0IVKo0?ooo`3oool0
B03oool000l0oooo00<0c<co010@o`000?l05P000?l00`2o_ol0oooo0?ooo`0o0?ooo`03071`o`00
0?l0003o0240003o00<0<c?o0?ooo`3oool0B@3oool00100oooo00<0_koo0000o`000?l05@000?l0
0`2o_ol0oooo0?ooo`100?ooo`0306IVo`000?l0003o01l0003o00<0<c?o0>o_o`3oool0BP3oool0
0140oooo00<0VIWo010@o`000?l050000?l00`2o_ol0oooo0?ooo`110?ooo`0309VIo`000?l0003o
01d0003o00<0IVKo0>o_o`3oool0B`3oool00180oooo00<0c<co020Po`000?l04`000?l00`2o_ol0
oooo0?ooo`120?ooo`030;noo`0P8?l0003o01/0003o00<0Ogoo0?ooo`3oool0C03oool001<0oooo
00<0knoo06IVo`000?l04P000?l00`2o_ol0oooo0?ooo`130?ooo`030>o_o`1VI_l0003o01P0003o
00<0<c?o0<c<o`3oool0CP3oool001D0oooo00<0_koo0410o`000?l040000?l00`2o_ol0oooo0?oo
o`150?ooo`030<c<o`10@?l0003o01@0003o00<0823o09VIo`3oool0D03oool001L0oooo00<0_koo
051@o`000?l03P000?l00`2o_ol0oooo0?ooo`170?ooo`030<c<o`1VI_l0413o0100003o00<0D53o
0:n_o`3oool0DP3oool001T0oooo00@0knoo0:n_o`1VI_l0@43o20000?l0100@4?l0@43o07moo`3O
gom<0?ooo`040;noo`1oOol0@43o010@o`P0003o00@0@43o071`o`2_[ol0knooE@3oool001h0oooo
00<0knoo0;noo`2o_ol00`2o_omF0?ooo`030<c<o`2o_ol0_koo0080_koo00<0knoo0?ooo`3oool0
F03oool00001\
\>"],
            ImageRangeCache->{{{0, 217}, {87, 0}} -> {-0.00108501, 0.999385, 
            1.00001, 
            1.00001}}], \(This\ package\ includes\ routines\ which\ provide\ \
SNAP\ functionalities . \ 
              The\ version\ of\ this\ package\ is\ 0.2  .4\ and\ implemented\ \
by\ Kosaku\ \(\(NAGASAKA\)\(.\)\)\)}
        },
      RowAlignments->Top,
      ColumnAlignments->{Right, Left}]]]], "DefinitionBox",
  GeneratedCell->True,
  CellAutoOverwrite->True,
  Background->GrayLevel[1],
  CellTags->"b:0.0"],

Cell[BoxData[
    \("This package includes routines which export Mathematica's Graphics \
into FLASH format, implemented by Kosaku NAGASAKA."\)], "Print",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[1]:=",
  CellTags->"b:0.0"],

Cell["\<\
In this package, all the polynomials must be represented as the following \
SNAP structure, a set of polynomials around a representative polynomial.\
\>", "Text",
  CellTags->{"i:4", "b:0.0"}],

Cell[BoxData[
    \(TextForm\`\(\({f\&_ | 
        f\&_ \[Element] \[DoubleStruckCapitalC][u\_1, \ \[Ellipsis], \ 
            u\_r], \ \(deg\_u\) f\&_ = \(deg\_u\) 
          f\ \((\[ForAll] u \[Element] {u\_1, \ \[Ellipsis], \ 
                  u\_r})\), \ \(\(\[DoubleVerticalBar]\)\(f - 
          f\&_\)\(\[DoubleVerticalBar]\)\(\[LessEqual]\)\(\[Epsilon]\)\)}\)\(,\
\)\)\)], "DisplayMath",
  TextAlignment->Center,
  TextJustification->0,
  CellTags->"b:0.0"],

Cell[TextData[{
  "for the given polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`f\)]],
  " and the tolerance ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  " where ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(\[DoubleVerticalBar]\)\(p\)\(\[DoubleVerticalBar]\
\)\)\)]],
  " means a norm of polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`p\)]],
  ". Additionally, you can use ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s native precision and accuracy tracking system for coefficients of \
polynomials. Most of functions in this package can use with both tolerance \
systems."
}], "Text",
  CellTags->"b:0.0"],

Cell["\<\
Converting normal polynomials into SNAP structures is done by the following \
functions.\
\>", "Text",
  CellTags->"b:0.0"],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          RowBox[{"SNAP", "[", " ", 
            StyleBox["polynomial",
              FontSlant->"Italic"], 
            "]"}], \(gives\ a\ SNAP\ structure\ with\ an\ error\ bound\ \
automatically\ computed, \ the\ variables, \ 
          their\ degrees\ and\ the\ default\ error\ \(\(scheme\)\(.\)\)\)},
        {
          RowBox[{"SNAP", "[", " ", 
            RowBox[{
              StyleBox["polynomial",
                FontSlant->"Italic"], 
              StyleBox[",",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], 
              StyleBox[" ",
                FontSlant->"Italic"], 
              StyleBox[\(error\ bound\),
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
            RowBox[{
            "gives", " ", "a", " ", "SNAP", " ", "structure", " ", "with", 
              " ", "the", " ", "given", " ", 
              StyleBox["error",
                FontSlant->"Italic"], 
              StyleBox[" ",
                FontSlant->"Italic"], 
              StyleBox["bound",
                FontSlant->"Italic"]}], ",", " ", \(the\ variables\), ",", 
            " ", \(their\ degrees\ and\ the\ default\ error\ \
\(\(scheme\)\(.\)\)\)}]},
        {
          RowBox[{"SNAP", "[", " ", 
            RowBox[{
              StyleBox["polynomial",
                FontSlant->"Italic"], ",", " ", 
              StyleBox[\(error\ bound\),
                FontSlant->"Italic"], ",", " ", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{
                      StyleBox["var1",
                        FontSlant->"Italic"], ",", " ", 
                      StyleBox["deg1",
                        FontSlant->"Italic"]}], 
                    StyleBox["}",
                      FontSlant->"Italic"]}], ",", "\[Ellipsis]", ",", 
                  RowBox[{"{", 
                    RowBox[{
                      StyleBox["varr",
                        FontSlant->"Italic"], ",", 
                      StyleBox["degr",
                        FontSlant->"Italic"]}], "}"}]}], "}"}]}], "]"}], 
          RowBox[{
            RowBox[{
            "gives", " ", "a", " ", "SNAP", " ", "structure", " ", "with", 
              " ", "the", " ", "given", " ", 
              StyleBox["error",
                FontSlant->"Italic"], 
              StyleBox[" ",
                FontSlant->"Italic"], 
              StyleBox["bound",
                FontSlant->"Italic"]}], ",", " ", 
            RowBox[{
              StyleBox["variables",
                FontSlant->"Italic"], " ", "and", " ", "their", " ", 
              StyleBox["degrees",
                FontSlant->"Italic"], " ", "and", " ", "the", " ", "default", 
              " ", "error", " ", \(\(scheme\)\(.\)\)}]}]},
        {
          RowBox[{"SNAP", "[", " ", 
            RowBox[{
              StyleBox["polynomial",
                FontSlant->"Italic"], ",", " ", 
              StyleBox[\(error\ bound\),
                FontSlant->"Italic"], ",", " ", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{
                      StyleBox["var1",
                        FontSlant->"Italic"], ",", " ", 
                      StyleBox["deg1",
                        FontSlant->"Italic"]}], 
                    StyleBox["}",
                      FontSlant->"Italic"]}], ",", "\[Ellipsis]", ",", 
                  RowBox[{"{", 
                    RowBox[{
                      StyleBox["varr",
                        FontSlant->"Italic"], ",", 
                      StyleBox["degr",
                        FontSlant->"Italic"]}], "}"}]}], "}"}], 
              StyleBox[",",
                FontVariations->{"CompatibilityType"->0}], 
              StyleBox[" ",
                FontVariations->{"CompatibilityType"->0}], 
              StyleBox[\(error\ scheme\),
                FontSlant->"Italic",
                FontVariations->{"CompatibilityType"->0}]}], 
            StyleBox["]",
              FontVariations->{"CompatibilityType"->0}]}], 
          RowBox[{
            RowBox[{
            "gives", " ", "a", " ", "SNAP", " ", "structure", " ", "with", 
              " ", "the", " ", "given", " ", 
              StyleBox["error",
                FontSlant->"Italic"], 
              StyleBox[" ",
                FontSlant->"Italic"], 
              StyleBox["bound",
                FontSlant->"Italic"]}], ",", " ", 
            StyleBox["variables",
              FontSlant->"Italic"], ",", " ", 
            RowBox[{"their", " ", 
              StyleBox["degrees",
                FontSlant->"Italic"], " ", "and", " ", 
              StyleBox["error",
                FontSlant->"Italic"], 
              StyleBox[" ",
                FontSlant->"Italic"], 
              RowBox[{
                StyleBox["scheme",
                  FontSlant->"Italic"], "."}]}]}]}
        }]]]], "DefinitionBox",
  CellTags->"b:0.0"],

Cell["SNAP structure functions. ", "Caption",
  CellTags->"b:0.0"],

Cell["This gives a SNAP structure.", "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[2]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[TextData[{
  "This gives the ",
  ButtonBox["FullForm",
    ButtonStyle->"RefGuideLink"],
  " of the above SNAP structure."
}], "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FullForm[g]\)], "Input",
  CellLabel->"In[3]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    TagBox[
      StyleBox[\(SNAP[
          Plus[Rational[1509, 4000], Times[Rational[1381, 500], x], 
            Times[Rational[7647, 1000], Power[x, 2]], 
            Times[Rational[1953, 200], Power[x, 3]], 
            Times[Rational[5503, 1000], Power[x, 4]], Power[x, 5]], 
          1.537912594467733879419288314202518`14.30331501075744*^-15, 
          List[List[x, 5]], AbsolutePolynomial2Norm]\),
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[3]//FullForm=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell["\<\
All the functions in this package preserving SNAP structures guarantee the \
following relation for any operations. Hence, after an operation, its error \
bound must be increased.\
\>", "Text",
  CellTags->"b:0.0"],

Cell["\<\
\[ForAll]g\[Element]G and \[ForAll]h\[Element]H, \[Exists]f\[Element]F s.t. \
f=g\[CenterDot]h where F, G and H satisfying F=G\[CenterDot]H as SNAP \
structures.\
\>", "FramedBox",
  TextAlignment->Center,
  TextJustification->0,
  CellTags->"b:0.0"],

Cell[TextData[{
  "The error bound of this SNAP structure, a set of polynomials is given by \
",
  StyleBox["Tolerance",
    FontFamily->"Courier"],
  "."
}], "MathCaption",
  CellTags->{"i:5", "b:0.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g]\)], "Input",
  CellLabel->"In[4]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(1.537912594467733879419288314202518`14.30331501075744*^-15\)], "Output",\

  CellLabel->"Out[4]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell["Each calculation enlarges its error bound as follows.", "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2 = g*g\)], "Input",
  CellLabel->"In[5]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(\((\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + \
9.765`\ x\^3 + 5.503`\ x\^4 + x\^5)\)\^2\)], "Output",
  CellLabel->"Out[5]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g2]\)], "Input",
  CellLabel->"In[6]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(1.0463751274522413289474713`14.30331501075744*^-13\)], "Output",
  CellLabel->"Out[6]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[TextData[{
  "By ",
  StyleBox["Element",
    FontFamily->"Courier"],
  ", we can check whether a polynomial is included in the given SNAP \
structure or not. The error bound of the below SNAP structure is about ",
  Cell[BoxData[
      \(1.5379125945029852`*^-15\)]],
  ", hence we have the following results."
}], "MathCaption",
  CellTags->{"i:6", "b:0.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Element[Normal[g] + 1.5`16*^-15, g]\)], "Input",
  CellLabel->"In[9]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[9]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Element[Normal[g] + 1.6`16*^-15, g]\)], "Input",
  CellLabel->"In[10]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[10]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[TextData[{
  "In the above, ",
  StyleBox["Normal",
    FontFamily->"Courier"],
  " gives corresponding representative polynomials in the normal form."
}], "MathCaption",
  CellTags->{"i:7", "b:0.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Normal[g] // FullForm\)], "Input",
  CellLabel->"In[11]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    TagBox[
      StyleBox[\(Plus[Rational[1509, 4000], Times[Rational[1381, 500], x], 
          Times[Rational[7647, 1000], Power[x, 2]], 
          Times[Rational[1953, 200], Power[x, 3]], 
          Times[Rational[5503, 1000], Power[x, 4]], Power[x, 5]]\),
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[11]//FullForm=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell["\<\
For the SNAP structure, the package provides the following elementary \
functions.\
\>", "Text",
  CellTags->{"i:8", "b:0.0"}],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          RowBox[{"Tolerance", "[", " ", 
            StyleBox["expr",
              FontSlant->"Italic"], "]"}], 
          RowBox[{
          "gives", " ", "the", " ", "error", " ", "bound", " ", "of", " ", 
            RowBox[{
              StyleBox["expr",
                FontSlant->"Italic"], "."}]}]},
        {
          RowBox[{"Element", "[", " ", 
            RowBox[{
              StyleBox["expr",
                FontSlant->"Italic"], ",", " ", 
              StyleBox["stru",
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
            RowBox[{
            "gives", " ", "True", " ", "or", " ", "False", " ", "if", " ", 
              StyleBox["expr",
                FontSlant->"Italic"], " ", "is", " ", "included", " ", "in", 
              " ", 
              StyleBox["stru",
                FontSlant->"Italic"], " ", "or", " ", "not"}], ",", 
            " ", \(\(respectively\)\(.\)\)}]},
        {
          RowBox[{"Normal", "[", " ", 
            StyleBox["stru",
              FontSlant->"Italic"], "]"}], 
          RowBox[{
            RowBox[{
            "gives", " ", "the", " ", "representative", " ", "polynomial", 
              " ", "of", " ", 
              StyleBox["stru",
                FontSlant->"Italic"]}], ",", 
            " ", \(in\ the\ normal\ \(\(form\)\(.\)\)\)}]},
        {
          RowBox[{
            RowBox[{"SNAPQ", "[", " ", 
              StyleBox["expr",
                FontSlant->"Italic"], "]"}], " ", "and", " ", 
            RowBox[{"NotSNAPQ", "[", " ", 
              StyleBox["expr",
                FontSlant->"Italic"], "]"}]}], 
          RowBox[{
            RowBox[{
            "gives", " ", "True", " ", "of", " ", "False", " ", "if", " ", 
              StyleBox["expr",
                FontSlant->"Italic"], " ", "has", " ", "a", " ", "SNAP", " ", 
              "structure", " ", "or", " ", "not"}], ",", 
            " ", \(\(respectively\)\(.\)\)}]}
        }]]]], "DefinitionBox",
  CellTags->"b:0.0"],

Cell["SNAP elementary functions for the structure.", "Caption",
  CellTags->"b:0.0"],

Cell["\<\
In this package, the most notable characteristic is providing built-in \
functions expanded for SNAP structures.\
\>", "Text",
  CellTags->"b:0.0"],

Cell[TextData[StyleBox["Expand, NSolve, PolynomialQuotient, \
PolynomialRemainder, Normal, ReplaceAll, D, PolynomialReduce",
  FontFamily->"Courier"]], "FramedBox",
  CellTags->"b:0.0"],

Cell["SNAP compatible built-in functions", "Caption",
  CellTags->"b:0.0"],

Cell["This expands a product of SNAP structures.", "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2\)], "Input",
  CellLabel->"In[12]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(\((\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + \
9.765`\ x\^3 + 5.503`\ x\^4 + x\^5)\)\^2\)], "Output",
  CellLabel->"Out[12]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Expand[g2]\)], "Input",
  CellLabel->"In[13]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(\(\(0.1423175625`\)\(\[InvisibleSpace]\)\) + 2.083929`\ x + 
      13.3983055`\ x\^2 + 49.6097205`\ x\^3 + 116.5704825`\ x\^4 + 
      180.498982`\ x\^5 + 185.042107`\ x\^6 + 122.76759`\ x\^7 + 
      49.813009`\ x\^8 + 11.006`\ x\^9 + x\^10\)], "Output",
  CellLabel->"Out[13]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(SNAPQ[g2]\)], "Input",
  CellLabel->"In[14]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[14]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell["\<\
This gives all the roots of the given represetative polynomial with \
considerations of the error bound. We recommend you to compare the following \
two results. NSolve with a SNAP structure considers all the possible \
polynomials within the structure, hence their tolerances are larger than that \
of NSolve without a SNAP structure.\
\>", "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g == 0, x]\)], "Input",
  CellLabel->"In[15]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323233693630293112`12.407615040405513\)}, {x \
\[Rule] \(-0.9989903848991318032656328004`10.444596803913411\)}, {x \[Rule] \
\(-0.5412151824480374484`7.8952673893060785\)}, {x \[Rule] \
\(-0.4813611757602536895`7.990094526358402\) - 
            0.0294645370012453413`6.7769230881613085\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611757602536895`7.990094526358402\) + 
            0.0294645370012453413`6.7769230881613085\ \[ImaginaryI]}}\)], \
"Output",
  CellLabel->"Out[15]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[16]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \({1.17359067209884415906484606`14.311183702869375*^-12, 
      3.588926005055130327117290194`14.55149623130222*^-11, 
      6.88814977586837182100790896816`14.68058294939889*^-9, 
      6.9645254663058019001987684614`14.68083784411003*^-9, 
      6.9645254663058019001987684614`14.68083784411003*^-9}\)], "Output",
  CellLabel->"Out[16]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`NSolve[Normal[g] \[Equal] 0, x]\)], "Input",
  CellLabel->"In[19]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323225`\)}, {x \[Rule] \(-0.998990384899134`\
\)}, {x \[Rule] \(-0.5412151824480371`\)}, {x \[Rule] \(-0.48136117576025317`\
\) - 0.02946453700124859`\ \[ImaginaryI]}, {x \[Rule] \(-0.48136117576025317`\
\) + 0.02946453700124859`\ \[ImaginaryI]}}\)], "Output",
  CellLabel->"Out[19]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[20]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \({3.33074910000823053836814551428295`14.402674445050097*^-16, 
      1.10910212669416721696134260152239`14.389476498229513*^-16, 
      6.008695568305212868623124098097`14.229966603804716*^-17, 
      5.3541849581150122348540987955976`14.178540852175638*^-17, 
      5.3541849581150122348540987955976`14.178540852175638*^-17}\)], "Output",\

  CellLabel->"Out[20]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[TextData[{
  "In this case, PolynomialRemainder gives a pseudo zero number since ",
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  " can divide ",
  Cell[BoxData[
      \(TraditionalForm\`g2\)]],
  ". However, these polynomials have their error bounds and we can not argue \
that its remainder is completely zero, hence the following warning messages \
are generated."
}], "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \({g3, g4} = {PolynomialQuotient[g2, g, x], 
        PolynomialRemainder[g2, g, x]}\)], "Input",
  CellLabel->"In[23]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(SNAP::"invalid" \(\(:\)\(\ \)\) 
      "Tolerance is larger than the representing leading coefficient: \!\(0.`\
\) \[LessEqual] \!\(1.0292162141035635`*^-6\)."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[23]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(SNAP::"invalid" \(\(:\)\(\ \)\) 
      "Tolerance is larger than the representing leading coefficient: \!\(0.`\
\) \[LessEqual] \!\(1.0292162141035635`*^-6\)."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[23]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(SNAP::"invalid" \(\(:\)\(\ \)\) 
      "Tolerance is larger than the representing leading coefficient: \!\(0.`\
\) \[LessEqual] \!\(1.0292162141035635`*^-6\)."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[23]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(SNAP :: \\\"invalid\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[23]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \({\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
        9.765`\ x\^3 + 5.503`\ x\^4 + x\^5, 0``5.987493380603699}\)], "Output",\

  CellLabel->"Out[23]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[TextData[{
  "SNAP functions give normal ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " numbers if their degrees are not larger than zero."
}], "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \({SNAPQ[g3], SNAPQ[g4]}\)], "Input",
  CellLabel->"In[24]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \({True, False}\)], "Output",
  CellLabel->"Out[24]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell["\<\
Each operation or calculation enlarge error bounds, hence tolerances of the \
roots also are getting larger and larger as below.\
\>", "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g3 \[Equal] 0, x]\)], "Input",
  CellLabel->"In[25]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323233694`6.2306465993141655\)}, {x \[Rule] \
\(-0.9989903848991318033`5.434114855338267\)}, {x \[Rule] \
\(-0.5412151824480374484`3.9260922346825913\)}, {x \[Rule] \
\(-0.4813611757602536895`4.08331464508511\) - 
            0.0294645370012453413`2.870143206888019\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611757602536895`4.08331464508511\) + 
            0.0294645370012453413`2.870143206888019\ \[ImaginaryI]}}\)], \
"Output",
  CellLabel->"Out[25]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[26]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \({1.76394520485190070637574035984544`14.724754193445829*^-6, 
      3.67660059293547846037953621246252`14.857210209241426*^-6, 
      0.0000641619768854553415584505`14.969877986893863, 
      0.0000561916017665273804302229`14.963951575340827, 
      0.0000561916017665273804302229`14.963951575340827}\)], "Output",
  CellLabel->"Out[26]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell["\<\
The tolerance correction mechanism used in NSolve with SNAP structures \
suppose that the given representative polynomial does not have multiple \
roots. Therefore, the following warning message  is generated if the given \
polynomial has mupltiple roots and any tolerance correction is not applied.\
\>", "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g2 \[Equal] 0, x]\)], "Input",
  CellLabel->"In[27]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(SNAP::"multipleroots" \(\(:\)\(\ \)\) 
      "The given representative polynomial has multiple roots. Tolerances of \
the roots can not be computed."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[27]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323233693632654705`14.729158691352879\)}, {x \
\[Rule] \(-3.0000720811323233693632654705`14.729158691352879\)}, {x \[Rule] \
\(-0.9989903848991318032356922583`13.629769732003524\)}, {x \[Rule] \
\(-0.9989903848991318032356922583`13.629769732003524\)}, {x \[Rule] \
\(-0.5412151824480374498780858927`12.299124322812547\)}, {x \[Rule] \
\(-0.5412151824480374498780858927`12.299124322812547\)}, {x \[Rule] \
\(-0.4813611757602536887614781893`12.50853383781171\) - 
            0.0294645370012453425307476961`11.295362399614618\ \
\[ImaginaryI]}, {x \[Rule] \
\(-0.4813611757602536887614781893`12.50853383781171\) - 
            0.0294645370012453425307476961`11.295362399614618\ \
\[ImaginaryI]}, {x \[Rule] \
\(-0.4813611757602536887614781893`12.50853383781171\) + 
            0.0294645370012453425307476961`11.295362399614618\ \
\[ImaginaryI]}, {x \[Rule] \
\(-0.4813611757602536887614781893`12.50853383781171\) + 
            0.0294645370012453425307476961`11.295362399614618\ \
\[ImaginaryI]}}\)], "Output",
  CellLabel->"Out[27]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[TextData[{
  "The SNAP structures have the following options. These options are supposed \
to use fia ",
  StyleBox["SetOptions",
    FontFamily->"Courier"],
  "."
}], "Text",
  CellTags->"b:0.0"],

Cell[BoxData[
    FormBox[GridBox[{
          {Cell[BoxData[
                FormBox[
                  RowBox[{
                    StyleBox["\<\"option name\"\>",
                      "TI"], "\<\" \"\>"}], TraditionalForm]]], Cell[BoxData[
                FormBox[
                  RowBox[{
                    StyleBox["\<\"default value\"\>",
                      "TI"], "\<\" \"\>"}], TraditionalForm]]], Cell[BoxData[
                \(TraditionalForm\`\[Null]\)]]},
          {
            "DefaultErrorScheme", \(AbsolutePolynomial2Norm\), \(Scheme\ to\ \
compute\ norms\ of\ polynomials . \ In\ this\ version, \ 
            error\ schemes\ are\ AbsolutePolynomial2Norm, \ 
            AbsolutePolynomial1Norm\ and\ \
\(\(AbsolutePolynomialiNorm\)\(.\)\)\)},
          {"TolerancePrecision", 
            "MachinePrecision", \(Each\ error\ bound\ is\ represented\ in\ \
this\ \(\(precision\)\(.\)\)\)}
          },
        ColumnAlignments->{Left}], TraditionalForm]], "DefinitionBox3Col",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}},
  CellTags->"b:0.0"],

Cell["Options for SNAP.", "Caption",
  CellTags->"b:0.0"],

Cell["\<\
The error schemes are important for measuring existance domains of \
polynomials. This package also provides the following functions treating \
error schemes and tolerances.\
\>", "Text",
  CellTags->"b:0.0"],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          RowBox[{"SetTolerance", "[", " ", 
            RowBox[{
              StyleBox["stru",
                FontSlant->"Italic"], ",", " ", 
              StyleBox[\(error\ bound\),
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
          "gives", " ", "a", " ", "new", " ", "SNAP", " ", "structure", " ", 
            "of", " ", 
            StyleBox["stru",
              FontSlant->"Italic"], " ", "with", " ", 
            StyleBox["error",
              FontSlant->"Italic"], 
            StyleBox[" ",
              FontSlant->"Italic"], 
            RowBox[{
              StyleBox["bound",
                FontSlant->"Italic"], "."}]}]},
        {
          RowBox[{"TransformSNAP", "[", " ", 
            RowBox[{
              StyleBox["stru",
                FontSlant->"Italic"], ",", " ", 
              StyleBox[\(error\ scheme\),
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
          "gives", " ", "a", " ", "new", " ", "SNAP", " ", "structure", " ", 
            "of", " ", 
            StyleBox["stru",
              FontSlant->"Italic"], " ", "with", " ", 
            StyleBox["error",
              FontSlant->"Italic"], 
            StyleBox[" ",
              FontSlant->"Italic"], 
            RowBox[{
              StyleBox["scheme",
                FontSlant->"Italic"], "."}]}]}
        }]]]], "DefinitionBox",
  CellTags->"b:0.0"],

Cell["SNAP functions for their scheme and tolerance.", "Caption",
  CellTags->"b:0.0"],

Cell["Changing error schemes enlarge their error bounds.", "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g]\)], "Input",
  CellLabel->"In[28]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(1.537912594467733879419288314202518`14.30331501075744*^-15\)], "Output",\

  CellLabel->"Out[28]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g1 = TransformSNAP[g, AbsolutePolynomial1Norm]\)], "Input",
  CellLabel->"In[29]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[29]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g1]\)], "Input",
  CellLabel->"In[30]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(3.7671011254457795485523`14.30331501075744*^-15\)], "Output",
  CellLabel->"Out[30]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[TextData[{
  "For users with experimental data, this package provides the following \
approximate algebraic operations. We note that the following operations are \
",
  StyleBox["on preliminary stages",
    FontColor->RGBColor[1, 0, 0]],
  " and some operations do not give SNAP structures, but polynomials in the \
normal form, since these operations have been developed for such operations \
that calculate one exact algebraic value from approximate algebraic values."
}], "Text",
  CellTags->{"i:9", "b:0.0"}],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          RowBox[{"NearestSingularPolynomial", "[", " ", 
            StyleBox["expr",
              FontSlant->"Italic"], "]"}], 
          RowBox[{
            RowBox[{
            "gives", " ", "the", " ", "nearest", " ", "singular", " ", 
              "polynomial", " ", "to", " ", 
              StyleBox["expr",
                FontSlant->"Italic"], " ", "in", " ", "the", " ", 
              "polynomial", " ", "2"}], "-", \(\(norm\)\(.\)\)}]},
        {
          RowBox[{"PolynomialGCD", "[", " ", 
            RowBox[{
              StyleBox["g",
                FontSlant->"Italic"], ",", " ", 
              StyleBox["h",
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{\(gives\ an\ \[Epsilon]\), "-", 
            RowBox[{"GCD", " ", "of", " ", "polynomials", " ", 
              StyleBox["g",
                FontSlant->"Italic"], " ", "and", " ", 
              RowBox[{
                StyleBox["h",
                  FontSlant->"Italic"], ".", " ", "One"}], " ", "of", " ", 
              StyleBox["g",
                FontSlant->"Italic"], " ", "and", " ", 
              StyleBox["h",
                FontSlant->"Italic"], " ", "must", " ", "have", " ", "a", " ",
               "SNAP", " ", "structure", " ", "at", 
              " ", \(\(least\)\(.\)\)}]}]},
        {
          RowBox[{"ApproximateQuotient", "[", " ", 
            RowBox[{
              StyleBox["g",
                FontSlant->"Italic"], ",", " ", 
              StyleBox["h",
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
          "gives", " ", "an", " ", "approximate", " ", "quotient", " ", "of", 
            " ", 
            StyleBox["g",
              FontSlant->"Italic"], " ", "by", " ", 
            StyleBox["h",
              FontSlant->"Italic"], " ", "due", " ", "to", 
            " ", \(\(CGTW95\)\(.\)\)}]},
        {
          RowBox[{"ApproximateDivisorQ", "[", " ", 
            RowBox[{
              StyleBox["g",
                FontSlant->"Italic"], ",", " ", 
              StyleBox["h",
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
            RowBox[{
            "gives", " ", "True", " ", "or", " ", "False", " ", "if", " ", 
              StyleBox["h",
                FontSlant->"Italic"], " ", "divides", " ", 
              StyleBox["g",
                FontSlant->"Italic"], " ", "approximately", " ", "or", " ", 
              "not"}], ",", " ", "respectively", ",", 
            " ", \(due\ to\ \(\(CGTW95\)\(.\)\)\)}]},
        {
          RowBox[{
            FormBox[
              StyleBox["AbsolutelyIrreducibleQ",
                FontFamily->"Courier"],
              "TraditionalForm"], "[", " ", 
            RowBox[{
              StyleBox["g",
                FontSlant->"Italic"], ",", " ", 
              StyleBox["\[Epsilon]",
                FontSlant->"Italic"]}], "]"}], 
          FormBox[
            RowBox[{"gives", " ", 
              StyleBox["True",
                FontFamily->"Courier"], " ", "if", " ", "the", " ", 
              "polynomial", " ", Cell["g"], " ", "is", " ", "absolutely", " ",
               "irreducible", " ", "within", " ", "the", " ", "tolerance", 
              " ", 
              RowBox[{Cell["\[Epsilon]"], "."}]}],
            "TraditionalForm"]},
        {
          RowBox[{
            FormBox[
              StyleBox["SeparationBound",
                FontFamily->"Courier"],
              "TraditionalForm"], "[", " ", 
            StyleBox["g",
              FontSlant->"Italic"], "]"}], 
          FormBox[
            RowBox[{"computes", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "separation", " ", "bound", " ", 
              "of", " ", "the", " ", "given", " ", "polynomial", " ", 
              RowBox[{Cell["g"], "."}]}],
            "TraditionalForm"]},
        {
          RowBox[{
            FormBox[
              StyleBox["Factor",
                FontFamily->"Courier"],
              "TraditionalForm"], "[", " ", 
            StyleBox["g",
              FontSlant->"Italic"], "]"}], 
          FormBox[
            RowBox[{
            "factorizes", " ", "the", " ", "given", " ", "polynomial", " ", 
              Cell["g"], " ", \(\(numerically\)\(.\)\)}],
            "TraditionalForm"]},
        {
          FormBox[
            StyleBox[\(FactorList[\ g]\),
              FontFamily->"Courier"],
            "TraditionalForm"], 
          FormBox[
            RowBox[{"gives", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "list", " ", "of", " ", "pseudo", 
              " ", "factors", " ", "of", " ", "the", " ", "given", " ", 
              "polynomial", " ", 
              RowBox[{Cell["g"], "."}]}],
            "TraditionalForm"]}
        }]]]], "DefinitionBox",
  CellTags->"b:0.0"],

Cell["SNAP functions for experimental data.", "Caption",
  CellTags->"b:0.0"],

Cell[TextData[{
  "This gives the nearest singular polynomial of ",
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  "."
}], "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ng = NearestSingularPolynomial[g]\)], "Input",
  CellLabel->"In[31]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(SNAP::"preliminary" \(\(:\)\(\ \)\) 
      "Preliminary implemented function is called."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[31]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(0.3772035197483813701677578908898396818763600422140656721197769713561301\
7214794`62.15884992412265 + 
      2.7620229415240444334283504894063958576218693665264727856231377878387684\
7587559`63.230266896501476\ x + 
      7.6469886766205613576225041617310994650085222144475957978865060135373168\
1741195`63.898025741189215\ x\^2 + 
      9.7650055889452532941127029302322860194239056859654563607269875010535303\
9650503`64.24250602428043\ x\^3 + 
      5.5029972414322761523668220364701836077471614600933081235123015006948311\
0355289`64.2410391539356\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[31]=",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[TextData[{
  "Hence, ",
  Cell[BoxData[
      \(TraditionalForm\`ng\)]],
  " has a multiple root."
}], "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(x /. NSolve[ng \[Equal] 0, x]\)], "Input",
  CellLabel->"In[32]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \(SNAP::"multipleroots" \(\(:\)\(\ \)\) 
      "The given representative polynomial has multiple roots. Tolerances of \
the roots can not be computed."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[32]:=",
  CellTags->"b:0.0"],

Cell[BoxData[
    \({\(-3.\
00005313065094568375230434318607841057397433984142283781058763766680702446855`\
60.93312933438438\), \
\(-0.9993512817134660583032410448644260135642552612868565250016588763365995831\
3285`59.82710481423128\), \
\(-0.5164413724592175098972076648365735469193342793208424522206174451433216110\
0515`57.58427799035825\), \
\(-0.493575728304323450207034491791553778728861334943`29.47911010017004\), \
\(-0.493575728304323450207034491791551926818921531456`29.47911010017004\)}\)],\
 "Output",
  CellLabel->"Out[32]=",
  CellTags->"b:0.0"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["References", "Subsection",
  CellTags->{"b:0.1", "c:3"}],

Cell["\<\
[BL98] B. Beckermann and G. Labahn. When are two numerical polynomials \
relatively prime? J. Symb. Comput., 267:677-689, 1998.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[BLSSW04] A. Bostan, G. Lecerf, B. Salvy, E. Schost, and B. Wiebelt. \
Complexity Issues in Bivariate Polynomial Factorization. In Proceedings of \
the 2004 International Symposium on Symbolic and Algebraic Computation, ISSAC \
2004, pages 42-49, 2004.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[CGTW95] R. M. Corless, P. M. Gianni, B. M. Trager, and S. M. Watt. The \
singular value decomposition for polynomial systems. In Proceedings of the \
1995 International Symposium on Symbolic and Algebraic Computation, ISSAC \
'95, pages 195-207, 1995.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[CGHKW01] R. M. Corless, M. W. Giesbrecht, M. Hoeij, I. S. Kotsireas, and S. \
M. Watt. Towards factoring bivariate approximate polynomials. In Proceedings \
of the 2001 International Symposium on Symbolic and Algebraic Computation, \
ISSAC 2001, pages 85-92, 2001.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[EGL97] I. Z. Emiris, A. Galligo, and H. Lombardi. Certified approximate \
univariate gcds. J. Pure Appl. Algebra, 117&118:229-251, 1997.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[GR03] S. Gao and V. M. Rodrigues. Irreducibility of polynomials modulo p via \
Newton Polytopes. J. Number Theory, 101:32-47, 2003.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[GL96] G. H. Golub and C. F. V. Loan. Matrix Computations Third Edition, \
Johns Hopkins Series in the Mathematical Sciences. The Johns Hopkins \
University Press, Baltimore, 1996.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[HK98] M. A. Hitz and E. Kaltofen. Efficient algorithms for computing the \
nearest polynomial with constrained roots. In Proceedings of the 1998 \
International Symposium on Symbolic and Algebraic Computation, ISSAC '98, \
pages 236-243, 1998.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[HKL99] M. A. Hitz, E. Kaltofen, and Y. N. Lakshman. Efficient algorithms for \
computing the nearest polynomial with a real root and related problems. In \
Proceedings of the 1999 International Symposium on Symbolic and Algebraic \
Computation, ISSAC '99, pages 205-212, 1999.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[KS97] F. Kako and T. Sasaki. Proposal of \"effective floating-point number\" \
for approximate algebraic computation. preprint, 1997.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[Kal95] E. Kaltofen. Effective Noether irreducibility forms and applications. \
J. Computer and System Sciences, 50:274-295, 1995.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[KM03] E. Kaltofen and J. May. On Approximate Irreducibility of Polynomials \
in Several Variables. In Proceedings of the 2003 International Symposium on \
Symbolic and Algebraic Computation, ISSAC 2003, pages 161-168, 2003.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[KL96] N. Karmarkar and Y. N. Lakshman. Approximate polynomial greatest \
common divisors and nearest singular polynomials. In Proceedings of the 1996 \
International Symposium on Symbolic and Algebraic Computation, ISSAC '96, \
pages 35-39, 1996.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[MU88] Z. Mou-tan and R. Unbehauen. Approximate factorization of multivariate \
polynomials. Signal Processing, 14:141-152, 1988.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell[TextData[{
  "[Nag05] K. Nagasaka. SNAP. International ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " Symposium 2005, IMS 2005. "
}], "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[Nag04a] K. Nagasaka. SNAP Package(Talk in Japanese). JSSAC 2004. 2004.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[Nag04b] K. Nagasaka. SNAP Package and Its Applications. ATCM 2004. 2004.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[Nag04c] K. Nagasaka.  Towards More Accurate Separation Bounds of Empirical \
Polynomials. SIGSAM Bulletin, Formally Reviewed Articles, 38(4):119-129, \
2004.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[Nag03] K. Nagasaka. Neighborhood Irreducibility Testing of Multivariate \
Polynomials. In Proc. Computer Algebra in Scientific Computing, CASC2003, \
pages 283-292, 2003.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[Nag02] K. Nagasaka. Towards Certified Irreducibility Testing of Bivariate \
Approximate Polynomials. In Proc. International Symposium on Symbolic and \
Algebraic Computation, ISSAC2002, pages 192-199, 2002.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[Pan98] V. Y. Pan. Approximate polynomial gcds, pad'e approximation, \
polynomial zeros and bipartite graphs. In Proc. Ninth Annual ACM-SIAM Symp. \
on Discrete Algorithms, pages 68-77, 1998.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[Pan01] V. Y. Pan. Computation of approximate polynomial gcds and an \
extension. Inform. and Comput., 167(2):71-85, 2001.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell[TextData[{
  "[Rup99] W. M. Ruppert. Reducibility of polynomials ",
  Cell[BoxData[
      \(TraditionalForm\`f(x, y)\)]],
  " modulo ",
  Cell[BoxData[
      \(TraditionalForm\`p\)]],
  ". J. Number Theory, 77:62-70, 1999."
}], "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[Sas01] T. Sasaki. Approximate multivariate polynomial factorization based on \
zero-sum relations. In Proceedings of the 2001 International Symposium on \
Symbolic and Algebraic Computation, ISSAC 2001, pages 284-291.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[Smi70] B. Smith. Error bounds for zeros of a polynomial based upon \
Gerschgorin's theorems. J. Assoc. Comput. Mach., 17:661-674, 1970.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[TS00] A. Terui and T. Sasaki. \"approximate zero-points\" of real univariate \
polynomial with large error terms. IPSJ J., 41:974-989, 2000.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[WSZ00] Y. H. W. Wu, H. J. Stetter, and L. Zhi. Pseudofactors of multivariate \
polynomials. In Proceedings of the 2000 International Symposium on Symbolic \
and Algebraic Computation, ISSAC 2000, pages 161-168, 2000.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[ZW98] L. Zhi and W. Wu. Nearest singular polynomials. J. Symbolic Comput., \
26(6):667-675, 1998.\
\>", "Reference",
  CellTags->"b:0.1"],

Cell["\<\
[ZWNK01] L. Zhi, W. Wu, M.-T. Noda, and H. Kai. Hybrid method for computing \
the nearest singular polynomials. MM Research Preprints, 20:229-239, 2001.\
\>", "Reference",
  CellTags->"b:0.1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Document for IMS 2005", "Section",
  CellTags->"c:4"],

Cell[CellGroupData[{

Cell["Introduction", "Subsection",
  CellTags->{"b:1.0", "c:5"}],

Cell[TextData[{
  "Recently, there are a lot of results in the area called Symbolic Numeric \
Algebra, especially for polynomials (for example, approximate GCD for \
univariate polynomials [Pan98, Pan01, BL98, EGL97] and approximate \
factorization for bivariate polynomials [CGHKW01, MU88, Sas01, WSZ00]). We \
think that those results have been getting practical qualities, and we should \
combine them and implement it into integrated one computer algebra system \
such as ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ". In fact, ",
  StyleBox["Maple",
    FontSlant->"Italic"],
  " has such a special package called \[OpenCurlyDoubleQuote]SNAP\
\[CloseCurlyDoubleQuote] (Symbolic-Numeric Algorithms for Polynomials). \
Unfortunately, there is no such a package for ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ", currently, except for this package."
}], "Text",
  CellTags->"b:1.0"],

Cell[TextData[{
  "We have been developing our \[OpenCurlyDoubleQuote]SNAP",
  "\[CloseCurlyDoubleQuote]",
  " package for ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ", and it is an abbreviation for Symbolic Numeric ",
  StyleBox["Algebra",
    FontWeight->"Bold"],
  " for Polynomials. By Algebra, we mean that continuous capabilities of \
approximate operations: for example, computing an approximate GCD between an \
empirical polynomial and a polynomial which is the nearest singular \
polynomial computed by SNAP functions, of another empirical polynomial. This \
continuous applicability is more important for practical computations. \
Especially for average users, it is more important than the number of \
algorithms that are already implemented."
}], "Text",
  CellTags->"b:1.0"],

Cell[TextData[{
  "Our aim of this package is providing practical implementations of SNAP \
functions with an unified tolerance mechanism for polynomials like ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s floating-point numbers or Kako and Sasaki's effective floating-point \
number [KS97]. Our idea is very simple. We only have to add 1) new data \
structures representing such polynomials with tolerances, 2) basic \
calculation routines for the structures and 3) SNAP functions for the \
structures. We note that the package does not have enough functionality yet \
for now, comparing with ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s floating-point numbers, since the package is an on-going project (we \
have a plan on which the version 1.0 will be released on Mar. 2007). At this \
time, simple tolerance representations, ",
  Cell[BoxData[
      \(TraditionalForm\`l\^2\)]],
  "-norm, ",
  Cell[BoxData[
      \(TraditionalForm\`l\^1\)]],
  "-norm and ",
  Cell[BoxData[
      \(TraditionalForm\`l\^\[Infinity]\)]],
  "-norm for coefficients vectors of polynomials, and a few SNAP functions \
are only implemented."
}], "Text",
  CellTags->"b:1.0"],

Cell["\<\
We note that this research is partly helped by Grants-in-Aid for Scientific \
Research, Ministry of Education, Culture, Sports, Science and Technology, \
JAPAN, #16700016.\
\>", "Text",
  CellTags->"b:1.0"]
}, Closed]],

Cell[CellGroupData[{

Cell["Tolerance Mechanisms and Implementations", "Subsection",
  CellTags->{"i:10", "b:1.1", "c:6"}],

Cell[TextData[{
  "First of all, we introduce a framework of our package, which includes SNAP \
structures and its implementations by using ",
  ButtonBox["UpSetDelayed",
    ButtonStyle->"RefGuideLink"],
  ", ",
  ButtonBox["Format",
    ButtonStyle->"RefGuideLink"],
  " and others."
}], "Text",
  CellTags->"b:1.1"],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {Cell["function"], Cell["purpose"]},
          {
            StyleBox["SNAP",
              
              FontFamily->
                "Courier"], \(converts\ the\ given\ polynomial\ to\ its\ SNAP\
\ \(\(representation\)\(.\)\)\)},
          {
            StyleBox["Normal",
              
              FontFamily->
                "Courier"], \(converts\ the\ given\ SNAP\ representation\ to\ \
its\ normal\ polynomial\ \(\(expression\)\(.\)\)\)},
          {
            StyleBox["SNAPQ",
              FontFamily->"Courier"], 
            RowBox[{
            "tests", " ", "whether", " ", "the", " ", "given", " ", 
              "expression", " ", "is", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "SNAP", " ", "structure", " ", 
              "or", " ", \(\(not\)\(.\)\)}]},
          {
            StyleBox["Tolerance",
              
              FontFamily->
                "Courier"], \(gives\ the\ tolerance\ of\ the\ given\ SNAP\ \(\
\(structure\)\(.\)\)\)},
          {
            StyleBox["SetTolerance",
              
              FontFamily->
                "Courier"], \(overwrite\ the\ tolerance\ of\ the\ given\ SNAP\
\ \(\(structure\)\(.\)\)\)},
          {
            StyleBox["TransformSNAP",
              
              FontFamily->
                "Courier"], \(converts\ the\ given\ SNAP\ structure\ with\ \
another\ scheme\ to\ that\ with\ the\ given\ \(\(scheme\)\(.\)\)\)},
          {
            "Element", \(tests\ whether\ the\ given\ polynomial\ is\ in\ the\ \
given\ SNAP\ structure\ or\ \(\(not\)\(.\)\)\)},
          {
            "Expand", \(the\ same\ effect\ as\ the\ builtin\ \
\(\(function\)\(.\)\)\)},
          {
            "ReplaceAll", \(the\ same\ effect\ as\ the\ builtin\ \(\(function\
\)\(.\)\)\)}
          }], TraditionalForm]], "DisplayFormula",
  GridBoxOptions->{RowLines->{2, 0.5},
  ColumnLines->True},
  CellTags->"Groups:classical groups"]], "DefinitionBox",
  CellTags->"b:1.1"],

Cell[TextData[{
  StyleBox["Table ", "SB"],
  StyleBox[
  CounterBox["NumberedTable"], "SB"],
  StyleBox[". ", "SB"],
  "Basic Functions"
}], "SmallTextSans",
  CellMargins->{{27, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[CellGroupData[{

Cell["Tolerance Examples", "Subsubsection",
  ShowCellBracket->True,
  CellTags->"b:1.1"],

Cell["\<\
We show some examples of the package, about its tolerance mechanism. At \
first, this loads the package.\
\>", "Text",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[1]:=",
  CellTags->"b:1.1"],

Cell[TextData[Cell[BoxData[GridBox[{
        {Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .40092 
%%ImageSize: 218 88 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
4.33681e-19 0.00460829 -0.00460829 0.00460829 [
[ 0 0 0 0 ]
[ 1 .40092 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .40092 L
0 .40092 L
closepath
clip
newpath
% Start of colorimage (RGB)
p
0 -0.00461 translate
1.00461 .40553 scale
654 string
218 88 8 [218 0 0 88 0 0] {
\tcurrentfile
\t1 index
\treadhexstring
\tpop
}  false 3 Mcolorimage
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF4040FF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF
7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF2020FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF1010FF4040FF4040FF4040FF4040FF4040FF1010FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FF
7070FF9999FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF
BFBFFF8F8FFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF7F7FFFAFAFFFBFBFFF
EFEFFFFFFFFFFFFFFFFFFFFFCCCCFFBFBFFF8F8FFF6666FF2020FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FFDFDFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF9999FF3333FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF8F8FFF2020FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF3333FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
BFBFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8FFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFBFBFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF3333FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFFF1010FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF
1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
AFAFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFEFEFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6666FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFDFDFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF1010FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFF
FFFFFFEFEFFFBFBFFFBFBFFFBFBFFFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFDFDFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFFFFFFFFFFFFEFEFFF
BFBFFFBFBFFFBFBFFFBFBFFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
EFEFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFDFDFFF7070FF
2020FF0000FF0000FF0000FF0000FF0000FF1010FF7070FFEFEFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF8F8FFF3333FF0000FF
0000FF0000FF0000FF0000FF0000FF3333FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFCCCCFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFDFDFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF8F8FFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFEFEFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F7FFF7F7FFF7F7FFF
7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF
DFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FFEFEFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFCCCCFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8F8FFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFCCCCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFEFEFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF7070FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFCCCCFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF8F8FFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFAFAFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF7070FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8FFF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF2020FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5050FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
BFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFAFAFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
BFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3333FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF2020FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
7070FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
DFDFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFDFDFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFDFDFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6666FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFCCCCFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FF
EFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF2020FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF3333FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FF9999FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF3333FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFAFAFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF1010FF7070FFAFAFFFBFBFFFBFBFFF7070FF
1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFEFEFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FF
6666FF8080FF9999FF8080FF8080FF3333FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF8F8FFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFDFDFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFCCCCFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8F8FFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF1010FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFCCCCFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF7070FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF3333FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFEFEFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
CCCCFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF1010FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF3333FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFCCCCFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
8F8FFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF7070FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFEFEFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF1010FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFAFAFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF1010FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF3333FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFEFEFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFEFEFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF1010FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF3333FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFBFBFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF
4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF3333FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF6666FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFDFDFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF7070FFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF8F8FFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF1010FF7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF3333FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FF9999FFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFEFEFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFEFEFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF6666FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
BFBFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF3333FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF5050FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF3333FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFDFDFFF7F7FFF2020FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FF7F7FFF
DFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFEFEFFF9999FF6666FF3333FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF2020FF5050FF8F8FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF8F8FFF4040FF2020FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF2020FF5050FF7F7FFFCCCCFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF1010FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFFBFBFFFBFBFFFDFDFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFDFDFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
2020FFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF6666FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFBFBFFFBFBFFFBFBFFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FFAFAFFFFFFFFFFFFFFF
FFFFFFFFFFFFBFBFFF7070FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF1010FF4040FF4040FF4040FF2020FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
AFAFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5050FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF2020FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6666FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF3333FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFDFDFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF1010FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6666FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFEFEFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF1010FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FFEFEFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF2020FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFBFBFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF7F7FFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF6666FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFEFEFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF3333FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF4040FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFCCCCFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF2020FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF
5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF6666FF1010FF0000FF0000FF0000FF
0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF5050FFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFEFEFFFAFAFFF6666FF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF
0000FF1010FF4040FF7F7FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF7F7FFF4040FF
1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FF7070FFAFAFFF
EFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFFBFBFFFBFBFFFBFBFFFBFBFFFBFBFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFCCCCFFBFBFFFBFBFFFBFBFFFBFBFFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
FFFFFFFFFFFF
pop
P
% End of image
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
            ImageSize->{218, 88},
            ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003J0000F2000`400?l00000o`00003ofP000?l0
0=X0003o003J0000o`00fP000?l009h0003o00<0@43o07moo`1oOol03@1oOol00`0P8?l0003o0000
o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o02T0003o002N0000
o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0:@000?l009h0003o00<0P83o0?ooo`3o
ool03@3oool00`10@?l0003o0000o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`030410
o`000?l0003o02T0003o002N0000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0:@00
0?l009h0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0Y0000o`00WP000?l00`20
P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o02T0003o002N0000o`030820o`3oool0oooo00d0
oooo00<0@43o0000o`000?l0:@000?l009h0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o
0000o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o02T0003o002N
0000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0:@000?l009h0003o00<0P83o0?oo
o`3oool03@3oool00`10@?l0003o0000o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`03
0410o`000?l0003o02T0003o002N0000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0
:@000?l009h0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0Y0000o`0040000?l0
0`0@4?l0@43o0410o`030410o`03010@o`000?l0003o08D0003o00<0P83o0?ooo`3oool03@3oool0
0`10@?l0003o0000o`0Y0000o`002`000?l0100P8?l0L73o09VIo`3<c?l80?ooo`040>o_o`2o_ol0
Shoo051@oh<0003o00<0P83o0?ooo`3oool03@3oool01`10@?l0003o0000o`1oOol0[joo0;noo`3_
kol00`3oool01@3<c?l0_koo08n?o`1VI_l0823o01d0003o00090000o`0306IVo`3Ogol0oooo0100
oooo00<0VIWo03<co`000?l04@000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0
003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0
oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0
003o0000o`0<0?ooo`030=oOo`2?Sol0823o01X0003o00090000o`030820o`3oool0oooo0180oooo
00<0_koo03<co`000?l03`000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o
3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo
0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o
0000o`0?0?ooo`030;noo`10@?l0003o01L0003o00090000o`030820o`3oool0oooo01@0oooo00<0
Shoo0000o`000?l03@000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3o
ool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?oo
o`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000
o`0A0?ooo`030;noo`0P8?l0003o01D0003o00090000o`030820o`3oool0oooo01D0oooo00<0c<co
010@o`000?l030000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool0
0`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>
0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0C
0?ooo`03071`o`000?l0003o01<0003o00090000o`030820o`3oool0oooo01H0oooo00<0knoo03<c
o`000?l02`000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o
_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?oo
o`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0D0?oo
o`030:n_o`0@4?l0003o0180003o00090000o`030820o`3oool0oooo01L0oooo00<0c<co010@o`00
0?l02P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0
003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`03
0820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0E0?ooo`03
0<c<o`0@4?l0003o0140003o00090000o`030820o`3oool0oooo01P0oooo00<0[joo0000o`000?l0
2@000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o
0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820
o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0F0?ooo`030<c<
o`0@4?l0003o0100003o00090000o`030820o`3oool0oooo01T0oooo00<0IVKo0000o`000?l02000
0?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000
o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`00
0?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0G0?ooo`030<c<o`0@
4?l0003o00l0003o00090000o`030820o`3oool0oooo01T0oooo00<0knoo010@o`000?l020000?l0
0`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`06
0000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0
003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0H0?ooo`0309VIo`000?l0
003o00h0003o00090000o`030820o`3oool0oooo01X0oooo00<0P83o0000o`000?l01`000?l00`20
P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000
o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o
00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0I0?ooo`0306IVo`000?l0003o
00d0003o00090000o`030820o`3oool0oooo01X0oooo00<0gmoo0000o`000?l01`000?l00`20P?l0
oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`03
0410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0
003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0I0?ooo`030>o_o`0@4?l0003o00d0
003o00090000o`030820o`3oool0oooo01/0oooo00<0<c?o0000o`000?l01P000?l00`20P?l0oooo
0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410
o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o
00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0J0?ooo`0309VIo`000?l0003o00`0003o
00090000o`030820o`3oool0oooo01/0oooo00<0P83o0000o`000?l01P000?l00`20P?l0oooo0?oo
o`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3o
ool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0
P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0K0?ooo`03020Po`000?l0003o00/0003o0009
0000o`030820o`3oool0oooo01/0oooo00<0_koo0000o`000?l01P000?l00`20P?l0oooo0?ooo`0=
0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0
oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o
0?ooo`3oool03@3oool00`10@?l0003o0000o`0K0?ooo`0309VIo`000?l0003o00/0003o00090000
o`050820o`3oool0oooo0?ooo`3_kol00`2o_ol00`3<c?l0oooo0?ooo`0C0?ooo`030=oOo`000?l0
003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`080000o`l0oooo00<0_koo
0000o`000?l01P000?l00`10@?l0oooo0?ooo`0?0?ooo`l0003o00<0_koo0?ooo`3oool03P3oool0
0`20P?l0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l00P3oool0
0`3_kol0_koo0;noo`020;noo`030>o_o`3oool0oooo0140oooo00<0knoo0000o`000?l02`000?l0
00T0003o00@0P83o0=oOo`1`L?l0823o1@000?l00`0@4?l0L73o0>o_o`0C0?ooo`P0003o00<0P83o
0?ooo`3oool03@3oool00`10@?l0003o0000o`080000o`l0oooo00<0_koo0000o`000?l01P000?l0
0`10@?l0oooo0?ooo`0?0?ooo`l0003o00<0_koo0?ooo`3oool03P3oool00`20P?l0003o0000o`06
0000o`030820o`3oool0oooo00d0oooo00D0@43o0000o`000?l0Shoo03<co`060000o`0303<co`2I
VOl0oooo0140oooo00<0D53o0000o`000?l02P000?l000T0003o00<0413o0000o`000?l020000?l0
0`0@4?l0c<co0?ooo`0A0?ooo`P0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`08
0000o`l0oooo00<0_koo0000o`000?l01P000?l00`10@?l0oooo0?ooo`0?0?ooo`l0003o00<0_koo
0?ooo`3oool03P3oool00`20P?l0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o
0000o`000?l02P000?l00`0c<ol0gmoo0?ooo`0?0?ooo`0308n?o`000?l0003o00X0003o000E0000
o`03010@o`3_kol0oooo0100oooo20000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o
00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`1oOol00`3O
gol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10
@?l0003o0000o`0;0000o`03020Po`3_kol0oooo00h0oooo00<0c<co0000o`000?l02P000?l001H0
003o00<0Shoo0?ooo`3oool03`3oool80000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`00
0?l020000?l?0?ooo`030;noo`000?l0003o00H0003o00<0@43o0?ooo`3oool0;`3oool00`20P?l0
003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l030000?l00`10@?l0
oooo0?ooo`0>0?ooo``0003o000F0000o`030820o`3oool0oooo00l0oooo20000?l00`20P?l0oooo
0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410
o`3oool0oooo02l0oooo00<0P83o0000o`000?l01P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410
o`000?l0003o00d0003o00<0c<co0?ooo`3oool03@3oool00`10@?l0003o0000o`090000o`005P00
0?l00`20P?l0oooo0?ooo`0>0?ooo`030>o_o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3o
ool00`10@?l0003o0000o`080000o`l0oooo00<0_koo0000o`000?l01P000?l00`10@?l0oooo0?oo
o`0_0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000
o`0=0000o`03071`o`3oool0oooo00d0oooo00<0@43o0000o`000?l02@000?l001H0003o00<0c<co
0?ooo`3oool03P3oool00`2o_ol0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o
0000o`000?l020000?l?0?ooo`030;noo`000?l0003o00H0003o00<0@43o0?ooo`3oool0;`3oool0
0`20P?l0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l03@000?l0
0`10@?l0oooo0?ooo`0=0?ooo`0306IVo`000?l0003o00T0003o000E0000o`03020Po`3oool0oooo
00l0oooo00<0Shoo0000o`000?l01P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o
00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo02l0oooo00<0P83o0000
o`000?l01P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00d0003o00<0<c?o0?oo
o`3oool03@3oool00`20P?l0003o0000o`090000o`005@000?l00`2_[ol0oooo0?ooo`0?0?ooo`03
051@o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`080000o`l0
oooo00<0_koo0000o`000?l01P000?l00`10@?l0oooo0?ooo`0_0?ooo`030820o`000?l0003o00H0
003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0=0000o`03020Po`3oool0oooo00d0
oooo00<0P83o0000o`000?l02@000?l001@0003o00<0@43o0?ooo`3oool0403oool90000o`030820
o`3oool0oooo00d0oooo00<0@43o0000o`000?l020000?l?0?ooo`030;noo`000?l0003o00H0003o
00<0@43o0?ooo`3oool0;`3oool00`20P?l0003o0000o`060000o`03071`o`3oool0oooo00d0oooo
00<0L73o0000o`000?l03@000?l00`10@?l0oooo0?ooo`0=0?ooo`030820o`000?l0003o00T0003o
000D0?ooo`03020Po`000?l0003o00l0003o00<0IVKo0?ooo`3oool01`3oool00`20P?l0003o0000
o`0=0000o`030;noo`3oool0oooo00P0oooo3`000?l00`10@?l0oooo0?ooo`060?ooo`030;noo`00
0?l0003o02l0003o00<0P83o0?ooo`3oool01P3oool00`2o_ol0003o0000o`0=0000o`0306IVo`3o
ool0oooo00d0oooo00<0Shoo0000o`000?l03@000?l00`2_[ol0oooo0?ooo`090?ooo`004`3oool0
0`1`L?l0003o0000o`0@0000o`030;noo`3oool0oooo00L0oooo00<0VIWo0000o`000?l03@000?l0
0`2o_ol0oooo0?ooo`080?ooo`l0003o00<0P83o0?ooo`3oool01P3oool00`2o_ol0003o0000o`0_
0000o`030820o`3oool0oooo00H0oooo00<0_koo0000o`000?l03@000?l00`0P8?l0oooo0?ooo`0=
0?ooo`03051@o`000?l0003o00d0003o00<0_koo0?ooo`3oool02@3oool00180oooo00<0_koo0000
o`000?l040000?l00`10@?l0oooo0?ooo`080?ooo`030;noo`000?l0003o00d0003o00<0P83o0?oo
o`3oool01`3oool00`2_[ol0003o0000o`0=0000o`030820o`3oool0oooo00H0oooo00<0_koo0000
o`000?l0;`000?l00`20P?l0oooo0?ooo`070?oooa00003o00<0VIWo0?ooo`3oool02`3oool00`3O
gol0003o0000o`0>0000o`030>o_o`3oool0oooo00T0oooo000B0?ooo`03020Po`000?l0003o0100
003o00<0gmoo0?ooo`3oool0203oool00`2o_ol0003o0000o`0=0000o`030410o`3oool0oooo00L0
oooo00<0IVKo0000o`000?l03@000?l00`20P?l0oooo0?ooo`060?ooo`030;noo`000?l0003o02l0
003o00<0P83o0?ooo`3oool01`3oool00`0P8?l0003o0000o`0=0000o`03010@o`3oool0oooo00/0
oooo00<0<c?o0000o`000?l03@000?l00`0P8?l0oooo0?ooo`0:0?ooo`004@3oool00`20P?l0003o
0000o`0@0000o`03071`o`3oool0oooo00T0oooo00<0gmoo0000o`000?l03P000?l00`2o_ol0oooo
0?ooo`050?ooo`030=oOo`0@4?l0003o00h0003o00<0VIWo0?ooo`3oool01P3oool00`2o_ol0003o
0000o`0_0000o`030820o`3oool0oooo00L0oooo00<0D53o0000o`000?l03P000?l00`0c<ol0gmoo
0?ooo`090?ooo`0306IVo`000?l0003o00h0003o00<0IVKo0?ooo`3oool02P3oool00100oooo00<0
c<co0000o`000?l040000?l00`0@4?l0knoo0?ooo`0;0?oooa00003o00<0823o0<c<o`3oool01@3o
ool00`0c<ol0003o0000o`0>0000o`030;noo`3oool0oooo00H0oooo00<0_koo0000o`000?l0;`00
0?l00`20P?l0oooo0?ooo`070?ooo`0309VIo`000?l0003o00l0003o00<0413o09VIo`3oool01P3o
ool00`2o_ol0<c?o0000o`0@0000o`0309VIo`3oool0oooo00X0oooo000@0?ooo`0303<co`000?l0
003o0100003o00<0[joo0?ooo`3oool02`3oool00`10@?l0003o0000o`0>0000o`03010@o`1`L?l0
[joo0080_koo00<0L73o010@o`000?l040000?l90?ooo`030;noo`000?l0003o02l0003o00<0P83o
0?ooo`3oool01`3oool00`3_kol0003o0000o`0A0000o`04010@o`1VI_l0P83o09VIo`80P83o00<0
<c?o0000o`000?l04@000?l00`3_kol0oooo0?ooo`0:0?ooo`003`3oool00`2?Sol0003o0000o`0@
0000o`030410o`3oool0oooo00`0oooo00<0P83o0000o`000?l09@000?l00`10@?l0oooo0?ooo`07
0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0
oooo00P0oooo00<0D53o0000o`000?l0:@000?l00`1VI_l0oooo0?ooo`0;0?ooo`003`3oool00`0@
4?l0003o0000o`0?0000o`03010@o`3Ogol0oooo00d0oooo00<0c<co0000o`000?l09@000?l00`2?
Sol0oooo0?ooo`070?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000
o`030820o`3oool0oooo00P0oooo00<0_koo0000o`000?l0:@000?l00`2o_ol0oooo0?ooo`0;0?oo
o`003P3oool00`20P?l0003o0000o`0@0000o`0308n?o`3oool0oooo00h0oooo00<0823o0000o`00
0?l08`000?l00`0@4?l0knoo0?ooo`080?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0
003o0000o`0>0000o`030820o`3oool0oooo00T0oooo00<0<c?o0000o`000?l09`000?l00`10@?l0
oooo0?ooo`0<0?ooo`003P3oool00`0@4?l0003o0000o`0?0000o`0303<co`3oool0oooo00l0oooo
00<0VIWo0000o`000?l08`000?l00`1VI_l0oooo0?ooo`080?ooo`030;noo`000?l0003o00l0003o
3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0oooo00T0oooo00<0_koo0000o`000?l0
9`000?l00`3<c?l0oooo0?ooo`0<0?ooo`003@3oool00`2IVOl0003o0000o`0@0000o`030;noo`3o
ool0oooo0100oooo00<0823o0000o`000?l08P000?l00`3Ogol0oooo0?ooo`080?ooo`030;noo`00
0?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0oooo00X0oooo00<0
L73o0000o`000?l09@000?l00`1`L?l0oooo0?ooo`0=0?ooo`003@3oool00`0P8?l0003o0000o`0?
0000o`0306IVo`3oool0oooo0140oooo00<0VIWo0000o`000?l08@000?l00`20P?l0oooo0?ooo`09
0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0
oooo00X0oooo00<0knoo03<co`000?l090000?l00`0c<ol0knoo0?ooo`0>0?ooo`00303oool00`3<
c?l0003o0000o`0?0000o`03010@o`3_kol0oooo01<0oooo00<0@43o0000o`000?l07`000?l00`0c
<ol0knoo0?ooo`0:0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000
o`030820o`3oool0oooo00/0oooo00<0c<co010@o`000?l08P000?l00`0@4?l0c<co0?ooo`0?0?oo
o`00303oool00`2?Sol0003o0000o`0?0000o`03071`o`3oool0oooo01<0oooo00<0knoo010@o`00
0?l07P000?l00`0@4?l0c<co0?ooo`0;0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0
003o0000o`0>0000o`0308n?o`3oool0oooo00`0oooo00<0_koo0000o`000?l08@000?l00`2_[ol0
oooo0?ooo`0?0?ooo`00303oool00`10@?l0003o0000o`0?0000o`030=oOo`3oool0oooo01@0oooo
00<0c<co010@o`000?l07@000?l00`2IVOl0oooo0?ooo`0;0?ooo`030;noo`000?l0003o00l0003o
3`3oool00`10@?l0003o0000o`0>0000o`030;noo`3oool0oooo00d0oooo00<0VIWo010@o`000?l0
7`000?l00`2IVOl0oooo0?ooo`0@0?ooo`00303ooolA0000o`0303<co`3oool0oooo01H0oooo00<0
c<co010@o`000?l06`000?l00`2IVOl0oooo0?ooo`0<0?ooo`030>o_o`000?l0003o00l0003o00<0
knoo0?ooo`3oool0303oool00`0@4?l0003o0000o`0>0000o`030;noo`3oool0oooo00h0oooo00<0
c<co010@o`000?l070000?l00`0@4?l0_koo0?ooo`0B0?ooo`002`3oool00`3Ogol0003o0000o`0?
0000o`030820o`3oool0oooo01L0oooo00<0c<co03<co`000?l060000?l00`0@4?l0_koo0?ooo`0?
0?oooa40003o00<0_koo0?ooo`3oool02`3oool00`3_kol0003o0000o`0?0000o`030;noo`3oool0
oooo00l0oooo00<0gmoo0410o`000?l06P000?l00`0c<ol0gmoo0?ooo`0C0?ooo`002`3oool00`2o
_ol0003o0000o`0?0000o`030820o`3oool0oooo01P0oooo00<0knoo06IVo`000?l05P000?l00`10
@?l0gmoo0?ooo`0@0?ooo`03010@o`000?l0003o00h0003o00<0L73o0?ooo`3oool02`3oool00`2_
[ol0003o0000o`0?0000o`030=oOo`3oool0oooo0140oooo00<0Shoo010@o`000?l05P000?l00`0@
4?l0Ogoo0?ooo`0E0?ooo`002`3oool00`2o_ol0003o0000o`0?0000o`030820o`3oool0oooo01X0
oooo00<0_koo03<co`000?l04P000?l00`0P8?l0VIWo0?ooo`0B0?ooo`030410o`000?l0003o00h0
003o00<0413o0>o_o`3oool02`3oool00`10@?l0003o0000o`0?0000oaD0oooo00<0knoo06IVo`00
0?l050000?l00`1VI_l0gmoo0?ooo`0F0?ooo`002`3oool00`2o_ol0003o0000o`0?0000o`030410
o`3oool0oooo01`0oooo00<0_koo051@o`000?l03P000?l00`0c<ol0VIWo0?ooo`0D0?ooo`03071`
o`000?l0003o00l0003o00<0D53o0?ooo`3oool02@3oool00`2IVOl0003o0000o`0?0000o`0303<c
o`3oool0oooo01D0oooo00<0gmoo07moo`0P8?l03`000?l00`0P8?l0Ogoo0=oOo`0I0?ooo`002`3o
ool00`2o_ol0003o0000o`0@0000o`030;noo`3oool0oooo01d0oooo00@0knoo09VIo`1VI_l0<c?o
1`000?l0100P8?l0D53o08n?o`3OgolG0?ooo`0309VIo`000?l0003o0100003o00<0IVKo0?ooo`3o
ool01`3oool00`2IVOl0003o0000o`0@0000o`0306IVo`3oool0oooo01P0oooo00@0c<co08n?o`10
@?l0823o1`000?l0100P8?l0D53o07moo`3<c?lL0?ooo`002`3oool00`2o_ol0003o0000o`0@0000
o`03010@o`2o_ol0oooo02<0oooo00@0c<co0;noo`2o_ol0gmoo703oool00`3Ogol0003o0000o`0A
0000o`03020Po`2_[ol0oooo00@0oooo00<0gmoo06IVo`000?l04P000?l00`2IVOl0oooo0?ooo`0N
0?ooo`<0_koo00<0gmoo0?ooo`3oool07`3oool000`0oooo50000?l00`1VI_l0[joo0?ooo`030?oo
o`030;noo`1`L?l0c<co03`0oooo00<0823o0000o`000?l04P000?l01@0@4?l0@43o0410o`10@?l0
823o01D0003o00<0gmoo0?ooo`3oool0@`3oool000`0oooo00<0823o0000o`000?l06@000?l00`2o
_ol0oooo0?ooo`0j0?ooo`03071`o`000?l0003o02/0003o00<0@43o0?ooo`3oool0A03oool000`0
oooo00<0IVKo0000o`000?l06@000?l00`2o_ol0oooo0?ooo`0j0?ooo`030=oOo`000?l0003o02/0
003o00<0VIWo0?ooo`3oool0A03oool000`0oooo00<0[joo0000o`000?l06@000?l00`2o_ol0oooo
0?ooo`0k0?ooo`03051@o`000?l0003o02T0003o00<0823o0?ooo`3oool0A@3oool000d0oooo00<0
413o0000o`000?l060000?l00`2o_ol0oooo0?ooo`0k0?ooo`030;noo`000?l0003o02T0003o00<0
VIWo0?ooo`3oool0A@3oool000d0oooo00<0P83o0000o`000?l060000?l00`2o_ol0oooo0?ooo`0l
0?ooo`0306IVo`000?l0003o02L0003o00<0<c?o0?ooo`3oool0AP3oool000d0oooo00<0gmoo010@
o`000?l060000?l00`2o_ol0oooo0?ooo`0l0?ooo`030>o_o`0@4?l0003o02L0003o00<0c<co0?oo
o`3oool0AP3oool000h0oooo00<0P83o0000o`000?l05`000?l00`2o_ol0oooo0?ooo`0m0?ooo`03
0;noo`000?l0003o02D0003o00<0Shoo0?ooo`3oool0A`3oool000l0oooo00<0<c?o0000o`000?l0
5P000?l00`2o_ol0oooo0?ooo`0n0?ooo`0309VIo`000?l0003o02<0003o00<0IVKo0?ooo`3oool0
B03oool000l0oooo00<0c<co010@o`000?l05P000?l00`2o_ol0oooo0?ooo`0o0?ooo`03071`o`00
0?l0003o0240003o00<0<c?o0?ooo`3oool0B@3oool00100oooo00<0_koo0000o`000?l05@000?l0
0`2o_ol0oooo0?ooo`100?ooo`0306IVo`000?l0003o01l0003o00<0<c?o0>o_o`3oool0BP3oool0
0140oooo00<0VIWo010@o`000?l050000?l00`2o_ol0oooo0?ooo`110?ooo`0309VIo`000?l0003o
01d0003o00<0IVKo0>o_o`3oool0B`3oool00180oooo00<0c<co020Po`000?l04`000?l00`2o_ol0
oooo0?ooo`120?ooo`030;noo`0P8?l0003o01/0003o00<0Ogoo0?ooo`3oool0C03oool001<0oooo
00<0knoo06IVo`000?l04P000?l00`2o_ol0oooo0?ooo`130?ooo`030>o_o`1VI_l0003o01P0003o
00<0<c?o0<c<o`3oool0CP3oool001D0oooo00<0_koo0410o`000?l040000?l00`2o_ol0oooo0?oo
o`150?ooo`030<c<o`10@?l0003o01@0003o00<0823o09VIo`3oool0D03oool001L0oooo00<0_koo
051@o`000?l03P000?l00`2o_ol0oooo0?ooo`170?ooo`030<c<o`1VI_l0413o0100003o00<0D53o
0:n_o`3oool0DP3oool001T0oooo00@0knoo0:n_o`1VI_l0@43o20000?l0100@4?l0@43o07moo`3O
gom<0?ooo`040;noo`1oOol0@43o010@o`P0003o00@0@43o071`o`2_[ol0knooE@3oool001h0oooo
00<0knoo0;noo`2o_ol00`2o_omF0?ooo`030<c<o`2o_ol0_koo0080_koo00<0knoo0?ooo`3oool0
F03oool00001\
\>"],
            ImageRangeCache->{{{0, 217}, {87, 0}} -> {-0.00108501, 0.999385, 
            1.00001, 
            1.00001}}], \(This\ package\ includes\ routines\ which\ provide\ \
SNAP\ functionalities . \ 
              The\ version\ of\ this\ package\ is\ 0.2  .4\ and\ implemented\ \
by\ Kosaku\ \(\(NAGASAKA\)\(.\)\)\)}
        },
      RowAlignments->Top,
      ColumnAlignments->{Right, Left}]]]], "DefinitionBox",
  GeneratedCell->True,
  CellAutoOverwrite->True,
  Background->GrayLevel[1],
  CellTags->"b:1.1"],

Cell[BoxData[
    \("This package includes routines which export Mathematica's Graphics \
into FLASH format, implemented by Kosaku NAGASAKA."\)], "Print",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[1]:=",
  CellTags->"b:1.1"],

Cell[TextData[{
  "This gives a SNAP structure. The output looks like a normal expression. \
Note that using machine precision numbers in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " sometimes is risky because the product of a machine precisions number and \
a arbitray precisions number has always machine precisions. Hence, in the \
below, we does not use machine precisions numbers."
}], "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[1.`16\ x^5 + 5.503`16\ x^4 + 9.765`16\ x^3 + 7.647`16\ x^2 + 
          2.762`16\ x + 0.37725`16]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[2]=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[TextData[{
  "This gives the ",
  ButtonBox["FullForm",
    ButtonStyle->"RefGuideLink"],
  " of the above SNAP structure."
}], "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FullForm[g]\)], "Input",
  CellLabel->"In[3]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    TagBox[
      StyleBox[\(SNAP[
          Plus[Rational[1509, 4000], Times[Rational[1381, 500], x], 
            Times[Rational[7647, 1000], Power[x, 2]], 
            Times[Rational[1953, 200], Power[x, 3]], 
            Times[Rational[5503, 1000], Power[x, 4]], Power[x, 5]], 
          1.388833339758600409374164608968865`14.403201466246212*^-15, 
          List[List[x, 5]], AbsolutePolynomial2Norm]\),
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[3]//FullForm=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[TextData[{
  "The error bound of this SNAP structure, a set of polynomials is given by \
",
  StyleBox["Tolerance",
    FontFamily->"Courier"],
  "."
}], "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g]\)], "Input",
  CellLabel->"In[4]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(1.388833339758600409374164608968865`14.403201466246212*^-15\)], "Output",\

  CellLabel->"Out[4]=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell["Each calculation enlarges its error bound as follows.", "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2 = g*g\)], "Input",
  CellLabel->"In[5]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(\((\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + \
9.765`\ x\^3 + 5.503`\ x\^4 + x\^5)\)\^2\)], "Output",
  CellLabel->"Out[5]=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g2]\)], "Input",
  CellLabel->"In[6]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(9.449435996086558768912085`14.403201466246216*^-14\)], "Output",
  CellLabel->"Out[6]=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[TextData[{
  "By ",
  StyleBox["Element",
    FontFamily->"Courier"],
  ", we can check whether a polynomial is included in the given SNAP \
structure or not. The error bound of the below SNAP structure is about ",
  Cell[BoxData[
      \(1.38883\[Times]10\^\(-15\)\)]],
  ", hence we have the following results."
}], "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Element[Normal[g] + 1.2`16*^-15, g]\)], "Input",
  CellLabel->"In[7]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[7]=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Element[Normal[g] + 1.5`16*^-15, g]\)], "Input",
  CellLabel->"In[8]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[8]=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[TextData[{
  "In the above, ",
  StyleBox["Normal",
    FontFamily->"Courier"],
  " gives corresponding representative polynomials in the normal form."
}], "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Normal[g] // FullForm\)], "Input",
  CellLabel->"In[9]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    TagBox[
      StyleBox[\(Plus[Rational[1509, 4000], Times[Rational[1381, 500], x], 
          Times[Rational[7647, 1000], Power[x, 2]], 
          Times[Rational[1953, 200], Power[x, 3]], 
          Times[Rational[5503, 1000], Power[x, 4]], Power[x, 5]]\),
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[9]//FullForm=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell["\<\
We can expand the expression of the representative polynomial of a SNAP \
structure.\
\>", "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Expand[g2]\)], "Input",
  CellLabel->"In[10]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(\(\(0.1423175625`\)\(\[InvisibleSpace]\)\) + 2.083929`\ x + 
      13.3983055`\ x\^2 + 49.6097205`\ x\^3 + 116.5704825`\ x\^4 + 
      180.498982`\ x\^5 + 185.042107`\ x\^6 + 122.76759`\ x\^7 + 
      49.813009`\ x\^8 + 11.006`\ x\^9 + x\^10\)], "Output",
  CellLabel->"Out[10]=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell["\<\
Any result of a substitution for a SNAP structure has also a guaranteed \
accuracy.\
\>", "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g3 = g2 /. x -> 1\)], "Input",
  CellLabel->"In[11]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(731.9324430624999999999999999973`14.847672424864392\)], "Output",
  CellLabel->"Out[11]=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g3]\)], "Input",
  CellLabel->"In[12]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(1.03943795956956296505578855`14.513801222004547*^-12\)], "Output",
  CellLabel->"Out[12]=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell["\<\
Moreover, we show a situation argued in the last of the subsection \
\[OpenCurlyDoubleQuote]Tolerance Mechanisms\[CloseCurlyDoubleQuote].\
\>", "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g\)], "Input",
  CellLabel->"In[13]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[13]=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g - x^5\)], "Input",
  CellLabel->"In[15]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(SNAP::"invalid" \(\(:\)\(\ \)\) 
      "Tolerance is larger than the representing leading coefficient: \!\(0.`\
\) \[LessEqual] \!\(1.3888333397586004`*^-15\)."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[15]:=",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4\)], "Output",
  CellLabel->"Out[15]=",
  CellTags->"b:1.1"]
}, Open  ]],

Cell["\<\
This rewriting can be an important information for users, so this package \
generates the above warning.\
\>", "Text",
  CellTags->"b:1.1"]
}, Closed]],

Cell[CellGroupData[{

Cell["Mathematical Background", "Subsubsection",
  ShowCellBracket->True,
  CellTags->"b:1.1"],

Cell[TextData[{
  "We introduce the following data structures for empirical polynomials. They \
are very simple but there is no system in which we can use the following \
structures unconsciously like as ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s floating-point numbers or Kako and Sasaki's effective floating-point \
numbers [KS97]. The following data structures are different from that of the \
previous version of this package [Nag04a, Nag04b]. This version become to be \
able to operate polynomials which have more than 2 variables (bivariate or \
multivariate polynomials)."
}], "Text",
  CellTags->"b:1.1"],

Cell["Definition 1 (SNAP structures)", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.1"],

Cell[TextData[{
  "We define the following SNAP structures (like sets of neighbors) for \
approximate polynomials, for the given polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`f(u\_1, \[Ellipsis], \ 
          u\_r)\  \[Element] \ \[DoubleStruckCapitalC][u\_1, \ \[Ellipsis], \ 
          u\_r]\)]],
  " and tolerance ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\  \[Element] \ \
\[DoubleStruckCapitalR]\)]],
  "."
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(P\_2\) \((f, \ \[Epsilon])\) = {f\&_ | 
          f\&_ \[Element] \[DoubleStruckCapitalC][u\_1, \ \[Ellipsis], \ 
              u\_r], \ \(deg\_u\) f\&_ = \(deg\_u\) 
            f\ \((\[ForAll] u \[Element] {u\_1, \ \[Ellipsis], \ 
                    u\_r})\), \ \(\(\[DoubleVerticalBar]\)\(f - 
            f\&_\)\( \[DoubleVerticalBar] \_2\)\(\[LessEqual]\)\(\[Epsilon]\)\
\)}\)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(P\_1\) \((f, \ \[Epsilon])\) = {f\&_ | 
          f\&_ \[Element] \[DoubleStruckCapitalC][u\_1, \ \[Ellipsis], \ 
              u\_r], \ \(deg\_u\) f\&_ = \(deg\_u\) 
            f\ \((\[ForAll] u \[Element] {u\_1, \ \[Ellipsis], \ 
                    u\_r})\), \ \(\(\[DoubleVerticalBar]\)\(f - 
            f\&_\)\( \[DoubleVerticalBar] \_1\)\(\[LessEqual]\)\(\[Epsilon]\)\
\)}\)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(P\_\[Infinity]\) \((f, \ \[Epsilon])\) = \(\({f\&_ | 
            f\&_ \[Element] \[DoubleStruckCapitalC][u\_1, \ \[Ellipsis], \ 
                u\_r], \ \(deg\_u\) f\&_ = \(deg\_u\) 
              f\ \((\[ForAll] u \[Element] {u\_1, \ \[Ellipsis], \ 
                      u\_r})\), \ \(\(\[DoubleVerticalBar]\)\(f - 
              f\&_\)\( \[DoubleVerticalBar] \_\[Infinity]\)\(\[LessEqual]\)\(\
\[Epsilon]\)\)}\)\(.\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[TextData[{
  "where ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(\[DoubleVerticalBar]\)\(f\)\( \
\[DoubleVerticalBar] \_p\)\)\)]],
  " denotes coefficients vector norms for polynomials: "
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\[DoubleVerticalBar]\)\(f\)\( \[DoubleVerticalBar] \
\_p\)\) = \((\[CapitalSigma]\_i | f\_i\( | \^p\))\)\^\(1\/p\), \ 
    f = \(\[CapitalSigma]\_i\) \(f\_i\) \(u\_1\%\(e\_i1\)\) \[CenterEllipsis]\
\ \(\(u\_r\%\(e\_ir\)\)\(.\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[TextData[{
  "In the rest of this notebook, ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_*\)(f, \[Epsilon])\)]],
  " means any of ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_2\)(f, \[Epsilon])\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_1\)(f, \[Epsilon])\)]],
  " or ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_\[Infinity]\)(f, \[Epsilon])\)]],
  "."
}], "Text",
  CellTags->"b:1.1"],

Cell["Remark 1", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.1"],

Cell["\<\
One may think that the following definition is better than the above \
definition.\
\>", "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(P\_*\) \((f, \ \[Epsilon])\) = {f\&_ | 
          f\&_ \[Element] \[DoubleStruckCapitalC][u\_1, \ \[Ellipsis], \ 
              u\_r], \ \(deg\_u\) f\&_ \[LessEqual] \(deg\_u\) 
            f\ \((\[ForAll] u \[Element] {u\_1, \ \[Ellipsis], \ 
                    u\_r})\), \ \(\(\[DoubleVerticalBar]\)\(f - 
            f\&_\)\( \[DoubleVerticalBar] \_*\)\(\[LessEqual]\)\(\[Epsilon]\)\
\)}\)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[TextData[{
  "However, this definition poses strange situations. For example, let ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  " be an arbitrary small positive real number and ",
  Cell[BoxData[
      \(TraditionalForm\`f\)]],
  " be the following polynomial."
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`f = \(f\_n\) x\^n + \(f\_\(n - 1\)\) 
          x\^\(n - 1\) + \[CenterEllipsis] + \(f\_1\) x + f\_0, \ 
    f\_i \[Element] \[DoubleStruckCapitalC], \ \(\(|\)\(f\_n\)\(|\)\(\(\
\[LessEqual]\)\(\(\[Epsilon]\)\(.\)\)\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[TextData[{
  "For this polynomial, ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_*\)(f, \[Epsilon])\)]],
  " includes polynomials which have ",
  Cell[BoxData[
      \(TraditionalForm\`n\)]],
  " roots (counting multiplicities) and also polynomials which have at most \
",
  Cell[BoxData[
      \(TraditionalForm\`n - 1\)]],
  " roots. This causes terrible situations for algorithms, hence we use the \
expressions of Definition 1."
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell["\<\
The coefficients vector norms for polynomials have similar properties of \
normal vector norms (see [GL96] if the reader would like to study those basic \
properties), hence we have the following corollary.\
\>", "Text",
  CellTags->"b:1.1"],

Cell["Corollary 1", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.1"],

Cell["We have the following properties.", "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(P\_2\) \((f, \ \[Epsilon])\) \[SubsetEqual] \(P\_1\) \
\((f, \ \[Epsilon] \@\(\( \[CapitalPi]\_\(i = 1\)\%r\) \((e\_i + \
1)\)\))\)\)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(P\_2\) \((f, \ \[Epsilon])\) \[SubsetEqual] \(P\_\
\[Infinity]\) \((f, \ \[Epsilon])\)\)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(P\_1\) \((f, \ \[Epsilon])\) \[SubsetEqual] \(P\_2\) \
\((f, \ \[Epsilon])\)\)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(P\_1\) \((f, \ \[Epsilon])\) \[SubsetEqual] \(P\_\
\[Infinity]\) \((f, \ \[Epsilon])\)\)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(P\_\[Infinity]\) \((f, \ \[Epsilon])\) \[SubsetEqual] \
\(P\_2\) \((f, \ \[Epsilon] \@\(\( \[CapitalPi]\_\(i = 1\)\%r\) \((e\_i + \
1)\)\))\)\)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(P\_\[Infinity]\) \((f, \ \[Epsilon])\) \[SubsetEqual] \
\(P\_1\) \((f, \ \[Epsilon]\ \(\[CapitalPi]\_\(i = 1\)\%r\) \((e\_i + 
                1)\))\)\)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[TextData[{
  "where ",
  Cell[BoxData[
      \(TraditionalForm\`e\_i\)]],
  " denotes the degree of ",
  Cell[BoxData[
      \(TraditionalForm\`f(u\_1, \ \[Ellipsis], \ u\_r)\)]],
  " w.r.t. ",
  Cell[BoxData[
      \(TraditionalForm\`u\_i\)]],
  ".",
  Cell[BoxData[
      FormBox[Cell[""], TraditionalForm]]]
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell["Lemma 1", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.1"],

Cell[TextData[{
  "We have the following properties, for polynomials ",
  Cell[BoxData[
      \(TraditionalForm\`f(u\_1, \ \[Ellipsis], \ u\_r)\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`h(u\_1, \ \[Ellipsis], \ u\_r)\)]],
  "."
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\[ForAll] f\&_ \[Element] \(P\_2\) \((f, \[Epsilon]\_f)\), \ \
\[ForAll] h\&_ \[Element] \(P\_2\) \((h, \[Epsilon]\_h)\), \
\[IndentingNewLine]f\&_\[Times]
        h\&_ \[Element] \(P\_2\) \((f\[Times]
            h, \(\@\(min {\(\[CapitalPi]\_\(i = 1\)\%r\) \((e\_i + 
                          1)\), \(\[CapitalPi]\_\(i = 1\)\%r\) \((d\_i + 
                          1)\)}\)\) \((\(\[DoubleVerticalBar]\)\(f\)\( \
\[DoubleVerticalBar] \
\_2\)\(\(\[Epsilon]\_h\)\(+\)\)\(\[DoubleVerticalBar]\)\(h\)\( \
\[DoubleVerticalBar] \_2\)\(\[Epsilon]\_f + \[Epsilon]\_f\ \
\[Epsilon]\_h\))\))\), \)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\[ForAll] f\&_ \[Element] \(P\_1\) \((f, \[Epsilon]\_f)\), \ \
\[ForAll] h\&_ \[Element] \(P\_1\) \((h, \[Epsilon]\_h)\), \
\[IndentingNewLine]f\&_\[Times]
        h\&_ \[Element] \(P\_1\) \((f\[Times]
            h, \(\(\[DoubleVerticalBar]\)\(f\)\( \[DoubleVerticalBar] \_1\)\(\
\(\[Epsilon]\_h\)\(+\)\)\(\[DoubleVerticalBar]\)\(h\)\( \[DoubleVerticalBar] \
\_1\)\(\[Epsilon]\_f + \[Epsilon]\_f\ \[Epsilon]\_h\)\))\), \)], \
"NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\[ForAll] f\&_ \[Element] \(P\_\[Infinity]\) \((f, \[Epsilon]\
\_f)\), \ \[ForAll] h\&_ \[Element] \(P\_\[Infinity]\) \((h, \
\[Epsilon]\_h)\), \[IndentingNewLine]f\&_\[Times]
        h\&_ \[Element] \(P\_\[Infinity]\) \((f\[Times]h, 
          min {\(\[CapitalPi]\_\(i = 1\)\%r\) \((e\_i + 
                    1)\), \(\[CapitalPi]\_\(i = 1\)\%r\) \((d\_i + 
                    1)\)} \((\(\[DoubleVerticalBar]\)\(f\)\( \
\[DoubleVerticalBar] \
\_1\)\(\(\[Epsilon]\_h\)\(+\)\)\(\[DoubleVerticalBar]\)\(h\)\( \
\[DoubleVerticalBar] \_1\)\(\[Epsilon]\_f + \[Epsilon]\_f\ \
\[Epsilon]\_h\))\))\), \)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[TextData[{
  "where ",
  Cell[BoxData[
      \(TraditionalForm\`e\_i\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`d\_i\)]],
  " denotes the degree of ",
  Cell[BoxData[
      \(TraditionalForm\`f(u\_1, \ \[Ellipsis], \ u\_r)\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`h(u\_1, \ \[Ellipsis], \ u\_r)\)]],
  " w.r.t. ",
  Cell[BoxData[
      \(TraditionalForm\`u\_i\)]],
  ", respectively.",
  Cell[BoxData[
      FormBox[Cell[""], TraditionalForm]]]
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell["Proof of Lemma 1", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.1"],

Cell["\<\
The lemma is proved by the following properties of vector and matrix norms \
(see [GL96]), since any multiplication of polynomials can be done as matrix \
multiplications.\
\>", "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(\[DoubleVerticalBar]\)\(A\)\( \[DoubleVerticalBar] \
\_2\)\(\[LessEqual]\)\(\[DoubleVerticalBar]\)\(A\)\( \[DoubleVerticalBar] \_F\
\)\)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(\(\[DoubleVerticalBar]\)\(A\)\( \[DoubleVerticalBar] \
\_1\)\) = \(max\_\(1 \[LessEqual] j \[LessEqual] 
                n\)\) \[CapitalSigma]\_\(i = 1\)\%m | 
        a\_ij | \)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(\(\[DoubleVerticalBar]\)\(A\)\( \[DoubleVerticalBar] \_\
\[Infinity]\)\) = \(max\_\(1 \[LessEqual] i \[LessEqual] 
                m\)\) \[CapitalSigma]\_\(j = 1\)\%n | 
        a\_ij | \)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[TextData[{
  "where ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(\[DoubleVerticalBar]\)\(A\)\( \
\[DoubleVerticalBar] \_p\)\)\)]],
  " denotes matrix ",
  Cell[BoxData[
      \(TraditionalForm\`p\)]],
  "-norms for matrix ",
  Cell[BoxData[
      \(TraditionalForm\`A\)]],
  " of size ",
  Cell[BoxData[
      \(TraditionalForm\`m\[Times]n\)]],
  "."
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell["Lemma 2", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.1"],

Cell[TextData[{
  "For polynomials ",
  Cell[BoxData[
      \(TraditionalForm\`f(u\_1, \ \[Ellipsis], \ u\_r)\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`h(u\_1, \ \[Ellipsis], \ u\_r)\)]],
  ", if the following relation holds,"
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\[ForAll] g\_f \[Element] \(P\_*\) \((f, \[Epsilon]\_f)\), \ \
\[ForAll] h\&_ \[Element] \(P\_*\) \((h, \[Epsilon]\_h)\), \(deg\_u\) \((g\_f \
+ h\&_)\) = 
      max {\(deg\_u\) f, \(deg\_u\) 
            h}\ \ \((\[ForAll] u \[Element] {u\_1, \ \[Ellipsis], \ 
                u\_r})\), \)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell["we have the following properties.", "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\[ForAll] f\&_ \[Element] \(P\_2\) \((f, \[Epsilon]\_f)\), \ \
\[ForAll] h\&_ \[Element] \(P\_2\) \((h, \[Epsilon]\_h)\), \
\[IndentingNewLine]f\&_ + 
        h\&_ \[Element] \(P\_2\) \((f + 
              h, \[Epsilon]\_f + \[Epsilon]\_h)\) \[Congruent] {g | 
            g \[Element] \[DoubleStruckCapitalC][u\_1, \ \[Ellipsis], \ 
                u\_r], \ \(deg\_u\) g = 
            max {\(deg\_u\) f\&_, \(deg\_u\) 
                  h\&_}\ \ \((\[ForAll] u \[Element] {u\_1, \ \[Ellipsis], \ 
                      u\_r})\), \ \(\(\[DoubleVerticalBar]\)\(\((f + h)\) - 
              g\)\( \[DoubleVerticalBar] \_2\)\(\[LessEqual]\)\(\[Epsilon]\_f \
+ \[Epsilon]\_h\)\)}, \)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\[ForAll] f\&_ \[Element] \(P\_1\) \((f, \[Epsilon]\_f)\), \ \
\[ForAll] h\&_ \[Element] \(P\_1\) \((h, \[Epsilon]\_h)\), \
\[IndentingNewLine]f\&_ + 
        h\&_ \[Element] \(P\_1\) \((f + 
              h, \[Epsilon]\_f + \[Epsilon]\_h)\) \[Congruent] {g | 
            g \[Element] \[DoubleStruckCapitalC][u\_1, \ \[Ellipsis], \ 
                u\_r], \ \(deg\_u\) g = 
            max {\(deg\_u\) f\&_, \(deg\_u\) 
                  h\&_}\ \ \((\[ForAll] u \[Element] {u\_1, \ \[Ellipsis], \ 
                      u\_r})\), \ \(\(\[DoubleVerticalBar]\)\(\((f + h)\) - 
              g\)\( \[DoubleVerticalBar] \_1\)\(\[LessEqual]\)\(\[Epsilon]\_f \
+ \[Epsilon]\_h\)\)}, \)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\[ForAll] f\&_ \[Element] \(P\_\[Infinity]\) \((f, \[Epsilon]\
\_f)\), \ \[ForAll] h\&_ \[Element] \(P\_\[Infinity]\) \((h, \
\[Epsilon]\_h)\), \[IndentingNewLine]f\&_ + 
        h\&_ \[Element] \(P\_\[Infinity]\) \((f + 
              h, \[Epsilon]\_f + \[Epsilon]\_h)\) \[Congruent] {g | 
            g \[Element] \[DoubleStruckCapitalC][u\_1, \ \[Ellipsis], \ 
                u\_r], \ \(deg\_u\) g = 
            max {\(deg\_u\) f\&_, \(deg\_u\) 
                  h\&_}\ \ \((\[ForAll] u \[Element] {u\_1, \ \[Ellipsis], \ 
                      u\_r})\), \ \(\(\[DoubleVerticalBar]\)\(\((f + h)\) - 
              g\)\( \[DoubleVerticalBar] \_\[Infinity]\)\(\[LessEqual]\)\(\
\[Epsilon]\_f + \[Epsilon]\_h\)\)}, \)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[TextData[{
  "where ",
  Cell[BoxData[
      \(TraditionalForm\`e\_i\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`d\_i\)]],
  " denotes the degree of ",
  Cell[BoxData[
      \(TraditionalForm\`f(u\_1, \ \[Ellipsis], \ u\_r)\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`h(u\_1, \ \[Ellipsis], \ u\_r)\)]],
  " w.r.t. ",
  Cell[BoxData[
      \(TraditionalForm\`u\_i\)]],
  ", respectively.",
  Cell[BoxData[
      FormBox[Cell[""], TraditionalForm]]]
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell["Proof of Lemma 2", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.1"],

Cell["\<\
The lemma is directly proved by the norm's triangle inequality. \
\>", "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[TextData[{
  "The condition of Lemma 2 is necessary for ensuring equalities for degrees \
in ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_*\)(f + h, \[Epsilon]\_f + \[Epsilon]\_h)\)]],
  ". Without the condition, strange situations as in Remark 1 may occur. \
However, for example, we have to operate with the following computation and \
determine the set ",
  Cell[BoxData[
      \(TraditionalForm\`S\)]],
  ". This is important especially for divisions (quotient and remainder) and \
reductions (for non-univariate polynomials)."
}], "Text",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\[ForAll] g \[Element] \(P\_*\) \((f, \[Epsilon])\), \ \
\[ForAll] h \[Element] \(P\_*\) \((f, \[Epsilon])\), \ 
    g - h \[Element] \(\(S\)\(.\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[TextData[{
  "We introduce a simple rule to operate this. If the norm of the leading \
coefficients of the representative polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`f\)]],
  ", w.r.t. ",
  Cell[BoxData[
      \(TraditionalForm\`u\_i\)]],
  ", is not larger than the tolerance ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  ", then we rewrite the SNAP structure as below."
}], "Text",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TextForm\`\(\(\(P\_*\) \((f, \[Epsilon])\)\  \[Implies] \ \(P\_*\) \((f\
\_new, \[Epsilon])\) = {g | 
          g \[Element] \[DoubleStruckCapitalC][u\_1, \ \[Ellipsis], \ 
              u\_r], \ \(deg\_u\) g = \(deg\_u\) 
            f\_new\ \((\[ForAll] u \[Element] {u\_1, \ \[Ellipsis], \ 
                    u\_r})\), \ \(\(\[DoubleVerticalBar]\)\(f\_new - 
            g\)\( \[DoubleVerticalBar] \_2\)\(\[LessEqual]\)\(\[Epsilon]\)\)}\
\)\(,\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.1"],

Cell[TextData[{
  "where  ",
  Cell[BoxData[
      \(TraditionalForm\`f\_new\)]],
  " denotes ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(f\)\(-\)\)\)]],
  "(all the leading monomials of ",
  Cell[BoxData[
      \(TraditionalForm\`f\)]],
  ", w.r.t. ",
  Cell[BoxData[
      \(TraditionalForm\`u\_i\)]],
  ")."
}], "Text",
  CellTags->"b:1.1"]
}, Closed]],

Cell[CellGroupData[{

Cell["Tolerance Implementations", "Subsubsection",
  ShowCellBracket->True,
  CellTags->"b:1.1"],

Cell["\<\
According to the above mechanisms, we have implemented the structures, basic \
operations (addition and multiplication) on the structures, and functions \
which transform a structure into another.\
\>", "Text",
  CellTags->"b:1.1"],

Cell[TextData[{
  "We define the following expression to represent SNAP structures ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_2\)(f, \[Epsilon])\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_1\)(f, \[Epsilon])\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_\[Infinity]\)(f, \[Epsilon])\)]],
  ", where \[OpenCurlyDoubleQuote]scheme\[CloseCurlyDoubleQuote] can be ",
  StyleBox["AbsolutePolynomial2Norm",
    FontFamily->"Courier"],
  ", ",
  StyleBox["AbsolutePolynomial1Norm",
    FontFamily->"Courier"],
  " and ",
  StyleBox["AbsolutePolynomialiNorm",
    FontFamily->"Courier"],
  ", respectively. In the future release, other schemes will be implemented."
}], "Text",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(SNAP[f, \[Epsilon], {{u\_1, e\_1}, \[Ellipsis], {u\_r, e\_r}}, 
      scheme]\)], "DefinitionBox",
  CellTags->"b:1.1"],

Cell["\<\
Using the above structure, we have implemented basic functions provided by \
the mechanisms. We show some of their expressions. We note that the package \
also provides functions which transform the given polynomial to the above \
representation automatically.\
\>", "Text",
  CellTags->"b:1.1"],

Cell[BoxData[
    \(TransformSNAP[
        SNAP[f_, epsf_, {{x_Symbol, n_}, yz___}, AbsolutePolynomial2Norm], 
        AbsolutePolynomialiNorm] := 
      SNAP[f, epsf, {{x, n}, yz}, AbsolutePolynomialiNorm]\)], "Input",
  Evaluatable->False,
  CellTags->"b:1.1"],

Cell[BoxData[
    \(Normal[SNAP[f_, epsf_, {{x_Symbol, n_}, yz___}, scheme_]] := 
      f\)], "Input",
  Evaluatable->False,
  CellTags->"b:1.1"],

Cell[BoxData[
    \(SNAP /: \(-SNAP[f_, epsf_, {{x_Symbol, n_}, yz___}, scheme_]\) := 
      SNAP[\(-f\), epsf, {{x, n}, yz}, scheme]\)], "Input",
  Evaluatable->False,
  CellTags->"b:1.1"],

Cell[BoxData[
    \(SNAP[g_, epsg_, varsg_List, scheme_] + 
        SNAP[h_, epsh_, varsh_List, scheme_] ^:= 
      SNAP[g + h, epsg + epsh, maxvarslist[varsg, varsh], scheme]\)], "Input",\

  Evaluatable->False,
  CellTags->"b:1.1"],

Cell[BoxData[
    \(SNAP[g_, epsg_, varsg_, scheme_] + f_?NotSNAPQ ^:= 
      SNAP[g, epsg, varsg, scheme] + SNAP[f]\)], "Input",
  Evaluatable->False,
  CellTags->"b:1.1"],

Cell[BoxData[
    \(Tolerance[SNAP[f_, epsf_, vars_, scheme_]] := epsf\)], "Input",
  Evaluatable->False,
  CellTags->"b:1.1"],

Cell[TextData[{
  "One of aims of the package is providing an environment in which we use \
SNAP structures transparently like ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s floating-point numbers, hence we have implemented the following ",
  StyleBox["Format",
    FontFamily->"Courier"],
  " code."
}], "Text",
  CellMargins->{{Inherited, Inherited}, {Inherited, 12}},
  CellTags->"b:1.1"],

Cell[BoxData[
    \(Format[SNAP[f_, e_, variables_, scheme_]] := N@f\)], "Input",
  Evaluatable->False,
  CellTags->"b:1.1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Other Basic Operations", "Subsection",
  CellTags->{"i:11", "b:1.2", "c:7"}],

Cell["\<\
We implemented other basic operations: a polynomial division (quotient and \
remainder), reductions (for non-univariate polynomials) and a root finding \
with error considerations.\
\>", "Text",
  CellTags->"b:1.2"],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {Cell["function"], Cell["purpose"]},
          {
            StyleBox["NSolve",
              
              FontFamily->
                "Courier"], \(finds\ numerical\ roots\ with\ error\ \
\(\(considerations\)\(.\)\)\)},
          {
            StyleBox["PolynomialQuotient",
              FontFamily->"Courier"], 
            RowBox[{"computes", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "polynomial", " ", "quotient", " ",
               "as", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "SNAP", 
              " ", \(\(structure\)\(.\)\)}]},
          {
            StyleBox["PolynomialRemainder",
              FontFamily->"Courier"], 
            RowBox[{"computes", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "polynomial", " ", "remainder", 
              " ", "as", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "SNAP", 
              " ", \(\(structure\)\(.\)\)}]},
          {
            StyleBox["PolynomialReduce",
              FontFamily->"Courier"], 
            RowBox[{"computes", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "reduced", " ", "polynomial", " ", 
              "as", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "SNAP", 
              " ", \(\(structure\)\(.\)\(\ \)\)}]},
          {
            StyleBox["D",
              FontFamily->"Courier",
              FontWeight->"Plain",
              FontSlant->"Plain",
              FontTracking->"Plain",
              FontVariations->{"Underline"->False,
              "Outline"->False,
              "Shadow"->False,
              "StrikeThrough"->False,
              "Masked"->False,
              "CompatibilityType"->0,
              
              "RotationAngle"->
                0}], \(computes\ derivatives\ as\ SNAP\ \(\(structures\)\(.\)\
\)\)}
          }], TraditionalForm]], "DisplayFormula",
  GridBoxOptions->{RowLines->{2, 0.5},
  ColumnLines->True},
  CellTags->"Groups:classical groups"]], "DefinitionBox",
  CellTags->"b:1.2"],

Cell[TextData[{
  StyleBox["Table ", "SB"],
  StyleBox[
  CounterBox["NumberedTable"], "SB"],
  StyleBox[". ", "SB"],
  "Other Basic Functions"
}], "SmallTextSans",
  CellMargins->{{27, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell["Examples", "Subsubsection",
  ShowCellBracket->True,
  CellTags->"b:1.2"],

Cell["\<\
We show some examples of the package, about basic operations. This remains \
the polynomial used in the above.\
\>", "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g\)], "Input",
  CellLabel->"In[16]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[16]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell["\<\
This gives all the roots of the given representative polynomial with \
considerations of the error bound. We recommend you to compare the following \
two results. NSolve with a SNAP structure considers all the possible \
polynomials within the structure, hence their tolerances are larger than that \
of NSolve without a SNAP structure.\
\>", "Text",
  CellTags->"b:1.2"],

Cell["These evaluations give results with error considerations.", "Commentary",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g == 0, x]\)], "Input",
  CellLabel->"In[17]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323233693630293112`12.451896560482764\)}, {x \
\[Rule] \(-0.9989903848991318032656328004`10.488878323990713\)}, {x \[Rule] \
\(-0.5412151824480374484`7.939548909383962\)}, {x \[Rule] \
\(-0.4813611757602536895`8.0343760464362\) - 
            0.0294645370012453413`6.821204608239104\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611757602536895`8.0343760464362\) + 
            0.0294645370012453413`6.821204608239104\ \[ImaginaryI]}}\)], \
"Output",
  CellLabel->"Out[17]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[18]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({1.05982736502957936665826858`14.514107086853524*^-12, 
      3.241029501726395456118204006`14.505377420246694*^-11, 
      6.22043937501758725179356157442`14.67823309883378*^-9, 
      6.28941150360925010069892807736`14.678486617701141*^-9, 
      6.28941150360925010069892807736`14.678486617701141*^-9}\)], "Output",
  CellLabel->"Out[18]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[Normal[g] == 0, x]\)], "Input",
  CellLabel->"In[19]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323233693630293112`12.406486330673758\)}, {x \
\[Rule] \(-0.9989903848991318032656328004`10.443468094181657\)}, {x \[Rule] \
\(-0.5412151824480374484`7.894138679574308\)}, {x \[Rule] \
\(-0.4813611757602536895`7.988965816626636\) - 
            0.0294645370012453413`6.775794378429541\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611757602536895`7.988965816626636\) + 
            0.0294645370012453413`6.775794378429541\ \[ImaginaryI]}}\)], \
"Output",
  CellLabel->"Out[19]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[20]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({1.17664474278366996555289856`14.312353501933648*^-12, 
      3.598265576306532285814514775`14.552671874229734*^-11, 
      6.90607501743990298553806793993`14.680643012185827*^-9, 
      6.98264946265843353310967186449`14.680897942161621*^-9, 
      6.98264946265843353310967186449`14.680897942161621*^-9}\)], "Output",
  CellLabel->"Out[20]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[
      0.37725`16\[InvisibleSpace] + 2.762`16\ x + 7.647`16\ x\^2 + 
          9.765`16\ x\^3 + 5.503`16\ x\^4 + 1.`16  x\^5 \[Equal] 0, 
      x]\)], "Input",
  CellLabel->"In[21]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323233693630293112`12.445188837095142\)}, {x \
\[Rule] \(-0.9989903848991318032656328004`10.488144866492453\)}, {x \[Rule] \
\(-0.5412151824480374484`7.939505857375257\)}, {x \[Rule] \
\(-0.4813611757602536895`8.03434587464204\) - 
            0.0294645370012453413`6.821174436444947\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611757602536895`8.03434587464204\) + 
            0.0294645370012453413`6.821174436444947\ \[ImaginaryI]}}\)], \
"Output",
  CellLabel->"Out[21]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[22]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({1.07632357367441199463730259`14.514350427202238*^-12, 
      3.246507733545744873875241618`14.50614124651739*^-11, 
      6.22105604341996951147452969159`14.678235377275305*^-9, 
      6.28984846384943642689983899398`14.678488215414191*^-9, 
      6.28984846384943642689983899398`14.678488215414191*^-9}\)], "Output",
  CellLabel->"Out[22]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell["This gives a result without error considerations.", "Commentary",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`NSolve[Normal[g] \[Equal] 0, x]\)], "Input",
  CellLabel->"In[23]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323225`\)}, {x \[Rule] \(-0.998990384899134`\
\)}, {x \[Rule] \(-0.5412151824480371`\)}, {x \[Rule] \(-0.48136117576025317`\
\) - 0.02946453700124859`\ \[ImaginaryI]}, {x \[Rule] \(-0.48136117576025317`\
\) + 0.02946453700124859`\ \[ImaginaryI]}}\)], "Output",
  CellLabel->"Out[23]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[24]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({3.33074910000823053836814551428295`14.402674445050097*^-16, 
      1.10910212669416721696134260152239`14.389476498229513*^-16, 
      6.008695568305212868623124098097`14.229966603804716*^-17, 
      5.3541849581150122348540987955976`14.178540852175638*^-17, 
      5.3541849581150122348540987955976`14.178540852175638*^-17}\)], "Output",\

  CellLabel->"Out[24]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell["\<\
To show division examples, we prepare the following two polynomials.\
\>", "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2 = Expand[g*g]\)], "Input",
  CellLabel->"In[25]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(\(\(0.1423175625`\)\(\[InvisibleSpace]\)\) + 2.083929`\ x + 
      13.3983055`\ x\^2 + 49.6097205`\ x\^3 + 116.5704825`\ x\^4 + 
      180.498982`\ x\^5 + 185.042107`\ x\^6 + 122.76759`\ x\^7 + 
      49.813009`\ x\^8 + 11.006`\ x\^9 + x\^10\)], "Output",
  CellLabel->"Out[25]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(h = 1.`16  x^3 + SetPrecision[Random[], 16]\)], "Input",
  CellLabel->"In[26]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(0.4427195513295876794224170681`16.  + 1.`16. \ x\^3\)], "Output",
  CellLabel->"Out[26]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[TextData[{
  "This gives the quotient and remainder of ",
  Cell[BoxData[
      \(TraditionalForm\`g2\)]],
  " by ",
  Cell[BoxData[
      \(TraditionalForm\`h\)]],
  " with error considerations. Note that though ",
  Cell[BoxData[
      \(TraditionalForm\`h\)]],
  " is not in SNAP structure, it automatically is transformed into SNAP \
structure."
}], "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \({{PolynomialQuotient[g2, h, x]}, 
      PolynomialRemainder[g2, h, x]}\)], "Input",
  CellLabel->"In[27]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({{\(-30.1548554720906`\) + 62.41487073851469`\ x + 
          158.4457890051433`\ x\^2 + 180.16953561806653`\ x\^3 + 
          122.32487044867041`\ x\^4 + 49.813009`\ x\^5 + 11.006`\ x\^6 + 
          x\^7}, \(\(13.492461647512513`\)\(\[InvisibleSpace]\)\) - 
        25.548354569649437`\ x - 56.74874311841956`\ x\^2}\)], "Output",
  CellLabel->"Out[27]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell["\<\
The above commands and the following are the same for univariate polynomials.\
\
\>", "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolynomialReduce[g2, {h}, {x}]\)], "Input",
  CellLabel->"In[28]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({{\(-30.1548554720906`\) + 62.41487073851469`\ x + 
          158.4457890051433`\ x\^2 + 180.16953561806653`\ x\^3 + 
          122.32487044867041`\ x\^4 + 49.813009`\ x\^5 + 11.006`\ x\^6 + 
          x\^7}, \(\(13.492461647512513`\)\(\[InvisibleSpace]\)\) - 
        25.548354569649437`\ x - 56.74874311841956`\ x\^2}\)], "Output",
  CellLabel->"Out[28]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[TextData[{
  "In this case, ",
  StyleBox["PolynomialRemainder",
    FontFamily->"Courier"],
  " gives a pseudo zero number since ",
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  " can divide ",
  Cell[BoxData[
      \(TraditionalForm\`g2\)]],
  ". However, these polynomials have their error bounds and we can not argue \
that its remainder is completely zero, hence the following warning messages \
are generated."
}], "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \({g3, g4} = {PolynomialQuotient[g2, g, x], 
        PolynomialRemainder[g2, g, x]}\)], "Input",
  CellLabel->"In[29]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(SNAP::"invalid" \(\(:\)\(\ \)\) 
      "Tolerance is larger than the representing leading coefficient: \!\(0.`\
\) \[LessEqual] \!\(9.294480043841616`*^-7\)."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[29]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(SNAP::"invalid" \(\(:\)\(\ \)\) 
      "Tolerance is larger than the representing leading coefficient: \!\(0.`\
\) \[LessEqual] \!\(9.294480043841616`*^-7\)."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[29]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(SNAP::"invalid" \(\(:\)\(\ \)\) 
      "Tolerance is larger than the representing leading coefficient: \!\(0.`\
\) \[LessEqual] \!\(9.294480043841616`*^-7\)."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[29]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(SNAP :: \\\"invalid\\\"\\) will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], \
"Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[29]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
        9.765`\ x\^3 + 5.503`\ x\^4 + x\^5, 0``6.031774900717962}\)], "Output",\

  CellLabel->"Out[29]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[TextData[{
  "SNAP functions give normal ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " numbers if their degrees are not larger than zero."
}], "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \({SNAPQ[g3], SNAPQ[g4]}\)], "Input",
  CellLabel->"In[30]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({True, False}\)], "Output",
  CellLabel->"Out[30]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell["\<\
Each operation or calculation enlarge error bounds, hence tolerances of the \
roots also are getting larger and larger as below.\
\>", "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g3 \[Equal] 0, x]\)], "Input",
  CellLabel->"In[31]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323233694`6.274928120702081\)}, {x \[Rule] \
\(-0.9989903848991318033`5.478396376726195\)}, {x \[Rule] \
\(-0.5412151824480374484`3.9703737560704813\)}, {x \[Rule] \
\(-0.4813611757602536895`4.127596166473172\) - 
            0.0294645370012453413`2.914424728276078\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611757602536895`4.127596166473172\) + 
            0.0294645370012453413`2.914424728276078\ \[ImaginaryI]}}\)], \
"Output",
  CellLabel->"Out[31]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[32]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({1.5929552247799109756956468754764`14.677142952335963*^-6, 
      3.32020524664598606587715264881257`14.853685854596664*^-6, 
      0.0000579423646668668774993838`14.965315229534575, 
      0.0000507446066785433115621863`14.959450339410328, 
      0.0000507446066785433115621863`14.959450339410328}\)], "Output",
  CellLabel->"Out[32]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell["\<\
The tolerance correction mechanism used in NSolve with SNAP structures \
suppose that the given representative polynomial does not have multiple \
roots. Therefore, the following warning message  is generated if the given \
polynomial has multiple (or close) roots and any tolerance correction is not \
applied.\
\>", "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g2 \[Equal] 0, x]\)], "Input",
  CellLabel->"In[33]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(SNAP::"multipleroots" \(\(:\)\(\ \)\) 
      "The given representative polynomial has multiple roots. Tolerances of \
the roots can not be computed."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[33]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323283887`6.79793659095208\)}, {x \[Rule] \
\(-3.00007208113231835`6.797936590952076\)}, {x \[Rule] \
\(-0.9989903858280728634`5.786817010304116\)}, {x \[Rule] \
\(-0.9989903839701907336`5.786817007244727\)}, {x \[Rule] \
\(-0.5412152279236396235`2.157949138401507\)}, {x \[Rule] \
\(-0.5412151369723347837`2.157947442349799\)}, {x \[Rule] \
\(-0.4813611980373619149`2.46489286118313\) - 
            0.0294644986528884862`1.2517208376486502\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611980373619149`2.46489286118313\) + 
            0.0294644986528884862`1.2517208376486502\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611534831957137`2.4648951462689612\) - 
            0.0294645753495020859`1.2517242934069985\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611534831957137`2.4648951462689612\) + 
            0.0294645753495020859`1.2517242934069985\ \[ImaginaryI]}}\)], \
"Output",
  CellLabel->"Out[33]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[34]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({4.7774384270431897481761206923374`14.791601695924102*^-7, 
      4.7774384270432190592856730224112`14.791601695924102*^-7, 
      1.63209073100974389542433597311578`14.688473973102907*^-6, 
      1.63209073947171905138796751658259`14.688473975523593*^-6, 
      0.0037620180005753401718769887`15.207737718780693, 
      0.0037620320602154510867671968`15.207738009507398, 
      0.002333958964430891250346219`15.145963685428221, 
      0.002333958964430891250346219`15.145963685428221, 
      0.0023339464680669715227015905`15.145960976446649, 
      0.0023339464680669715227015905`15.145960976446649}\)], "Output",
  CellLabel->"Out[34]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell["\<\
Partial derivatives also can be computed in SNAP structures. \
\>", "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2d = D[g2, x]\)], "Input",
  CellLabel->"In[35]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(\(\(2.083929`\)\(\[InvisibleSpace]\)\) + 26.796611`\ x + 
      148.8291615`\ x\^2 + 466.28193`\ x\^3 + 902.49491`\ x\^4 + 
      1110.252642`\ x\^5 + 859.37313`\ x\^6 + 398.504072`\ x\^7 + 
      99.054`\ x\^8 + 10.`\ x\^9\)], "Output",
  CellLabel->"Out[35]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g2d == 0, x]\)], "Input",
  CellLabel->"In[36]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323233694`8.566923065286524\)}, {x \[Rule] \
\(-2.5308272775510289792`8.067034632210817\)}, {x \[Rule] \
\(-0.998990384899131803`4.972067184450808\)}, {x \[Rule] \
\(-0.8692254815392273313`4.262890222476106\)}, {x \[Rule] \
\(-0.5412151824480368253`0.07574789952197347\)}, {x \[Rule] 
          0``-1.1084579531959013}, {x \[Rule] 
          0``-1.007229585454007}, {x \[Rule] \
\(-0.4813611757602539841`0.25338339684598155\) + 
            0``0.5709123375647115\ \[ImaginaryI]}, {x \[Rule] \
\(-0.4813611757602539841`0.25338339684598155\) + 
            0``0.5709123375647115\ \[ImaginaryI]}}\)], "Output",
  CellLabel->"Out[36]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[37]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({8.13221073251823824168964816176`14.684436759566854*^-9, 
      2.168841798426865843990389763824`14.707931498534261*^-8, 
      0.00001065354448819472915331578328329049`14.700532201197124, 
      0.00004745065664697163286823715426170962`14.956512725698872, 
      0.4545922961971204403040339907`16.057868321675425, 
      12.8368348291395277253281678009`15.353229365177462, 
      10.1678606464998043420709920769`15.589245607629707, 
      0.3798417168646954000446470258`15.9687141223348, 
      0.3798417168646954000446470258`15.9687141223348}\)], "Output",
  CellLabel->"Out[37]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[TextData[{
  "In this case, the working precision used in ",
  StyleBox["System`NSolve",
    FontFamily->"Courier"],
  " is too small, so enlarge the precision gives us better answers."
}], "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g2d == 0, x, 32]\)], "Input",
  CellLabel->"In[38]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323233693632654706`10.367077689985788\)}, {x \
\[Rule] \(-2.5308272775510289791613863995`10.240070815092158\)}, {x \[Rule] \
\(-0.9989903848991318032`9.15563424433536\)}, {x \[Rule] \
\(-0.8692254815392273303`8.73834527426704\)}, {x \[Rule] \
\(-0.5412151824480374499`6.166918145377783\)}, {x \[Rule] \
\(-0.5094234012658212724`5.3552452881656185\)}, {x \[Rule] \
\(-0.4929238396439224181`5.358826089716271\)}, {x \[Rule] \
\(-0.4813611757602536887`6.339715519679965\) - 
            0.0294645370012453425`5.126544081482871\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611757602536887`6.339715519679965\) + 
            0.0294645370012453425`5.126544081482871\ \[ImaginaryI]}}\)], \
"Output",
  CellLabel->"Out[38]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[39]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({1.2884097403623410349588855385`14.597180161149632*^-10, 
      1.4561016419520578381129804383`14.599519873192252*^-10, 
      6.9811515168095660958672235194`14.594776021815075*^-10, 
      1.58776847570078961200425305299`14.534607072533955*^-9, 
      3.6851216227806676582872463395653`14.783923524199723*^-7, 
      2.24819306083059217069208067597535`14.83812846653758*^-6, 
      2.15751454916419144534622915934287`14.81887596279349*^-6, 
      3.1136553394309446631706035272608`14.779011331520701*^-7, 
      3.1136553394309446631706035272608`14.779011331520701*^-7}\)], "Output",
  CellLabel->"Out[39]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[TextData[{
  "One may think that this package is useless. The followings may be counter \
examples to them. The leading coefficients of ",
  Cell[BoxData[
      \(TraditionalForm\`newg\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`newg2\)]],
  " have low accuracy numbers. Hence, the precisions and accuracirs of \
coefficients on lower degree terms become lower. "
}], "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{

Cell[BoxData[
    \(newg = 
      1.001`6  x^5 + \((5503  x^4 + 9765  x^3 + 7647  x^2 + 2762  x + 377)\)/
          1000\)], "Input",
  CellLabel->"In[40]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(1.001`5.999999999999999\ x\^5 + \(377 + 2762\ x + 7647\ x\^2 + 9765\ \
x\^3 + 5503\ x\^4\)\/1000\)], "Output",
  CellLabel->"Out[40]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(newg2 = Expand[newg^2]\)], "Input",
  CellLabel->"In[41]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(142129\/1000000 + \(520637\ x\)\/250000 + \(6697241\ x\^2\)\/500000 + \
\(24802419\ x\^3\)\/500000 + \(116567731\ x\^4\)\/1000000 + 
      180.499236`8.378669944656089\ x\^5 + 
      185.047631`7.524595782195373\ x\^6 + 
      122.7828839999999990687`6.904182666808125\ x\^7 + 
      49.8325390000000000002`6.406376694551547\ x\^8 + 
      11.0170060000000000003`5.999999999999999\ x\^9 + 
      1.0020010000000000001`5.698970004336017\ x\^10\)], "Output",
  CellLabel->"Out[41]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(qofnewg2 = System`PolynomialQuotient[newg2, newg, x]\)], "Input",
  CellLabel->"In[42]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(0.3770000000004689179`0.6532872578215781 + 
      2.7619999999996594761`2.36601592227288\ x + 
      7.6470000000000735015`3.6561271484490563\ x\^2 + 
      9.7650000000000000001`4.609268262721972\ x\^3 + 
      5.5029999999999999999`5.221848749616356\ x\^4 + 
      1.0010000000000000001`5.522878745280337\ x\^5\)], "Output",
  CellLabel->"Out[42]=",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Map[Tolerance, CoefficientList[qofnewg2, x]]\)], "Input",
  CellLabel->"In[43]:=",
  CellTags->"b:1.2"],

Cell[BoxData[
    \({0.0837633604837701654547362713`15.351823247397052, 
      0.0118907090319978911631314865`15.12037590016638, 
      0.0016879669606956531923164417`14.982612047692037, 
      0.0002401065374625391168956593`14.888473820203483, 
      0.00003301800000000009544469527147762021`14.802670564671018, 
      3.00300000000001134195079329688822`14.850242708344911*^-6}\)], "Output",\

  CellLabel->"Out[43]=",
  CellTags->"b:1.2"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Mathematical Background", "Subsubsection",
  ShowCellBracket->True,
  CellTags->"b:1.2"],

Cell["Polynomial Division (univariate case)", "FramedBox",
  CellTags->"b:1.2"],

Cell[TextData[{
  "Let ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`g(x)\)]],
  " be the following polynomials of degrees ",
  Cell[BoxData[
      \(TraditionalForm\`n\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`m\)]],
  " ",
  Cell[BoxData[
      \(TraditionalForm\`\((\(\[LessEqual]\)\(n\))\)\)]],
  " with tolerances ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\_f\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\_g\)]],
  ", respectively."
}], "Text",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(TextForm\`f \((x)\) = \(f\_n\) x\^n + \(f\_\(n - 1\)\) 
          x\^\(n - 1\) + \[CenterEllipsis] + \(f\_1\) x + f\_0, \ 
    f\_i \[Element] \[DoubleStruckCapitalC], \[IndentingNewLine]g \((x)\) = \
\(g\_m\) x\^m + \(g\_\(m - 1\)\) x\^\(m - 1\) + \[CenterEllipsis] + \(g\_1\) 
          x + g\_0, \ 
    g\_i \[Element] \(\(\[DoubleStruckCapitalC]\)\(.\)\)\)], \
"NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[TextData[{
  "Dividing ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  " by ",
  Cell[BoxData[
      \(TraditionalForm\`g(x)\)]],
  " is defined as follows, with polynomials ",
  Cell[BoxData[
      \(TraditionalForm\`q(x)\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`r(x)\)]],
  "."
}], "Text",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(TextForm\`f \((x)\) = q \((x)\)\ g \((x)\) + r \((x)\), \ 
    deg\ q = n - m, \ deg\ r < \(\(m\)\(.\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[TextData[{
  "For SNAP structures, we have to take care of the following polynomials ",
  Cell[BoxData[
      \(TraditionalForm\`\(q\&_\)(x)\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`\(r\&_\)(x)\)]],
  " for the given ",
  Cell[BoxData[
      \(TraditionalForm\`\(f\&_\)(x)\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`\(g\&_\)(x)\)]],
  "."
}], "Text",
  CellTags->"b:1.2"],

Cell[BoxData[
    \(TextForm\`\(f\&_\) \((x)\) = \(q\&_\) \((x)\)\ \(g\&_\) \((x)\) + \
\(r\&_\) \((x)\), \ deg\ q\&_ = n - m, \ deg\ r\&_ < m, \ 
    f\&_ \[Element] \(P\_*\) \((f, \[Epsilon]\_f)\), \ 
    g\&_ \[Element] \(P\_*\) \(\((g, \[Epsilon]\_g)\)\(.\)\)\)], \
"NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell["\<\
We have the following corollaries [Nag04b]. Note that the discussion at the \
end of the subsection \[OpenCurlyDoubleQuote]Tolerance Mechanisms\
\[CloseCurlyDoubleQuote].\
\>", "Text",
  CellTags->"b:1.2"],

Cell["Corollary 2 (Corollary 2 in [Nag04b])", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.2"],

Cell["If the following expression holds,", "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[BoxData[
    \(TextForm\`\(\[Sigma]\_2\) \(\@\(n + 1\)\) \[Epsilon]\_g < 
      1, \ \[Sigma]\_2 = \(\(\[DoubleVerticalBar]\)\(G\^\(-1\)\)\( \
\[DoubleVerticalBar] \_2\)\), \)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell["we have", "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[BoxData[
    \(TextForm\`\[ForAll] f\&_ \[Element] \(P\_2\) \((f, \[Epsilon]\_f)\), \ \
\[ForAll] g\&_ \[Element] \(P\_2\) \((g, \[Epsilon]\_g)\), \ 
    q\&_ \[Element] \(P\_2\) \((q, \[Epsilon]\_q)\), \ 
    r\&_ \[Element] \(P\_2\) \((r, \[Epsilon]\_r)\), \[IndentingNewLine]\
\[Epsilon]\_q = \(\[Sigma]\_2\) \((\[Epsilon]\_f + \(\@\(n + 
                    1\)\) \(\[Epsilon]\_g\) \
\((\(\[DoubleVerticalBar]\)\(q\)\( \[DoubleVerticalBar] \_2\)\(\(+\[Sigma]\_2\
\) \[Epsilon]\_f\))\)/\((1 - \(\[Sigma]\_2\) \(\@\(n + 
                            1\)\) \[Epsilon]\_g)\))\), \[IndentingNewLine]\
\[Epsilon]\_r = \[Epsilon]\_f + \(\@\(\[LeftCeiling]n\/2\[RightCeiling] + 
                1\)\) \(\((\(\[DoubleVerticalBar]\)\(g\)\( \
\[DoubleVerticalBar] \
\_2\)\(\(\[Epsilon]\_q\)\(+\)\)\(\[DoubleVerticalBar]\)\(q\)\( \
\[DoubleVerticalBar] \_2\)\(\[Epsilon]\_g + \(\[Epsilon]\_g\) \
\[Epsilon]\_q\))\)\(.\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell["Corollary 3 (Corollary 3 in [Nag04b])", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.2"],

Cell["If the following expression holds,", "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[BoxData[
    \(TextForm\`\[Sigma]\_1\ \[Epsilon]\_g < 
      1, \ \[Sigma]\_1 = \(\(\[DoubleVerticalBar]\)\(G\^\(-1\)\)\( \
\[DoubleVerticalBar] \_1\)\), \)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell["we have", "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[BoxData[
    \(TextForm\`\[ForAll] f\&_ \[Element] \(P\_1\) \((f, \[Epsilon]\_f)\), \ \
\[ForAll] g\&_ \[Element] \(P\_1\) \((g, \[Epsilon]\_g)\), \ 
    q\&_ \[Element] \(P\_1\) \((q, \[Epsilon]\_q)\), \ 
    r\&_ \[Element] \(P\_1\) \((r, \[Epsilon]\_r)\), \[IndentingNewLine]\
\[Epsilon]\_q = \(\[Sigma]\_1\) \((\[Epsilon]\_f + \(\[Epsilon]\_g\) \((\(\
\[DoubleVerticalBar]\)\(q\)\( \[DoubleVerticalBar] \_1\)\(\(+\[Sigma]\_1\) \
\[Epsilon]\_f\))\)/\((1 - \[Sigma]\_1\ \[Epsilon]\_g)\))\), \
\[IndentingNewLine]\[Epsilon]\_r = \(\(\[Epsilon]\_f\)\(+\)\) \
\[DoubleVerticalBar] 
        g\( \[DoubleVerticalBar] \_1\)\(\(\[Epsilon]\_q\)\(+\)\) \
\[DoubleVerticalBar] 
        q\( \[DoubleVerticalBar] \_1\)\[Epsilon]\_g + \(\[Epsilon]\_g\) \(\(\
\[Epsilon]\_q\)\(.\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell["Corollary 4 (Corollary 4 in [Nag04b])", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.2"],

Cell["If the following expression holds,", "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[BoxData[
    \(TextForm\`\(\[Sigma]\_\[Infinity]\) \((n + 1)\) \[Epsilon]\_g < 
      1, \ \[Sigma]\_\[Infinity] = \(\(\[DoubleVerticalBar]\)\(G\^\(-1\)\)\( \
\[DoubleVerticalBar] \_\[Infinity]\)\), \)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell["we have", "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[BoxData[
    \(TextForm\`\[ForAll] f\&_ \[Element] \(P\_\[Infinity]\) \((f, \[Epsilon]\
\_f)\), \ \[ForAll] g\&_ \[Element] \(P\_\[Infinity]\) \((g, \
\[Epsilon]\_g)\), \ 
    q\&_ \[Element] \(P\_\[Infinity]\) \((q, \[Epsilon]\_q)\), \ 
    r\&_ \[Element] \(P\_\[Infinity]\) \((r, \[Epsilon]\_r)\), \
\[IndentingNewLine]\[Epsilon]\_q = \(\[Sigma]\_\[Infinity]\) \((\[Epsilon]\_f \
+ \((n + 1)\) \(\[Epsilon]\_g\) \((\(\[DoubleVerticalBar]\)\(q\)\( \
\[DoubleVerticalBar] \_\[Infinity]\)\(\(+\[Sigma]\_\[Infinity]\) \
\[Epsilon]\_f\))\)/\((1 - \(\[Sigma]\_\[Infinity]\) \((n + 
                          1)\) \[Epsilon]\_g)\))\), \[IndentingNewLine]\
\[Epsilon]\_r = \[Epsilon]\_f + \((\[LeftCeiling]n\/2\[RightCeiling] + 
              1)\) \(\((\(\[DoubleVerticalBar]\)\(g\)\( \[DoubleVerticalBar] \
\_\[Infinity]\)\(\(\[Epsilon]\_q\)\(+\)\)\(\[DoubleVerticalBar]\)\(q\)\( \
\[DoubleVerticalBar] \_\[Infinity]\)\(\[Epsilon]\_g + \(\[Epsilon]\_g\) \
\[Epsilon]\_q\))\)\(.\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[TextData[{
  "In the above corollaries, ",
  Cell[BoxData[
      \(TraditionalForm\`A\^\(-1\)\)]],
  " denotes the inverse matrix of ",
  Cell[BoxData[
      \(TraditionalForm\`A\)]],
  " and G is the following matrix of size ",
  Cell[BoxData[
      \(TraditionalForm\`\((n + 1)\)\[Times]\((n + 1)\)\)]],
  "."
}], "Text",
  CellTags->"b:1.2"],

Cell[BoxData[
    FormBox[
      RowBox[{"G", "=", 
        RowBox[{
          RowBox[{"(", GridBox[{
                {\(g\_m\), "0", "\[CenterEllipsis]", "\[CenterEllipsis]", "0",
                   "0"},
                {\(g\_\(m - 1\)\), \(g\_m\), "\[DescendingEllipsis]", 
                  "\[DescendingEllipsis]", "\[VerticalEllipsis]", 
                  "\[VerticalEllipsis]"},
                {"\[VerticalEllipsis]", \(g\_\(m - 1\)\), 
                  "\[DescendingEllipsis]", "\[DescendingEllipsis]", 
                  "\[VerticalEllipsis]", "\[VerticalEllipsis]"},
                {\(g\_0\), "\[VerticalEllipsis]", "\[DescendingEllipsis]", 
                  "\[DescendingEllipsis]", "0", "\[VerticalEllipsis]"},
                {"\[VerticalEllipsis]", "\[VerticalEllipsis]", 
                  "\[DescendingEllipsis]", "\[DescendingEllipsis]", \(g\_m\), 
                  "0"},
                {"0", "\[CenterEllipsis]", "\[CenterEllipsis]", 
                  "\[CenterEllipsis]", \(g\_\(m - 1\)\), \(g\_m\)}
                }], ")"}], "."}]}], TextForm]], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell["Polynomial Reduction (more than one variable case)", "FramedBox",
  CellTags->"b:1.2"],

Cell["\<\
In this version, the SNAP structure is extended to multivariate polynomials, \
hence we introduce polynomial reductions for that. However, a reduction can \
be done by two multiplications and one subtraction. There is nothing to do \
except for operations for normal polynomial reductions. We just reduce \
polynomials by ordinary algorithms, but using SNAP structures introduced in \
the previous section.\
\>", "Text",
  CellTags->"b:1.2"],

Cell["Root Finding (with error considerations)", "FramedBox",
  CellTags->"b:1.2"],

Cell[TextData[{
  "There are a lot of root finding methods. For example, basically, ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " uses Jenkins\[Hyphen]Traub method. Since those roots found by numerical \
methods may not the exact ones, we have to consider numerical errors after \
calculations. For example, Smith [Smi70] studied error bounds for numerical \
roots."
}], "Text",
  CellTags->"b:1.2"],

Cell["\<\
However, operating polynomials with errors on their coefficients extends the \
problem. In Terui and Sasaki [TS00], they studied an extended version of \
Smith's work, by which we can bound errors included in numerical roots of \
polynomials with errors on their coefficients and for polynomials represented \
as SNAP structures.\
\>", "Text",
  CellTags->"b:1.2"],

Cell["Lemma 3 (Statement in [TS00])", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.2"],

Cell[TextData[{
  "For any polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`\(f\&_\)(x) \[Element] \(P\_*\)(f, \[Epsilon])\)]],
  ", we have"
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[BoxData[
    FormBox[
      RowBox[{
        RowBox[{
          StyleBox["|",
            SpanMaxSize->1], 
          StyleBox[\(\[Zeta]\_i - \[Zeta]\&_\_\(\[Pi] \((i)\)\)\),
            SpanMaxSize->1], 
          StyleBox["|",
            
            SpanMaxSize->
              1], \(\(\[LessEqual]\)\(n\ \(\(|\)\(f \((\[Zeta]\_i)\)\)\(|\)\(\
\(+\ \[Epsilon]\)\ \[Sum]\_\(j = 0\)\%n\)\(|\)\(\[Zeta]\_i\)\( | \
\^j\)\)\/\(\((\(|\)\(f\_n\)\(|\)\(+\ \[Epsilon]\))\) | \[Product]\_\(j = 1, \
\(\(\[NotEqual]\)\(i\)\)\)\%n\((\[Zeta]\_i - \[Zeta]\_j)\) | \)\)\)}], ","}], 
      TextForm]], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[TextData[{
  "where ",
  Cell[BoxData[
      \(TraditionalForm\`n\)]],
  " denotes the degree of ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`\[Zeta]\_1, \[Ellipsis], \ \[Zeta]\_n\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`\[Zeta]\&_\_\(\[Pi](1)\), \ \[Ellipsis], \ \
\[Zeta]\&_\_\(\[Pi](n)\)\)]],
  " are the roots of ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`\(f\&_\)(x)\)]],
  ", respectively, and ",
  Cell[BoxData[
      \(TraditionalForm\`\[Pi](i)\)]],
  " is a permutation on ",
  Cell[BoxData[
      \(TraditionalForm\`{1, \ \[Ellipsis], \ n}\)]],
  ", which minimizes the maximum distance between the roots: ",
  Cell[BoxData[
      \(TraditionalForm\`\(max\_i\) \(\(|\)\(\[Zeta]\_i - \
\[Zeta]\&_\_\(\[Pi](i)\)\)\(|\)\)\)]],
  "."
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell["Partial Derivation (with error considerations)", "FramedBox",
  CellTags->"b:1.2"],

Cell["\<\
Computing the partial derivation of the given polynomial is also important. \
We have the following trivial lemma to calculate the derivations of SNAP \
structures.\
\>", "Text",
  CellTags->"b:1.2"],

Cell["Lemma 4", "Text",
  FontWeight->"Bold",
  CellTags->"b:1.2"],

Cell[TextData[{
  "For any polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`\(f\&_\)(u\_1, \ \[Ellipsis], \ 
          u\_r) \[Element] \(P\_*\)(f, \[Epsilon])\)]],
  ", we have"
}], "Text",
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"],

Cell[BoxData[
    \(TextForm\`\(\[PartialD]f\&_ \((u\_1, \ \[Ellipsis], \ u\_r)\)\)\/\
\[PartialD]u\_i \[Element] \(P\_*\) \((\(\[PartialD]f \((u\_1, \ \[Ellipsis], \
\ u\_r)\)\)\/\[PartialD]u\_i, \ \[Epsilon]\[Times]\(deg\_\(u\_i\)\) 
            f)\)\ \ \ \ \ \ \ \ \ \ \ \ \ \(\((i = 1, \[Ellipsis], \ 
            r)\)\(.\)\)\)], "NumberedEquation",
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.2"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Symbolic Numeric Algorithms Implemented", "Subsection",
  CellTags->{"i:12", "b:1.3", "c:8"}],

Cell["\<\
Using the above basic features, we have started to modify and implement known \
symbolic numeric algorithms. In the below and the current implementations, \
one algorithm for each computation is only used, however, this is not \
intended and other algorithms will be implemented in the near future.\
\>", "Text",
  CellTags->"b:1.3"],

Cell[TextData[Cell[BoxData[
    FormBox[GridBox[{
          {Cell["function"], Cell["purpose"]},
          {
            StyleBox["PolynomialGCD",
              FontFamily->"Courier"], \(computes\ an\ \[Epsilon] - 
              GCD\ of\ the\ given\ two\ \(\(polynomials\)\(.\)\)\)},
          {
            "CoprimeQ", \(gives\ True\ if\ the\ two\ polynomials\ are\ \
coprime\ within\ the\ tolerance\ or\ significant\ \(\(numbers\)\(.\)\)\)},
          {
            StyleBox["ApproximateDivisorQ",
              FontFamily->"Courier"], 
            RowBox[{"gives", " ", 
              StyleBox["True",
                FontFamily->"Courier"], " ", "if", " ", "the", " ", "first", 
              " ", "argument", " ", "is", " ", "divisible", " ", "by", " ", 
              "the", " ", "second", " ", "one", 
              " ", \(\(approximately\)\(.\)\)}]},
          {
            StyleBox["ApproximateQuotient",
              FontFamily->"Courier"], 
            RowBox[{"gives", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "quotient", " ", "if", " ", 
              StyleBox["ApproximateDivisorQ",
                FontFamily->"Courier"], " ", "is", " ", 
              RowBox[{
                StyleBox["True",
                  FontFamily->"Courier"], ".", " "}]}]},
          {
            StyleBox["NearestSingularPolynomial",
              
              FontFamily->
                "Courier"], \(computes\ the\ nearest\ singular\ polynomial\ \
\(\((\ tolerace\ is\ not\ considered)\)\(.\)\)\)},
          {
            StyleBox["AbsolutelyIrreducibleQ",
              FontFamily->"Courier"], 
            RowBox[{"gives", " ", 
              StyleBox["True",
                FontFamily->"Courier"], " ", "if", " ", "the", " ", 
              "polynomial", " ", "is", " ", "absolutely", " ", "irreducible", 
              " ", "within", " ", "the", " ", \(\(tolerance\)\(.\)\)}]},
          {
            StyleBox["SeparationBound",
              FontFamily->"Courier"], 
            RowBox[{"computes", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "separation", " ", "bound", " ", 
              "of", " ", "the", " ", "given", 
              " ", \(\(polynomial\)\(.\)\)}]},
          {
            StyleBox["Factor",
              
              FontFamily->
                "Courier"], \(factorizes\ the\ given\ polynomial\ \
\(\(numerically\)\(.\)\)\)},
          {
            StyleBox["FactorList",
              FontFamily->"Courier"], 
            RowBox[{"gives", " ", 
              StyleBox["a",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], " ", "list", " ", "of", " ", "pseudo", 
              " ", "factors", " ", "of", " ", "the", " ", "given", 
              " ", \(\(polynomial\)\(.\)\)}]}
          }], TraditionalForm]], "DisplayFormula",
  GridBoxOptions->{RowLines->{2, 0.5},
  ColumnLines->True},
  CellTags->"Groups:classical groups"]], "DefinitionBox",
  CellTags->"b:1.3"],

Cell[TextData[{
  StyleBox["Table ", "SB"],
  StyleBox[
  CounterBox["NumberedTable"], "SB"],
  StyleBox[". ", "SB"],
  "Symbolic Numeric Functions"
}], "SmallTextSans",
  CellMargins->{{27, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell["Examples", "Subsubsection",
  ShowCellBracket->True,
  CellTags->"b:1.3"],

Cell["\<\
We show some examples of the package, about SNAP operations. This remains the \
polynomial used in the above.\
\>", "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g\)], "Input",
  CellLabel->"In[44]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[44]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell["\<\
Introduce another polynomial. Though we retain it as not in a SNAP structure, \
treating it in that is also acceptable.\
\>", "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(h = 
      1.3883`16\[InvisibleSpace] + 4.417`16\ x + 3.8861`16\ x\^2 + 
        0.85593`16\ x\^3\)], "Input",
  CellLabel->"In[45]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(1.3883`16.000000000000004 + 4.417`16.000000000000004\ x + 
      3.8861`16.000000000000004\ x\^2 + 
      0.85593`16.000000000000004\ x\^3\)], "Output",
  CellLabel->"Out[45]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell["The built-in function outputs these polynomial are coprime.", "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`PolynomialGCD[Normal[g], h]\)], "Input",
  CellLabel->"In[46]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(1\/4000\)], "Output",
  CellLabel->"Out[46]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[TextData[{
  "SNAP package can compute a their ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-GCD as below, where ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon] = 0.0001\)]],
  "."
}], "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(gcdofgh = PolynomialGCD[g, h, 0.0001`16]\)], "Input",
  CellLabel->"In[50]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(SNAP::"preliminary" \(\(:\)\(\ \)\) 
      "Preliminary implemented function is called."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[50]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(\(\(0.00005`\)\(\[InvisibleSpace]\)\) + 0.00015907944968666715`\ x + 
      0.00013995894259165886`\ x\^2 + 
      0.00003082655045739393`\ x\^3\)], "Output",
  CellLabel->"Out[50]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell["We can check its approximate divisibility.", "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ApproximateDivisorQ[g, gcdofgh, 0.0001`16]\)], "Input",
  CellLabel->"In[51]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[51]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ApproximateQuotient[g, gcdofgh, 0.0001`16]\)], "Input",
  CellLabel->"In[52]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(\(\(7543.972371664776`\)\(\[InvisibleSpace]\)\) + 
      31237.66598363115`\ x + 32438.96839463335`\ x\^2\)], "Output",
  CellLabel->"Out[52]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell["\<\
Without any tolerance, the maximum tolerance between the given polynomials is \
used.\
\>", "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolynomialGCD[g, h] // Timing\)], "Input",
  CellLabel->"In[53]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(SNAP::"preliminary" \(\(:\)\(\ \)\) 
      "Preliminary implemented function is called."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[53]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \({0.810999999999999`\ Second, 1}\)], "Output",
  CellLabel->"Out[53]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell["\<\
This also checks whether they are coprime or not within their tolerance.\
\>", "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CoprimeQ[g, h] // Timing\)], "Input",
  CellLabel->"In[54]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \({0.07099999999999973`\ Second, True}\)], "Output",
  CellLabel->"Out[54]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[TextData[{
  "This gives the nearest singular polynomial of ",
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  ", so the output polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`nsg\)]],
  " has a double root."
}], "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(nsg = NearestSingularPolynomial[g]\)], "Input",
  CellLabel->"In[55]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(SNAP::"preliminary" \(\(:\)\(\ \)\) 
      "Preliminary implemented function is called."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[55]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(0.3772035197483813701677578908898396818763600422140656721197769713561301\
7214802`62.180990684161266 + 
      2.7620229415240444334283504894063958576218693665264727856231377878387684\
7587565`63.25240765654008\ x + 
      7.6469886766205613576225041617310994650085222144475957978865060135373168\
1741202`63.92016650122782\ x\^2 + 
      9.7650055889452532941127029302322860194239056859654563607269875010535303\
9650504`64.26464678431904\ x\^3 + 
      5.5029972414322761523668220364701836077471614600933081235123015006948311\
0355288`64.26317991397421\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[55]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(x /. NSolve[nsg == 0, x]\)], "Input",
  CellLabel->"In[56]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(SNAP::"multipleroots" \(\(:\)\(\ \)\) 
      "The given representative polynomial has multiple roots. Tolerances of \
the roots can not be computed."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[56]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \({\(-3.\
00005313065094568375230434318607841057397433984142283781058763766680702446852`\
60.955270094423\), \
\(-0.9993512817134660583032410448644260135642552612868565250016588763365995831\
3288`59.84924557426989\), \
\(-0.5164413724592175098972076648365735469193342793208424522206174451433216109\
8457`57.60641875039687\), \
\(-0.493575728304323450207034491791553778728861567829`29.49018048018935\), \
\(-0.493575728304323450207034491791551926818921518859`29.49018048018935\)}\)],\
 "Output",
  CellLabel->"Out[56]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell["\<\
To show the example of absolutely irreducibility testing, we define the \
following bivariate polynomial.\
\>", "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(f = 
      Expand[\((x^2 + y*x + 2  y - 1)\) \((x^3 + y^2\ x - y + 7)\) + 
          0.2`16  x]\)], "Input",
  CellLabel->"In[57]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(\(-7\) + 0.2`16. \ x + 7\ x\^2 - x\^3 + x\^5 + 15\ y + 7\ x\ y - 
      x\^2\ y + 2\ x\^3\ y + x\^4\ y - 2\ y\^2 - 2\ x\ y\^2 + x\^3\ y\^2 + 
      2\ x\ y\^3 + x\^2\ y\^3\)], "Output",
  CellLabel->"Out[57]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[TextData[{
  "This tests its absolutely irreducibility within the given tolerance ",
  Cell[BoxData[
      \(TraditionalForm\`0.00001\)]],
  "."
}], "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(AbsolutelyIrreducibleQ[f, 0.00001`16]\)], "Input",
  CellLabel->"In[59]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[59]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell["\<\
If the given polynomial has a SNAP structure, its tolerance is used, so the \
following evaluations give the same result.\
\>", "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(fs = SNAP[f, 0.00001`16]\)], "Input",
  CellLabel->"In[61]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(\(-7.`\) + 0.2`\ x + 7.`\ x\^2 - 1.`\ x\^3 + x\^5 + 15.`\ y + 
      7.`\ x\ y - 1.`\ x\^2\ y + 2.`\ x\^3\ y + x\^4\ y - 2.`\ y\^2 - 
      2.`\ x\ y\^2 + x\^3\ y\^2 + 2.`\ x\ y\^3 + x\^2\ y\^3\)], "Output",
  CellLabel->"Out[61]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(AbsolutelyIrreducibleQ[fs]\)], "Input",
  CellLabel->"In[62]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[62]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[TextData[{
  "We can compute a separation bound of ",
  Cell[BoxData[
      \(TraditionalForm\`f\)]],
  " also. In this case, all the polynomial of ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_2\)(f, 0.000791621567)\)]],
  " are absolutely irreducible."
}], "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SeparationBound[f]\)], "Input",
  CellLabel->"In[63]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(0.0007916215678719798758995567`10.251025827330634\)], "Output",
  CellLabel->"Out[63]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[TextData[{
  "This gives an example using the algorithm adapted for the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s coefficient-wise accuracy concept. Hence, changing all the coefficients \
within their accuracy does not change its absolute irreducibility."
}], "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(AbsolutelyIrreducibleQ[f]\)], "Input",
  CellLabel->"In[64]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[64]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell["\<\
For numerical polynomials, the built-in function gives the input.\
\>", "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(f2 = 
      N@Expand[\((x^2 + y*x + 2  y - 1)\) \((x^3 + y^2\ x - y + 
                7)\)]\)], "Input",
  CellLabel->"In[65]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(\(-7.`\) + 7.`\ x\^2 - 1.`\ x\^3 + x\^5 + 15.`\ y + 7.`\ x\ y - 
      1.`\ x\^2\ y + 2.`\ x\^3\ y + x\^4\ y - 2.`\ y\^2 - 2.`\ x\ y\^2 + 
      x\^3\ y\^2 + 2.`\ x\ y\^3 + x\^2\ y\^3\)], "Output",
  CellLabel->"Out[65]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`Factor[f2]\)], "Input",
  CellLabel->"In[66]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(1.`\ \((\(-7.`\) + 7.`\ x\^2 - 1.`\ x\^3 + 1.`\ x\^5 + 15.`\ y + 
          7.`\ x\ y - 1.`\ x\^2\ y + 2.`\ x\^3\ y + 1.`\ x\^4\ y - 
          2.`\ y\^2 - 2.`\ x\ y\^2 + 1.`\ x\^3\ y\^2 + 2.`\ x\ y\^3 + 
          1.`\ x\^2\ y\^3)\)\)], "Output",
  CellLabel->"Out[66]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell["\<\
With the SNAP package, for example, we can factorize it numerically with a \
backward error bound.\
\>", "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Chop@Factor[f2, 0.0000001`16]\)], "Input",
  CellLabel->"In[70]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(SNAP::"machineprecision" \(\(:\)\(\ \)\) 
      "SNAP function encounters a machine precision number. Machine precision \
numbers may not have enough accuracy due to Mathematica's inner operation \
policy."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[70]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(SNAP::"machineprecision" \(\(:\)\(\ \)\) 
      "SNAP function encounters a machine precision number. Machine precision \
numbers may not have enough accuracy due to Mathematica's inner operation \
policy."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[70]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(SNAP::"machineprecision" \(\(:\)\(\ \)\) 
      "SNAP function encounters a machine precision number. Machine precision \
numbers may not have enough accuracy due to Mathematica's inner operation \
policy."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[70]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(SNAP :: \\\"machineprecision\\\"\\) will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[70]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(\((\(-1.`15.272219027674444\) + 
          x\^2 + \((\(\(2.`\)\(\[InvisibleSpace]\)\) + 
                1.`\ x)\)\ y)\)\ \((7.`15.377181505608839 + x\^3 - 
          1.0000000000000002`\ y + 
          0.9999999999999997`\ x\ y\^2)\)\)], "Output",
  CellLabel->"Out[70]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell["\<\
If we use a SNAP structure, its tolerance is used as a backward error bound \
automatically.\
\>", "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(f2s = 
      SNAP[N@Expand[\((x^2 + y*x + 2  y - 1)\) \((x^3 + y^2\ x - y + 7)\)], 
        0.0000001`16]\)], "Input",
  CellLabel->"In[71]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(\(-7.`\) + 7.`\ x\^2 - 1.`\ x\^3 + x\^5 + 15.`\ y + 7.`\ x\ y - 
      1.`\ x\^2\ y + 2.`\ x\^3\ y + x\^4\ y - 2.`\ y\^2 - 2.`\ x\ y\^2 + 
      x\^3\ y\^2 + 2.`\ x\ y\^3 + x\^2\ y\^3\)], "Output",
  CellLabel->"Out[71]=",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Chop@Factor[f2s]\)], "Input",
  CellLabel->"In[72]:=",
  CellTags->"b:1.3"],

Cell[BoxData[
    \(\((\(-1.`15.317629257483443\) + 
          x\^2 + \((2.0000000000000000000069174357`14.093546064686803 + 
                1.0000000000000000000023999267`13.806630799766396\ x)\)\ y)\)\
\ \((7.`15.422591735417836 + x\^3 - 
          1.0000000000000000002183012924`13.05560191700747\ y + 
          0.9999999999999999998041428575`12.029207339667247\ x\ y\^2)\)\)], \
"Output",
  CellLabel->"Out[72]=",
  CellTags->"b:1.3"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Mathematical Background", "Subsubsection",
  ShowCellBracket->True,
  CellTags->"b:1.3"],

Cell["Approximate GCD and Divisors (univariate case)", "FramedBox",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell[TextData[{
  "Various approximate GCDs have been studied from the early period in \
history of symbolic numeric computations. The problem treated here is very \
simple, for the given polynomials ",
  Cell[BoxData[
      \(TraditionalForm\`g(x)\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`h(x)\)]],
  " and the tolerance ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  ", finding polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  " which maximizes its degree and satisfies"
}], "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell[BoxData[
    \(TextForm\`\(\(\[Exists] \(g\&_\) \((x)\) \[Element] \(P\_*\) \((g, \ \
\[Epsilon]\  \[DoubleVerticalBar] 
              g\( \[DoubleVerticalBar] \_*\))\)\)\(,\)\(\ \)\(\[Exists] \
\(h\&_\) \((x)\) \[Element] \(P\_*\) \((h, \ \[Epsilon]\  \
\[DoubleVerticalBar] 
              h\( \[DoubleVerticalBar] \_*\))\)\)\(,\)\(\ \)\(f \((x)\) | \(g\
\&_\) \((x)\)\)\(,\)\(\ \)\(f \((x)\) | \(h\&_\) \((x)\)\)\(,\)\(\ \)\)\)], \
"NumberedEquation",
  ShowCellBracket->False,
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.3"],

Cell[TextData[{
  "where ",
  Cell[BoxData[
      \(TraditionalForm\`*\)]],
  " denotes ",
  Cell[BoxData[
      \(TraditionalForm\`2\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`1\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`\[Infinity]\)]],
  ", respectively. ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  " is called ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-GCD of polynomials ",
  Cell[BoxData[
      \(TraditionalForm\`g(x)\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`h(x)\)]],
  " with tolerance ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  ". Currently, we have implemented the algorithm by Pan [Pan01], for the ",
  Cell[BoxData[
      \(TraditionalForm\`2\)]],
  "-norm case only."
}], "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell["\<\
We note that there are also other approximate GCDs which have a little bit \
different definitions, and also approximate GCDs of multivariate polynomials. \
Those approximate GCDs will be implemented in the future release.\
\>", "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell[TextData[{
  "Considering approximate GCDs, the following concept of an ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-divisor is useful. For the given polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`g(x)\)]],
  " and the tolerance ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  ", we call a polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  " is an ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-divisor of ",
  Cell[BoxData[
      \(TraditionalForm\`g(x)\)]],
  " if ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  " satisfies "
}], "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell[BoxData[
    \(TextForm\`\[Exists] \(g\&_\) \((x)\) \[Element] \(P\_*\) \((g, \ \
\[Epsilon]\  \[DoubleVerticalBar] g\( \[DoubleVerticalBar] \_*\))\), \ 
    f \((x)\) | \(g\&_\) \((x)\), \)], "NumberedEquation",
  ShowCellBracket->False,
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.3"],

Cell[TextData[{
  "where ",
  Cell[BoxData[
      \(TraditionalForm\`*\)]],
  " denotes ",
  Cell[BoxData[
      \(TraditionalForm\`2\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`1\)]],
  " and ",
  Cell[BoxData[
      \(TraditionalForm\`\[Infinity]\)]],
  ", respectively. Moreover, in this package, we call the quotient of ",
  Cell[BoxData[
      \(TraditionalForm\`\(g\&_\)(x)\)]],
  " by ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  " an ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-quotient of ",
  Cell[BoxData[
      \(TraditionalForm\`g(x)\)]],
  " by ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  ". These concepts are used in the Pan's algorithm and currently, we have \
implemented for the ",
  Cell[BoxData[
      \(TraditionalForm\`2\)]],
  "-norm case only."
}], "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell[TextData[{
  "Note that, theoretically, ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-GCD, ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-divisor and ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-quotient are exact polynomials, since only the given polynomials have \
perturbation parts and ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-GCD, ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-divisor and ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-quotient are treated as exact polynomials in that computations. However, \
due to numerical errors, in this package,  ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-GCD, ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-divisor and ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-quotient are treated as SNAP structures."
}], "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell["The Nearest Singular Polynomial (univariate case)", "FramedBox",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell[TextData[{
  "The nearest singular polynomial [KL96, ZW98, ZWNK01], of ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  " is the nearest polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`\(f\&_\)(x)\)]],
  " which has a double root, minimizes ",
  Cell[BoxData[
      \(TraditionalForm\`\(\(\[DoubleVerticalBar]\)\(f(x) - \(f\&_\)(
            x)\)\(\[DoubleVerticalBar]\)\)\)]],
  " and has the same degree as ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  ". The similar problem that finds the nearest polynomial with constrained \
roots, has been studied [HK98, HKL99]."
}], "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell["\<\
In this package, finding the nearest singular polynomial can be written as \
follows.\
\>", "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell[TextData[{
  "For the given polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`f(x)\)]],
  " and the tolerance ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  ", find a polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`\(f\&_\)(x)\)]],
  " satisfying "
}], "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell[BoxData[
    \(TextForm\`\(f\&_\) \((x)\) \[Element] \(P\_*\) \((f, \ \[Epsilon])\), \ \
\[Exists] c \[Element] \[DoubleStruckCapitalC], \ \((x - c)\)\^2 | \(f\&_\) \
\((x)\), \)], "NumberedEquation",
  ShowCellBracket->False,
  CellMargins->{{103, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.3"],

Cell[TextData[{
  "where ",
  Cell[BoxData[
      \(TraditionalForm\`*\)]],
  " denotes ",
  Cell[BoxData[
      \(TraditionalForm\`1\)]],
  ", ",
  Cell[BoxData[
      \(TraditionalForm\`2\)]],
  " or ",
  Cell[BoxData[
      \(TraditionalForm\`\[Infinity]\)]],
  ", or output False which means that the nearest singular polynomial does \
not exist in the given SNAP structure. The current version of package solves \
this problem due to the known algorithm [ZWNK01], so the command can solve \
the problem for the ",
  Cell[BoxData[
      \(TraditionalForm\`2\)]],
  "-norm case only. The constrained roots version of the problem will be \
solvable in the future release."
}], "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell["\<\
Note that the current implementation outputs a normal polynomial (not in a \
SNAP structure) and the given tolerance for the command corresponding to the \
nearest singular polynomial does not have the same meaning of other commands \
of SNAP package. For more information, see [ZWNK01].\
\>", "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell["Irreducibility Testing for Bivariate Polynomials", "FramedBox",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell["\<\
Conventional ordinary factorization algorithms may always output \
\[OpenCurlyDoubleQuote]absolutely irreducible\[CloseCurlyDoubleQuote] for \
numerical or empirical polynomials since the given polynomial may have error \
parts on their coefficients even if the original polynomial is reducible. \
Moreover, if a numerical factorization algorithm, for example see [Sas01], \
outputs \[OpenCurlyDoubleQuote]no non-trivial factors found\
\[CloseCurlyDoubleQuote], it does not mean \[OpenCurlyDoubleQuote]absolutely \
irreducible\[CloseCurlyDoubleQuote] since those algorithms basically can find \
factors when the given polynomial is enough close to a reducible polynomial. \
Hence, the problem \[OpenCurlyDoubleQuote]irreducibility testing\
\[CloseCurlyDoubleQuote] is still important for numerical or empirical \
polynomials (for more informations, see [Kal95, KM03, Nag04c, Nag03, Nag02]).\
\
\>", "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell["In this package, the problem becomes as follows.", "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell[TextData[{
  "For the given SNAP structure ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_*\)(f, \[Epsilon])\)]],
  ", prove that any polynomial ",
  Cell[BoxData[
      \(TraditionalForm\`\(f\&_\)(u\_1, \ \[Ellipsis], \ 
          u\_r) \[Element] \(P\_*\)(f, \[Epsilon])\)]],
  " is absolutely irreducible."
}], "Text",
  ShowCellBracket->False,
  CellMargins->{{87, Inherited}, {Inherited, Inherited}},
  CellTags->"b:1.3"],

Cell[TextData[{
  "The algorithm implemented in this package is due to Nagasaka [Nag04c] \
which is an improved version of the algorithm due to Kaltofen and May [KM03], \
for bivariate polynomials. Note that the current implementation is based on \
the algorithm for the ",
  Cell[BoxData[
      \(TraditionalForm\`2\)]],
  "-norm case, hence there are possibilities to be better for another norms. \
The version for more than two variables will be implemented in the future \
release. The largest problem to implement more than two variable cases is \
effectiveness and we have to wait further studies."
}], "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell[TextData[{
  "Those methods [KM03, Nag04c] use the coefficients of the given polynomial \
directly, so we can adapt it to the  ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s coefficient-wise accuracy concept. This is better than the originals, \
because treating tolerances as polynomial norms tends to be over-estimated. \
The current implementation can do this for polynomials not in SNAP \
structures."
}], "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell["Numerical Factorization of Multivariate Polynomials", "FramedBox",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell["\<\
The same reason of the above irreducibility testing, we have to use \
completely different factorization algorithms for numerical or empirical \
polynomials. In this package, we have implemented the Sasaki's algorithm \
[Sas01] with a degree bound studied by Bostan et al. [BLSSW04]. Currently, \
for non-monic polynomials, the command is not stable since non of approximate \
GCD algorithms for multivariate polynomials which are needed for factoring \
non-monic polynomials, is implemented.\
\>", "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"],

Cell["\<\
Note that the given polynomial may have approximate factors (or called \
numerical or pseudo factors) even if the algorithm outputs \
\[OpenCurlyDoubleQuote]absolutely irreducible\[CloseCurlyDoubleQuote]  or \
\[OpenCurlyDoubleQuote]no factors\[CloseCurlyDoubleQuote]. Therefore, you are \
encouraged to use the above irreducibility testing when you do not get \
approximate factors.\
\>", "Text",
  ShowCellBracket->False,
  CellTags->"b:1.3"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["References", "Subsection",
  ShowCellBracket->True,
  CellTags->{"b:1.4", "c:9"}],

Cell["\<\
[BL98] B. Beckermann and G. Labahn. When are two numerical polynomials \
relatively prime? J. Symb. Comput., 267:677-689, 1998.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[BLSSW04] A. Bostan, G. Lecerf, B. Salvy, E. Schost, and B. Wiebelt. \
Complexity Issues in Bivariate Polynomial Factorization. In Proceedings of \
the 2004 International Symposium on Symbolic and Algebraic Computation, ISSAC \
2004, pages 42-49, 2004.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[CGTW95] R. M. Corless, P. M. Gianni, B. M. Trager, and S. M. Watt. The \
singular value decomposition for polynomial systems. In Proceedings of the \
1995 International Symposium on Symbolic and Algebraic Computation, ISSAC \
'95, pages 195-207, 1995.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[CGHKW01] R. M. Corless, M. W. Giesbrecht, M. Hoeij, I. S. Kotsireas, and S. \
M. Watt. Towards factoring bivariate approximate polynomials. In Proceedings \
of the 2001 International Symposium on Symbolic and Algebraic Computation, \
ISSAC 2001, pages 85-92, 2001.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[EGL97] I. Z. Emiris, A. Galligo, and H. Lombardi. Certified approximate \
univariate gcds. J. Pure Appl. Algebra, 117&118:229-251, 1997.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[GR03] S. Gao and V. M. Rodrigues. Irreducibility of polynomials modulo p via \
Newton Polytopes. J. Number Theory, 101:32-47, 2003.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[GL96] G. H. Golub and C. F. V. Loan. Matrix Computations Third Edition, \
Johns Hopkins Series in the Mathematical Sciences. The Johns Hopkins \
University Press, Baltimore, 1996.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[HK98] M. A. Hitz and E. Kaltofen. Efficient algorithms for computing the \
nearest polynomial with constrained roots. In Proceedings of the 1998 \
International Symposium on Symbolic and Algebraic Computation, ISSAC '98, \
pages 236-243, 1998.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[HKL99] M. A. Hitz, E. Kaltofen, and Y. N. Lakshman. Efficient algorithms for \
computing the nearest polynomial with a real root and related problems. In \
Proceedings of the 1999 International Symposium on Symbolic and Algebraic \
Computation, ISSAC '99, pages 205-212, 1999.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[KS97] F. Kako and T. Sasaki. Proposal of \"effective floating-point number\" \
for approximate algebraic computation. preprint, 1997.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[Kal95] E. Kaltofen. Effective Noether irreducibility forms and applications. \
J. Computer and System Sciences, 50:274-295, 1995.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[KM03] E. Kaltofen and J. May. On Approximate Irreducibility of Polynomials \
in Several Variables. In Proceedings of the 2003 International Symposium on \
Symbolic and Algebraic Computation, ISSAC 2003, pages 161-168, 2003.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[KL96] N. Karmarkar and Y. N. Lakshman. Approximate polynomial greatest \
common divisors and nearest singular polynomials. In Proceedings of the 1996 \
International Symposium on Symbolic and Algebraic Computation, ISSAC '96, \
pages 35-39, 1996.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[MU88] Z. Mou-tan and R. Unbehauen. Approximate factorization of multivariate \
polynomials. Signal Processing, 14:141-152, 1988.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[Nag04a] K. Nagasaka. SNAP Package(Talk in Japanese). JSSAC 2004. 2004.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[Nag04b] K. Nagasaka. SNAP Package and Its Applications. ATCM 2004. 2004.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[Nag04c] K. Nagasaka.  Towards More Accurate Separation Bounds of Empirical \
Polynomials. SIGSAM Bulletin, Formally Reviewed Articles, 38(4):119-129, \
2004.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[Nag03] K. Nagasaka. Neighborhood Irreducibility Testing of Multivariate \
Polynomials. In Proc. Computer Algebra in Scientific Computing, CASC2003, \
pages 283-292, 2003.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[Nag02] K. Nagasaka. Towards Certified Irreducibility Testing of Bivariate \
Approximate Polynomials. In Proc. International Symposium on Symbolic and \
Algebraic Computation, ISSAC2002, pages 192-199, 2002.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[Pan98] V. Y. Pan. Approximate polynomial gcds, pad'e approximation, \
polynomial zeros and bipartite graphs. In Proc. Ninth Annual ACM-SIAM Symp. \
on Discrete Algorithms, pages 68-77, 1998.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[Pan01] V. Y. Pan. Computation of approximate polynomial gcds and an \
extension. Inform. and Comput., 167(2):71-85, 2001.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell[TextData[{
  "[Rup99] W. M. Ruppert. Reducibility of polynomials ",
  Cell[BoxData[
      \(TraditionalForm\`f(x, y)\)]],
  " modulo ",
  Cell[BoxData[
      \(TraditionalForm\`p\)]],
  ". J. Number Theory, 77:62-70, 1999."
}], "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[Sas01] T. Sasaki. Approximate multivariate polynomial factorization based on \
zero-sum relations. In Proceedings of the 2001 International Symposium on \
Symbolic and Algebraic Computation, ISSAC 2001, pages 284-291.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[Smi70] B. Smith. Error bounds for zeros of a polynomial based upon \
Gerschgorin's theorems. J. Assoc. Comput. Mach., 17:661-674, 1970.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[TS00] A. Terui and T. Sasaki. \"approximate zero-points\" of real univariate \
polynomial with large error terms. IPSJ J., 41:974-989, 2000.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[WSZ00] Y. H. W. Wu, H. J. Stetter, and L. Zhi. Pseudofactors of multivariate \
polynomials. In Proceedings of the 2000 International Symposium on Symbolic \
and Algebraic Computation, ISSAC 2000, pages 161-168, 2000.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[Zen04] Z. Zeng. The approximate GCD of inexact polynomials. Part I: a \
univariate algorithm. Preprint, 2004.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[ZW98] L. Zhi and W. Wu. Nearest singular polynomials. J. Symbolic Comput., \
26(6):667-675, 1998.\
\>", "Reference",
  CellTags->"b:1.4"],

Cell["\<\
[ZWNK01] L. Zhi, W. Wu, M.-T. Noda, and H. Kai. Hybrid method for computing \
the nearest singular polynomials. MM Research Preprints, 20:229-239, 2001.\
\>", "Reference",
  CellTags->"b:1.4"]
}, Closed]],

Cell[CellGroupData[{

Cell["About the Author", "Subsection",
  CellTags->{"b:1.5", "c:10"}],

Cell[TextData[{
  "Kosaku Nagasaka is an assistant Professor at Kobe University, JAPAN. He \
worked for Wolfram Research on the summer 1999 student internship program. \
His main research topic is symbolic numeric algorithms for polynomials. From  \
2001, he has worked for Japanese ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " User Group as one of directors."
}], "Text",
  CellTags->"b:1.5"],

Cell[TextData[{
  StyleBox["Kosaku Nagasaka",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ", Division of Mathematics and Informatics, Department of Science of Human \
Environment, Faculty of Human Development, Kobe University, Japan\n",
  ButtonBox["nagasaka@main.h.kobe-u.ac.jp",
    ButtonData:>{
      URL[ "mailto:nagasaka@main.h.kobe-u.ac.jp"], None},
    ButtonStyle->"Hyperlink"]
}], "Text",
  CellTags->"b:1.5"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Mathematical Background", "Section"],

Cell[CellGroupData[{

Cell[TextData[{
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s Precision and Accuracy tracking system"
}], "Subsection"],

Cell[TextData[{
  "This is a supplimental note which is based on the academic article: M. \
Sofroniou and G. Spaletta, Precise Numerical Computation, Journal of Logic \
and Algebraic Programming, Volume 64, Issue 1, July 2005, Pages 113--134. We \
recommend readers to refer the article if you'd like to know ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s precision and accuracy tracking system in detail."
}], "Text"],

Cell[TextData[{
  "In the mathematical context, there is an important fact on ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s precision and accuracy tracking system."
}], "Text"],

Cell[TextData[{
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s significant digits are not correct in theory though they are well \
estimated and correct almost always."
}], "FramedBox"],

Cell["", "Text"],

Cell["\<\
kokoha gosa no ryou ga kotonaru toiukoto wo iudake. ikano rei no youni ookina \
matigai ha mitukaranai kara.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FullForm[11`100]\)], "Input",
  CellLabel->"In[16]:="],

Cell[BoxData[
    TagBox[
      StyleBox["11.`100.",
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[16]//FullForm="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Precision[11`100]\)], "Input",
  CellLabel->"In[17]:="],

Cell[BoxData[
    \(100.`\)], "Output",
  CellLabel->"Out[17]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Accuracy[11`100]\)], "Input",
  CellLabel->"In[18]:="],

Cell[BoxData[
    \(98.95860731484179`\)], "Output",
  CellLabel->"Out[18]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((10^\(-Accuracy[11`100]\))\)/11 // FullForm\)], "Input",
  CellLabel->"In[10]:="],

Cell[BoxData[
    TagBox[
      StyleBox["9.999999999999763`*^-101",
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[10]//FullForm="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((10^\(-Accuracy[\((11`100)\)*\((11`100)\)]\))\)/121 // 
      FullForm\)], "Input",
  CellLabel->"In[11]:="],

Cell[BoxData[
    TagBox[
      StyleBox["2.000000000000036`*^-100",
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[11]//FullForm="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((10^\(-Accuracy[11`100]\))\) // FullForm\)], "Input",
  CellLabel->"In[3]:="],

Cell[BoxData[
    TagBox[
      StyleBox["1.0999999999999738`*^-99",
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[3]//FullForm="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((10^\(-Accuracy[\((11`100)\) + \((11`100)\)]\))\) // 
      FullForm\)], "Input",
  CellLabel->"In[4]:="],

Cell[BoxData[
    TagBox[
      StyleBox["2.199999999999948`*^-99",
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[4]//FullForm="]
}, Open  ]],

Cell[BoxData[
    \(a = SetTolerance[100, 10*^-10]\)], "Input",
  CellLabel->"In[1]:="],

Cell[CellGroupData[{

Cell[BoxData[
    \(10^\(-Accuracy[a*a]\)\)], "Input",
  CellLabel->"In[146]:="],

Cell[BoxData[
    \(1.9999999999999962`*^-7\)], "Output",
  CellLabel->"Out[146]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[a*a]\)], "Input",
  CellLabel->"In[143]:="],

Cell[BoxData[
    \(2.0000000000000002685499438236249`14.581813272528889*^-7\)], "Output",
  CellLabel->"Out[143]="]
}, Open  ]],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[46]:="],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[a]\)], "Input",
  CellLabel->"In[132]:="],

Cell[BoxData[
    \(0.0367881280561126257452358393`15.304327546682178\)], "Output",
  CellLabel->"Out[132]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(FloorFloat[a] // FullForm\)], "Input",
  CellLabel->"In[133]:="],

Cell[BoxData[
    TagBox[
      StyleBox["0.3310931525048704763`0.9542425094391371",
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[133]//FullForm="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(CeilingFloat[a] // FullForm\)], "Input",
  CellLabel->"In[134]:="],

Cell[BoxData[
    TagBox[
      StyleBox["0.4046694086170957278`1.0413926851580717",
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[134]//FullForm="]
}, Open  ]]
}, Open  ]],

Cell["Operating with Empirical Polynomials Exactly", "Subsection"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Reference Guide", "Section",
  CellTags->"c:11"],

Cell[CellGroupData[{

Cell["AbsolutelyIrreducibleQ", "ObjectName",
  CellTags->{"i:1", "b:2.0", "c:12"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["AbsolutelyIrreducibleQ",
    FontFamily->"Courier New"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  "] gives True if the given polynomial ",
  StyleBox["poly",
    FontSlant->"Italic"],
  " is absolutely irreducible within the coefficient-wise tolerance.\n\
\[FilledSmallSquare] ",
  StyleBox["AbsolutelyIrreducibleQ",
    FontFamily->"Courier New"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  ", ",
  StyleBox["eps",
    FontSlant->"Italic"],
  "] gives True if the given polynomial ",
  StyleBox["poly",
    FontSlant->"Italic"],
  " is absolutely irreducible within the given polynomial 2-norm tolerance ",
  StyleBox["eps",
    FontSlant->"Italic"],
  ".\n\[FilledSmallSquare] ",
  StyleBox["AbsolutelyIrreducibleQ",
    FontFamily->"Courier New"],
  "[",
  StyleBox["polyset",
    FontSlant->"Italic"],
  "] gives True if the all polynomials included in the given SNAP polynomial \
set ",
  StyleBox["polyset",
    FontSlant->"Italic"],
  " are absolutely irreducible."
}], "Usage",
  CellTags->"b:2.0"],

Cell[TextData[{
  "\[FilledSmallSquare] This function gives ",
  StyleBox["$Failed",
    FontFamily->"Courier New"],
  " if the given polynomial is reducible or absolutely irreducibilities of \
all the possible polynomials can not be guaranteed."
}], "Notes",
  CellTags->"b:2.0"],

Cell[TextData[{
  "\[FilledSmallSquare] This function tries to guarantee the irreducibility \
by an adaptive method if the option ",
  StyleBox["Adaptive",
    FontFamily->"Courier New"],
  " is ",
  StyleBox["True",
    FontFamily->"Courier New"],
  " (this is default). This method is not fast."
}], "Notes",
  CellTags->"b:2.0"],

Cell[TextData[{
  "\[FilledSmallSquare] This function tries to guarantee the irreducibility \
by using Gao and Rodrigues criterion for sparse polynomials if the option ",
  StyleBox["Method",
    FontFamily->"Courier New"],
  " is ",
  StyleBox["NewtonPolytope",
    FontFamily->"Courier New"],
  " (",
  StyleBox["Automatic",
    FontFamily->"Courier New"],
  " is default). In this case, coefficients of terms included in the Newton \
polytope of the given polynomial, are only considered as coefficients with \
errors."
}], "Notes",
  CellTags->"b:2.0"],

Cell["\<\
\[FilledSmallSquare] See articles: K.Nagasaka. Towards More Accurate \
Separation Bounds of Empirical Polynomials. SIGSAM Bulletin, Formally \
Reviewed Articles, Vol. 38(4), 2004, 119--129, and K.Nagasaka. Towards More \
Accurate Separation Bounds of Empirical Polynomials II. Computer Algebra in \
Scientific Computing 2005, the Lecture Notes of Computer Science (LNCS) \
Volume 3718, 318--329.\
\>", "Notes",
  CellTags->"b:2.0"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.0"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["SeparationBound",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.0"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.0"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.0"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.0"],

Cell["Let consider the following bivariate polynomial.", "ExampleText",
  CellTags->"b:2.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(f = 
      SetAccuracy[
        Expand[\((x^2 + y*x + 2  y - 1)\) \((x^3 + y^2\ x - y + 7)\) + 
            0.2  x], 8]\)], "Input",
  CellLabel->"In[1]:=",
  CellTags->"b:2.0"],

Cell[BoxData[
    \(\(-7.`8.845098040014257\) + 
      0.2000000000000000111`7.301029995663982\ x + 
      7.`8.845098040014257\ x\^2 - 1.`7.999999999999999\ x\^3 + x\^5 + 
      15.`9.176091259055681\ y + 7.`8.845098040014257\ x\ y - 
      1.`7.999999999999999\ x\^2\ y + 2.`8.30102999566398\ x\^3\ y + 
      x\^4\ y - 2.`8.30102999566398\ y\^2 - 2.`8.30102999566398\ x\ y\^2 + 
      x\^3\ y\^2 + 2.`8.30102999566398\ x\ y\^3 + x\^2\ y\^3\)], "Output",
  CellLabel->"Out[1]=",
  CellTags->"b:2.0"]
}, Open  ]],

Cell["\<\
This tests its absolutely irreducibility within the given coefficient-wise \
tolerance.\
\>", "ExampleText",
  CellTags->"b:2.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(AbsolutelyIrreducibleQ[f]\)], "Input",
  CellLabel->"In[3]:=",
  CellTags->"b:2.0"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[3]=",
  CellTags->"b:2.0"]
}, Open  ]],

Cell["\<\
If the given polynomial has a SNAP structure or a tolerance is given, then \
the polynomial norm tolerance is used for bounding errors on coefficients.\
\>", "ExampleText",
  CellTags->"b:2.0"],

Cell[CellGroupData[{

Cell[BoxData[
    \(AbsolutelyIrreducibleQ[f, 0.000001`16]\)], "Input",
  CellLabel->"In[7]:=",
  CellTags->"b:2.0"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[7]=",
  CellTags->"b:2.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fs = SNAP[f]\)], "Input",
  CellLabel->"In[4]:=",
  CellTags->"b:2.0"],

Cell[BoxData[
    \(\(-7.`\) + 0.2`\ x + 7.`\ x\^2 - 1.`\ x\^3 + x\^5 + 15.`\ y + 
      7.`\ x\ y - 1.`\ x\^2\ y + 2.`\ x\^3\ y + x\^4\ y - 2.`\ y\^2 - 
      2.`\ x\ y\^2 + x\^3\ y\^2 + 2.`\ x\ y\^3 + x\^2\ y\^3\)], "Output",
  CellLabel->"Out[4]=",
  CellTags->"b:2.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(AbsolutelyIrreducibleQ[fs]\)], "Input",
  CellLabel->"In[5]:=",
  CellTags->"b:2.0"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[5]=",
  CellTags->"b:2.0"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ApproximateDivisorQ", "ObjectName",
  CellTags->{"i:13", "b:2.1", "c:13"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["ApproximateDivisorQ",
    FontFamily->"Courier"],
  "[",
  StyleBox["g",
    FontSlant->"Italic"],
  ", ",
  StyleBox["h",
    FontSlant->"Italic"],
  "] gives True if ",
  StyleBox["g",
    FontSlant->"Italic"],
  " divides ",
  StyleBox["h",
    FontSlant->"Italic"],
  " approximately, considering errors on their coefficients.\n\
\[FilledSmallSquare] ",
  StyleBox["ApproximateDivisorQ",
    FontFamily->"Courier"],
  "[",
  StyleBox["g",
    FontSlant->"Italic"],
  ", ",
  StyleBox["h",
    FontSlant->"Italic"],
  ", ",
  StyleBox["err",
    FontSlant->"Italic"],
  "] gives True if ",
  StyleBox["g",
    FontSlant->"Italic"],
  " divides ",
  StyleBox["h",
    FontSlant->"Italic"],
  " approximately, within the given error bound ",
  StyleBox["err",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.1"],

Cell["\<\
\[FilledSmallSquare] Tolerances, error bounds and accuracy of SNAP polynomial \
sets are the same in this package. We recommend you to read the package \
documents for understanding coefficient-wise and polynomial norm \
tolerances.\
\>", "Notes",
  CellTags->"b:2.1"],

Cell["\<\
\[FilledSmallSquare] See articles: R. M. Corless, P. M. Gianni, B. M. Trager, \
and S. M. Watt. The singular value decomposition for polynomial systems. In \
Proceedings of the 1995 International Symposium on Symbolic and Algebraic \
Computation, ISSAC '95, pages 195-207, 1995.\
\>", "Notes",
  CellTags->"b:2.1"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.1"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["CoprimeQ",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["PolynomialGCD",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["ApproximateQuotient",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.1"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.1"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.1"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.1"],

Cell["Let consider the following polynomials.", "ExampleText",
  CellTags->"b:2.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[76]:=",
  CellTags->"b:2.1"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[76]=",
  CellTags->"b:2.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(h = 
      SNAP[1.3883\[InvisibleSpace] + 4.417\ x + 3.8861\ x\^2 + 
          0.85593\ x\^3]\)], "Input",
  CellLabel->"In[77]:=",
  CellTags->"b:2.1"],

Cell[BoxData[
    \(\(\(1.3883`\)\(\[InvisibleSpace]\)\) + 4.417`\ x + 3.8861`\ x\^2 + 
      0.85593`\ x\^3\)], "Output",
  CellLabel->"Out[77]=",
  CellTags->"b:2.1"]
}, Open  ]],

Cell[TextData[{
  "SNAP package can compute a their ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-GCD as below, where ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon] = 0.0001\)]],
  "."
}], "ExampleText",
  CellTags->"b:2.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(appgcd = PolynomialGCD[g, h, 0.0001`16]\)], "Input",
  CellLabel->"In[78]:=",
  CellTags->"b:2.1"],

Cell[BoxData[
    \(SNAP::"preliminary" \(\(:\)\(\ \)\) 
      "Preliminary implemented function is called."\)], "Message",
  CellLabel->"From In[78]:=",
  CellTags->"b:2.1"],

Cell[BoxData[
    \(\(\(0.00005`\)\(\[InvisibleSpace]\)\) + 0.00015907944968666715`\ x + 
      0.00013995894259165886`\ x\^2 + 
      0.00003082655045739393`\ x\^3\)], "Output",
  CellLabel->"Out[78]=",
  CellTags->"b:2.1"]
}, Open  ]],

Cell[TextData[{
  "This tests whether ",
  Cell[BoxData[
      \(TraditionalForm\`appgcd\)]],
  " is an approximate divisor of ",
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  " or not."
}], "ExampleText",
  CellTags->"b:2.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ApproximateDivisorQ[g, \ appgcd, \ 0.0001`16]\)], "Input",
  CellLabel->"In[80]:=",
  CellTags->"b:2.1"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[80]=",
  CellTags->"b:2.1"]
}, Open  ]],

Cell[TextData[{
  "This computes an approximate quotient of ",
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  " by ",
  Cell[BoxData[
      \(TraditionalForm\`appgcd\)]],
  "."
}], "ExampleText",
  CellTags->"b:2.1"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ApproximateQuotient[g, \ appgcd, \ 0.0001`16]\)], "Input",
  CellLabel->"In[81]:=",
  CellTags->"b:2.1"],

Cell[BoxData[
    \(\(\(7543.972371664776`\)\(\[InvisibleSpace]\)\) + 
      31237.66598363115`\ x + 32438.96839463335`\ x\^2\)], "Output",
  CellLabel->"Out[81]=",
  CellTags->"b:2.1"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["ApproximateQuotient", "ObjectName",
  CellTags->{"i:14", "b:2.2", "c:14"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["ApproximateQuotient",
    FontFamily->"Courier"],
  "[",
  StyleBox["g",
    FontSlant->"Italic"],
  ", ",
  StyleBox["h",
    FontSlant->"Italic"],
  "] gives an approximate quotient of  ",
  StyleBox["g",
    FontSlant->"Italic"],
  " by ",
  StyleBox["h",
    FontSlant->"Italic"],
  ", considering errors on their coefficients.\n\[FilledSmallSquare] ",
  StyleBox["ApproximateQuotient",
    FontFamily->"Courier"],
  "[",
  StyleBox["g",
    FontSlant->"Italic"],
  ", ",
  StyleBox["h",
    FontSlant->"Italic"],
  ", ",
  StyleBox["err",
    FontSlant->"Italic"],
  "] gives an approximate quotient  ",
  StyleBox["g",
    FontSlant->"Italic"],
  " by ",
  StyleBox["h",
    FontSlant->"Italic"],
  ", within the given error bound ",
  StyleBox["err",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.2"],

Cell["\<\
\[FilledSmallSquare] Tolerances, error bounds and accuracy of SNAP polynomial \
sets are the same in this package. We recommend you to read the package \
documents for understanding coefficient-wise and polynomial norm \
tolerances.\
\>", "Notes",
  CellTags->"b:2.2"],

Cell["\<\
\[FilledSmallSquare] See articles: R. M. Corless, P. M. Gianni, B. M. Trager, \
and S. M. Watt. The singular value decomposition for polynomial systems. In \
Proceedings of the 1995 International Symposium on Symbolic and Algebraic \
Computation, ISSAC '95, pages 195-207, 1995.\
\>", "Notes",
  CellTags->"b:2.2"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.2"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["CoprimeQ",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["PolynomialGCD",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["ApproximateDivisorQ",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.2"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.2"],

Cell[TextData[{
  "See the further examples of ",
  ButtonBox["ApproximateDivisorQ",
    ButtonStyle->"AddOnsLink"],
  "."
}], "ExampleText",
  CellTags->"b:2.2"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CeilingFloat", "ObjectName",
  CellTags->{"i:15", "b:2.3", "c:15"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["CeilingFloat",
    FontFamily->"Courier"],
  "[",
  StyleBox["num",
    FontSlant->"Italic"],
  "] gives an upper bound of ",
  StyleBox["num",
    FontSlant->"Italic"],
  ", considering its error."
}], "Usage",
  CellTags->"b:2.3"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.3"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["FloorFloat",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.3"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.3"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.3"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.3"],

Cell["This computes an upper bound.", "ExampleText",
  CellTags->"b:2.3"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CeilingFloat[1.0`16] // FullForm\)], "Input",
  CellLabel->"In[22]:=",
  CellTags->"b:2.3"],

Cell[BoxData[
    TagBox[
      StyleBox["1.0000000000000001`15.999999999999998",
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[22]//FullForm=",
  CellTags->"b:2.3"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["CoprimeQ", "ObjectName",
  CellTags->{"i:16", "b:2.4", "c:16"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["CoprimeQ",
    FontFamily->"Courier"],
  "[",
  StyleBox["g",
    FontSlant->"Italic"],
  ", ",
  StyleBox["h",
    FontSlant->"Italic"],
  "] gives ",
  StyleBox["True",
    FontFamily->"Courier"],
  " if they are coprime, considering errors on their coefficients.\n\
\[FilledSmallSquare] ",
  StyleBox["CoprimeQ",
    FontFamily->"Courier"],
  "[",
  StyleBox["g",
    FontSlant->"Italic"],
  ", ",
  StyleBox["h",
    FontSlant->"Italic"],
  ", ",
  StyleBox["err",
    FontSlant->"Italic"],
  "] gives ",
  StyleBox["True",
    FontFamily->"Courier"],
  " if they are coprime within the given error bound ",
  StyleBox["err",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.4"],

Cell["\<\
\[FilledSmallSquare] Tolerances, error bounds and accuracy of SNAP polynomial \
sets are the same in this package. We recommend you to read the package \
documents for understanding coefficient-wise and polynomial norm \
tolerances.\
\>", "Notes",
  CellTags->"b:2.4"],

Cell["\<\
\[FilledSmallSquare] The argument polynomials do not have to be SNAP \
polynomial sets. This function can operate with polynomials.\
\>", "Notes",
  CellTags->"b:2.4"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.4"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["PolynomialGCD",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["ApproximateDivisorQ",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["ApproximateQuotient",
    ButtonStyle->"AddOnsLink"],
  ", System`",
  ButtonBox["PolynomialGCD",
    ButtonStyle->"RefGuideLink"],
  "."
}], "Notes",
  CellTags->"b:2.4"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.4"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.4"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.4"],

Cell["Let consider the following polynomials.", "ExampleText",
  CellTags->"b:2.4"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[66]:=",
  CellTags->"b:2.4"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[66]=",
  CellTags->"b:2.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(h = SNAP[1.3883 + 4.417\ x + 3.8861\ x\^2 + 0.85593\ x\^3]\)], "Input",
  CellLabel->"In[67]:=",
  CellTags->"b:2.4"],

Cell[BoxData[
    \(\(\(1.3883`\)\(\[InvisibleSpace]\)\) + 4.417`\ x + 3.8861`\ x\^2 + 
      0.85593`\ x\^3\)], "Output",
  CellLabel->"Out[67]=",
  CellTags->"b:2.4"]
}, Open  ]],

Cell["\<\
The built-in function says that they are coprime since the function can not \
operate with error considering.\
\>", "ExampleText",
  CellTags->"b:2.4"],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`PolynomialGCD[Normal[g], Normal[h]]\)], "Input",
  CellLabel->"In[68]:=",
  CellTags->"b:2.4"],

Cell[BoxData[
    \(1\/100000\)], "Output",
  CellLabel->"Out[68]=",
  CellTags->"b:2.4"]
}, Open  ]],

Cell["\<\
In fact, this function also guarantees their coprimeness. However, we can not \
determine their coprimeness if they have numerical errors on their \
coefficients and they have an approximate greatest common divisor as follows.\
\
\>", "ExampleText",
  CellTags->"b:2.4"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CoprimeQ[g, h]\)], "Input",
  CellLabel->"In[69]:=",
  CellTags->"b:2.4"],

Cell[BoxData[
    \(SNAP::"toleranceadjusted" \(\(:\)\(\ \)\) 
      "The given different tolerances adjusted into their maximum."\)], \
"Message",
  CellLabel->"From In[69]:=",
  CellTags->"b:2.4"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[69]=",
  CellTags->"b:2.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(CoprimeQ[g, h, 1.0`16*^-4]\)], "Input",
  CellLabel->"In[74]:=",
  CellTags->"b:2.4"],

Cell[BoxData[
    \($Failed\)], "Output",
  CellLabel->"Out[74]=",
  CellTags->"b:2.4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolynomialGCD[g, h, 1.0`16*^-4]\)], "Input",
  CellLabel->"In[75]:=",
  CellTags->"b:2.4"],

Cell[BoxData[
    \(SNAP::"preliminary" \(\(:\)\(\ \)\) 
      "Preliminary implemented function is called."\)], "Message",
  CellLabel->"From In[75]:=",
  CellTags->"b:2.4"],

Cell[BoxData[
    \(\(\(0.00005`\)\(\[InvisibleSpace]\)\) + 0.00015907944968666715`\ x + 
      0.00013995894259165886`\ x\^2 + 
      0.00003082655045739393`\ x\^3\)], "Output",
  CellLabel->"Out[75]=",
  CellTags->"b:2.4"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["D", "ObjectName",
  CellTags->{"i:17", "b:2.5", "c:17"}],

Cell["\<\
\[FilledSmallSquare] This function is extended to SNAP polynomial sets.\
\>", "Notes",
  CellTags->"b:2.5"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.5"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: System`",
  ButtonBox["D",
    ButtonStyle->"RefGuideLink"],
  "."
}], "Notes",
  CellTags->"b:2.5"]
}, Closed]],

Cell[CellGroupData[{

Cell["Element", "ObjectName",
  CellTags->{"i:18", "b:2.6", "c:18"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["Element",
    FontFamily->"Courier"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  ", ",
  StyleBox["polyset",
    FontSlant->"Italic"],
  "] gives ",
  StyleBox["True",
    FontFamily->"Courier"],
  " if ",
  StyleBox["poly",
    FontSlant->"Italic"],
  " is included in the given polynomial set ",
  StyleBox["polyset",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.6"],

Cell["\<\
\[FilledSmallSquare] Tolerances, error bounds and accuracy of SNAP polynomial \
sets are the same in this package. We recommend you to read the package \
documents for understanding coefficient-wise and polynomial norm \
tolerances.\
\>", "Notes",
  CellTags->"b:2.6"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.6"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["SNAP",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["Tolerance",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.6"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.6"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.6"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.6"],

Cell["\<\
This gives the SNAP polynomial set of the specified polynomial.\
\>", "ExampleText",
  CellTags->"b:2.6"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[17]:=",
  CellTags->"b:2.6"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[17]=",
  CellTags->"b:2.6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g]\)], "Input",
  CellLabel->"In[18]:=",
  CellTags->"b:2.6"],

Cell[BoxData[
    \(1.537912594467730969706440231090759`14.303315010757439*^-15\)], "Output",\

  CellLabel->"Out[18]=",
  CellTags->"b:2.6"]
}, Open  ]],

Cell[TextData[{
  "The error bound of the above SNAP structure is about ",
  Cell[BoxData[
      \(1.53791\[Times]10\^\(-15\)\)]],
  ", hence we have the following results."
}], "ExampleText",
  CellTags->"b:2.6"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Element[Normal[g] + 1.0`16*^-15, g]\)], "Input",
  CellLabel->"In[16]:=",
  CellTags->"b:2.6"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[16]=",
  CellTags->"b:2.6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Element[Normal[g] + 2.0`16*^-15, g]\)], "Input",
  CellLabel->"In[15]:=",
  CellTags->"b:2.6"],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[15]=",
  CellTags->"b:2.6"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Expand", "ObjectName",
  CellTags->{"i:19", "b:2.7", "c:19"}],

Cell["\<\
\[FilledSmallSquare] This function is extended to SNAP polynomial sets.\
\>", "Notes",
  CellTags->"b:2.7"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.7"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: System`",
  ButtonBox["Expand",
    ButtonStyle->"RefGuideLink"],
  "."
}], "Notes",
  CellTags->"b:2.7"]
}, Closed]],

Cell[CellGroupData[{

Cell["Exponent", "ObjectName",
  CellTags->{"i:20", "b:2.8", "c:20"}],

Cell["\<\
\[FilledSmallSquare] This function is extended to SNAP polynomial sets.\
\>", "Notes",
  CellTags->"b:2.8"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.8"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: System`",
  ButtonBox["Exponent",
    ButtonStyle->"RefGuideLink"],
  "."
}], "Notes",
  CellTags->"b:2.8"]
}, Closed]],

Cell[CellGroupData[{

Cell["ExportSWF", "ObjectName",
  CellTags->{"i:21", "b:2.9", "c:21"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["ExportSWF",
    FontFamily->"Courier New"],
  "[",
  StyleBox["filename",
    FontSlant->"Italic"],
  ", ",
  StyleBox["anime",
    FontSlant->"Italic"],
  "] exports the list of ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " graphics ",
  StyleBox["anim",
    FontSlant->"Italic"],
  " to the specified file ",
  StyleBox["filename",
    FontSlant->"Italic"],
  " in the SWF format."
}], "Usage",
  CellTags->"b:2.9"],

Cell["\<\
\[FilledSmallSquare] This function is not supported by the package SNAP. This \
is a kind of goodies.\
\>", "Notes",
  CellTags->"b:2.9"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.9"],

Cell["This loads the package.", "ExampleText",
  CellTags->"b:2.9"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellTags->"b:2.9"],

Cell["This generates an animation.", "ExampleText",
  CellTags->"b:2.9"],

Cell[BoxData[
    \(anim = 
      Do[Plot[Sin[x + i], {x, \(-Pi\), Pi}], {i, 0, Pi, Pi/10}]\)], "Input",
  CellLabel->"In[3]:=",
  CellTags->"b:2.9"],

Cell["This exports it to a file.", "ExampleText",
  CellTags->"b:2.9"],

Cell[BoxData[
    \(ExportSWF["\<sin.swf\>", anim]\)], "Input",
  CellLabel->"In[3]:=",
  CellTags->"b:2.9"],

Cell["This function has the following options.", "ExampleText",
  CellTags->"b:2.9"],

Cell[BoxData[
    \(Options[ExportSWF]\)], "Input",
  CellTags->"b:2.9"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Factor", "ObjectName",
  CellTags->{"i:22", "b:2.10", "c:22"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["Factor",
    FontFamily->"Courier"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  "] factors a polynomial over the complex numbers, numerically.\n\
\[FilledSmallSquare] ",
  StyleBox["Factor",
    FontFamily->"Courier"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  ", ",
  StyleBox["err",
    FontSlant->"Italic"],
  "] factors a polynomial over the complex numbers, numerically, within the \
specified tolerance ",
  StyleBox["err",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.10"],

Cell["\<\
\[FilledSmallSquare] This function does not guarantee anything. This only \
tries to factor the given polynomial numerically. The given error bound is \
used only for a backward error check.\
\>", "Notes",
  CellTags->"b:2.10"],

Cell["\<\
\[FilledSmallSquare] See articles: T. Sasaki. Approximate multivariate \
polynomial factorization based on zero-sum relations. In Proceedings of the \
2001 International Symposium on Symbolic and Algebraic Computation, ISSAC \
2001, pages 284-291.\
\>", "Notes",
  CellTags->"b:2.10"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.10"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["FactorList",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["AbsolutelyIrreducibleQ",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SeparationBound",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.10"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.10"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.10"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.10"],

Cell["Let consider the following reducible polynomial.", "ExampleText",
  CellTags->"b:2.10"],

Cell[CellGroupData[{

Cell[BoxData[
    \(f = 
      Expand[\((x^2 + y*x + 2  y - 1)\) \((x^3 + y^2\ x - y + 
              7)\)]\)], "Input",
  CellLabel->"In[7]:=",
  CellTags->"b:2.10"],

Cell[BoxData[
    \(\(-7\) + 7\ x\^2 - x\^3 + x\^5 + 15\ y + 7\ x\ y - x\^2\ y + 
      2\ x\^3\ y + x\^4\ y - 2\ y\^2 - 2\ x\ y\^2 + x\^3\ y\^2 + 2\ x\ y\^3 + 
      x\^2\ y\^3\)], "Output",
  CellLabel->"Out[7]=",
  CellTags->"b:2.10"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`Factor[f]\)], "Input",
  CellLabel->"In[8]:=",
  CellTags->"b:2.10"],

Cell[BoxData[
    \(\((\(-1\) + x\^2 + 2\ y + x\ y)\)\ \((7 + x\^3 - y + 
          x\ y\^2)\)\)], "Output",
  CellLabel->"Out[8]=",
  CellTags->"b:2.10"]
}, Open  ]],

Cell["\<\
The built-in function can not factor if we change the coefficients of the \
polynomial to floating-point numbers.\
\>", "ExampleText",
  CellTags->"b:2.10"],

Cell[CellGroupData[{

Cell[BoxData[
    \(nf = N[f, 15]\)], "Input",
  CellLabel->"In[18]:=",
  CellTags->"b:2.10"],

Cell[BoxData[
    \(\(-7.`15. \) + 7.`15. \ x\^2 - 1.`15. \ x\^3 + x\^5 + 15.`15. \ y + 
      7.`15. \ x\ y - 1.`15. \ x\^2\ y + 2.`15. \ x\^3\ y + x\^4\ y - 
      2.`15. \ y\^2 - 2.`15. \ x\ y\^2 + x\^3\ y\^2 + 2.`15. \ x\ y\^3 + 
      x\^2\ y\^3\)], "Output",
  CellLabel->"Out[18]=",
  CellTags->"b:2.10"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`Factor[nf]\)], "Input",
  CellLabel->"In[19]:=",
  CellTags->"b:2.10"],

Cell[BoxData[
    \(1.`15. \ \((\(-7.`14.698970004336019\) + 7.`14.698970004336019\ x\^2 - 
          1.`14.698970004336019\ x\^3 + 1.`14.698970004336019\ x\^5 + 
          15.`14.698970004336019\ y + 7.`14.698970004336019\ x\ y - 
          1.`14.698970004336019\ x\^2\ y + 2.`14.698970004336019\ x\^3\ y + 
          1.`14.698970004336019\ x\^4\ y - 2.`14.698970004336019\ y\^2 - 
          2.`14.698970004336019\ x\ y\^2 + 
          1.`14.698970004336019\ x\^3\ y\^2 + 
          2.`14.698970004336019\ x\ y\^3 + 
          1.`14.698970004336019\ x\^2\ y\^3)\)\)], "Output",
  CellLabel->"Out[19]=",
  CellTags->"b:2.10"]
}, Open  ]],

Cell["\<\
The function of SNAP package can factor the polynomial as follows.\
\>", "ExampleText",
  CellTags->"b:2.10"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Chop@Factor[nf, 1.0`16*^-6]\)], "Input",
  CellLabel->"In[25]:=",
  CellTags->"b:2.10"],

Cell[BoxData[
    \(\((\(-1.`14.317629257483443\) + 
          x\^2 + \((2.0000000000000000000069174357`13.485671647191593 + 
                1.0000000000000000000023999267`13.220326185774484\ x)\)\ y)\)\
\ \((7.`14.422591735417836 + x\^3 - 
          1.0000000000000000002183013178`12.183993352805858\ y + 
          0.9999999999999999997187145589`11.209300563149837\ x\ y\^2)\)\)], \
"Output",
  CellLabel->"Out[25]=",
  CellTags->"b:2.10"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Chop@FactorList[nf, 1.0`16*^-6]\)], "Input",
  CellLabel->"In[26]:=",
  CellTags->"b:2.10"],

Cell[BoxData[
    \({{1, 
        1}, {\(-1.`14.317629257483443\) + 
          x\^2 + \((2.0000000000000000000069174357`13.485671647191593 + 
                1.0000000000000000000023999267`13.220326185774484\ x)\)\ y, 
        1}, {7.`14.422591735417836 + x\^3 - 
          1.0000000000000000002183013178`12.183993352805858\ y + 
          0.9999999999999999997187145589`11.209300563149837\ x\ y\^2, 
        1}}\)], "Output",
  CellLabel->"Out[26]=",
  CellTags->"b:2.10"]
}, Open  ]],

Cell["\<\
We note that an error bound with the machine precision is used if we do not \
specify the error bound.\
\>", "ExampleText",
  CellTags->"b:2.10"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Chop@Factor[nf]\)], "Input",
  CellLabel->"In[28]:=",
  CellTags->"b:2.10"],

Cell[BoxData[
    \(SNAP::"machineprecision" \(\(:\)\(\ \)\) 
      "SNAP function encounters a machine precision number. Machine precision \
numbers may not have enough accuracy due to Mathematica's inner operation \
policy."\)], "Message",
  CellLabel->"From In[28]:=",
  CellTags->"b:2.10"],

Cell[BoxData[
    \(SNAP::"machineprecision" \(\(:\)\(\ \)\) 
      "SNAP function encounters a machine precision number. Machine precision \
numbers may not have enough accuracy due to Mathematica's inner operation \
policy."\)], "Message",
  CellLabel->"From In[28]:=",
  CellTags->"b:2.10"],

Cell[BoxData[
    \(SNAP::"machineprecision" \(\(:\)\(\ \)\) 
      "SNAP function encounters a machine precision number. Machine precision \
numbers may not have enough accuracy due to Mathematica's inner operation \
policy."\)], "Message",
  CellLabel->"From In[28]:=",
  CellTags->"b:2.10"],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"Further output of \
\\!\\(SNAP :: \\\"machineprecision\\\"\\) will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message",
  CellLabel->"From In[28]:=",
  CellTags->"b:2.10"],

Cell[BoxData[
    \(\((\(-1.`14.317629257483443\) + 
          x\^2 + \((2.0000000000000000000069174357`13.485671647191593 + 
                1.0000000000000000000023999267`13.220326185774484\ x)\)\ y)\)\
\ \((7.`14.422591735417836 + x\^3 - 
          1.0000000000000000002183013178`12.183993352805858\ y + 
          0.9999999999999999997187145589`11.209300563149837\ x\ y\^2)\)\)], \
"Output",
  CellLabel->"Out[28]=",
  CellTags->"b:2.10"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FactorList", "ObjectName",
  CellTags->{"i:23", "b:2.11", "c:23"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["FactorList",
    FontFamily->"Courier"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  "] factors a polynomial over the complex numbers, numerically.\n\
\[FilledSmallSquare] ",
  StyleBox["FactorList",
    FontFamily->"Courier"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  ", ",
  StyleBox["err",
    FontSlant->"Italic"],
  "] factors a polynomial over the complex numbers, numerically, within the \
specified tolerance ",
  StyleBox["err",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.11"],

Cell["\<\
\[FilledSmallSquare] This function does not guarantee anything. This only \
tries to factor the given polynomial numerically. The given error bound is \
used only for a backward error check.\
\>", "Notes",
  CellTags->"b:2.11"],

Cell["\<\
\[FilledSmallSquare] See articles: T. Sasaki. Approximate multivariate \
polynomial factorization based on zero-sum relations. In Proceedings of the \
2001 International Symposium on Symbolic and Algebraic Computation, ISSAC \
2001, pages 284-291.\
\>", "Notes",
  CellTags->"b:2.11"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.11"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["Factor",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["AbsolutelyIrreducibleQ",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SeparationBound",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.11"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.11"],

Cell[TextData[{
  "See the further examples of ",
  ButtonBox["Factor",
    ButtonStyle->"AddOnsLink"],
  "."
}], "ExampleText",
  CellTags->"b:2.11"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FloorFloat", "ObjectName",
  CellTags->{"i:24", "b:2.12", "c:24"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["FloorFloat",
    FontFamily->"Courier"],
  "[",
  StyleBox["num",
    FontSlant->"Italic"],
  "] gives a lower bound of ",
  StyleBox["num",
    FontSlant->"Italic"],
  ", considering its error."
}], "Usage",
  CellTags->"b:2.12"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.12"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["CeilingFloat",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.12"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.12"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.12"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.12"],

Cell["This computes a lower bound.", "ExampleText",
  CellTags->"b:2.12"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FloorFloat[1.0`16] // FullForm\)], "Input",
  CellLabel->"In[23]:=",
  CellTags->"b:2.12"],

Cell[BoxData[
    TagBox[
      StyleBox["0.9999999999999999`15.999999999999998",
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[23]//FullForm=",
  CellTags->"b:2.12"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["NSolve", "ObjectName",
  CellTags->{"i:25", "b:2.13", "c:25"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["NSolve",
    FontFamily->"Courier"],
  "[",
  StyleBox["eqn",
    FontSlant->"Italic"],
  ", ",
  StyleBox["var",
    FontSlant->"Italic"],
  "] gives a list of numerical roots with exact accuracy, of the specified \
equation ",
  StyleBox["eqn",
    FontSlant->"Italic"],
  " w.r.t. ",
  StyleBox["var",
    FontSlant->"Italic"],
  ".\n\[FilledSmallSquare] ",
  StyleBox["NSolve",
    FontFamily->"Courier"],
  "[",
  StyleBox["eqn",
    FontSlant->"Italic"],
  ", ",
  StyleBox["var",
    FontSlant->"Italic"],
  ", ",
  StyleBox["prec",
    FontSlant->"Italic"],
  "] gives a list of numerical roots with exact accuracy, of the specified \
equation ",
  StyleBox["eqn",
    FontSlant->"Italic"],
  " w.r.t. ",
  StyleBox["var",
    FontSlant->"Italic"],
  ", using the specified working precision ",
  StyleBox["prec",
    FontSlant->"Italic"],
  ". "
}], "Usage",
  CellTags->"b:2.13"],

Cell["\<\
\[FilledSmallSquare] Computing numerical roots makes some numerical errors so \
we have to bound such numerical errors. This function can bound them and the \
results have exact accuracy in this sense.\
\>", "Notes",
  CellTags->"b:2.13"],

Cell["\<\
\[FilledSmallSquare] See articles: A. Terui and T. Sasaki. \"approximate \
zero-points\" of real univariate polynomial with large error terms. IPSJ J., \
41:974-989, 2000.\
\>", "Notes",
  CellTags->"b:2.13"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.13"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: System`",
  ButtonBox["NSolve",
    ButtonStyle->"RefGuideLink"],
  "."
}], "Notes",
  CellTags->"b:2.13"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.13"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.13"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.13"],

Cell["\<\
This gives the SNAP polynomial set of the specified polynomial.\
\>", "ExampleText",
  CellTags->"b:2.13"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[3]:=",
  CellTags->"b:2.13"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[3]=",
  CellTags->"b:2.13"]
}, Open  ]],

Cell["\<\
This computes all the roots of the above polynomial, with exact accuracy.\
\>", "ExampleText",
  CellTags->"b:2.13"],

Cell[CellGroupData[{

Cell[BoxData[
    \(x /. NSolve[g \[Equal] 0, x]\)], "Input",
  CellLabel->"In[8]:=",
  CellTags->"b:2.13"],

Cell[BoxData[
    \({\(-3.0000720811323233693630293113`12.375639510555482\), \
\(-0.9989903848991318032656327981`10.442341063609597\), \
\(-0.5412151824480374484`7.895061796226485\), \
\(-0.4813611757602536895`7.989916442886993\) - 
        0.0294645370012453413`6.7767450046898965\ \[ImaginaryI], \
\(-0.4813611757602536895`7.989916442886993\) + 
        0.0294645370012453413`6.7767450046898965\ \[ImaginaryI]}\)], "Output",\

  CellLabel->"Out[8]=",
  CellTags->"b:2.13"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ %\)], "Input",
  CellLabel->"In[9]:=",
  CellTags->"b:2.13"],

Cell[BoxData[
    \({1.26325835375972984811264119`14.344324771319387*^-12, 
      3.607615503667432125110190319`14.553845773237134*^-11, 
      6.89141136734143784597959251833`14.680593889142427*^-9, 
      6.96738187191396353314190778`14.68084732559646*^-9, 
      6.96738187191396353314190778`14.68084732559646*^-9}\)], "Output",
  CellLabel->"Out[9]=",
  CellTags->"b:2.13"]
}, Open  ]],

Cell["\<\
The built-in function with a specified precision, can compute roots with \
higher accuracy, however it's not correct since the given polynomial has \
limited accuracy on its coefficients.\
\>", "ExampleText",
  CellTags->"b:2.13"],

Cell[CellGroupData[{

Cell[BoxData[
    \(x /. System`NSolve[Normal[g] \[Equal] 0, x, 32]\)], "Input",
  CellLabel->"In[14]:=",
  CellTags->"b:2.13"],

Cell[BoxData[
    \({\(-3.000072081132323369363265470615469368072618807267`30.\
774293073400294\), \
\(-0.998990384899131803235692255967327781747148608801`29.66690248209708\), \
\(-0.54121518244803744987808590833093969954`28.310493185161103\), \
\(-0.48136117576025368876147818254313157532`28.511587497216297\) - 
        0.02946453700124534253074769542182660678`27.298416059019203\ \
\[ImaginaryI], \(-0.48136117576025368876147818254313157532`28.511587497216297\
\) + 0.02946453700124534253074769542182660678`27.298416059019203\ \
\[ImaginaryI]}\)], "Output",
  CellLabel->"Out[14]=",
  CellTags->"b:2.13"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ %\)], "Input",
  CellLabel->"In[15]:=",
  CellTags->"b:2.13"],

Cell[BoxData[
    \({5.04473800074196880382201252`14.110972141207645*^-31, 
      2.151091212605542114942148535`13.984779051038164*^-30, 
      2.6477488372383614037666447914`14.136355574152187*^-29, 
      2.0960351428151453528800261594`14.119650478586713*^-29, 
      2.0960351428151453528800261594`14.119650478586713*^-29}\)], "Output",
  CellLabel->"Out[15]=",
  CellTags->"b:2.13"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["PolynomialGCD", "ObjectName",
  CellTags->{"i:26", "b:2.14", "c:26"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["PolynomialGCD[", "MR"],
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["\<\"poly\"\>",
            "TI"], "1"], TraditionalForm]], "InlineFormula"],
  StyleBox[",", "MR"],
  " ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["\<\"poly\"\>",
            "TI"], "2"], TraditionalForm]], "InlineFormula"],
  StyleBox["]", "MR"],
  " gives an approximate greatest common divisor of the polynomials ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["\<\"poly\"\>",
            "TI"], "1"], TraditionalForm]], "InlineFormula"],
  "and ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["poly",
            FontSlant->"Italic"], "2"], TraditionalForm]]],
  ". \n\[FilledSmallSquare] ",
  StyleBox["PolynomialGCD[", "MR"],
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["\<\"poly\"\>",
            "TI"], "1"], TraditionalForm]], "InlineFormula"],
  StyleBox[",", "MR"],
  " ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["\<\"poly\"\>",
            "TI"], "2"], TraditionalForm]], "InlineFormula"],
  ", ",
  StyleBox["err",
    FontSlant->"Italic"],
  StyleBox["]", "MR"],
  " gives an approximate greatest common divisor of the polynomials ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["\<\"poly\"\>",
            "TI"], "1"], TraditionalForm]], "InlineFormula"],
  "and ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["poly",
            FontSlant->"Italic"], "2"], TraditionalForm]]],
  " within the given error bound ",
  StyleBox["err",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.14"],

Cell["\<\
\[FilledSmallSquare] This function does not guarantee anything. This only \
tries to find an approximate greatest common divisor numerically. The given \
error bound is used only for a backward error check.\
\>", "Notes",
  CellTags->"b:2.14"],

Cell["\<\
\[FilledSmallSquare] See articles: V. Y. Pan. Computation of approximate \
polynomial gcds and an extension. Inform. and Comput., 167(2):71-85, 2001, \
and R. M. Corless, P. M. Gianni, B. M. Trager, and S. M. Watt. The singular \
value decomposition for polynomial systems. In Proceedings of the 1995 \
International Symposium on Symbolic and Algebraic Computation, ISSAC '95, \
pages 195-207, 1995.\
\>", "Notes",
  CellTags->"b:2.14"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.14"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["CoprimeQ",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["ApproximateDivisorQ",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["ApproximateQuotient",
    ButtonStyle->"AddOnsLink"],
  ", System`",
  ButtonBox["PolynomialGCD",
    ButtonStyle->"RefGuideLink"],
  "."
}], "Notes",
  CellTags->"b:2.14"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.14"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.14"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.14"],

Cell["Let consider the following polynomials.", "ExampleText",
  CellTags->"b:2.14"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[6]:=",
  CellTags->"b:2.14"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[6]=",
  CellTags->"b:2.14"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(h = 
      SNAP[1.3883\[InvisibleSpace] + 4.417\ x + 3.8861\ x\^2 + 
          0.85593\ x\^3]\)], "Input",
  CellLabel->"In[5]:=",
  CellTags->"b:2.14"],

Cell[BoxData[
    \(\(\(1.3883`\)\(\[InvisibleSpace]\)\) + 4.417`\ x + 3.8861`\ x\^2 + 
      0.85593`\ x\^3\)], "Output",
  CellLabel->"Out[5]=",
  CellTags->"b:2.14"]
}, Open  ]],

Cell["The built-in function outputs these polynomial are coprime.", \
"ExampleText",
  CellTags->"b:2.14"],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`PolynomialGCD[Normal[g], Normal[h]]\)], "Input",
  CellLabel->"In[7]:=",
  CellTags->"b:2.14"],

Cell[BoxData[
    \(1\/100000\)], "Output",
  CellLabel->"Out[7]=",
  CellTags->"b:2.14"]
}, Open  ]],

Cell[TextData[{
  "SNAP package can compute a their ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-GCD as below, where ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon] = 0.0001\)]],
  "."
}], "ExampleText",
  CellTags->"b:2.14"],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolynomialGCD[g, h, 0.0001`16]\)], "Input",
  CellLabel->"In[10]:=",
  CellTags->"b:2.14"],

Cell[BoxData[
    \(SNAP::"preliminary" \(\(:\)\(\ \)\) 
      "Preliminary implemented function is called."\)], "Message",
  CellLabel->"From In[10]:=",
  CellTags->"b:2.14"],

Cell[BoxData[
    \(\(\(0.00005`\)\(\[InvisibleSpace]\)\) + 0.00015907944968666715`\ x + 
      0.00013995894259165886`\ x\^2 + 
      0.00003082655045739393`\ x\^3\)], "Output",
  CellLabel->"Out[10]=",
  CellTags->"b:2.14"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["PolynomialNorm", "ObjectName",
  CellTags->{"i:27", "b:2.15", "c:27"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["PolynomialNorm",
    FontFamily->"Courier"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  "] gives a polynomial norm of ",
  StyleBox["poly",
    FontSlant->"Italic"],
  ".\n\[FilledSmallSquare] ",
  StyleBox["PolynomialNorm",
    FontFamily->"Courier"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  ", ",
  StyleBox["scheme",
    FontSlant->"Italic"],
  "] gives the specified polynomial norm of ",
  StyleBox["poly",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.15"],

Cell["\<\
\[FilledSmallSquare] The definitions of polynomial norms can be found in the \
package document or text books on mathematics.\
\>", "Notes",
  CellTags->"b:2.15"],

Cell[TextData[{
  "\[FilledSmallSquare] Possible schemes: ",
  ButtonBox["AbsolutePolynomial1Norm",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["AbsolutePolynomial2Norm",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["AbsolutePolynomialiNorm",
    ButtonStyle->"AddOnsLink"],
  ". The default scheme is ",
  StyleBox["AbsolutePolynomial2Norm",
    FontFamily->"Courier"],
  " and refers its value of the function ",
  ButtonBox["SNAP",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.15"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.15"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["SNAP",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.15"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.15"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.15"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.15"],

Cell["This computes the polynomial 2-norm of the given polynomial.", \
"ExampleText",
  CellTags->"b:2.15"],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolynomialNorm[x + 2]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.15"],

Cell[BoxData[
    \(\@5\)], "Output",
  CellLabel->"Out[2]=",
  CellTags->"b:2.15"]
}, Open  ]],

Cell["We can compute other polynomial norms as follows.", "ExampleText",
  CellTags->"b:2.15"],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolynomialNorm[x + 2, AbsolutePolynomial1Norm]\)], "Input",
  CellLabel->"In[3]:=",
  CellTags->"b:2.15"],

Cell[BoxData[
    \(3\)], "Output",
  CellLabel->"Out[3]=",
  CellTags->"b:2.15"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolynomialNorm[x + 2, AbsolutePolynomialiNorm]\)], "Input",
  CellLabel->"In[4]:=",
  CellTags->"b:2.15"],

Cell[BoxData[
    \(2\)], "Output",
  CellLabel->"Out[4]=",
  CellTags->"b:2.15"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["PolynomialQuotient", "ObjectName",
  CellTags->{"i:28", "b:2.16", "c:28"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["PolynomialQuotient",
    FontFamily->"Courier"],
  "[",
  StyleBox["p",
    FontSlant->"Italic"],
  ", ",
  StyleBox["q",
    FontSlant->"Italic"],
  ", ",
  StyleBox["x",
    FontSlant->"Italic"],
  "] gives the quotient of the given univariate polynomial set ",
  StyleBox["p", "TI"],
  " by the given polynomial set ",
  StyleBox["q ", "TI"],
  "in ",
  StyleBox["x", "TI"],
  ", with any remainder dropped and with exact accuracy in SNAP sense."
}], "Usage",
  CellTags->"b:2.16"],

Cell["\<\
\[FilledSmallSquare] Tolerances, error bounds and accuracy of SNAP polynomial \
sets are the same in this package. We recommend you to read the package \
documents for understanding coefficient-wise and polynomial norm \
tolerances.\
\>", "Notes",
  CellTags->"b:2.16"],

Cell["\<\
\[FilledSmallSquare] One of arguments must be a SNAP polynomial set. The \
built-in function is used if two arguments are not SNAP polynomial sets.\
\>", "Notes",
  CellTags->"b:2.16"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.16"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["PolynomialRemainder",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["PolynomialReduce",
    ButtonStyle->"AddOnsLink"],
  ", System`",
  ButtonBox["PolynomialQuotient",
    ButtonStyle->"RefGuideLink"],
  "."
}], "Notes",
  CellTags->"b:2.16"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.16"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.16"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.16"],

Cell["\<\
This gives the SNAP polynomial sets of the specified polynomials.\
\>", "ExampleText",
  CellTags->"b:2.16"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[20]:=",
  CellTags->"b:2.16"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[20]=",
  CellTags->"b:2.16"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(h = SNAP[x^3 + 0.4427]\)], "Input",
  CellLabel->"In[19]:=",
  CellTags->"b:2.16"],

Cell[BoxData[
    \(\(\(0.4427`\)\(\[InvisibleSpace]\)\) + x\^3\)], "Output",
  CellLabel->"Out[19]=",
  CellTags->"b:2.16"]
}, Open  ]],

Cell[TextData[{
  "This gives the polynomial quotient of ",
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  " by ",
  Cell[BoxData[
      \(TraditionalForm\`h\)]],
  ". The result is also a SNAP polynomial set."
}], "ExampleText",
  CellTags->"b:2.16"],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolynomialQuotient[g, h, x]\)], "Input",
  CellLabel->"In[21]:=",
  CellTags->"b:2.16"],

Cell[BoxData[
    \(\(\(9.765`\)\(\[InvisibleSpace]\)\) + 5.503`\ x + x\^2\)], "Output",
  CellLabel->"Out[21]=",
  CellTags->"b:2.16"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(SNAPQ[%]\)], "Input",
  CellLabel->"In[22]:=",
  CellTags->"b:2.16"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[22]=",
  CellTags->"b:2.16"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[%%]\)], "Input",
  CellLabel->"In[23]:=",
  CellTags->"b:2.16"],

Cell[BoxData[
    \(3.60304269982765894680905`14.262182264288592*^-15\)], "Output",
  CellLabel->"Out[23]=",
  CellTags->"b:2.16"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["PolynomialReduce", "ObjectName",
  CellTags->{"i:29", "b:2.17", "c:29"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["PolynomialReduce",
    FontFamily->"Courier"],
  StyleBox["[", "MR"],
  StyleBox["poly", "TI"],
  StyleBox[",", "MR"],
  " ",
  Cell[BoxData[
      \(TraditionalForm\`{\)], "InlineFormula"],
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["\<\"poly\"\>",
            "TI"], "1"], TraditionalForm]], "InlineFormula"],
  StyleBox[",", "MR"],
  " ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["\<\"poly\"\>",
            "TI"], "2"], TraditionalForm]], "InlineFormula"],
  StyleBox[",", "MR"],
  " \[Ellipsis] ",
  Cell[BoxData[
      \(TraditionalForm\`}\)], "InlineFormula"],
  StyleBox[",", "MR"],
  " ",
  Cell[BoxData[
      \(TraditionalForm\`{\)], "InlineFormula"],
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["\<\"x\"\>",
            "TI"], "1"], TraditionalForm]], "InlineFormula"],
  StyleBox[",", "MR"],
  " ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["\<\"x\"\>",
            "TI"], "2"], TraditionalForm]], "InlineFormula"],
  StyleBox[",", "MR"],
  " \[Ellipsis] ",
  Cell[BoxData[
      \(TraditionalForm\`}\)], "InlineFormula"],
  StyleBox["]", "MR"],
  " yields a list representing a reduction of ",
  StyleBox["poly", "TI"],
  " in terms of the ",
  Cell[BoxData[
      FormBox[
        SubscriptBox[
          StyleBox["\<\"poly\"\>",
            "TI"], 
          StyleBox["i",
            "TI"]], TraditionalForm]], "InlineFormula"],
  ". "
}], "Usage",
  CellTags->"b:2.17"],

Cell["\<\
\[FilledSmallSquare] Tolerances, error bounds and accuracy of SNAP polynomial \
sets are the same in this package. We recommend you to read the package \
documents for understanding coefficient-wise and polynomial norm \
tolerances.\
\>", "Notes",
  CellTags->"b:2.17"],

Cell["\<\
\[FilledSmallSquare] First argument and one of elements of second argument \
must be SNAP polynomial sets. The built-in function is used if all the \
arguments are not SNAP polynomial sets.\
\>", "Notes",
  CellTags->"b:2.17"],

Cell["\<\
\[FilledSmallSquare] The arguments do not have to be univariate polynomial \
sets. This function can treat multivariate polynomial sets.\
\>", "Notes",
  CellTags->"b:2.17"],

Cell["\<\
\[FilledSmallSquare] Monomial ordering can be specified by the option \
MonomialOrder.\
\>", "Notes",
  CellTags->"b:2.17"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.17"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["PolynomialQuotient",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["PolynomialRemainder",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.17"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.17"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.17"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[1]:=",
  CellTags->"b:2.17"],

Cell["\<\
This gives the SNAP polynomial sets of the specified polynomials.\
\>", "ExampleText",
  CellTags->"b:2.17"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.17"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[2]=",
  CellTags->"b:2.17"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(h = SNAP[x^3 + 0.4427]\)], "Input",
  CellLabel->"In[3]:=",
  CellTags->"b:2.17"],

Cell[BoxData[
    \(\(\(0.4427`\)\(\[InvisibleSpace]\)\) + x\^3\)], "Output",
  CellLabel->"Out[3]=",
  CellTags->"b:2.17"]
}, Open  ]],

Cell[TextData[{
  "This gives the polynomial quotient and remainder of ",
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  " by ",
  Cell[BoxData[
      \(TraditionalForm\`h\)]],
  ". The result is also SNAP polynomial sets."
}], "ExampleText",
  CellTags->"b:2.17"],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolynomialReduce[g, {h}, {x}]\)], "Input",
  CellLabel->"In[4]:=",
  CellTags->"b:2.17"],

Cell[BoxData[
    \({{\(\(9.765`\)\(\[InvisibleSpace]\)\) + 5.503`\ x + 
          x\^2}, \(-3.9457155`\) + 0.3258219`\ x + 7.2043`\ x\^2}\)], "Output",\

  CellLabel->"Out[4]=",
  CellTags->"b:2.17"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(SNAPQ /@ Flatten@%\)], "Input",
  CellLabel->"In[5]:=",
  CellTags->"b:2.17"],

Cell[BoxData[
    \({True, True}\)], "Output",
  CellLabel->"Out[5]=",
  CellTags->"b:2.17"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ Flatten@%%\)], "Input",
  CellLabel->"In[6]:=",
  CellTags->"b:2.17"],

Cell[BoxData[
    \({3.60304269982765894680905`14.262182264288592*^-15, 
      9.32074847629070155539787`14.272007530727354*^-15}\)], "Output",
  CellLabel->"Out[6]=",
  CellTags->"b:2.17"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["PolynomialRemainder", "ObjectName",
  CellTags->{"i:30", "b:2.18", "c:30"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["PolynomialRemainder",
    FontFamily->"Courier"],
  "[",
  StyleBox["p",
    FontSlant->"Italic"],
  ", ",
  StyleBox["q",
    FontSlant->"Italic"],
  ", ",
  StyleBox["x",
    FontSlant->"Italic"],
  "] gives the remainder of the given univariate polynomial set ",
  StyleBox["p", "TI"],
  " by the given polynomial set ",
  StyleBox["q ", "TI"],
  "in ",
  StyleBox["x", "TI"],
  ", with any quotient dropped and with exact accuracy in SNAP sense."
}], "Usage",
  CellTags->"b:2.18"],

Cell["\<\
\[FilledSmallSquare] Tolerances, error bounds and accuracy of SNAP polynomial \
sets are the same in this package. We recommend you to read the package \
documents for understanding coefficient-wise and polynomial norm \
tolerances.\
\>", "Notes",
  CellTags->"b:2.18"],

Cell["\<\
\[FilledSmallSquare] One of arguments must be a SNAP polynomial set. The \
built-in function is used if two arguments are not SNAP polynomial sets.\
\>", "Notes",
  CellTags->"b:2.18"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.18"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["PolynomialQuotient",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["PolynomialReduce",
    ButtonStyle->"AddOnsLink"],
  ", System`",
  ButtonBox["PolynomialRemainder",
    ButtonStyle->"RefGuideLink"],
  "."
}], "Notes",
  CellTags->"b:2.18"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.18"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.18"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.18"],

Cell["\<\
This gives the SNAP polynomial sets of the specified polynomials.\
\>", "ExampleText",
  CellTags->"b:2.18"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[20]:=",
  CellTags->"b:2.18"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[20]=",
  CellTags->"b:2.18"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(h = SNAP[x^3 + 0.4427]\)], "Input",
  CellLabel->"In[19]:=",
  CellTags->"b:2.18"],

Cell[BoxData[
    \(\(\(0.4427`\)\(\[InvisibleSpace]\)\) + x\^3\)], "Output",
  CellLabel->"Out[19]=",
  CellTags->"b:2.18"]
}, Open  ]],

Cell[TextData[{
  "This gives the polynomial remainder of ",
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  " by ",
  Cell[BoxData[
      \(TraditionalForm\`h\)]],
  ". The result is also a SNAP polynomial set."
}], "ExampleText",
  CellTags->"b:2.18"],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolynomialRemainder[g, h, x]\)], "Input",
  CellLabel->"In[24]:=",
  CellTags->"b:2.18"],

Cell[BoxData[
    \(\(-3.9457155`\) + 0.3258219`\ x + 7.2043`\ x\^2\)], "Output",
  CellLabel->"Out[24]=",
  CellTags->"b:2.18"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(SNAPQ[%]\)], "Input",
  CellLabel->"In[25]:=",
  CellTags->"b:2.18"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[25]=",
  CellTags->"b:2.18"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[%%]\)], "Input",
  CellLabel->"In[26]:=",
  CellTags->"b:2.18"],

Cell[BoxData[
    \(9.32074847629070155539787`14.272007530727354*^-15\)], "Output",
  CellLabel->"Out[26]=",
  CellTags->"b:2.18"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SeparationBound", "ObjectName",
  CellTags->{"i:2", "b:2.19", "c:31"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["SeparationBound",
    FontFamily->"Courier"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  "]",
  " gives a separation bound of ",
  StyleBox["poly",
    FontSlant->"Italic"],
  ".\n\[FilledSmallSquare] ",
  StyleBox["SeparationBound",
    FontFamily->"Courier"],
  "[",
  StyleBox["polyset",
    FontSlant->"Italic"],
  "]",
  " gives a separation bound of the given SNAP polynomial set ",
  StyleBox["polyset",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.19"],

Cell["\<\
\[FilledSmallSquare] Separation bounds are depending on error bounding \
schemes. We recommend you to read the package documents for understanding \
coefficient-wise and polynomial norm tolerances.\
\>", "Notes",
  CellTags->"b:2.19"],

Cell[TextData[{
  "\[FilledSmallSquare] This function tries to use an adaptive method if the \
option ",
  StyleBox["Adaptive",
    FontFamily->"Courier New"],
  " is ",
  StyleBox["True",
    FontFamily->"Courier New"],
  " (this is default). This method is not fast."
}], "Notes",
  CellTags->"b:2.19"],

Cell[TextData[{
  "\[FilledSmallSquare] This function tries to use Gao and Rodrigues \
criterion for sparse polynomials if the option ",
  StyleBox["Method",
    FontFamily->"Courier New"],
  " is ",
  StyleBox["NewtonPolytope",
    FontFamily->"Courier New"],
  " (",
  StyleBox["Automatic",
    FontFamily->"Courier New"],
  " is default). In this case, coefficients of terms included in the Newton \
polytope of the given polynomial, are only considered as coefficients with \
errors."
}], "Notes",
  CellTags->"b:2.19"],

Cell["\<\
\[FilledSmallSquare] See articles: K.Nagasaka. Towards More Accurate \
Separation Bounds of Empirical Polynomials. SIGSAM Bulletin, Formally \
Reviewed Articles, Vol. 38(4), 2004, 119--129, and K.Nagasaka. Towards More \
Accurate Separation Bounds of Empirical Polynomials II. Computer Algebra in \
Scientific Computing 2005, the Lecture Notes of Computer Science (LNCS) \
Volume 3718, 318--329.\
\>", "Notes",
  CellTags->"b:2.19"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.19"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["AbsolutelyIrreducibleQ",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.19"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.19"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.19"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.19"],

Cell["Let consider the following bivariate polynomial.", "ExampleText",
  CellTags->"b:2.19"],

Cell[CellGroupData[{

Cell[BoxData[
    \(f = 
      SetAccuracy[
        Expand[\((x^2 + y*x + 2  y - 1)\) \((x^3 + y^2\ x - y + 7)\) + 
            0.2  x], 8]\)], "Input",
  CellLabel->"In[1]:=",
  CellTags->"b:2.19"],

Cell[BoxData[
    \(\(-7.`8.845098040014257\) + 
      0.2000000000000000111`7.301029995663982\ x + 
      7.`8.845098040014257\ x\^2 - 1.`7.999999999999999\ x\^3 + x\^5 + 
      15.`9.176091259055681\ y + 7.`8.845098040014257\ x\ y - 
      1.`7.999999999999999\ x\^2\ y + 2.`8.30102999566398\ x\^3\ y + 
      x\^4\ y - 2.`8.30102999566398\ y\^2 - 2.`8.30102999566398\ x\ y\^2 + 
      x\^3\ y\^2 + 2.`8.30102999566398\ x\ y\^3 + x\^2\ y\^3\)], "Output",
  CellLabel->"Out[1]=",
  CellTags->"b:2.19"]
}, Open  ]],

Cell[TextData[{
  "We can compute a separation bound of ",
  Cell[BoxData[
      \(TraditionalForm\`f\)]],
  ". In this case, all the polynomial of ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_2\)(f, 0.0007915)\)]],
  " are absolutely irreducible."
}], "ExampleText",
  CellTags->"b:2.19"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SeparationBound[f]\)], "Input",
  CellLabel->"In[8]:=",
  CellTags->"b:2.19"],

Cell[BoxData[
    \(0.0007916215678719799`4.493893020022529\)], "Output",
  CellLabel->"Out[8]=",
  CellTags->"b:2.19"]
}, Open  ]],

Cell["\<\
If you want to bound errors on coefficients by the coefficient-wise \
tolerance, you should use the following option which is effective for the \
coefficient-wise tolerance and not applicable for the polynomial norm \
tolerance.\
\>", "ExampleText",
  CellTags->"b:2.19"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SeparationBound[f, Method \[Rule] NewtonPolytope]\)], "Input",
  CellLabel->"In[9]:=",
  CellTags->"b:2.19"],

Cell[BoxData[
    \(0.0028711129685531784`5.125030075637465\)], "Output",
  CellLabel->"Out[9]=",
  CellTags->"b:2.19"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SetTolerance", "ObjectName",
  CellTags->{"i:31", "b:2.20", "c:32"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["SetTolerance",
    FontFamily->"Courier"],
  "[",
  StyleBox["polyset",
    FontSlant->"Italic"],
  ", ",
  StyleBox["err",
    FontSlant->"Italic"],
  "] gives the polynomial set with the specified error bound ",
  StyleBox["err",
    FontSlant->"Italic"],
  ", of ",
  StyleBox["polyset",
    FontSlant->"Italic"],
  ".\n\[FilledSmallSquare] ",
  StyleBox["SetTolerance",
    FontFamily->"Courier"],
  "[",
  StyleBox["num",
    FontSlant->"Italic"],
  ", ",
  StyleBox["err",
    FontSlant->"Italic"],
  "] gives the number with the specified error bound ",
  StyleBox["err",
    FontSlant->"Italic"],
  ", of ",
  StyleBox["num",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.20"],

Cell["\<\
\[FilledSmallSquare] Tolerances of SNAP polynomial sets are depending on \
error bounding schemes. We recommend you to read the package documents for \
understanding coefficient-wise and polynomial norm tolerances.\
\>", "Notes",
  CellTags->"b:2.20"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.20"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["Tolerance",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.20"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.20"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.20"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.20"],

Cell["\<\
This gives the SNAP polynomial set of the specified polynomial.\
\>", "ExampleText",
  CellTags->"b:2.20"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.20"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[2]=",
  CellTags->"b:2.20"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g]\)], "Input",
  CellLabel->"In[13]:=",
  CellTags->"b:2.20"],

Cell[BoxData[
    \(1.537912594467730969706440231090759`14.303315010757439*^-15\)], "Output",\

  CellLabel->"Out[13]=",
  CellTags->"b:2.20"]
}, Open  ]],

Cell["\<\
This givens the polynomial set with the specified error bound.\
\>", "ExampleText",
  CellTags->"b:2.20"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2 = SetTolerance[g, 1.0`16*^-10]\)], "Input",
  CellLabel->"In[25]:=",
  CellTags->"b:2.20"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[25]=",
  CellTags->"b:2.20"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g2]\)], "Input",
  CellLabel->"In[26]:=",
  CellTags->"b:2.20"],

Cell[BoxData[
    \(1.0000000000000001`15.999999999999996*^-10\)], "Output",
  CellLabel->"Out[26]=",
  CellTags->"b:2.20"]
}, Open  ]],

Cell["This function can also change tolerances of numbers.", "ExampleText",
  CellTags->"b:2.20"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SetTolerance[1.0`16, 1.0`16*^-10] // FullForm\)], "Input",
  CellLabel->"In[21]:=",
  CellTags->"b:2.20"],

Cell[BoxData[
    TagBox[
      StyleBox["1.`10.",
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[21]//FullForm=",
  CellTags->"b:2.20"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SingularValueListWithErrorBound", "ObjectName",
  CellTags->{"i:32", "b:2.21", "c:33"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["SingularValueListWithErrorBound",
    FontFamily->"Courier"],
  "[",
  StyleBox["m", "TI"],
  "] gives a list of the non\[Hyphen]zero singular values of a numerical \
matrix ",
  StyleBox["m", "TI"],
  ", considering numerical error."
}], "Usage",
  CellTags->"b:2.21"],

Cell["\<\
\[FilledSmallSquare] See articles: G. H. Golub and C. F. V. Loan. Matrix \
Computations Third Edition, Johns Hopkins Series in the Mathematical \
Sciences. The Johns Hopkins University Press, Baltimore, 1996.\
\>", "Notes",
  CellTags->"b:2.21"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.21"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: System`",
  ButtonBox["SingularValueList",
    ButtonStyle->"RefGuideLink"],
  "."
}], "Notes",
  CellTags->"b:2.21"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.21"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.21"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.21"],

Cell["Let consider the following numerical matrix.", "ExampleText",
  CellTags->"b:2.21"],

Cell[CellGroupData[{

Cell[BoxData[
    \(m = N[{{1, 2}, {3, 4}}, 8]\)], "Input",
  CellLabel->"In[32]:=",
  CellTags->"b:2.21"],

Cell[BoxData[
    \({{1.`7.999999999999999, 2.`7.999999999999999}, {3.`8. , 
        4.`7.999999999999999}}\)], "Output",
  CellLabel->"Out[32]=",
  CellTags->"b:2.21"]
}, Open  ]],

Cell[TextData[{
  "This function can compute the singular values with error considering. \
Hence, all the values are correct if we take lower or upper values of them by \
",
  ButtonBox["FloorFloat",
    ButtonStyle->"AddOnsLink"],
  " or ",
  ButtonBox["CeilingFloat",
    ButtonStyle->"AddOnsLink"],
  "."
}], "ExampleText",
  CellTags->"b:2.21"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SingularValueListWithErrorBound[m]\)], "Input",
  CellLabel->"In[35]:=",
  CellTags->"b:2.21"],

Cell[BoxData[
    \({5.4649857042190417289`7.999031046552798, 
      0.3659661906262576259`6.824882981772291}\)], "Output",
  CellLabel->"Out[35]=",
  CellTags->"b:2.21"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ %\)], "Input",
  CellLabel->"In[36]:=",
  CellTags->"b:2.21"],

Cell[BoxData[
    \({5.477192233517025142772855835332`14.731351207685654*^-8, 
      5.477192233517025142772855835332`14.731351207685654*^-8}\)], "Output",
  CellLabel->"Out[36]=",
  CellTags->"b:2.21"]
}, Open  ]],

Cell[TextData[{
  "The singular values of the built-in function have higher precisions, \
however ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " book does not argue its correctness against to the input precisions of \
the given matrix."
}], "ExampleText",
  CellTags->"b:2.21"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SingularValueList[m]\)], "Input",
  CellLabel->"In[33]:=",
  CellTags->"b:2.21"],

Cell[BoxData[
    \({5.4649857042190426505`7.999999999999999, 
      0.3659661906262578205`7.999999999999999}\)], "Output",
  CellLabel->"Out[33]=",
  CellTags->"b:2.21"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ %\)], "Input",
  CellLabel->"In[34]:=",
  CellTags->"b:2.21"],

Cell[BoxData[
    \({5.464985704219065380894383705595`14.731293260096079*^-8, 
      3.6596619062626083804346669223`14.481244853272308*^-9}\)], "Output",
  CellLabel->"Out[34]=",
  CellTags->"b:2.21"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SNAP", "ObjectName",
  CellTags->{"i:33", "b:2.22", "c:34"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["SNAP",
    FontFamily->"Courier"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  "] gives the polynomial set of ",
  StyleBox["poly",
    FontSlant->"Italic"],
  ".\n\[FilledSmallSquare] ",
  StyleBox["SNAP",
    FontFamily->"Courier"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  ", ",
  StyleBox["err",
    FontSlant->"Italic"],
  "] gives the polynomial set of ",
  StyleBox["poly",
    FontSlant->"Italic"],
  " with the specified error bound ",
  StyleBox["err",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.22"],

Cell["\<\
\[FilledSmallSquare] SNAP polynomial sets are depending on error bounding \
schemes. We recommend you to read the package documents for understanding \
coefficient-wise and polynomial norm tolerances.\
\>", "Notes",
  CellTags->"b:2.22"],

Cell[TextData[{
  "\[FilledSmallSquare] SNAP package provides three error schemes: ",
  ButtonBox["AbsolutePolynomial1Norm",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["AbsolutePolynomial2Norm",
    ButtonStyle->"AddOnsLink"],
  " and  ",
  ButtonBox["AbsolutePolynomialiNorm",
    ButtonStyle->"AddOnsLink"],
  ". They are specified by the option ",
  StyleBox["DefaultErrorScheme",
    FontFamily->"Courier"],
  ". The default error scheme is ",
  StyleBox["AbsolutePolynomial2Norm",
    FontFamily->"Courier"],
  "."
}], "Notes",
  CellTags->"b:2.22"],

Cell[TextData[{
  "\[FilledSmallSquare] SNAP package preserves tolerances of polynomial sets \
up to a specified precision by the option ",
  StyleBox["TolerancePrecision",
    FontFamily->"Courier"],
  ". The default value is 16."
}], "Notes",
  CellTags->"b:2.22"],

Cell[TextData[{
  "\[FilledSmallSquare] NOTE THAT: This function does not accept any option. \
The options must be specified by ",
  ButtonBox["SetOptions",
    ButtonStyle->"RefGuideLink"],
  "."
}], "Notes",
  CellTags->"b:2.22"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.22"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["SNAPQ",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["Normal",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["Tolerance",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["TransformSNAP",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SetTolerance",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.22"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.22"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.22"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[1]:=",
  CellTags->"b:2.22"],

Cell["\<\
This gives the SNAP polynomial set of the specified polynomial.\
\>", "ExampleText",
  CellTags->"b:2.22"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.22"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[2]=",
  CellTags->"b:2.22"]
}, Open  ]],

Cell["\<\
Although its appearance is not changed, its inner representation is \
different.\
\>", "ExampleText",
  CellTags->"b:2.22"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FullForm[g]\)], "Input",
  CellLabel->"In[3]:=",
  CellTags->"b:2.22"],

Cell[BoxData[
    TagBox[
      StyleBox[\(SNAP[
          Plus[Rational[1509, 4000], Times[Rational[1381, 500], x], 
            Times[Rational[7647, 1000], Power[x, 2]], 
            Times[Rational[1953, 200], Power[x, 3]], 
            Times[Rational[5503, 1000], Power[x, 4]], Power[x, 5]], 
          1.537912594467730969706440231090759`14.303315010757439*^-15, 
          List[List[x, 5]], AbsolutePolynomial2Norm]\),
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[3]//FullForm=",
  CellTags->"b:2.22"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Tolerance", "ObjectName",
  CellTags->{"i:34", "b:2.23", "c:35"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["Tolerance",
    FontFamily->"Courier"],
  "[",
  StyleBox["polyset",
    FontSlant->"Italic"],
  "] gives the tolerance of the specified polynomial set ",
  StyleBox["polyset",
    FontSlant->"Italic"],
  ".\n\[FilledSmallSquare] ",
  StyleBox["Tolerance",
    FontFamily->"Courier"],
  "[",
  StyleBox["expr",
    FontSlant->"Italic"],
  "] gives the tolerance of the specified expression ",
  StyleBox["expr",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.23"],

Cell["\<\
\[FilledSmallSquare] Tolerances of SNAP polynomial sets are depending on \
error bounding schemes. We recommend you to read the package documents for \
understanding coefficient-wise and polynomial norm tolerances.\
\>", "Notes",
  CellTags->"b:2.23"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.23"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["SetTolerance",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.23"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.23"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.23"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.23"],

Cell["\<\
This gives the SNAP polynomial set of the specified polynomial.\
\>", "ExampleText",
  CellTags->"b:2.23"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.23"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[2]=",
  CellTags->"b:2.23"]
}, Open  ]],

Cell["This gives the tolerance of the above polynomial set.", "ExampleText",
  CellTags->"b:2.23"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g]\)], "Input",
  CellLabel->"In[9]:=",
  CellTags->"b:2.23"],

Cell[BoxData[
    \(1.537912594467730969706440231090759`14.303315010757439*^-15\)], "Output",\

  CellLabel->"Out[9]=",
  CellTags->"b:2.23"]
}, Open  ]],

Cell["\<\
This function can also compute tolerances of numbers or polynomials.\
\>", "ExampleText",
  CellTags->"b:2.23"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[1.0`16]\)], "Input",
  CellLabel->"In[7]:=",
  CellTags->"b:2.23"],

Cell[BoxData[
    \(1.00000000000000409021277824102681`14.388254098835615*^-16\)], "Output",\

  CellLabel->"Out[7]=",
  CellTags->"b:2.23"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[1.0`16 + 1.0`16\ x]\)], "Input",
  CellLabel->"In[8]:=",
  CellTags->"b:2.23"],

Cell[BoxData[
    \(1.4142135623731066176704566825728`14.388254098835615*^-16\)], "Output",
  CellLabel->"Out[8]=",
  CellTags->"b:2.23"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["TransformSNAP", "ObjectName",
  CellTags->{"i:35", "b:2.24", "c:36"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["TransformSNAP",
    FontFamily->"Courier"],
  "[",
  StyleBox["polyset",
    FontSlant->"Italic"],
  ", ",
  StyleBox["scheme",
    FontSlant->"Italic"],
  "] gives the polynomial set of ",
  StyleBox["polyset",
    FontSlant->"Italic"],
  " with the specified error scheme ",
  StyleBox["scheme",
    FontSlant->"Italic"],
  " which includes all the polynomials of the set ",
  StyleBox["polyset",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.24"],

Cell["\<\
\[FilledSmallSquare] SNAP polynomial sets are depending on error bounding \
schemes. We recommend you to read the package documents for understanding \
coefficient-wise and polynomial norm tolerances.\
\>", "Notes",
  CellTags->"b:2.24"],

Cell[TextData[{
  "\[FilledSmallSquare] Possible error schemes are ",
  ButtonBox["AbsolutePolynomial1Norm",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["AbsolutePolynomial2Norm",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["AbsolutePolynomialiNorm",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.24"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.24"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["SNAPQ",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["Normal",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["Tolerance",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SetTolerance",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.24"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.24"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.24"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.24"],

Cell["\<\
This gives the SNAP polynomial set of the specified polynomial.\
\>", "ExampleText",
  CellTags->"b:2.24"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.24"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[2]=",
  CellTags->"b:2.24"]
}, Open  ]],

Cell["\<\
This generates the polynomial set with another error scheme, of the above \
set.\
\>", "ExampleText",
  CellTags->"b:2.24"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2 = TransformSNAP[g, AbsolutePolynomial1Norm]\)], "Input",
  CellLabel->"In[4]:=",
  CellTags->"b:2.24"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[4]=",
  CellTags->"b:2.24"]
}, Open  ]],

Cell["Changing error schemes increases tolerances.", "ExampleText",
  CellTags->"b:2.24"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g]\)], "Input",
  CellLabel->"In[5]:=",
  CellTags->"b:2.24"],

Cell[BoxData[
    \(1.537912594467730969706440231090759`14.303315010757439*^-15\)], "Output",\

  CellLabel->"Out[5]=",
  CellTags->"b:2.24"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g2]\)], "Input",
  CellLabel->"In[6]:=",
  CellTags->"b:2.24"],

Cell[BoxData[
    \(3.76710112544577242124053`14.29849478682027*^-15\)], "Output",
  CellLabel->"Out[6]=",
  CellTags->"b:2.24"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Variables", "ObjectName",
  CellTags->{"i:36", "b:2.25", "c:37"}],

Cell["\<\
\[FilledSmallSquare] This function is extended to SNAP polynomial sets.\
\>", "Notes",
  CellTags->"b:2.25"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.25"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: System`",
  ButtonBox["Variables",
    ButtonStyle->"RefGuideLink"],
  "."
}], "Notes",
  CellTags->"b:2.25"]
}, Closed]],

Cell[CellGroupData[{

Cell["NearestSingularPolynomial", "ObjectName",
  CellTags->{"i:37", "b:2.26", "c:38"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["NearestSingularPolynomial",
    FontFamily->"Courier"],
  "[",
  StyleBox["poly",
    FontSlant->"Italic"],
  "] gives the nearest singular polynomial of ",
  StyleBox["poly",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.26"],

Cell["\<\
\[FilledSmallSquare] The nearest singular polynomial is a polynomial having \
multiple roots, which is the closest to the given polynomial in polynomial \
2-norm.\
\>", "Notes",
  CellTags->"b:2.26"],

Cell["\<\
\[FilledSmallSquare] This function can operate with a polynomial or a SNAP \
polynomial set.\
\>", "Notes",
  CellTags->"b:2.26"],

Cell["\<\
\[FilledSmallSquare] See articles: L. Zhi, W. Wu, M.-T. Noda, and H. Kai. \
Hybrid method for computing the nearest singular polynomials. MM Research \
Preprints, 20:229-239, 2001.\
\>", "Notes",
  CellTags->"b:2.26"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.26"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.26"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.26"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.26"],

Cell["Let consider the following polynomial which is square-free.", \
"ExampleText",
  CellTags->"b:2.26"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
        0.37725\)], "Input",
  CellLabel->"In[37]:=",
  CellTags->"b:2.26"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[37]=",
  CellTags->"b:2.26"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(x /. System`NSolve[g \[Equal] 0, x]\)], "Input",
  CellLabel->"In[40]:=",
  CellTags->"b:2.26"],

Cell[BoxData[
    \({\(-3.000072081132323`\), \(-0.9989903848991334`\), \
\(-0.5412151824480371`\), \(-0.4813611757602533`\) - 
        0.029464537001247744`\ \[ImaginaryI], \(-0.4813611757602533`\) + 
        0.029464537001247744`\ \[ImaginaryI]}\)], "Output",
  CellLabel->"Out[40]=",
  CellTags->"b:2.26"]
}, Open  ]],

Cell["\<\
This computes the nearest singular polynomial of the above polynomial.\
\>", "ExampleText",
  CellTags->"b:2.26"],

Cell[CellGroupData[{

Cell[BoxData[
    \(nsg = NearestSingularPolynomial[g]\)], "Input",
  CellLabel->"In[38]:=",
  CellTags->"b:2.26"],

Cell[BoxData[
    \(SNAP::"preliminary" \(\(:\)\(\ \)\) 
      "Preliminary implemented function is called."\)], "Message",
  CellLabel->"From In[38]:=",
  CellTags->"b:2.26"],

Cell[BoxData[
    \(\(\(0.3772035197483813`\)\(\[InvisibleSpace]\)\) + 
      2.7620229415240445`\ x + 7.646988676620562`\ x\^2 + 
      9.765005588945254`\ x\^3 + 5.5029972414322765`\ x\^4 + x\^5\)], "Output",\

  CellLabel->"Out[38]=",
  CellTags->"b:2.26"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(x /. System`NSolve[nsg \[Equal] 0, x]\)], "Input",
  CellLabel->"In[41]:=",
  CellTags->"b:2.26"],

Cell[BoxData[
    \({\(-3.000053130650948`\), \(-0.9993512817134619`\), \
\(-0.5164413724592519`\), \(-0.4935757297584094`\), \
\(-0.49357572685020595`\)}\)], "Output",
  CellLabel->"Out[41]=",
  CellTags->"b:2.26"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SNAPQ", "ObjectName",
  CellTags->{"i:38", "b:2.27", "c:39"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["SNAPQ",
    FontFamily->"Courier"],
  "[",
  StyleBox["expr",
    FontSlant->"Italic"],
  "] gives ",
  StyleBox["True",
    FontFamily->"Courier"],
  " if ",
  StyleBox["expr",
    FontSlant->"Italic"],
  " is a SNAP polynomial set."
}], "Usage",
  CellTags->"b:2.27"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.27"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["SNAP",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["Normal",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.27"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.27"],

Cell["This function requires to load the package.", "ExampleText",
  CellTags->"b:2.27"],

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.27"],

Cell["\<\
This gives the SNAP polynomial set of the specified polynomial.\
\>", "ExampleText",
  CellTags->"b:2.27"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[2]:=",
  CellTags->"b:2.27"],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[2]=",
  CellTags->"b:2.27"]
}, Open  ]],

Cell[TextData[{
  StyleBox["SNAPQ",
    FontFamily->"Courier"],
  " can test whether the given argument is a SNAP polynomial set or not."
}], "ExampleText",
  CellTags->"b:2.27"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SNAPQ[g]\)], "Input",
  CellLabel->"In[82]:=",
  CellTags->"b:2.27"],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[82]=",
  CellTags->"b:2.27"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(SNAPQ[Normal[g]]\)], "Input",
  CellLabel->"In[84]:=",
  CellTags->"b:2.27"],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[84]=",
  CellTags->"b:2.27"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(SNAPQ[
      x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
        0.37725]\)], "Input",
  CellLabel->"In[83]:=",
  CellTags->"b:2.27"],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[83]=",
  CellTags->"b:2.27"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Normal", "ObjectName",
  CellTags->{"i:39", "b:2.28", "c:40"}],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["Normal",
    FontFamily->"Courier"],
  "[",
  StyleBox["polyset",
    FontSlant->"Italic"],
  "] gives a normal represetation polynomial of ",
  StyleBox["polyset",
    FontSlant->"Italic"],
  "."
}], "Usage",
  CellTags->"b:2.28"],

Cell["\<\
\[FilledSmallSquare] This function outputs a polynomial with rational \
coefficients.\
\>", "Notes",
  CellTags->"b:2.28"],

Cell[TextData[{
  "\[FilledSmallSquare] See package documents: ",
  ButtonBox["SNAP0",
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["SNAP1",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.28"],

Cell[TextData[{
  "\[FilledSmallSquare] See also: ",
  ButtonBox["SNAP",
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAPQ",
    ButtonStyle->"AddOnsLink"],
  "."
}], "Notes",
  CellTags->"b:2.28"],

Cell[CellGroupData[{

Cell["Further Examples", "ExampleSection",
  CellTags->"b:2.28"],

Cell[TextData[{
  "See the further exmaples of ",
  ButtonBox["SNAPQ",
    ButtonStyle->"AddOnsLink"],
  "."
}], "ExampleText",
  CellTags->"b:2.28"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"5.1 for X",
ScreenRectangle->{{0, 2560}, {0, 1024}},
ScreenStyleEnvironment->"Brackets",
ShowPageBreaks->False,
WindowSize->{741, 777},
WindowMargins->{{351, Automatic}, {Automatic, 60}},
PrintingStartingPageNumber->1,
TaggingRules:>{"NextIndexingNumber" -> 40, "IndexEntries" -> {{"i:10", \
"Element"}, {"i:10", "Expand"}, {"i:10", "Normal"}, {"i:10", "ReplaceAll"}, \
{"i:10", "SetTolerance"}, {"i:10", "SNAP"}, {"i:10", "SNAPQ"}, {"i:10", \
"Tolerance"}, {"i:10", "TransformSNAP"}, {"i:11", "D"}, {"i:11", "NSolve"}, \
{"i:11", "PolynomialQuotient"}, {"i:11", "PolynomialReduce"}, {"i:11", \
"PolynomialRemainder"}, {"i:12", "AbsolutelyIrreducibleQ"}, {"i:12", \
"ApproximateDivisorQ"}, {"i:12", "ApproximateQuotient"}, {"i:12", \
"CoprimeQ"}, {"i:12", "Factor"}, {"i:12", "FactorList"}, {"i:12", \
"NearestSingularPolynomial"}, {"i:12", "PolynomialGCD"}, {"i:12", \
"SeparationBound"}, {"i:13", "ApproximateDivisorQ"}, {"i:14", \
"ApproximateQuotient"}, {"i:15", "CeilingFloat"}, {"i:16", "CoprimeQ"}, \
{"i:17", "D"}, {"i:18", "Element"}, {"i:19", "Expand"}, {"i:2", \
"SeparationBound"}, {"i:20", "Exponent"}, {"i:21", "ExportSWF"}, {"i:22", \
"Factor"}, {"i:23", "FactorList"}, {"i:24", "FloorFloat"}, {"i:25", \
"NSolve"}, {"i:26", "PolynomialGCD"}, {"i:27", "PolynomialNorm"}, {"i:28", \
"PolynomialQuotient"}, {"i:29", "PolynomialReduce"}, {"i:30", \
"PolynomialRemainder"}, {"i:31", "SetTolerance"}, {"i:32", \
"SingularValueListWithErrorBound"}, {"i:33", "SNAP"}, {"i:34", "Tolerance"}, \
{"i:35", "TransformSNAP"}, {"i:36", "Variables"}, {"i:37", \
"NearestSingularPolynomial"}, {"i:38", "SNAPQ"}, {"i:39", "Normal"}, {"i:4", \
"SNAP"}, {"i:5", "Tolerance"}, {"i:6", "Element"}, {"i:7", "Normal"}, {"i:8", \
"NotSNAPQ"}, {"i:8", "SNAPQ"}, {"i:9", "AbsolutelyIrreducibleQ"}, {"i:9", \
"ApproximateDivisorQ"}, {"i:9", "ApproximateQuotient"}, {"i:9", "Factor"}, \
{"i:9", "FactorList"}, {"i:9", "NearestSingularPolynomial"}, {"i:9", \
"PolynomialGCD"}, {"i:9", "SeparationBound"}, {"i:1", "Absolute \
irreducibility", "", ""}, {"i:1", "AbsolutelyIrreducibleQ", "", ""}, {"i:1", \
"Approximate factorization", "", ""}, {"i:1", "Numerical factorization", "", \
""}, {"i:2", "Irreducibility radius", "", ""}}, "PaginationCache" -> {{2005, \
8, 26, 2, 22, 42.786511`8.383881851352882}, {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
   1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, \
1, 1, 1, 1, 1, 1}}},
Magnification->1,
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "c:1"->{
    Cell[1825, 57, 50, 1, 65, "Section",
      CellTags->"c:1"]},
  "b:0.0"->{
    Cell[1900, 62, 60, 1, 40, "Subsection",
      CellTags->{"b:0.0", "c:2"}],
    Cell[1963, 65, 356, 7, 93, "Text",
      CellTags->"b:0.0"],
    Cell[2322, 74, 308, 6, 76, "Text",
      CellTags->"b:0.0"],
    Cell[2633, 82, 685, 13, 195, "FramedBox",
      CellTags->"b:0.0"],
    Cell[3321, 97, 67, 1, 41, "MathCaption",
      CellTags->"b:0.0"],
    Cell[3391, 100, 96, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[3490, 105, 136338, 1964, 116, "DefinitionBox",
      CellTags->"b:0.0"],
    Cell[139831, 2071, 227, 4, 61, "Print",
      CellTags->"b:0.0"],
    Cell[140061, 2077, 202, 4, 42, "Text",
      CellTags->{"i:4", "b:0.0"}],
    Cell[140266, 2083, 466, 10, 32, "DisplayMath",
      CellTags->"b:0.0"],
    Cell[140735, 2095, 657, 21, 76, "Text",
      CellTags->"b:0.0"],
    Cell[141395, 2118, 133, 4, 42, "Text",
      CellTags->"b:0.0"],
    Cell[141531, 2124, 5351, 134, 378, "DefinitionBox",
      CellTags->"b:0.0"],
    Cell[146885, 2260, 66, 1, 17, "Caption",
      CellTags->"b:0.0"],
    Cell[146954, 2263, 72, 1, 41, "MathCaption",
      CellTags->"b:0.0"],
    Cell[147051, 2268, 169, 5, 49, "Input",
      CellTags->"b:0.0"],
    Cell[147223, 2275, 187, 4, 27, "Output",
      CellTags->"b:0.0"],
    Cell[147425, 2282, 168, 6, 41, "MathCaption",
      CellTags->"b:0.0"],
    Cell[147618, 2292, 89, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[147710, 2297, 607, 14, 155, "Output",
      CellTags->"b:0.0"],
    Cell[148332, 2314, 224, 5, 59, "Text",
      CellTags->"b:0.0"],
    Cell[148559, 2321, 260, 7, 59, "FramedBox",
      CellTags->"b:0.0"],
    Cell[148822, 2330, 203, 7, 58, "MathCaption",
      CellTags->{"i:5", "b:0.0"}],
    Cell[149050, 2341, 90, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[149143, 2346, 139, 4, 27, "Output",
      CellTags->"b:0.0"],
    Cell[149297, 2353, 97, 1, 41, "MathCaption",
      CellTags->"b:0.0"],
    Cell[149419, 2358, 86, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[149508, 2363, 191, 4, 28, "Output",
      CellTags->"b:0.0"],
    Cell[149736, 2372, 91, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[149830, 2377, 129, 3, 27, "Output",
      CellTags->"b:0.0"],
    Cell[149974, 2383, 365, 10, 75, "MathCaption",
      CellTags->{"i:6", "b:0.0"}],
    Cell[150364, 2397, 113, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[150480, 2402, 83, 3, 27, "Output",
      CellTags->"b:0.0"],
    Cell[150600, 2410, 114, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[150717, 2415, 85, 3, 27, "Output",
      CellTags->"b:0.0"],
    Cell[150817, 2421, 205, 6, 58, "MathCaption",
      CellTags->{"i:7", "b:0.0"}],
    Cell[151047, 2431, 100, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[151150, 2436, 460, 11, 117, "Output",
      CellTags->"b:0.0"],
    Cell[151625, 2450, 136, 4, 25, "Text",
      CellTags->{"i:8", "b:0.0"}],
    Cell[151764, 2456, 2052, 53, 222, "DefinitionBox",
      CellTags->"b:0.0"],
    Cell[153819, 2511, 84, 1, 17, "Caption",
      CellTags->"b:0.0"],
    Cell[153906, 2514, 157, 4, 42, "Text",
      CellTags->"b:0.0"],
    Cell[154066, 2520, 185, 3, 76, "FramedBox",
      CellTags->"b:0.0"],
    Cell[154254, 2525, 74, 1, 17, "Caption",
      CellTags->"b:0.0"],
    Cell[154331, 2528, 86, 1, 41, "MathCaption",
      CellTags->"b:0.0"],
    Cell[154442, 2533, 81, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[154526, 2538, 192, 4, 28, "Output",
      CellTags->"b:0.0"],
    Cell[154755, 2547, 89, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[154847, 2552, 321, 6, 65, "Output",
      CellTags->"b:0.0"],
    Cell[155205, 2563, 88, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[155296, 2568, 84, 3, 27, "Output",
      CellTags->"b:0.0"],
    Cell[155395, 2574, 387, 7, 109, "MathCaption",
      CellTags->"b:0.0"],
    Cell[155807, 2585, 96, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[155906, 2590, 543, 10, 65, "Output",
      CellTags->"b:0.0"],
    Cell[156486, 2605, 104, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[156593, 2610, 379, 7, 65, "Output",
      CellTags->"b:0.0"],
    Cell[157009, 2622, 117, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[157129, 2627, 353, 6, 65, "Output",
      CellTags->"b:0.0"],
    Cell[157519, 2638, 104, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[157626, 2643, 406, 8, 65, "Output",
      CellTags->"b:0.0"],
    Cell[158047, 2654, 416, 11, 92, "MathCaption",
      CellTags->"b:0.0"],
    Cell[158488, 2669, 160, 4, 49, "Input",
      CellTags->"b:0.0"],
    Cell[158651, 2675, 268, 5, 50, "Message",
      CellTags->"b:0.0"],
    Cell[158922, 2682, 268, 5, 50, "Message",
      CellTags->"b:0.0"],
    Cell[159193, 2689, 268, 5, 50, "Message",
      CellTags->"b:0.0"],
    Cell[159464, 2696, 405, 7, 35, "Message",
      CellTags->"b:0.0"],
    Cell[159872, 2705, 216, 5, 46, "Output",
      CellTags->"b:0.0"],
    Cell[160103, 2713, 196, 6, 58, "MathCaption",
      CellTags->"b:0.0"],
    Cell[160324, 2723, 101, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[160428, 2728, 93, 3, 27, "Output",
      CellTags->"b:0.0"],
    Cell[160536, 2734, 180, 4, 58, "MathCaption",
      CellTags->"b:0.0"],
    Cell[160741, 2742, 103, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[160847, 2747, 520, 10, 46, "Output",
      CellTags->"b:0.0"],
    Cell[161404, 2762, 104, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[161511, 2767, 379, 7, 65, "Output",
      CellTags->"b:0.0"],
    Cell[161905, 2777, 351, 6, 92, "MathCaption",
      CellTags->"b:0.0"],
    Cell[162281, 2787, 103, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[162387, 2792, 258, 5, 50, "Message",
      CellTags->"b:0.0"],
    Cell[162648, 2799, 1102, 20, 141, "Output",
      CellTags->"b:0.0"],
    Cell[163765, 2822, 201, 7, 42, "Text",
      CellTags->"b:0.0"],
    Cell[163969, 2831, 1087, 25, 194, "DefinitionBox3Col",
      CellTags->"b:0.0"],
    Cell[165059, 2858, 57, 1, 17, "Caption",
      CellTags->"b:0.0"],
    Cell[165119, 2861, 218, 5, 59, "Text",
      CellTags->"b:0.0"],
    Cell[165340, 2868, 1453, 40, 102, "DefinitionBox",
      CellTags->"b:0.0"],
    Cell[166796, 2910, 86, 1, 17, "Caption",
      CellTags->"b:0.0"],
    Cell[166885, 2913, 94, 1, 41, "MathCaption",
      CellTags->"b:0.0"],
    Cell[167004, 2918, 91, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[167098, 2923, 140, 4, 27, "Output",
      CellTags->"b:0.0"],
    Cell[167275, 2932, 125, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[167403, 2937, 188, 4, 27, "Output",
      CellTags->"b:0.0"],
    Cell[167628, 2946, 92, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[167723, 2951, 127, 3, 27, "Output",
      CellTags->"b:0.0"],
    Cell[167865, 2957, 517, 10, 93, "Text",
      CellTags->{"i:9", "b:0.0"}],
    Cell[168385, 2969, 5564, 143, 476, "DefinitionBox",
      CellTags->"b:0.0"],
    Cell[173952, 3114, 77, 1, 17, "Caption",
      CellTags->"b:0.0"],
    Cell[174032, 3117, 161, 6, 41, "MathCaption",
      CellTags->"b:0.0"],
    Cell[174218, 3127, 112, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[174333, 3132, 197, 4, 35, "Message",
      CellTags->"b:0.0"],
    Cell[174533, 3138, 644, 12, 198, "Output",
      CellTags->"b:0.0"],
    Cell[175192, 3153, 143, 6, 41, "MathCaption",
      CellTags->"b:0.0"],
    Cell[175360, 3163, 108, 3, 29, "Input",
      CellTags->"b:0.0"],
    Cell[175471, 3168, 258, 5, 50, "Message",
      CellTags->"b:0.0"],
    Cell[175732, 3175, 560, 12, 141, "Output",
      CellTags->"b:0.0"]},
  "c:2"->{
    Cell[1900, 62, 60, 1, 40, "Subsection",
      CellTags->{"b:0.0", "c:2"}]},
  "i:4"->{
    Cell[140061, 2077, 202, 4, 42, "Text",
      CellTags->{"i:4", "b:0.0"}]},
  "i:5"->{
    Cell[148822, 2330, 203, 7, 58, "MathCaption",
      CellTags->{"i:5", "b:0.0"}]},
  "i:6"->{
    Cell[149974, 2383, 365, 10, 75, "MathCaption",
      CellTags->{"i:6", "b:0.0"}]},
  "i:7"->{
    Cell[150817, 2421, 205, 6, 58, "MathCaption",
      CellTags->{"i:7", "b:0.0"}]},
  "i:8"->{
    Cell[151625, 2450, 136, 4, 25, "Text",
      CellTags->{"i:8", "b:0.0"}]},
  "i:9"->{
    Cell[167865, 2957, 517, 10, 93, "Text",
      CellTags->{"i:9", "b:0.0"}]},
  "b:0.1"->{
    Cell[176341, 3193, 62, 1, 40, "Subsection",
      CellTags->{"b:0.1", "c:3"}],
    Cell[176406, 3196, 177, 4, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[176586, 3202, 302, 6, 76, "Reference",
      CellTags->"b:0.1"],
    Cell[176891, 3210, 302, 6, 76, "Reference",
      CellTags->"b:0.1"],
    Cell[177196, 3218, 315, 6, 76, "Reference",
      CellTags->"b:0.1"],
    Cell[177514, 3226, 187, 4, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[177704, 3232, 182, 4, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[177889, 3238, 230, 5, 59, "Reference",
      CellTags->"b:0.1"],
    Cell[178122, 3245, 294, 6, 76, "Reference",
      CellTags->"b:0.1"],
    Cell[178419, 3253, 327, 6, 76, "Reference",
      CellTags->"b:0.1"],
    Cell[178749, 3261, 184, 4, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[178936, 3267, 180, 4, 25, "Reference",
      CellTags->"b:0.1"],
    Cell[179119, 3273, 274, 5, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[179396, 3280, 297, 6, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[179696, 3288, 179, 4, 25, "Reference",
      CellTags->"b:0.1"],
    Cell[179878, 3294, 184, 6, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[180065, 3302, 121, 3, 25, "Reference",
      CellTags->"b:0.1"],
    Cell[180189, 3307, 123, 3, 25, "Reference",
      CellTags->"b:0.1"],
    Cell[180315, 3312, 208, 5, 59, "Reference",
      CellTags->"b:0.1"],
    Cell[180526, 3319, 221, 5, 59, "Reference",
      CellTags->"b:0.1"],
    Cell[180750, 3326, 257, 5, 59, "Reference",
      CellTags->"b:0.1"],
    Cell[181010, 3333, 241, 5, 59, "Reference",
      CellTags->"b:0.1"],
    Cell[181254, 3340, 172, 4, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[181429, 3346, 266, 9, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[181698, 3357, 268, 5, 59, "Reference",
      CellTags->"b:0.1"],
    Cell[181969, 3364, 186, 4, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[182158, 3370, 191, 4, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[182352, 3376, 267, 5, 59, "Reference",
      CellTags->"b:0.1"],
    Cell[182622, 3383, 148, 4, 42, "Reference",
      CellTags->"b:0.1"],
    Cell[182773, 3389, 202, 4, 59, "Reference",
      CellTags->"b:0.1"]},
  "c:3"->{
    Cell[176341, 3193, 62, 1, 40, "Subsection",
      CellTags->{"b:0.1", "c:3"}]},
  "c:4"->{
    Cell[183024, 3399, 59, 1, 39, "Section",
      CellTags->"c:4"]},
  "b:1.0"->{
    Cell[183108, 3404, 64, 1, 40, "Subsection",
      CellTags->{"b:1.0", "c:5"}],
    Cell[183175, 3407, 910, 20, 104, "Text",
      CellTags->"b:1.0"],
    Cell[184088, 3429, 802, 17, 88, "Text",
      CellTags->"b:1.0"],
    Cell[184893, 3448, 1186, 27, 136, "Text",
      CellTags->"b:1.0"],
    Cell[186082, 3477, 216, 5, 40, "Text",
      CellTags->"b:1.0"]},
  "c:5"->{
    Cell[183108, 3404, 64, 1, 40, "Subsection",
      CellTags->{"b:1.0", "c:5"}]},
  "i:10"->{
    Cell[186335, 3487, 100, 1, 40, "Subsection",
      CellTags->{"i:10", "b:1.1", "c:6"}]},
  "b:1.1"->{
    Cell[186335, 3487, 100, 1, 40, "Subsection",
      CellTags->{"i:10", "b:1.1", "c:6"}],
    Cell[186438, 3490, 318, 10, 59, "Text",
      CellTags->"b:1.1"],
    Cell[186759, 3502, 2386, 64, 244, "DefinitionBox",
      CellTags->"b:1.1"],
    Cell[189148, 3568, 237, 8, 30, "SmallTextSans",
      CellTags->"b:1.1"],
    Cell[189410, 3580, 89, 2, 35, "Subsubsection",
      CellTags->"b:1.1"],
    Cell[189502, 3584, 149, 4, 25, "Text",
      CellTags->"b:1.1"],
    Cell[189654, 3590, 96, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[189753, 3595, 136338, 1964, 114, "DefinitionBox",
      CellTags->"b:1.1"],
    Cell[326094, 5561, 227, 4, 42, "Print",
      CellTags->"b:1.1"],
    Cell[326324, 5567, 433, 9, 59, "Text",
      CellTags->"b:1.1"],
    Cell[326782, 5580, 191, 5, 29, "Input",
      CellTags->"b:1.1"],
    Cell[326976, 5587, 187, 4, 27, "Output",
      CellTags->"b:1.1"],
    Cell[327178, 5594, 161, 6, 25, "Text",
      CellTags->"b:1.1"],
    Cell[327364, 5604, 89, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[327456, 5609, 608, 14, 117, "Output",
      CellTags->"b:1.1"],
    Cell[328079, 5626, 187, 7, 25, "Text",
      CellTags->"b:1.1"],
    Cell[328291, 5637, 90, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[328384, 5642, 140, 4, 27, "Output",
      CellTags->"b:1.1"],
    Cell[328539, 5649, 90, 1, 25, "Text",
      CellTags->"b:1.1"],
    Cell[328654, 5654, 86, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[328743, 5659, 191, 4, 28, "Output",
      CellTags->"b:1.1"],
    Cell[328971, 5668, 91, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[329065, 5673, 129, 3, 27, "Output",
      CellTags->"b:1.1"],
    Cell[329209, 5679, 351, 10, 42, "Text",
      CellTags->"b:1.1"],
    Cell[329585, 5693, 113, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[329701, 5698, 83, 3, 27, "Output",
      CellTags->"b:1.1"],
    Cell[329821, 5706, 113, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[329937, 5711, 84, 3, 27, "Output",
      CellTags->"b:1.1"],
    Cell[330036, 5717, 189, 6, 25, "Text",
      CellTags->"b:1.1"],
    Cell[330250, 5727, 99, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[330352, 5732, 459, 11, 79, "Output",
      CellTags->"b:1.1"],
    Cell[330826, 5746, 129, 4, 25, "Text",
      CellTags->"b:1.1"],
    Cell[330980, 5754, 89, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[331072, 5759, 321, 6, 46, "Output",
      CellTags->"b:1.1"],
    Cell[331408, 5768, 128, 4, 25, "Text",
      CellTags->"b:1.1"],
    Cell[331561, 5776, 96, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[331660, 5781, 131, 3, 27, "Output",
      CellTags->"b:1.1"],
    Cell[331828, 5789, 92, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[331923, 5794, 132, 3, 27, "Output",
      CellTags->"b:1.1"],
    Cell[332070, 5800, 182, 4, 25, "Text",
      CellTags->"b:1.1"],
    Cell[332277, 5808, 80, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[332360, 5813, 188, 4, 27, "Output",
      CellTags->"b:1.1"],
    Cell[332585, 5822, 86, 3, 29, "Input",
      CellTags->"b:1.1"],
    Cell[332674, 5827, 269, 5, 35, "Message",
      CellTags->"b:1.1"],
    Cell[332946, 5834, 181, 4, 27, "Output",
      CellTags->"b:1.1"],
    Cell[333142, 5841, 149, 4, 25, "Text",
      CellTags->"b:1.1"],
    Cell[333328, 5850, 94, 2, 35, "Subsubsection",
      CellTags->"b:1.1"],
    Cell[333425, 5854, 631, 12, 93, "Text",
      CellTags->"b:1.1"],
    Cell[334059, 5868, 89, 2, 25, "Text",
      CellTags->"b:1.1"],
    Cell[334151, 5872, 523, 14, 42, "Text",
      CellTags->"b:1.1"],
    Cell[334677, 5888, 529, 9, 32, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[335209, 5899, 529, 9, 32, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[335741, 5910, 559, 9, 32, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[336303, 5921, 286, 8, 26, "Text",
      CellTags->"b:1.1"],
    Cell[336592, 5931, 366, 6, 43, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[336961, 5939, 418, 15, 25, "Text",
      CellTags->"b:1.1"],
    Cell[337382, 5956, 67, 2, 25, "Text",
      CellTags->"b:1.1"],
    Cell[337452, 5960, 185, 5, 25, "Text",
      CellTags->"b:1.1"],
    Cell[337640, 5967, 540, 9, 32, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[338183, 5978, 373, 10, 42, "Text",
      CellTags->"b:1.1"],
    Cell[338559, 5990, 353, 6, 32, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[338915, 5998, 531, 15, 59, "Text",
      CellTags->"b:1.1"],
    Cell[339449, 6015, 251, 5, 42, "Text",
      CellTags->"b:1.1"],
    Cell[339703, 6022, 70, 2, 25, "Text",
      CellTags->"b:1.1"],
    Cell[339776, 6026, 128, 2, 25, "Text",
      CellTags->"b:1.1"],
    Cell[339907, 6030, 280, 5, 39, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[340190, 6037, 235, 4, 31, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[340428, 6043, 225, 4, 31, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[340656, 6049, 235, 4, 31, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[340894, 6055, 290, 5, 39, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[341187, 6062, 299, 5, 32, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[341489, 6069, 406, 15, 27, "Text",
      CellTags->"b:1.1"],
    Cell[341898, 6086, 66, 2, 25, "Text",
      CellTags->"b:1.1"],
    Cell[341967, 6090, 333, 10, 25, "Text",
      CellTags->"b:1.1"],
    Cell[342303, 6102, 723, 13, 55, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[343029, 6117, 556, 10, 47, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[343588, 6129, 729, 13, 48, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[344320, 6144, 570, 21, 27, "Text",
      CellTags->"b:1.1"],
    Cell[344893, 6167, 75, 2, 25, "Text",
      CellTags->"b:1.1"],
    Cell[344971, 6171, 274, 6, 42, "Text",
      CellTags->"b:1.1"],
    Cell[345248, 6179, 283, 5, 31, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[345534, 6186, 325, 6, 33, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[345862, 6194, 335, 6, 34, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[346200, 6202, 449, 17, 26, "Text",
      CellTags->"b:1.1"],
    Cell[346652, 6221, 66, 2, 25, "Text",
      CellTags->"b:1.1"],
    Cell[346721, 6225, 332, 10, 25, "Text",
      CellTags->"b:1.1"],
    Cell[347056, 6237, 422, 8, 32, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[347481, 6247, 128, 2, 25, "Text",
      CellTags->"b:1.1"],
    Cell[347612, 6251, 812, 14, 64, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[348427, 6267, 812, 14, 64, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[349242, 6283, 852, 14, 64, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[350097, 6299, 570, 21, 27, "Text",
      CellTags->"b:1.1"],
    Cell[350670, 6322, 75, 2, 25, "Text",
      CellTags->"b:1.1"],
    Cell[350748, 6326, 167, 4, 25, "Text",
      CellTags->"b:1.1"],
    Cell[350918, 6332, 573, 13, 60, "Text",
      CellTags->"b:1.1"],
    Cell[351494, 6347, 282, 5, 31, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[351779, 6354, 436, 13, 42, "Text",
      CellTags->"b:1.1"],
    Cell[352218, 6369, 576, 10, 48, "NumberedEquation",
      CellTags->"b:1.1"],
    Cell[352797, 6381, 347, 15, 25, "Text",
      CellTags->"b:1.1"],
    Cell[353181, 6401, 96, 2, 35, "Subsubsection",
      CellTags->"b:1.1"],
    Cell[353280, 6405, 241, 5, 42, "Text",
      CellTags->"b:1.1"],
    Cell[353524, 6412, 727, 21, 59, "Text",
      CellTags->"b:1.1"],
    Cell[354254, 6435, 139, 3, 42, "DefinitionBox",
      CellTags->"b:1.1"],
    Cell[354396, 6440, 305, 6, 42, "Text",
      CellTags->"b:1.1"],
    Cell[354704, 6448, 262, 6, 49, "Input",
      Evaluatable->False,
      CellTags->"b:1.1"],
    Cell[354969, 6456, 145, 4, 29, "Input",
      Evaluatable->False,
      CellTags->"b:1.1"],
    Cell[355117, 6462, 189, 4, 49, "Input",
      Evaluatable->False,
      CellTags->"b:1.1"],
    Cell[355309, 6468, 233, 6, 49, "Input",
      Evaluatable->False,
      CellTags->"b:1.1"],
    Cell[355545, 6476, 172, 4, 29, "Input",
      Evaluatable->False,
      CellTags->"b:1.1"],
    Cell[355720, 6482, 126, 3, 29, "Input",
      Evaluatable->False,
      CellTags->"b:1.1"],
    Cell[355849, 6487, 405, 11, 46, "Text",
      CellTags->"b:1.1"],
    Cell[356257, 6500, 124, 3, 29, "Input",
      Evaluatable->False,
      CellTags->"b:1.1"]},
  "c:6"->{
    Cell[186335, 3487, 100, 1, 40, "Subsection",
      CellTags->{"i:10", "b:1.1", "c:6"}]},
  "i:11"->{
    Cell[356430, 6509, 82, 1, 40, "Subsection",
      CellTags->{"i:11", "b:1.2", "c:7"}]},
  "b:1.2"->{
    Cell[356430, 6509, 82, 1, 40, "Subsection",
      CellTags->{"i:11", "b:1.2", "c:7"}],
    Cell[356515, 6512, 225, 5, 59, "Text",
      CellTags->"b:1.2"],
    Cell[356743, 6519, 4259, 113, 156, "DefinitionBox",
      CellTags->"b:1.2"],
    Cell[361005, 6634, 243, 8, 30, "SmallTextSans",
      CellTags->"b:1.2"],
    Cell[361273, 6646, 79, 2, 35, "Subsubsection",
      CellTags->"b:1.2"],
    Cell[361355, 6650, 155, 4, 25, "Text",
      CellTags->"b:1.2"],
    Cell[361535, 6658, 80, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[361618, 6663, 188, 4, 27, "Output",
      CellTags->"b:1.2"],
    Cell[361821, 6670, 381, 7, 59, "Text",
      CellTags->"b:1.2"],
    Cell[362205, 6679, 100, 1, 33, "Commentary",
      CellTags->"b:1.2"],
    Cell[362330, 6684, 96, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[362429, 6689, 536, 10, 46, "Output",
      CellTags->"b:1.2"],
    Cell[363002, 6704, 104, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[363109, 6709, 384, 7, 46, "Output",
      CellTags->"b:1.2"],
    Cell[363530, 6721, 104, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[363637, 6726, 540, 10, 46, "Output",
      CellTags->"b:1.2"],
    Cell[364214, 6741, 104, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[364321, 6746, 385, 7, 46, "Output",
      CellTags->"b:1.2"],
    Cell[364743, 6758, 232, 6, 30, "Input",
      CellTags->"b:1.2"],
    Cell[364978, 6766, 538, 10, 46, "Output",
      CellTags->"b:1.2"],
    Cell[365553, 6781, 104, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[365660, 6786, 384, 7, 46, "Output",
      CellTags->"b:1.2"],
    Cell[366059, 6796, 92, 1, 33, "Commentary",
      CellTags->"b:1.2"],
    Cell[366176, 6801, 117, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[366296, 6806, 353, 6, 46, "Output",
      CellTags->"b:1.2"],
    Cell[366686, 6817, 104, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[366793, 6822, 406, 8, 46, "Output",
      CellTags->"b:1.2"],
    Cell[367214, 6833, 113, 3, 25, "Text",
      CellTags->"b:1.2"],
    Cell[367352, 6840, 95, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[367450, 6845, 321, 6, 46, "Output",
      CellTags->"b:1.2"],
    Cell[367808, 6856, 122, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[367933, 6861, 131, 3, 27, "Output",
      CellTags->"b:1.2"],
    Cell[368079, 6867, 387, 13, 42, "Text",
      CellTags->"b:1.2"],
    Cell[368491, 6884, 149, 4, 29, "Input",
      CellTags->"b:1.2"],
    Cell[368643, 6890, 399, 7, 46, "Output",
      CellTags->"b:1.2"],
    Cell[369057, 6900, 124, 4, 25, "Text",
      CellTags->"b:1.2"],
    Cell[369206, 6908, 109, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[369318, 6913, 399, 7, 46, "Output",
      CellTags->"b:1.2"],
    Cell[369732, 6923, 458, 14, 42, "Text",
      CellTags->"b:1.2"],
    Cell[370215, 6941, 160, 4, 29, "Input",
      CellTags->"b:1.2"],
    Cell[370378, 6947, 267, 5, 35, "Message",
      CellTags->"b:1.2"],
    Cell[370648, 6954, 267, 5, 35, "Message",
      CellTags->"b:1.2"],
    Cell[370918, 6961, 267, 5, 35, "Message",
      CellTags->"b:1.2"],
    Cell[371188, 6968, 405, 7, 20, "Message",
      CellTags->"b:1.2"],
    Cell[371596, 6977, 216, 5, 27, "Output",
      CellTags->"b:1.2"],
    Cell[371827, 6985, 189, 6, 25, "Text",
      CellTags->"b:1.2"],
    Cell[372041, 6995, 101, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[372145, 7000, 93, 3, 27, "Output",
      CellTags->"b:1.2"],
    Cell[372253, 7006, 173, 4, 25, "Text",
      CellTags->"b:1.2"],
    Cell[372451, 7014, 103, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[372557, 7019, 521, 10, 46, "Output",
      CellTags->"b:1.2"],
    Cell[373115, 7034, 104, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[373222, 7039, 378, 7, 46, "Output",
      CellTags->"b:1.2"],
    Cell[373615, 7049, 356, 7, 59, "Text",
      CellTags->"b:1.2"],
    Cell[373996, 7060, 103, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[374102, 7065, 258, 5, 35, "Message",
      CellTags->"b:1.2"],
    Cell[374363, 7072, 961, 17, 46, "Output",
      CellTags->"b:1.2"],
    Cell[375361, 7094, 104, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[375468, 7099, 681, 12, 65, "Output",
      CellTags->"b:1.2"],
    Cell[376164, 7114, 106, 3, 25, "Text",
      CellTags->"b:1.2"],
    Cell[376295, 7121, 93, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[376391, 7126, 303, 6, 46, "Output",
      CellTags->"b:1.2"],
    Cell[376731, 7137, 98, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[376832, 7142, 700, 13, 46, "Output",
      CellTags->"b:1.2"],
    Cell[377569, 7160, 104, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[377676, 7165, 624, 11, 65, "Output",
      CellTags->"b:1.2"],
    Cell[378315, 7179, 223, 6, 25, "Text",
      CellTags->"b:1.2"],
    Cell[378563, 7189, 102, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[378668, 7194, 779, 14, 65, "Output",
      CellTags->"b:1.2"],
    Cell[379484, 7213, 104, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[379591, 7218, 650, 11, 65, "Output",
      CellTags->"b:1.2"],
    Cell[380256, 7232, 411, 11, 42, "Text",
      CellTags->"b:1.2"],
    Cell[380692, 7247, 179, 5, 29, "Input",
      CellTags->"b:1.2"],
    Cell[380874, 7254, 176, 4, 43, "Output",
      CellTags->"b:1.2"],
    Cell[381087, 7263, 101, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[381191, 7268, 522, 10, 63, "Output",
      CellTags->"b:1.2"],
    Cell[381750, 7283, 131, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[381884, 7288, 392, 8, 27, "Output",
      CellTags->"b:1.2"],
    Cell[382313, 7301, 123, 3, 29, "Input",
      CellTags->"b:1.2"],
    Cell[382439, 7306, 440, 9, 46, "Output",
      CellTags->"b:1.2"],
    Cell[382928, 7321, 94, 2, 35, "Subsubsection",
      CellTags->"b:1.2"],
    Cell[383025, 7325, 79, 1, 42, "FramedBox",
      CellTags->"b:1.2"],
    Cell[383107, 7328, 580, 24, 26, "Text",
      CellTags->"b:1.2"],
    Cell[383690, 7354, 484, 9, 48, "NumberedEquation",
      CellTags->"b:1.2"],
    Cell[384177, 7365, 341, 15, 25, "Text",
      CellTags->"b:1.2"],
    Cell[384521, 7382, 228, 4, 31, "NumberedEquation",
      CellTags->"b:1.2"],
    Cell[384752, 7388, 406, 15, 25, "Text",
      CellTags->"b:1.2"],
    Cell[385161, 7405, 369, 7, 33, "NumberedEquation",
      CellTags->"b:1.2"],
    Cell[385533, 7414, 215, 5, 25, "Text",
      CellTags->"b:1.2"],
    Cell[385751, 7421, 96, 2, 25, "Text",
      CellTags->"b:1.2"],
    Cell[385850, 7425, 129, 2, 25, "Text",
      CellTags->"b:1.2"],
    Cell[385982, 7429, 282, 5, 35, "NumberedEquation",
      CellTags->"b:1.2"],
    Cell[386267, 7436, 102, 2, 25, "Text",
      CellTags->"b:1.2"],
    Cell[386372, 7440, 1021, 17, 89, "NumberedEquation",
      CellTags->"b:1.2"],
    Cell[387396, 7459, 96, 2, 25, "Text",
      CellTags->"b:1.2"],
    Cell[387495, 7463, 129, 2, 25, "Text",
      CellTags->"b:1.2"],
    Cell[387627, 7467, 263, 5, 34, "NumberedEquation",
      CellTags->"b:1.2"],
    Cell[387893, 7474, 102, 2, 25, "Text",
      CellTags->"b:1.2"],
    Cell[387998, 7478, 879, 15, 69, "NumberedEquation",
      CellTags->"b:1.2"],
    Cell[388880, 7495, 96, 2, 25, "Text",
      CellTags->"b:1.2"],
    Cell[388979, 7499, 129, 2, 25, "Text",
      CellTags->"b:1.2"],
    Cell[389111, 7503, 308, 5, 34, "NumberedEquation",
      CellTags->"b:1.2"],
    Cell[389422, 7510, 102, 2, 25, "Text",
      CellTags->"b:1.2"],
    Cell[389527, 7514, 1086, 17, 79, "NumberedEquation",
      CellTags->"b:1.2"],
    Cell[390616, 7533, 349, 12, 25, "Text",
      CellTags->"b:1.2"],
    Cell[390968, 7547, 1173, 22, 119, "NumberedEquation",
      CellTags->"b:1.2"],
    Cell[392144, 7571, 92, 1, 42, "FramedBox",
      CellTags->"b:1.2"],
    Cell[392239, 7574, 451, 8, 76, "Text",
      CellTags->"b:1.2"],
    Cell[392693, 7584, 82, 1, 42, "FramedBox",
      CellTags->"b:1.2"],
    Cell[392778, 7587, 412, 9, 59, "Text",
      CellTags->"b:1.2"],
    Cell[393193, 7598, 374, 7, 59, "Text",
      CellTags->"b:1.2"],
    Cell[393570, 7607, 88, 2, 25, "Text",
      CellTags->"b:1.2"],
    Cell[393661, 7611, 238, 7, 25, "Text",
      CellTags->"b:1.2"],
    Cell[393902, 7620, 693, 17, 58, "NumberedEquation",
      CellTags->"b:1.2"],
    Cell[394598, 7639, 972, 33, 44, "Text",
      CellTags->"b:1.2"],
    Cell[395573, 7674, 88, 1, 42, "FramedBox",
      CellTags->"b:1.2"],
    Cell[395664, 7677, 209, 5, 42, "Text",
      CellTags->"b:1.2"],
    Cell[395876, 7684, 66, 2, 25, "Text",
      CellTags->"b:1.2"],
    Cell[395945, 7688, 275, 8, 25, "Text",
      CellTags->"b:1.2"],
    Cell[396223, 7698, 433, 7, 53, "NumberedEquation",
      CellTags->"b:1.2"]},
  "c:7"->{
    Cell[356430, 6509, 82, 1, 40, "Subsection",
      CellTags->{"i:11", "b:1.2", "c:7"}]},
  "i:12"->{
    Cell[396705, 7711, 99, 1, 40, "Subsection",
      CellTags->{"i:12", "b:1.3", "c:8"}]},
  "b:1.3"->{
    Cell[396705, 7711, 99, 1, 40, "Subsection",
      CellTags->{"i:12", "b:1.3", "c:8"}],
    Cell[396807, 7714, 343, 6, 76, "Text",
      CellTags->"b:1.3"],
    Cell[397153, 7722, 3999, 97, 244, "DefinitionBox",
      CellTags->"b:1.3"],
    Cell[401155, 7821, 248, 8, 30, "SmallTextSans",
      CellTags->"b:1.3"],
    Cell[401428, 7833, 79, 2, 35, "Subsubsection",
      CellTags->"b:1.3"],
    Cell[401510, 7837, 154, 4, 25, "Text",
      CellTags->"b:1.3"],
    Cell[401689, 7845, 80, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[401772, 7850, 188, 4, 27, "Output",
      CellTags->"b:1.3"],
    Cell[401975, 7857, 164, 4, 25, "Text",
      CellTags->"b:1.3"],
    Cell[402164, 7865, 176, 5, 29, "Input",
      CellTags->"b:1.3"],
    Cell[402343, 7872, 218, 5, 27, "Output",
      CellTags->"b:1.3"],
    Cell[402576, 7880, 96, 1, 25, "Text",
      CellTags->"b:1.3"],
    Cell[402697, 7885, 113, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[402813, 7890, 87, 3, 40, "Output",
      CellTags->"b:1.3"],
    Cell[402915, 7896, 243, 9, 25, "Text",
      CellTags->"b:1.3"],
    Cell[403183, 7909, 119, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[403305, 7914, 197, 4, 20, "Message",
      CellTags->"b:1.3"],
    Cell[403505, 7920, 224, 5, 27, "Output",
      CellTags->"b:1.3"],
    Cell[403744, 7928, 79, 1, 25, "Text",
      CellTags->"b:1.3"],
    Cell[403848, 7933, 121, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[403972, 7938, 84, 3, 27, "Output",
      CellTags->"b:1.3"],
    Cell[404093, 7946, 121, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[404217, 7951, 185, 4, 27, "Output",
      CellTags->"b:1.3"],
    Cell[404417, 7958, 130, 4, 25, "Text",
      CellTags->"b:1.3"],
    Cell[404572, 7966, 108, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[404683, 7971, 197, 4, 20, "Message",
      CellTags->"b:1.3"],
    Cell[404883, 7977, 111, 3, 27, "Output",
      CellTags->"b:1.3"],
    Cell[405009, 7983, 117, 3, 25, "Text",
      CellTags->"b:1.3"],
    Cell[405151, 7990, 103, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[405257, 7995, 116, 3, 27, "Output",
      CellTags->"b:1.3"],
    Cell[405388, 8001, 255, 9, 25, "Text",
      CellTags->"b:1.3"],
    Cell[405668, 8014, 113, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[405784, 8019, 197, 4, 20, "Message",
      CellTags->"b:1.3"],
    Cell[405984, 8025, 644, 12, 103, "Output",
      CellTags->"b:1.3"],
    Cell[406665, 8042, 103, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[406771, 8047, 258, 5, 35, "Message",
      CellTags->"b:1.3"],
    Cell[407032, 8054, 558, 12, 84, "Output",
      CellTags->"b:1.3"],
    Cell[407605, 8069, 150, 4, 25, "Text",
      CellTags->"b:1.3"],
    Cell[407780, 8077, 174, 5, 29, "Input",
      CellTags->"b:1.3"],
    Cell[407957, 8084, 251, 5, 46, "Output",
      CellTags->"b:1.3"],
    Cell[408223, 8092, 182, 6, 25, "Text",
      CellTags->"b:1.3"],
    Cell[408430, 8102, 116, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[408549, 8107, 84, 3, 27, "Output",
      CellTags->"b:1.3"],
    Cell[408648, 8113, 166, 4, 25, "Text",
      CellTags->"b:1.3"],
    Cell[408839, 8121, 103, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[408945, 8126, 273, 5, 46, "Output",
      CellTags->"b:1.3"],
    Cell[409255, 8136, 105, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[409363, 8141, 84, 3, 27, "Output",
      CellTags->"b:1.3"],
    Cell[409462, 8147, 295, 9, 25, "Text",
      CellTags->"b:1.3"],
    Cell[409782, 8160, 97, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[409882, 8165, 129, 3, 27, "Output",
      CellTags->"b:1.3"],
    Cell[410026, 8171, 312, 7, 42, "Text",
      CellTags->"b:1.3"],
    Cell[410363, 8182, 104, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[410470, 8187, 84, 3, 27, "Output",
      CellTags->"b:1.3"],
    Cell[410569, 8193, 110, 3, 25, "Text",
      CellTags->"b:1.3"],
    Cell[410704, 8200, 171, 5, 29, "Input",
      CellTags->"b:1.3"],
    Cell[410878, 8207, 263, 5, 27, "Output",
      CellTags->"b:1.3"],
    Cell[411178, 8217, 96, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[411277, 8222, 313, 6, 46, "Output",
      CellTags->"b:1.3"],
    Cell[411605, 8231, 143, 4, 25, "Text",
      CellTags->"b:1.3"],
    Cell[411773, 8239, 108, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[411884, 8244, 315, 6, 50, "Message",
      CellTags->"b:1.3"],
    Cell[412202, 8252, 315, 6, 50, "Message",
      CellTags->"b:1.3"],
    Cell[412520, 8260, 315, 6, 50, "Message",
      CellTags->"b:1.3"],
    Cell[412838, 8268, 414, 7, 35, "Message",
      CellTags->"b:1.3"],
    Cell[413255, 8277, 314, 7, 27, "Output",
      CellTags->"b:1.3"],
    Cell[413584, 8287, 137, 4, 25, "Text",
      CellTags->"b:1.3"],
    Cell[413746, 8295, 184, 5, 29, "Input",
      CellTags->"b:1.3"],
    Cell[413933, 8302, 263, 5, 27, "Output",
      CellTags->"b:1.3"],
    Cell[414233, 8312, 95, 3, 29, "Input",
      CellTags->"b:1.3"],
    Cell[414331, 8317, 440, 9, 46, "Output",
      CellTags->"b:1.3"],
    Cell[414820, 8332, 94, 2, 35, "Subsubsection",
      CellTags->"b:1.3"],
    Cell[414917, 8336, 114, 2, 42, "FramedBox",
      CellTags->"b:1.3"],
    Cell[415034, 8340, 580, 18, 59, "Text",
      CellTags->"b:1.3"],
    Cell[415617, 8360, 564, 11, 32, "NumberedEquation",
      CellTags->"b:1.3"],
    Cell[416184, 8373, 833, 34, 42, "Text",
      CellTags->"b:1.3"],
    Cell[417020, 8409, 293, 6, 42, "Text",
      CellTags->"b:1.3"],
    Cell[417316, 8417, 675, 25, 42, "Text",
      CellTags->"b:1.3"],
    Cell[417994, 8444, 323, 6, 31, "NumberedEquation",
      CellTags->"b:1.3"],
    Cell[418320, 8452, 881, 35, 42, "Text",
      CellTags->"b:1.3"],
    Cell[419204, 8489, 985, 33, 59, "Text",
      CellTags->"b:1.3"],
    Cell[420192, 8524, 117, 2, 42, "FramedBox",
      CellTags->"b:1.3"],
    Cell[420312, 8528, 658, 18, 59, "Text",
      CellTags->"b:1.3"],
    Cell[420973, 8548, 156, 5, 25, "Text",
      CellTags->"b:1.3"],
    Cell[421132, 8555, 339, 13, 25, "Text",
      CellTags->"b:1.3"],
    Cell[421474, 8570, 311, 6, 33, "NumberedEquation",
      CellTags->"b:1.3"],
    Cell[421788, 8578, 733, 23, 59, "Text",
      CellTags->"b:1.3"],
    Cell[422524, 8603, 358, 7, 59, "Text",
      CellTags->"b:1.3"],
    Cell[422885, 8612, 116, 2, 42, "FramedBox",
      CellTags->"b:1.3"],
    Cell[423004, 8616, 963, 16, 110, "Text",
      CellTags->"b:1.3"],
    Cell[423970, 8634, 111, 2, 25, "Text",
      CellTags->"b:1.3"],
    Cell[424084, 8638, 433, 12, 25, "Text",
      CellTags->"b:1.3"],
    Cell[424520, 8652, 663, 13, 93, "Text",
      CellTags->"b:1.3"],
    Cell[425186, 8667, 483, 11, 59, "Text",
      CellTags->"b:1.3"],
    Cell[425672, 8680, 119, 2, 42, "FramedBox",
      CellTags->"b:1.3"],
    Cell[425794, 8684, 563, 10, 76, "Text",
      CellTags->"b:1.3"],
    Cell[426360, 8696, 454, 9, 59, "Text",
      CellTags->"b:1.3"]},
  "c:8"->{
    Cell[396705, 7711, 99, 1, 40, "Subsection",
      CellTags->{"i:12", "b:1.3", "c:8"}]},
  "b:1.4"->{
    Cell[426863, 8711, 87, 2, 40, "Subsection",
      CellTags->{"b:1.4", "c:9"}],
    Cell[426953, 8715, 177, 4, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[427133, 8721, 302, 6, 76, "Reference",
      CellTags->"b:1.4"],
    Cell[427438, 8729, 302, 6, 76, "Reference",
      CellTags->"b:1.4"],
    Cell[427743, 8737, 315, 6, 76, "Reference",
      CellTags->"b:1.4"],
    Cell[428061, 8745, 187, 4, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[428251, 8751, 182, 4, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[428436, 8757, 230, 5, 59, "Reference",
      CellTags->"b:1.4"],
    Cell[428669, 8764, 294, 6, 76, "Reference",
      CellTags->"b:1.4"],
    Cell[428966, 8772, 327, 6, 59, "Reference",
      CellTags->"b:1.4"],
    Cell[429296, 8780, 184, 4, 25, "Reference",
      CellTags->"b:1.4"],
    Cell[429483, 8786, 180, 4, 25, "Reference",
      CellTags->"b:1.4"],
    Cell[429666, 8792, 274, 5, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[429943, 8799, 297, 6, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[430243, 8807, 179, 4, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[430425, 8813, 121, 3, 25, "Reference",
      CellTags->"b:1.4"],
    Cell[430549, 8818, 123, 3, 25, "Reference",
      CellTags->"b:1.4"],
    Cell[430675, 8823, 208, 5, 59, "Reference",
      CellTags->"b:1.4"],
    Cell[430886, 8830, 221, 5, 59, "Reference",
      CellTags->"b:1.4"],
    Cell[431110, 8837, 257, 5, 59, "Reference",
      CellTags->"b:1.4"],
    Cell[431370, 8844, 241, 5, 59, "Reference",
      CellTags->"b:1.4"],
    Cell[431614, 8851, 172, 4, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[431789, 8857, 266, 9, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[432058, 8868, 268, 5, 59, "Reference",
      CellTags->"b:1.4"],
    Cell[432329, 8875, 186, 4, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[432518, 8881, 191, 4, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[432712, 8887, 267, 5, 59, "Reference",
      CellTags->"b:1.4"],
    Cell[432982, 8894, 160, 4, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[433145, 8900, 148, 4, 42, "Reference",
      CellTags->"b:1.4"],
    Cell[433296, 8906, 202, 4, 59, "Reference",
      CellTags->"b:1.4"]},
  "c:9"->{
    Cell[426863, 8711, 87, 2, 40, "Subsection",
      CellTags->{"b:1.4", "c:9"}]},
  "b:1.5"->{
    Cell[433535, 8915, 69, 1, 40, "Subsection",
      CellTags->{"b:1.5", "c:10"}],
    Cell[433607, 8918, 407, 9, 76, "Text",
      CellTags->"b:1.5"],
    Cell[434017, 8929, 426, 11, 84, "Text",
      CellTags->"b:1.5"]},
  "c:10"->{
    Cell[433535, 8915, 69, 1, 40, "Subsection",
      CellTags->{"b:1.5", "c:10"}]},
  "c:11"->{
    Cell[439610, 9170, 54, 1, 65, "Section",
      CellTags->"c:11"]},
  "i:1"->{
    Cell[439689, 9175, 82, 1, 38, "ObjectName",
      CellTags->{"i:1", "b:2.0", "c:12"}]},
  "b:2.0"->{
    Cell[439689, 9175, 82, 1, 38, "ObjectName",
      CellTags->{"i:1", "b:2.0", "c:12"}],
    Cell[439774, 9178, 1085, 38, 124, "Usage",
      CellTags->"b:2.0"],
    Cell[440862, 9218, 280, 7, 40, "Notes",
      CellTags->"b:2.0"],
    Cell[441145, 9227, 331, 10, 40, "Notes",
      CellTags->"b:2.0"],
    Cell[441479, 9239, 556, 15, 56, "Notes",
      CellTags->"b:2.0"],
    Cell[442038, 9256, 441, 8, 72, "Notes",
      CellTags->"b:2.0"],
    Cell[442482, 9266, 222, 9, 24, "Notes",
      CellTags->"b:2.0"],
    Cell[442707, 9277, 155, 6, 24, "Notes",
      CellTags->"b:2.0"],
    Cell[442887, 9287, 63, 1, 38, "ExampleSection",
      CellTags->"b:2.0"],
    Cell[442953, 9290, 87, 1, 34, "ExampleText",
      CellTags->"b:2.0"],
    Cell[443043, 9293, 96, 3, 26, "Input",
      CellTags->"b:2.0"],
    Cell[443142, 9298, 92, 1, 34, "ExampleText",
      CellTags->"b:2.0"],
    Cell[443259, 9303, 197, 6, 26, "Input",
      CellTags->"b:2.0"],
    Cell[443459, 9311, 501, 9, 66, "Output",
      CellTags->"b:2.0"],
    Cell[443975, 9323, 139, 4, 34, "ExampleText",
      CellTags->"b:2.0"],
    Cell[444139, 9331, 103, 3, 26, "Input",
      CellTags->"b:2.0"],
    Cell[444245, 9336, 83, 3, 25, "Output",
      CellTags->"b:2.0"],
    Cell[444343, 9342, 203, 4, 50, "ExampleText",
      CellTags->"b:2.0"],
    Cell[444571, 9350, 116, 3, 26, "Input",
      CellTags->"b:2.0"],
    Cell[444690, 9355, 83, 3, 25, "Output",
      CellTags->"b:2.0"],
    Cell[444810, 9363, 90, 3, 26, "Input",
      CellTags->"b:2.0"],
    Cell[444903, 9368, 272, 5, 47, "Output",
      CellTags->"b:2.0"],
    Cell[445212, 9378, 104, 3, 26, "Input",
      CellTags->"b:2.0"],
    Cell[445319, 9383, 83, 3, 25, "Output",
      CellTags->"b:2.0"]},
  "c:12"->{
    Cell[439689, 9175, 82, 1, 38, "ObjectName",
      CellTags->{"i:1", "b:2.0", "c:12"}]},
  "i:13"->{
    Cell[445463, 9393, 80, 1, 42, "ObjectName",
      CellTags->{"i:13", "b:2.1", "c:13"}]},
  "b:2.1"->{
    Cell[445463, 9393, 80, 1, 42, "ObjectName",
      CellTags->{"i:13", "b:2.1", "c:13"}],
    Cell[445546, 9396, 881, 40, 54, "Usage",
      CellTags->"b:2.1"],
    Cell[446430, 9438, 278, 6, 40, "Notes",
      CellTags->"b:2.1"],
    Cell[446711, 9446, 324, 6, 56, "Notes",
      CellTags->"b:2.1"],
    Cell[447038, 9454, 222, 9, 24, "Notes",
      CellTags->"b:2.1"],
    Cell[447263, 9465, 292, 12, 24, "Notes",
      CellTags->"b:2.1"],
    Cell[447580, 9481, 63, 1, 38, "ExampleSection",
      CellTags->"b:2.1"],
    Cell[447646, 9484, 87, 1, 34, "ExampleText",
      CellTags->"b:2.1"],
    Cell[447736, 9487, 96, 3, 26, "Input",
      CellTags->"b:2.1"],
    Cell[447835, 9492, 83, 1, 34, "ExampleText",
      CellTags->"b:2.1"],
    Cell[447943, 9497, 170, 5, 26, "Input",
      CellTags->"b:2.1"],
    Cell[448116, 9504, 188, 4, 28, "Output",
      CellTags->"b:2.1"],
    Cell[448341, 9513, 172, 5, 31, "Input",
      CellTags->"b:2.1"],
    Cell[448516, 9520, 168, 4, 28, "Output",
      CellTags->"b:2.1"],
    Cell[448699, 9527, 250, 9, 34, "ExampleText",
      CellTags->"b:2.1"],
    Cell[448974, 9540, 118, 3, 26, "Input",
      CellTags->"b:2.1"],
    Cell[449095, 9545, 174, 4, 18, "Message",
      CellTags->"b:2.1"],
    Cell[449272, 9551, 224, 5, 28, "Output",
      CellTags->"b:2.1"],
    Cell[449511, 9559, 230, 9, 34, "ExampleText",
      CellTags->"b:2.1"],
    Cell[449766, 9572, 124, 3, 26, "Input",
      CellTags->"b:2.1"],
    Cell[449893, 9577, 84, 3, 25, "Output",
      CellTags->"b:2.1"],
    Cell[449992, 9583, 219, 9, 34, "ExampleText",
      CellTags->"b:2.1"],
    Cell[450236, 9596, 124, 3, 26, "Input",
      CellTags->"b:2.1"],
    Cell[450363, 9601, 185, 4, 28, "Output",
      CellTags->"b:2.1"]},
  "c:13"->{
    Cell[445463, 9393, 80, 1, 42, "ObjectName",
      CellTags->{"i:13", "b:2.1", "c:13"}]},
  "i:14"->{
    Cell[450609, 9612, 80, 1, 42, "ObjectName",
      CellTags->{"i:14", "b:2.2", "c:14"}]},
  "b:2.2"->{
    Cell[450609, 9612, 80, 1, 42, "ObjectName",
      CellTags->{"i:14", "b:2.2", "c:14"}],
    Cell[450692, 9615, 878, 39, 54, "Usage",
      CellTags->"b:2.2"],
    Cell[451573, 9656, 278, 6, 40, "Notes",
      CellTags->"b:2.2"],
    Cell[451854, 9664, 324, 6, 56, "Notes",
      CellTags->"b:2.2"],
    Cell[452181, 9672, 222, 9, 24, "Notes",
      CellTags->"b:2.2"],
    Cell[452406, 9683, 292, 12, 24, "Notes",
      CellTags->"b:2.2"],
    Cell[452723, 9699, 63, 1, 38, "ExampleSection",
      CellTags->"b:2.2"],
    Cell[452789, 9702, 162, 6, 34, "ExampleText",
      CellTags->"b:2.2"]},
  "c:14"->{
    Cell[450609, 9612, 80, 1, 42, "ObjectName",
      CellTags->{"i:14", "b:2.2", "c:14"}]},
  "i:15"->{
    Cell[453000, 9714, 73, 1, 42, "ObjectName",
      CellTags->{"i:15", "b:2.3", "c:15"}]},
  "b:2.3"->{
    Cell[453000, 9714, 73, 1, 42, "ObjectName",
      CellTags->{"i:15", "b:2.3", "c:15"}],
    Cell[453076, 9717, 287, 12, 32, "Usage",
      CellTags->"b:2.3"],
    Cell[453366, 9731, 222, 9, 24, "Notes",
      CellTags->"b:2.3"],
    Cell[453591, 9742, 150, 6, 24, "Notes",
      CellTags->"b:2.3"],
    Cell[453766, 9752, 63, 1, 38, "ExampleSection",
      CellTags->"b:2.3"],
    Cell[453832, 9755, 87, 1, 34, "ExampleText",
      CellTags->"b:2.3"],
    Cell[453922, 9758, 96, 3, 26, "Input",
      CellTags->"b:2.3"],
    Cell[454021, 9763, 73, 1, 34, "ExampleText",
      CellTags->"b:2.3"],
    Cell[454119, 9768, 111, 3, 26, "Input",
      CellTags->"b:2.3"],
    Cell[454233, 9773, 267, 8, 38, "Output",
      CellTags->"b:2.3"]},
  "c:15"->{
    Cell[453000, 9714, 73, 1, 42, "ObjectName",
      CellTags->{"i:15", "b:2.3", "c:15"}]},
  "i:16"->{
    Cell[454561, 9788, 69, 1, 42, "ObjectName",
      CellTags->{"i:16", "b:2.4", "c:16"}]},
  "b:2.4"->{
    Cell[454561, 9788, 69, 1, 42, "ObjectName",
      CellTags->{"i:16", "b:2.4", "c:16"}],
    Cell[454633, 9791, 750, 34, 54, "Usage",
      CellTags->"b:2.4"],
    Cell[455386, 9827, 278, 6, 40, "Notes",
      CellTags->"b:2.4"],
    Cell[455667, 9835, 177, 4, 24, "Notes",
      CellTags->"b:2.4"],
    Cell[455847, 9841, 222, 9, 24, "Notes",
      CellTags->"b:2.4"],
    Cell[456072, 9852, 381, 15, 24, "Notes",
      CellTags->"b:2.4"],
    Cell[456478, 9871, 63, 1, 38, "ExampleSection",
      CellTags->"b:2.4"],
    Cell[456544, 9874, 87, 1, 34, "ExampleText",
      CellTags->"b:2.4"],
    Cell[456634, 9877, 96, 3, 26, "Input",
      CellTags->"b:2.4"],
    Cell[456733, 9882, 83, 1, 34, "ExampleText",
      CellTags->"b:2.4"],
    Cell[456841, 9887, 170, 5, 26, "Input",
      CellTags->"b:2.4"],
    Cell[457014, 9894, 188, 4, 28, "Output",
      CellTags->"b:2.4"],
    Cell[457239, 9903, 137, 3, 31, "Input",
      CellTags->"b:2.4"],
    Cell[457379, 9908, 168, 4, 28, "Output",
      CellTags->"b:2.4"],
    Cell[457562, 9915, 161, 4, 34, "ExampleText",
      CellTags->"b:2.4"],
    Cell[457748, 9923, 121, 3, 26, "Input",
      CellTags->"b:2.4"],
    Cell[457872, 9928, 89, 3, 43, "Output",
      CellTags->"b:2.4"],
    Cell[457976, 9934, 280, 6, 50, "ExampleText",
      CellTags->"b:2.4"],
    Cell[458281, 9944, 93, 3, 26, "Input",
      CellTags->"b:2.4"],
    Cell[458377, 9949, 198, 5, 18, "Message",
      CellTags->"b:2.4"],
    Cell[458578, 9956, 84, 3, 25, "Output",
      CellTags->"b:2.4"],
    Cell[458699, 9964, 105, 3, 26, "Input",
      CellTags->"b:2.4"],
    Cell[458807, 9969, 87, 3, 25, "Output",
      CellTags->"b:2.4"],
    Cell[458931, 9977, 110, 3, 26, "Input",
      CellTags->"b:2.4"],
    Cell[459044, 9982, 174, 4, 18, "Message",
      CellTags->"b:2.4"],
    Cell[459221, 9988, 224, 5, 28, "Output",
      CellTags->"b:2.4"]},
  "c:16"->{
    Cell[454561, 9788, 69, 1, 42, "ObjectName",
      CellTags->{"i:16", "b:2.4", "c:16"}]},
  "i:17"->{
    Cell[459506, 10000, 62, 1, 42, "ObjectName",
      CellTags->{"i:17", "b:2.5", "c:17"}]},
  "b:2.5"->{
    Cell[459506, 10000, 62, 1, 42, "ObjectName",
      CellTags->{"i:17", "b:2.5", "c:17"}],
    Cell[459571, 10003, 117, 3, 24, "Notes",
      CellTags->"b:2.5"],
    Cell[459691, 10008, 222, 9, 24, "Notes",
      CellTags->"b:2.5"],
    Cell[459916, 10019, 150, 6, 24, "Notes",
      CellTags->"b:2.5"]},
  "c:17"->{
    Cell[459506, 10000, 62, 1, 42, "ObjectName",
      CellTags->{"i:17", "b:2.5", "c:17"}]},
  "i:18"->{
    Cell[460103, 10030, 68, 1, 42, "ObjectName",
      CellTags->{"i:18", "b:2.6", "c:18"}]},
  "b:2.6"->{
    Cell[460103, 10030, 68, 1, 42, "ObjectName",
      CellTags->{"i:18", "b:2.6", "c:18"}],
    Cell[460174, 10033, 451, 21, 32, "Usage",
      CellTags->"b:2.6"],
    Cell[460628, 10056, 278, 6, 40, "Notes",
      CellTags->"b:2.6"],
    Cell[460909, 10064, 222, 9, 24, "Notes",
      CellTags->"b:2.6"],
    Cell[461134, 10075, 209, 9, 24, "Notes",
      CellTags->"b:2.6"],
    Cell[461368, 10088, 63, 1, 38, "ExampleSection",
      CellTags->"b:2.6"],
    Cell[461434, 10091, 87, 1, 34, "ExampleText",
      CellTags->"b:2.6"],
    Cell[461524, 10094, 96, 3, 26, "Input",
      CellTags->"b:2.6"],
    Cell[461623, 10099, 115, 3, 34, "ExampleText",
      CellTags->"b:2.6"],
    Cell[461763, 10106, 170, 5, 26, "Input",
      CellTags->"b:2.6"],
    Cell[461936, 10113, 188, 4, 28, "Output",
      CellTags->"b:2.6"],
    Cell[462161, 10122, 91, 3, 26, "Input",
      CellTags->"b:2.6"],
    Cell[462255, 10127, 141, 4, 28, "Output",
      CellTags->"b:2.6"],
    Cell[462411, 10134, 213, 6, 34, "ExampleText",
      CellTags->"b:2.6"],
    Cell[462649, 10144, 114, 3, 26, "Input",
      CellTags->"b:2.6"],
    Cell[462766, 10149, 84, 3, 25, "Output",
      CellTags->"b:2.6"],
    Cell[462887, 10157, 114, 3, 26, "Input",
      CellTags->"b:2.6"],
    Cell[463004, 10162, 85, 3, 25, "Output",
      CellTags->"b:2.6"]},
  "c:18"->{
    Cell[460103, 10030, 68, 1, 42, "ObjectName",
      CellTags->{"i:18", "b:2.6", "c:18"}]},
  "i:19"->{
    Cell[463150, 10172, 67, 1, 42, "ObjectName",
      CellTags->{"i:19", "b:2.7", "c:19"}]},
  "b:2.7"->{
    Cell[463150, 10172, 67, 1, 42, "ObjectName",
      CellTags->{"i:19", "b:2.7", "c:19"}],
    Cell[463220, 10175, 117, 3, 24, "Notes",
      CellTags->"b:2.7"],
    Cell[463340, 10180, 222, 9, 24, "Notes",
      CellTags->"b:2.7"],
    Cell[463565, 10191, 155, 6, 24, "Notes",
      CellTags->"b:2.7"]},
  "c:19"->{
    Cell[463150, 10172, 67, 1, 42, "ObjectName",
      CellTags->{"i:19", "b:2.7", "c:19"}]},
  "i:20"->{
    Cell[463757, 10202, 69, 1, 42, "ObjectName",
      CellTags->{"i:20", "b:2.8", "c:20"}]},
  "b:2.8"->{
    Cell[463757, 10202, 69, 1, 42, "ObjectName",
      CellTags->{"i:20", "b:2.8", "c:20"}],
    Cell[463829, 10205, 117, 3, 24, "Notes",
      CellTags->"b:2.8"],
    Cell[463949, 10210, 222, 9, 24, "Notes",
      CellTags->"b:2.8"],
    Cell[464174, 10221, 157, 6, 24, "Notes",
      CellTags->"b:2.8"]},
  "c:20"->{
    Cell[463757, 10202, 69, 1, 42, "ObjectName",
      CellTags->{"i:20", "b:2.8", "c:20"}]},
  "i:21"->{
    Cell[464368, 10232, 70, 1, 42, "ObjectName",
      CellTags->{"i:21", "b:2.9", "c:21"}]},
  "b:2.9"->{
    Cell[464368, 10232, 70, 1, 42, "ObjectName",
      CellTags->{"i:21", "b:2.9", "c:21"}],
    Cell[464441, 10235, 485, 21, 32, "Usage",
      CellTags->"b:2.9"],
    Cell[464929, 10258, 147, 4, 24, "Notes",
      CellTags->"b:2.9"],
    Cell[465101, 10266, 63, 1, 38, "ExampleSection",
      CellTags->"b:2.9"],
    Cell[465167, 10269, 67, 1, 34, "ExampleText",
      CellTags->"b:2.9"],
    Cell[465237, 10272, 72, 2, 26, "Input",
      CellTags->"b:2.9"],
    Cell[465312, 10276, 72, 1, 34, "ExampleText",
      CellTags->"b:2.9"],
    Cell[465387, 10279, 149, 4, 26, "Input",
      CellTags->"b:2.9"],
    Cell[465539, 10285, 70, 1, 34, "ExampleText",
      CellTags->"b:2.9"],
    Cell[465612, 10288, 108, 3, 26, "Input",
      CellTags->"b:2.9"],
    Cell[465723, 10293, 84, 1, 34, "ExampleText",
      CellTags->"b:2.9"],
    Cell[465810, 10296, 72, 2, 26, "Input",
      CellTags->"b:2.9"]},
  "c:21"->{
    Cell[464368, 10232, 70, 1, 42, "ObjectName",
      CellTags->{"i:21", "b:2.9", "c:21"}]},
  "i:22"->{
    Cell[465931, 10304, 68, 1, 42, "ObjectName",
      CellTags->{"i:22", "b:2.10", "c:22"}]},
  "b:2.10"->{
    Cell[465931, 10304, 68, 1, 42, "ObjectName",
      CellTags->{"i:22", "b:2.10", "c:22"}],
    Cell[466002, 10307, 574, 23, 54, "Usage",
      CellTags->"b:2.10"],
    Cell[466579, 10332, 237, 5, 40, "Notes",
      CellTags->"b:2.10"],
    Cell[466819, 10339, 294, 6, 40, "Notes",
      CellTags->"b:2.10"],
    Cell[467116, 10347, 223, 9, 24, "Notes",
      CellTags->"b:2.10"],
    Cell[467342, 10358, 300, 12, 24, "Notes",
      CellTags->"b:2.10"],
    Cell[467667, 10374, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.10"],
    Cell[467734, 10377, 88, 1, 34, "ExampleText",
      CellTags->"b:2.10"],
    Cell[467825, 10380, 97, 3, 26, "Input",
      CellTags->"b:2.10"],
    Cell[467925, 10385, 93, 1, 34, "ExampleText",
      CellTags->"b:2.10"],
    Cell[468043, 10390, 166, 5, 26, "Input",
      CellTags->"b:2.10"],
    Cell[468212, 10397, 237, 5, 28, "Output",
      CellTags->"b:2.10"],
    Cell[468486, 10407, 95, 3, 26, "Input",
      CellTags->"b:2.10"],
    Cell[468584, 10412, 154, 4, 30, "Output",
      CellTags->"b:2.10"],
    Cell[468753, 10419, 166, 4, 34, "ExampleText",
      CellTags->"b:2.10"],
    Cell[468944, 10427, 93, 3, 26, "Input",
      CellTags->"b:2.10"],
    Cell[469040, 10432, 311, 6, 66, "Output",
      CellTags->"b:2.10"],
    Cell[469388, 10443, 97, 3, 26, "Input",
      CellTags->"b:2.10"],
    Cell[469488, 10448, 625, 11, 105, "Output",
      CellTags->"b:2.10"],
    Cell[470128, 10462, 119, 3, 34, "ExampleText",
      CellTags->"b:2.10"],
    Cell[470272, 10469, 107, 3, 26, "Input",
      CellTags->"b:2.10"],
    Cell[470382, 10474, 442, 9, 52, "Output",
      CellTags->"b:2.10"],
    Cell[470861, 10488, 111, 3, 26, "Input",
      CellTags->"b:2.10"],
    Cell[470975, 10493, 473, 10, 52, "Output",
      CellTags->"b:2.10"],
    Cell[471463, 10506, 155, 4, 34, "ExampleText",
      CellTags->"b:2.10"],
    Cell[471643, 10514, 95, 3, 26, "Input",
      CellTags->"b:2.10"],
    Cell[471741, 10519, 293, 6, 44, "Message",
      CellTags->"b:2.10"],
    Cell[472037, 10527, 293, 6, 44, "Message",
      CellTags->"b:2.10"],
    Cell[472333, 10535, 293, 6, 44, "Message",
      CellTags->"b:2.10"],
    Cell[472629, 10543, 392, 7, 31, "Message",
      CellTags->"b:2.10"],
    Cell[473024, 10552, 442, 9, 52, "Output",
      CellTags->"b:2.10"]},
  "c:22"->{
    Cell[465931, 10304, 68, 1, 42, "ObjectName",
      CellTags->{"i:22", "b:2.10", "c:22"}]},
  "i:23"->{
    Cell[473527, 10568, 72, 1, 42, "ObjectName",
      CellTags->{"i:23", "b:2.11", "c:23"}]},
  "b:2.11"->{
    Cell[473527, 10568, 72, 1, 42, "ObjectName",
      CellTags->{"i:23", "b:2.11", "c:23"}],
    Cell[473602, 10571, 582, 23, 54, "Usage",
      CellTags->"b:2.11"],
    Cell[474187, 10596, 237, 5, 40, "Notes",
      CellTags->"b:2.11"],
    Cell[474427, 10603, 294, 6, 40, "Notes",
      CellTags->"b:2.11"],
    Cell[474724, 10611, 223, 9, 24, "Notes",
      CellTags->"b:2.11"],
    Cell[474950, 10622, 296, 12, 24, "Notes",
      CellTags->"b:2.11"],
    Cell[475271, 10638, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.11"],
    Cell[475338, 10641, 150, 6, 34, "ExampleText",
      CellTags->"b:2.11"]},
  "c:23"->{
    Cell[473527, 10568, 72, 1, 42, "ObjectName",
      CellTags->{"i:23", "b:2.11", "c:23"}]},
  "i:24"->{
    Cell[475537, 10653, 72, 1, 42, "ObjectName",
      CellTags->{"i:24", "b:2.12", "c:24"}]},
  "b:2.12"->{
    Cell[475537, 10653, 72, 1, 42, "ObjectName",
      CellTags->{"i:24", "b:2.12", "c:24"}],
    Cell[475612, 10656, 285, 12, 32, "Usage",
      CellTags->"b:2.12"],
    Cell[475900, 10670, 223, 9, 24, "Notes",
      CellTags->"b:2.12"],
    Cell[476126, 10681, 153, 6, 24, "Notes",
      CellTags->"b:2.12"],
    Cell[476304, 10691, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.12"],
    Cell[476371, 10694, 88, 1, 34, "ExampleText",
      CellTags->"b:2.12"],
    Cell[476462, 10697, 97, 3, 26, "Input",
      CellTags->"b:2.12"],
    Cell[476562, 10702, 73, 1, 34, "ExampleText",
      CellTags->"b:2.12"],
    Cell[476660, 10707, 110, 3, 26, "Input",
      CellTags->"b:2.12"],
    Cell[476773, 10712, 268, 8, 38, "Output",
      CellTags->"b:2.12"]},
  "c:24"->{
    Cell[475537, 10653, 72, 1, 42, "ObjectName",
      CellTags->{"i:24", "b:2.12", "c:24"}]},
  "i:25"->{
    Cell[477102, 10727, 68, 1, 42, "ObjectName",
      CellTags->{"i:25", "b:2.13", "c:25"}]},
  "b:2.13"->{
    Cell[477102, 10727, 68, 1, 42, "ObjectName",
      CellTags->{"i:25", "b:2.13", "c:25"}],
    Cell[477173, 10730, 944, 41, 70, "Usage",
      CellTags->"b:2.13"],
    Cell[478120, 10773, 248, 5, 40, "Notes",
      CellTags->"b:2.13"],
    Cell[478371, 10780, 218, 5, 40, "Notes",
      CellTags->"b:2.13"],
    Cell[478592, 10787, 223, 9, 24, "Notes",
      CellTags->"b:2.13"],
    Cell[478818, 10798, 156, 6, 24, "Notes",
      CellTags->"b:2.13"],
    Cell[478999, 10808, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.13"],
    Cell[479066, 10811, 88, 1, 34, "ExampleText",
      CellTags->"b:2.13"],
    Cell[479157, 10814, 97, 3, 26, "Input",
      CellTags->"b:2.13"],
    Cell[479257, 10819, 116, 3, 34, "ExampleText",
      CellTags->"b:2.13"],
    Cell[479398, 10826, 170, 5, 26, "Input",
      CellTags->"b:2.13"],
    Cell[479571, 10833, 188, 4, 28, "Output",
      CellTags->"b:2.13"],
    Cell[479774, 10840, 126, 3, 34, "ExampleText",
      CellTags->"b:2.13"],
    Cell[479925, 10847, 107, 3, 26, "Input",
      CellTags->"b:2.13"],
    Cell[480035, 10852, 474, 10, 41, "Output",
      CellTags->"b:2.13"],
    Cell[480546, 10867, 93, 3, 26, "Input",
      CellTags->"b:2.13"],
    Cell[480642, 10872, 377, 7, 52, "Output",
      CellTags->"b:2.13"],
    Cell[481034, 10882, 240, 5, 50, "ExampleText",
      CellTags->"b:2.13"],
    Cell[481299, 10891, 127, 3, 26, "Input",
      CellTags->"b:2.13"],
    Cell[481429, 10896, 607, 11, 73, "Output",
      CellTags->"b:2.13"],
    Cell[482073, 10912, 94, 3, 26, "Input",
      CellTags->"b:2.13"],
    Cell[482170, 10917, 386, 7, 52, "Output",
      CellTags->"b:2.13"]},
  "c:25"->{
    Cell[477102, 10727, 68, 1, 42, "ObjectName",
      CellTags->{"i:25", "b:2.13", "c:25"}]},
  "i:26"->{
    Cell[482617, 10931, 75, 1, 42, "ObjectName",
      CellTags->{"i:26", "b:2.14", "c:26"}]},
  "b:2.14"->{
    Cell[482617, 10931, 75, 1, 42, "ObjectName",
      CellTags->{"i:26", "b:2.14", "c:26"}],
    Cell[482695, 10934, 1766, 63, 72, "Usage",
      CellTags->"b:2.14"],
    Cell[484464, 10999, 253, 5, 40, "Notes",
      CellTags->"b:2.14"],
    Cell[484720, 11006, 446, 8, 72, "Notes",
      CellTags->"b:2.14"],
    Cell[485169, 11016, 223, 9, 24, "Notes",
      CellTags->"b:2.14"],
    Cell[485395, 11027, 377, 15, 24, "Notes",
      CellTags->"b:2.14"],
    Cell[485797, 11046, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.14"],
    Cell[485864, 11049, 88, 1, 34, "ExampleText",
      CellTags->"b:2.14"],
    Cell[485955, 11052, 97, 3, 26, "Input",
      CellTags->"b:2.14"],
    Cell[486055, 11057, 84, 1, 34, "ExampleText",
      CellTags->"b:2.14"],
    Cell[486164, 11062, 170, 5, 26, "Input",
      CellTags->"b:2.14"],
    Cell[486337, 11069, 188, 4, 28, "Output",
      CellTags->"b:2.14"],
    Cell[486562, 11078, 172, 5, 31, "Input",
      CellTags->"b:2.14"],
    Cell[486737, 11085, 168, 4, 28, "Output",
      CellTags->"b:2.14"],
    Cell[486920, 11092, 106, 2, 34, "ExampleText",
      CellTags->"b:2.14"],
    Cell[487051, 11098, 121, 3, 26, "Input",
      CellTags->"b:2.14"],
    Cell[487175, 11103, 89, 3, 43, "Output",
      CellTags->"b:2.14"],
    Cell[487279, 11109, 251, 9, 34, "ExampleText",
      CellTags->"b:2.14"],
    Cell[487555, 11122, 110, 3, 26, "Input",
      CellTags->"b:2.14"],
    Cell[487668, 11127, 175, 4, 18, "Message",
      CellTags->"b:2.14"],
    Cell[487846, 11133, 225, 5, 28, "Output",
      CellTags->"b:2.14"]},
  "c:26"->{
    Cell[482617, 10931, 75, 1, 42, "ObjectName",
      CellTags->{"i:26", "b:2.14", "c:26"}]},
  "i:27"->{
    Cell[488132, 11145, 76, 1, 42, "ObjectName",
      CellTags->{"i:27", "b:2.15", "c:27"}]},
  "b:2.15"->{
    Cell[488132, 11145, 76, 1, 42, "ObjectName",
      CellTags->{"i:27", "b:2.15", "c:27"}],
    Cell[488211, 11148, 558, 24, 54, "Usage",
      CellTags->"b:2.15"],
    Cell[488772, 11174, 172, 4, 24, "Notes",
      CellTags->"b:2.15"],
    Cell[488947, 11180, 525, 18, 40, "Notes",
      CellTags->"b:2.15"],
    Cell[489475, 11200, 223, 9, 24, "Notes",
      CellTags->"b:2.15"],
    Cell[489701, 11211, 145, 6, 24, "Notes",
      CellTags->"b:2.15"],
    Cell[489871, 11221, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.15"],
    Cell[489938, 11224, 88, 1, 34, "ExampleText",
      CellTags->"b:2.15"],
    Cell[490029, 11227, 97, 3, 26, "Input",
      CellTags->"b:2.15"],
    Cell[490129, 11232, 107, 2, 34, "ExampleText",
      CellTags->"b:2.15"],
    Cell[490261, 11238, 100, 3, 26, "Input",
      CellTags->"b:2.15"],
    Cell[490364, 11243, 83, 3, 32, "Output",
      CellTags->"b:2.15"],
    Cell[490462, 11249, 94, 1, 34, "ExampleText",
      CellTags->"b:2.15"],
    Cell[490581, 11254, 125, 3, 26, "Input",
      CellTags->"b:2.15"],
    Cell[490709, 11259, 81, 3, 25, "Output",
      CellTags->"b:2.15"],
    Cell[490827, 11267, 125, 3, 26, "Input",
      CellTags->"b:2.15"],
    Cell[490955, 11272, 81, 3, 25, "Output",
      CellTags->"b:2.15"]},
  "c:27"->{
    Cell[488132, 11145, 76, 1, 42, "ObjectName",
      CellTags->{"i:27", "b:2.15", "c:27"}]},
  "i:28"->{
    Cell[491097, 11282, 80, 1, 42, "ObjectName",
      CellTags->{"i:28", "b:2.16", "c:28"}]},
  "b:2.16"->{
    Cell[491097, 11282, 80, 1, 42, "ObjectName",
      CellTags->{"i:28", "b:2.16", "c:28"}],
    Cell[491180, 11285, 539, 21, 48, "Usage",
      CellTags->"b:2.16"],
    Cell[491722, 11308, 279, 6, 40, "Notes",
      CellTags->"b:2.16"],
    Cell[492004, 11316, 194, 4, 40, "Notes",
      CellTags->"b:2.16"],
    Cell[492201, 11322, 223, 9, 24, "Notes",
      CellTags->"b:2.16"],
    Cell[492427, 11333, 315, 12, 24, "Notes",
      CellTags->"b:2.16"],
    Cell[492767, 11349, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.16"],
    Cell[492834, 11352, 88, 1, 34, "ExampleText",
      CellTags->"b:2.16"],
    Cell[492925, 11355, 97, 3, 26, "Input",
      CellTags->"b:2.16"],
    Cell[493025, 11360, 118, 3, 34, "ExampleText",
      CellTags->"b:2.16"],
    Cell[493168, 11367, 171, 5, 26, "Input",
      CellTags->"b:2.16"],
    Cell[493342, 11374, 189, 4, 28, "Output",
      CellTags->"b:2.16"],
    Cell[493568, 11383, 102, 3, 26, "Input",
      CellTags->"b:2.16"],
    Cell[493673, 11388, 124, 3, 28, "Output",
      CellTags->"b:2.16"],
    Cell[493812, 11394, 254, 9, 34, "ExampleText",
      CellTags->"b:2.16"],
    Cell[494091, 11407, 107, 3, 26, "Input",
      CellTags->"b:2.16"],
    Cell[494201, 11412, 135, 3, 28, "Output",
      CellTags->"b:2.16"],
    Cell[494373, 11420, 88, 3, 26, "Input",
      CellTags->"b:2.16"],
    Cell[494464, 11425, 85, 3, 25, "Output",
      CellTags->"b:2.16"],
    Cell[494586, 11433, 93, 3, 26, "Input",
      CellTags->"b:2.16"],
    Cell[494682, 11438, 130, 3, 28, "Output",
      CellTags->"b:2.16"]},
  "c:28"->{
    Cell[491097, 11282, 80, 1, 42, "ObjectName",
      CellTags->{"i:28", "b:2.16", "c:28"}]},
  "i:29"->{
    Cell[494873, 11448, 78, 1, 42, "ObjectName",
      CellTags->{"i:29", "b:2.17", "c:29"}]},
  "b:2.17"->{
    Cell[494873, 11448, 78, 1, 42, "ObjectName",
      CellTags->{"i:29", "b:2.17", "c:29"}],
    Cell[494954, 11451, 1560, 59, 50, "Usage",
      CellTags->"b:2.17"],
    Cell[496517, 11512, 279, 6, 40, "Notes",
      CellTags->"b:2.17"],
    Cell[496799, 11520, 236, 5, 40, "Notes",
      CellTags->"b:2.17"],
    Cell[497038, 11527, 183, 4, 24, "Notes",
      CellTags->"b:2.17"],
    Cell[497224, 11533, 133, 4, 24, "Notes",
      CellTags->"b:2.17"],
    Cell[497360, 11539, 223, 9, 24, "Notes",
      CellTags->"b:2.17"],
    Cell[497586, 11550, 234, 9, 24, "Notes",
      CellTags->"b:2.17"],
    Cell[497845, 11563, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.17"],
    Cell[497912, 11566, 88, 1, 34, "ExampleText",
      CellTags->"b:2.17"],
    Cell[498003, 11569, 97, 3, 26, "Input",
      CellTags->"b:2.17"],
    Cell[498103, 11574, 118, 3, 34, "ExampleText",
      CellTags->"b:2.17"],
    Cell[498246, 11581, 170, 5, 26, "Input",
      CellTags->"b:2.17"],
    Cell[498419, 11588, 188, 4, 28, "Output",
      CellTags->"b:2.17"],
    Cell[498644, 11597, 101, 3, 26, "Input",
      CellTags->"b:2.17"],
    Cell[498748, 11602, 123, 3, 28, "Output",
      CellTags->"b:2.17"],
    Cell[498886, 11608, 267, 9, 34, "ExampleText",
      CellTags->"b:2.17"],
    Cell[499178, 11621, 108, 3, 26, "Input",
      CellTags->"b:2.17"],
    Cell[499289, 11626, 200, 5, 30, "Output",
      CellTags->"b:2.17"],
    Cell[499526, 11636, 97, 3, 26, "Input",
      CellTags->"b:2.17"],
    Cell[499626, 11641, 92, 3, 25, "Output",
      CellTags->"b:2.17"],
    Cell[499755, 11649, 102, 3, 26, "Input",
      CellTags->"b:2.17"],
    Cell[499860, 11654, 189, 4, 30, "Output",
      CellTags->"b:2.17"]},
  "c:29"->{
    Cell[494873, 11448, 78, 1, 42, "ObjectName",
      CellTags->{"i:29", "b:2.17", "c:29"}]},
  "i:30"->{
    Cell[500110, 11665, 81, 1, 42, "ObjectName",
      CellTags->{"i:30", "b:2.18", "c:30"}]},
  "b:2.18"->{
    Cell[500110, 11665, 81, 1, 42, "ObjectName",
      CellTags->{"i:30", "b:2.18", "c:30"}],
    Cell[500194, 11668, 540, 21, 48, "Usage",
      CellTags->"b:2.18"],
    Cell[500737, 11691, 279, 6, 40, "Notes",
      CellTags->"b:2.18"],
    Cell[501019, 11699, 194, 4, 40, "Notes",
      CellTags->"b:2.18"],
    Cell[501216, 11705, 223, 9, 24, "Notes",
      CellTags->"b:2.18"],
    Cell[501442, 11716, 315, 12, 24, "Notes",
      CellTags->"b:2.18"],
    Cell[501782, 11732, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.18"],
    Cell[501849, 11735, 88, 1, 34, "ExampleText",
      CellTags->"b:2.18"],
    Cell[501940, 11738, 97, 3, 26, "Input",
      CellTags->"b:2.18"],
    Cell[502040, 11743, 118, 3, 34, "ExampleText",
      CellTags->"b:2.18"],
    Cell[502183, 11750, 171, 5, 26, "Input",
      CellTags->"b:2.18"],
    Cell[502357, 11757, 189, 4, 28, "Output",
      CellTags->"b:2.18"],
    Cell[502583, 11766, 102, 3, 26, "Input",
      CellTags->"b:2.18"],
    Cell[502688, 11771, 124, 3, 28, "Output",
      CellTags->"b:2.18"],
    Cell[502827, 11777, 255, 9, 34, "ExampleText",
      CellTags->"b:2.18"],
    Cell[503107, 11790, 108, 3, 26, "Input",
      CellTags->"b:2.18"],
    Cell[503218, 11795, 128, 3, 28, "Output",
      CellTags->"b:2.18"],
    Cell[503383, 11803, 88, 3, 26, "Input",
      CellTags->"b:2.18"],
    Cell[503474, 11808, 85, 3, 25, "Output",
      CellTags->"b:2.18"],
    Cell[503596, 11816, 93, 3, 26, "Input",
      CellTags->"b:2.18"],
    Cell[503692, 11821, 130, 3, 28, "Output",
      CellTags->"b:2.18"]},
  "c:30"->{
    Cell[500110, 11665, 81, 1, 42, "ObjectName",
      CellTags->{"i:30", "b:2.18", "c:30"}]},
  "i:2"->{
    Cell[503883, 11831, 76, 1, 42, "ObjectName",
      CellTags->{"i:2", "b:2.19", "c:31"}]},
  "b:2.19"->{
    Cell[503883, 11831, 76, 1, 42, "ObjectName",
      CellTags->{"i:2", "b:2.19", "c:31"}],
    Cell[503962, 11834, 543, 23, 54, "Usage",
      CellTags->"b:2.19"],
    Cell[504508, 11859, 244, 5, 40, "Notes",
      CellTags->"b:2.19"],
    Cell[504755, 11866, 304, 10, 24, "Notes",
      CellTags->"b:2.19"],
    Cell[505062, 11878, 523, 15, 56, "Notes",
      CellTags->"b:2.19"],
    Cell[505588, 11895, 442, 8, 72, "Notes",
      CellTags->"b:2.19"],
    Cell[506033, 11905, 223, 9, 24, "Notes",
      CellTags->"b:2.19"],
    Cell[506259, 11916, 163, 6, 24, "Notes",
      CellTags->"b:2.19"],
    Cell[506447, 11926, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.19"],
    Cell[506514, 11929, 88, 1, 34, "ExampleText",
      CellTags->"b:2.19"],
    Cell[506605, 11932, 97, 3, 26, "Input",
      CellTags->"b:2.19"],
    Cell[506705, 11937, 93, 1, 34, "ExampleText",
      CellTags->"b:2.19"],
    Cell[506823, 11942, 198, 6, 26, "Input",
      CellTags->"b:2.19"],
    Cell[507024, 11950, 502, 9, 66, "Output",
      CellTags->"b:2.19"],
    Cell[507541, 11962, 293, 9, 34, "ExampleText",
      CellTags->"b:2.19"],
    Cell[507859, 11975, 97, 3, 26, "Input",
      CellTags->"b:2.19"],
    Cell[507959, 11980, 119, 3, 25, "Output",
      CellTags->"b:2.19"],
    Cell[508093, 11986, 281, 6, 50, "ExampleText",
      CellTags->"b:2.19"],
    Cell[508399, 11996, 128, 3, 26, "Input",
      CellTags->"b:2.19"],
    Cell[508530, 12001, 119, 3, 25, "Output",
      CellTags->"b:2.19"]},
  "c:31"->{
    Cell[503883, 11831, 76, 1, 42, "ObjectName",
      CellTags->{"i:2", "b:2.19", "c:31"}]},
  "i:31"->{
    Cell[508710, 12011, 74, 1, 42, "ObjectName",
      CellTags->{"i:31", "b:2.20", "c:32"}]},
  "b:2.20"->{
    Cell[508710, 12011, 74, 1, 42, "ObjectName",
      CellTags->{"i:31", "b:2.20", "c:32"}],
    Cell[508787, 12014, 755, 33, 54, "Usage",
      CellTags->"b:2.20"],
    Cell[509545, 12049, 261, 5, 40, "Notes",
      CellTags->"b:2.20"],
    Cell[509809, 12056, 223, 9, 24, "Notes",
      CellTags->"b:2.20"],
    Cell[510035, 12067, 150, 6, 24, "Notes",
      CellTags->"b:2.20"],
    Cell[510210, 12077, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.20"],
    Cell[510277, 12080, 88, 1, 34, "ExampleText",
      CellTags->"b:2.20"],
    Cell[510368, 12083, 97, 3, 26, "Input",
      CellTags->"b:2.20"],
    Cell[510468, 12088, 116, 3, 34, "ExampleText",
      CellTags->"b:2.20"],
    Cell[510609, 12095, 170, 5, 26, "Input",
      CellTags->"b:2.20"],
    Cell[510782, 12102, 188, 4, 28, "Output",
      CellTags->"b:2.20"],
    Cell[511007, 12111, 92, 3, 26, "Input",
      CellTags->"b:2.20"],
    Cell[511102, 12116, 142, 4, 28, "Output",
      CellTags->"b:2.20"],
    Cell[511259, 12123, 115, 3, 34, "ExampleText",
      CellTags->"b:2.20"],
    Cell[511399, 12130, 113, 3, 26, "Input",
      CellTags->"b:2.20"],
    Cell[511515, 12135, 189, 4, 28, "Output",
      CellTags->"b:2.20"],
    Cell[511741, 12144, 93, 3, 26, "Input",
      CellTags->"b:2.20"],
    Cell[511837, 12149, 123, 3, 28, "Output",
      CellTags->"b:2.20"],
    Cell[511975, 12155, 97, 1, 34, "ExampleText",
      CellTags->"b:2.20"],
    Cell[512097, 12160, 125, 3, 26, "Input",
      CellTags->"b:2.20"],
    Cell[512225, 12165, 237, 8, 38, "Output",
      CellTags->"b:2.20"]},
  "c:32"->{
    Cell[508710, 12011, 74, 1, 42, "ObjectName",
      CellTags->{"i:31", "b:2.20", "c:32"}]},
  "i:32"->{
    Cell[512523, 12180, 93, 1, 42, "ObjectName",
      CellTags->{"i:32", "b:2.21", "c:33"}]},
  "b:2.21"->{
    Cell[512523, 12180, 93, 1, 42, "ObjectName",
      CellTags->{"i:32", "b:2.21", "c:33"}],
    Cell[512619, 12183, 324, 11, 48, "Usage",
      CellTags->"b:2.21"],
    Cell[512946, 12196, 255, 5, 40, "Notes",
      CellTags->"b:2.21"],
    Cell[513204, 12203, 223, 9, 24, "Notes",
      CellTags->"b:2.21"],
    Cell[513430, 12214, 167, 6, 24, "Notes",
      CellTags->"b:2.21"],
    Cell[513622, 12224, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.21"],
    Cell[513689, 12227, 88, 1, 34, "ExampleText",
      CellTags->"b:2.21"],
    Cell[513780, 12230, 97, 3, 26, "Input",
      CellTags->"b:2.21"],
    Cell[513880, 12235, 89, 1, 34, "ExampleText",
      CellTags->"b:2.21"],
    Cell[513994, 12240, 106, 3, 26, "Input",
      CellTags->"b:2.21"],
    Cell[514103, 12245, 168, 4, 25, "Output",
      CellTags->"b:2.21"],
    Cell[514286, 12252, 348, 11, 50, "ExampleText",
      CellTags->"b:2.21"],
    Cell[514659, 12267, 114, 3, 26, "Input",
      CellTags->"b:2.21"],
    Cell[514776, 12272, 170, 4, 25, "Output",
      CellTags->"b:2.21"],
    Cell[514983, 12281, 94, 3, 26, "Input",
      CellTags->"b:2.21"],
    Cell[515080, 12286, 202, 4, 30, "Output",
      CellTags->"b:2.21"],
    Cell[515297, 12293, 289, 8, 50, "ExampleText",
      CellTags->"b:2.21"],
    Cell[515611, 12305, 100, 3, 26, "Input",
      CellTags->"b:2.21"],
    Cell[515714, 12310, 170, 4, 25, "Output",
      CellTags->"b:2.21"],
    Cell[515921, 12319, 94, 3, 26, "Input",
      CellTags->"b:2.21"],
    Cell[516018, 12324, 200, 4, 30, "Output",
      CellTags->"b:2.21"]},
  "c:33"->{
    Cell[512523, 12180, 93, 1, 42, "ObjectName",
      CellTags->{"i:32", "b:2.21", "c:33"}]},
  "i:33"->{
    Cell[516279, 12335, 66, 1, 42, "ObjectName",
      CellTags->{"i:33", "b:2.22", "c:34"}]},
  "b:2.22"->{
    Cell[516279, 12335, 66, 1, 42, "ObjectName",
      CellTags->{"i:33", "b:2.22", "c:34"}],
    Cell[516348, 12338, 607, 27, 54, "Usage",
      CellTags->"b:2.22"],
    Cell[516958, 12367, 247, 5, 40, "Notes",
      CellTags->"b:2.22"],
    Cell[517208, 12374, 563, 18, 56, "Notes",
      CellTags->"b:2.22"],
    Cell[517774, 12394, 266, 7, 40, "Notes",
      CellTags->"b:2.22"],
    Cell[518043, 12403, 231, 7, 24, "Notes",
      CellTags->"b:2.22"],
    Cell[518277, 12412, 223, 9, 24, "Notes",
      CellTags->"b:2.22"],
    Cell[518503, 12423, 410, 18, 24, "Notes",
      CellTags->"b:2.22"],
    Cell[518938, 12445, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.22"],
    Cell[519005, 12448, 88, 1, 34, "ExampleText",
      CellTags->"b:2.22"],
    Cell[519096, 12451, 97, 3, 26, "Input",
      CellTags->"b:2.22"],
    Cell[519196, 12456, 116, 3, 34, "ExampleText",
      CellTags->"b:2.22"],
    Cell[519337, 12463, 170, 5, 26, "Input",
      CellTags->"b:2.22"],
    Cell[519510, 12470, 188, 4, 28, "Output",
      CellTags->"b:2.22"],
    Cell[519713, 12477, 133, 4, 34, "ExampleText",
      CellTags->"b:2.22"],
    Cell[519871, 12485, 90, 3, 26, "Input",
      CellTags->"b:2.22"],
    Cell[519964, 12490, 609, 14, 102, "Output",
      CellTags->"b:2.22"]},
  "c:34"->{
    Cell[516279, 12335, 66, 1, 42, "ObjectName",
      CellTags->{"i:33", "b:2.22", "c:34"}]},
  "i:34"->{
    Cell[520634, 12511, 71, 1, 42, "ObjectName",
      CellTags->{"i:34", "b:2.23", "c:35"}]},
  "b:2.23"->{
    Cell[520634, 12511, 71, 1, 42, "ObjectName",
      CellTags->{"i:34", "b:2.23", "c:35"}],
    Cell[520708, 12514, 533, 21, 54, "Usage",
      CellTags->"b:2.23"],
    Cell[521244, 12537, 261, 5, 40, "Notes",
      CellTags->"b:2.23"],
    Cell[521508, 12544, 223, 9, 24, "Notes",
      CellTags->"b:2.23"],
    Cell[521734, 12555, 153, 6, 24, "Notes",
      CellTags->"b:2.23"],
    Cell[521912, 12565, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.23"],
    Cell[521979, 12568, 88, 1, 34, "ExampleText",
      CellTags->"b:2.23"],
    Cell[522070, 12571, 97, 3, 26, "Input",
      CellTags->"b:2.23"],
    Cell[522170, 12576, 116, 3, 34, "ExampleText",
      CellTags->"b:2.23"],
    Cell[522311, 12583, 170, 5, 26, "Input",
      CellTags->"b:2.23"],
    Cell[522484, 12590, 188, 4, 28, "Output",
      CellTags->"b:2.23"],
    Cell[522687, 12597, 98, 1, 34, "ExampleText",
      CellTags->"b:2.23"],
    Cell[522810, 12602, 91, 3, 26, "Input",
      CellTags->"b:2.23"],
    Cell[522904, 12607, 141, 4, 28, "Output",
      CellTags->"b:2.23"],
    Cell[523060, 12614, 121, 3, 34, "ExampleText",
      CellTags->"b:2.23"],
    Cell[523206, 12621, 96, 3, 26, "Input",
      CellTags->"b:2.23"],
    Cell[523305, 12626, 140, 4, 28, "Output",
      CellTags->"b:2.23"],
    Cell[523482, 12635, 108, 3, 26, "Input",
      CellTags->"b:2.23"],
    Cell[523593, 12640, 137, 3, 28, "Output",
      CellTags->"b:2.23"]},
  "c:35"->{
    Cell[520634, 12511, 71, 1, 42, "ObjectName",
      CellTags->{"i:34", "b:2.23", "c:35"}]},
  "i:35"->{
    Cell[523791, 12650, 75, 1, 42, "ObjectName",
      CellTags->{"i:35", "b:2.24", "c:36"}]},
  "b:2.24"->{
    Cell[523791, 12650, 75, 1, 42, "ObjectName",
      CellTags->{"i:35", "b:2.24", "c:36"}],
    Cell[523869, 12653, 520, 21, 48, "Usage",
      CellTags->"b:2.24"],
    Cell[524392, 12676, 247, 5, 40, "Notes",
      CellTags->"b:2.24"],
    Cell[524642, 12683, 339, 12, 40, "Notes",
      CellTags->"b:2.24"],
    Cell[524984, 12697, 223, 9, 24, "Notes",
      CellTags->"b:2.24"],
    Cell[525210, 12708, 401, 18, 24, "Notes",
      CellTags->"b:2.24"],
    Cell[525636, 12730, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.24"],
    Cell[525703, 12733, 88, 1, 34, "ExampleText",
      CellTags->"b:2.24"],
    Cell[525794, 12736, 97, 3, 26, "Input",
      CellTags->"b:2.24"],
    Cell[525894, 12741, 116, 3, 34, "ExampleText",
      CellTags->"b:2.24"],
    Cell[526035, 12748, 170, 5, 26, "Input",
      CellTags->"b:2.24"],
    Cell[526208, 12755, 188, 4, 28, "Output",
      CellTags->"b:2.24"],
    Cell[526411, 12762, 133, 4, 34, "ExampleText",
      CellTags->"b:2.24"],
    Cell[526569, 12770, 125, 3, 26, "Input",
      CellTags->"b:2.24"],
    Cell[526697, 12775, 188, 4, 28, "Output",
      CellTags->"b:2.24"],
    Cell[526900, 12782, 89, 1, 34, "ExampleText",
      CellTags->"b:2.24"],
    Cell[527014, 12787, 91, 3, 26, "Input",
      CellTags->"b:2.24"],
    Cell[527108, 12792, 141, 4, 28, "Output",
      CellTags->"b:2.24"],
    Cell[527286, 12801, 92, 3, 26, "Input",
      CellTags->"b:2.24"],
    Cell[527381, 12806, 128, 3, 28, "Output",
      CellTags->"b:2.24"]},
  "c:36"->{
    Cell[523791, 12650, 75, 1, 42, "ObjectName",
      CellTags->{"i:35", "b:2.24", "c:36"}]},
  "i:36"->{
    Cell[527570, 12816, 71, 1, 42, "ObjectName",
      CellTags->{"i:36", "b:2.25", "c:37"}]},
  "b:2.25"->{
    Cell[527570, 12816, 71, 1, 42, "ObjectName",
      CellTags->{"i:36", "b:2.25", "c:37"}],
    Cell[527644, 12819, 118, 3, 24, "Notes",
      CellTags->"b:2.25"],
    Cell[527765, 12824, 223, 9, 24, "Notes",
      CellTags->"b:2.25"],
    Cell[527991, 12835, 159, 6, 24, "Notes",
      CellTags->"b:2.25"]},
  "c:37"->{
    Cell[527570, 12816, 71, 1, 42, "ObjectName",
      CellTags->{"i:36", "b:2.25", "c:37"}]},
  "i:37"->{
    Cell[528187, 12846, 87, 1, 42, "ObjectName",
      CellTags->{"i:37", "b:2.26", "c:38"}]},
  "b:2.26"->{
    Cell[528187, 12846, 87, 1, 42, "ObjectName",
      CellTags->{"i:37", "b:2.26", "c:38"}],
    Cell[528277, 12849, 297, 12, 32, "Usage",
      CellTags->"b:2.26"],
    Cell[528577, 12863, 209, 5, 40, "Notes",
      CellTags->"b:2.26"],
    Cell[528789, 12870, 139, 4, 24, "Notes",
      CellTags->"b:2.26"],
    Cell[528931, 12876, 227, 5, 40, "Notes",
      CellTags->"b:2.26"],
    Cell[529161, 12883, 223, 9, 24, "Notes",
      CellTags->"b:2.26"],
    Cell[529409, 12896, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.26"],
    Cell[529476, 12899, 88, 1, 34, "ExampleText",
      CellTags->"b:2.26"],
    Cell[529567, 12902, 97, 3, 26, "Input",
      CellTags->"b:2.26"],
    Cell[529667, 12907, 106, 2, 34, "ExampleText",
      CellTags->"b:2.26"],
    Cell[529798, 12913, 163, 5, 26, "Input",
      CellTags->"b:2.26"],
    Cell[529964, 12920, 189, 4, 28, "Output",
      CellTags->"b:2.26"],
    Cell[530190, 12929, 115, 3, 26, "Input",
      CellTags->"b:2.26"],
    Cell[530308, 12934, 308, 6, 25, "Output",
      CellTags->"b:2.26"],
    Cell[530631, 12943, 123, 3, 34, "ExampleText",
      CellTags->"b:2.26"],
    Cell[530779, 12950, 114, 3, 26, "Input",
      CellTags->"b:2.26"],
    Cell[530896, 12955, 175, 4, 18, "Message",
      CellTags->"b:2.26"],
    Cell[531074, 12961, 259, 6, 28, "Output",
      CellTags->"b:2.26"],
    Cell[531370, 12972, 117, 3, 26, "Input",
      CellTags->"b:2.26"],
    Cell[531490, 12977, 215, 5, 25, "Output",
      CellTags->"b:2.26"]},
  "c:38"->{
    Cell[528187, 12846, 87, 1, 42, "ObjectName",
      CellTags->{"i:37", "b:2.26", "c:38"}]},
  "i:38"->{
    Cell[531766, 12989, 67, 1, 42, "ObjectName",
      CellTags->{"i:38", "b:2.27", "c:39"}]},
  "b:2.27"->{
    Cell[531766, 12989, 67, 1, 42, "ObjectName",
      CellTags->{"i:38", "b:2.27", "c:39"}],
    Cell[531836, 12992, 324, 15, 32, "Usage",
      CellTags->"b:2.27"],
    Cell[532163, 13009, 223, 9, 24, "Notes",
      CellTags->"b:2.27"],
    Cell[532389, 13020, 207, 9, 24, "Notes",
      CellTags->"b:2.27"],
    Cell[532621, 13033, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.27"],
    Cell[532688, 13036, 88, 1, 34, "ExampleText",
      CellTags->"b:2.27"],
    Cell[532779, 13039, 97, 3, 26, "Input",
      CellTags->"b:2.27"],
    Cell[532879, 13044, 116, 3, 34, "ExampleText",
      CellTags->"b:2.27"],
    Cell[533020, 13051, 170, 5, 26, "Input",
      CellTags->"b:2.27"],
    Cell[533193, 13058, 188, 4, 28, "Output",
      CellTags->"b:2.27"],
    Cell[533396, 13065, 178, 5, 34, "ExampleText",
      CellTags->"b:2.27"],
    Cell[533599, 13074, 88, 3, 26, "Input",
      CellTags->"b:2.27"],
    Cell[533690, 13079, 85, 3, 25, "Output",
      CellTags->"b:2.27"],
    Cell[533812, 13087, 96, 3, 26, "Input",
      CellTags->"b:2.27"],
    Cell[533911, 13092, 86, 3, 25, "Output",
      CellTags->"b:2.27"],
    Cell[534034, 13100, 166, 5, 26, "Input",
      CellTags->"b:2.27"],
    Cell[534203, 13107, 86, 3, 25, "Output",
      CellTags->"b:2.27"]},
  "c:39"->{
    Cell[531766, 12989, 67, 1, 42, "ObjectName",
      CellTags->{"i:38", "b:2.27", "c:39"}]},
  "i:39"->{
    Cell[534350, 13117, 68, 1, 42, "ObjectName",
      CellTags->{"i:39", "b:2.28", "c:40"}]},
  "b:2.28"->{
    Cell[534350, 13117, 68, 1, 42, "ObjectName",
      CellTags->{"i:39", "b:2.28", "c:40"}],
    Cell[534421, 13120, 286, 12, 32, "Usage",
      CellTags->"b:2.28"],
    Cell[534710, 13134, 132, 4, 24, "Notes",
      CellTags->"b:2.28"],
    Cell[534845, 13140, 223, 9, 24, "Notes",
      CellTags->"b:2.28"],
    Cell[535071, 13151, 206, 9, 24, "Notes",
      CellTags->"b:2.28"],
    Cell[535302, 13164, 64, 1, 38, "ExampleSection",
      CellTags->"b:2.28"],
    Cell[535369, 13167, 149, 6, 34, "ExampleText",
      CellTags->"b:2.28"]},
  "c:40"->{
    Cell[534350, 13117, 68, 1, 42, "ObjectName",
      CellTags->{"i:39", "b:2.28", "c:40"}]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"c:1", 541379, 13266},
  {"b:0.0", 541458, 13269},
  {"c:2", 548946, 13476},
  {"i:4", 549037, 13479},
  {"i:5", 549127, 13482},
  {"i:6", 549224, 13485},
  {"i:7", 549322, 13488},
  {"i:8", 549419, 13491},
  {"i:9", 549509, 13494},
  {"b:0.1", 549602, 13497},
  {"c:3", 551843, 13558},
  {"c:4", 551938, 13561},
  {"b:1.0", 552021, 13564},
  {"c:5", 552398, 13575},
  {"i:10", 552494, 13578},
  {"b:1.1", 552600, 13581},
  {"c:6", 560961, 13813},
  {"i:11", 561066, 13816},
  {"b:1.2", 561171, 13819},
  {"c:7", 569810, 14060},
  {"i:12", 569914, 14063},
  {"b:1.3", 570019, 14066},
  {"c:8", 576933, 14261},
  {"b:1.4", 577038, 14264},
  {"c:9", 579279, 14325},
  {"b:1.5", 579376, 14328},
  {"c:10", 579612, 14335},
  {"c:11", 579709, 14338},
  {"i:1", 579791, 14341},
  {"b:2.0", 579896, 14344},
  {"c:12", 581645, 14393},
  {"i:13", 581749, 14396},
  {"b:2.1", 581855, 14399},
  {"c:13", 583613, 14448},
  {"i:14", 583718, 14451},
  {"b:2.2", 583824, 14454},
  {"c:14", 584435, 14471},
  {"i:15", 584540, 14474},
  {"b:2.3", 584646, 14477},
  {"c:15", 585400, 14498},
  {"i:16", 585505, 14501},
  {"b:2.4", 585611, 14504},
  {"c:16", 587503, 14557},
  {"i:17", 587608, 14560},
  {"b:2.5", 587715, 14563},
  {"c:17", 588034, 14572},
  {"i:18", 588140, 14575},
  {"b:2.6", 588247, 14578},
  {"c:18", 589586, 14615},
  {"i:19", 589692, 14618},
  {"b:2.7", 589799, 14621},
  {"c:19", 590118, 14630},
  {"i:20", 590224, 14633},
  {"b:2.8", 590331, 14636},
  {"c:20", 590650, 14645},
  {"i:21", 590756, 14648},
  {"b:2.9", 590863, 14651},
  {"c:21", 591777, 14676},
  {"i:22", 591883, 14679},
  {"b:2.10", 591992, 14682},
  {"c:22", 594310, 14745},
  {"i:23", 594417, 14748},
  {"b:2.11", 594526, 14751},
  {"c:23", 595153, 14768},
  {"i:24", 595260, 14771},
  {"b:2.12", 595369, 14774},
  {"c:24", 596143, 14795},
  {"i:25", 596250, 14798},
  {"b:2.13", 596359, 14801},
  {"c:25", 598014, 14846},
  {"i:26", 598121, 14849},
  {"b:2.14", 598230, 14852},
  {"c:26", 599814, 14895},
  {"i:27", 599921, 14898},
  {"b:2.15", 600030, 14901},
  {"c:27", 601314, 14936},
  {"i:28", 601421, 14939},
  {"b:2.16", 601530, 14942},
  {"c:28", 603105, 14985},
  {"i:29", 603212, 14988},
  {"b:2.17", 603321, 14991},
  {"c:29", 605041, 15038},
  {"i:30", 605148, 15041},
  {"b:2.18", 605257, 15044},
  {"c:30", 606832, 15087},
  {"i:2", 606938, 15090},
  {"b:2.19", 607046, 15093},
  {"c:31", 608554, 15134},
  {"i:31", 608660, 15137},
  {"b:2.20", 608769, 15140},
  {"c:32", 610349, 15183},
  {"i:32", 610456, 15186},
  {"b:2.21", 610565, 15189},
  {"c:33", 612146, 15232},
  {"i:33", 612253, 15235},
  {"b:2.22", 612362, 15238},
  {"c:34", 613651, 15273},
  {"i:34", 613758, 15276},
  {"b:2.23", 613867, 15279},
  {"c:35", 615302, 15318},
  {"i:35", 615409, 15321},
  {"b:2.24", 615518, 15324},
  {"c:36", 617027, 15365},
  {"i:36", 617134, 15368},
  {"b:2.25", 617243, 15371},
  {"c:37", 617566, 15380},
  {"i:37", 617673, 15383},
  {"b:2.26", 617782, 15386},
  {"c:38", 619288, 15427},
  {"i:38", 619395, 15430},
  {"b:2.27", 619504, 15433},
  {"c:39", 620787, 15468},
  {"i:39", 620894, 15471},
  {"b:2.28", 621003, 15474},
  {"c:40", 621557, 15489}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 24, 0, 92, "Chapter"],

Cell[CellGroupData[{
Cell[1825, 57, 50, 1, 65, "Section",
  CellTags->"c:1"],

Cell[CellGroupData[{
Cell[1900, 62, 60, 1, 40, "Subsection",
  CellTags->{"b:0.0", "c:2"}],
Cell[1963, 65, 356, 7, 93, "Text",
  CellTags->"b:0.0"],
Cell[2322, 74, 308, 6, 76, "Text",
  CellTags->"b:0.0"],
Cell[2633, 82, 685, 13, 195, "FramedBox",
  CellTags->"b:0.0"],
Cell[3321, 97, 67, 1, 41, "MathCaption",
  CellTags->"b:0.0"],
Cell[3391, 100, 96, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[3490, 105, 136338, 1964, 116, "DefinitionBox",
  CellTags->"b:0.0"],
Cell[139831, 2071, 227, 4, 61, "Print",
  CellTags->"b:0.0"],
Cell[140061, 2077, 202, 4, 42, "Text",
  CellTags->{"i:4", "b:0.0"}],
Cell[140266, 2083, 466, 10, 32, "DisplayMath",
  CellTags->"b:0.0"],
Cell[140735, 2095, 657, 21, 76, "Text",
  CellTags->"b:0.0"],
Cell[141395, 2118, 133, 4, 42, "Text",
  CellTags->"b:0.0"],
Cell[141531, 2124, 5351, 134, 378, "DefinitionBox",
  CellTags->"b:0.0"],
Cell[146885, 2260, 66, 1, 17, "Caption",
  CellTags->"b:0.0"],
Cell[146954, 2263, 72, 1, 41, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[147051, 2268, 169, 5, 49, "Input",
  CellTags->"b:0.0"],
Cell[147223, 2275, 187, 4, 27, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[147425, 2282, 168, 6, 41, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[147618, 2292, 89, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[147710, 2297, 607, 14, 155, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[148332, 2314, 224, 5, 59, "Text",
  CellTags->"b:0.0"],
Cell[148559, 2321, 260, 7, 59, "FramedBox",
  CellTags->"b:0.0"],
Cell[148822, 2330, 203, 7, 58, "MathCaption",
  CellTags->{"i:5", "b:0.0"}],

Cell[CellGroupData[{
Cell[149050, 2341, 90, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[149143, 2346, 139, 4, 27, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[149297, 2353, 97, 1, 41, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[149419, 2358, 86, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[149508, 2363, 191, 4, 28, "Output",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[149736, 2372, 91, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[149830, 2377, 129, 3, 27, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[149974, 2383, 365, 10, 75, "MathCaption",
  CellTags->{"i:6", "b:0.0"}],

Cell[CellGroupData[{
Cell[150364, 2397, 113, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[150480, 2402, 83, 3, 27, "Output",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[150600, 2410, 114, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[150717, 2415, 85, 3, 27, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[150817, 2421, 205, 6, 58, "MathCaption",
  CellTags->{"i:7", "b:0.0"}],

Cell[CellGroupData[{
Cell[151047, 2431, 100, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[151150, 2436, 460, 11, 117, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[151625, 2450, 136, 4, 25, "Text",
  CellTags->{"i:8", "b:0.0"}],
Cell[151764, 2456, 2052, 53, 222, "DefinitionBox",
  CellTags->"b:0.0"],
Cell[153819, 2511, 84, 1, 17, "Caption",
  CellTags->"b:0.0"],
Cell[153906, 2514, 157, 4, 42, "Text",
  CellTags->"b:0.0"],
Cell[154066, 2520, 185, 3, 76, "FramedBox",
  CellTags->"b:0.0"],
Cell[154254, 2525, 74, 1, 17, "Caption",
  CellTags->"b:0.0"],
Cell[154331, 2528, 86, 1, 41, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[154442, 2533, 81, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[154526, 2538, 192, 4, 28, "Output",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[154755, 2547, 89, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[154847, 2552, 321, 6, 65, "Output",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[155205, 2563, 88, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[155296, 2568, 84, 3, 27, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[155395, 2574, 387, 7, 109, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[155807, 2585, 96, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[155906, 2590, 543, 10, 65, "Output",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[156486, 2605, 104, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[156593, 2610, 379, 7, 65, "Output",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[157009, 2622, 117, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[157129, 2627, 353, 6, 65, "Output",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[157519, 2638, 104, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[157626, 2643, 406, 8, 65, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[158047, 2654, 416, 11, 92, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[158488, 2669, 160, 4, 49, "Input",
  CellTags->"b:0.0"],
Cell[158651, 2675, 268, 5, 50, "Message",
  CellTags->"b:0.0"],
Cell[158922, 2682, 268, 5, 50, "Message",
  CellTags->"b:0.0"],
Cell[159193, 2689, 268, 5, 50, "Message",
  CellTags->"b:0.0"],
Cell[159464, 2696, 405, 7, 35, "Message",
  CellTags->"b:0.0"],
Cell[159872, 2705, 216, 5, 46, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[160103, 2713, 196, 6, 58, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[160324, 2723, 101, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[160428, 2728, 93, 3, 27, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[160536, 2734, 180, 4, 58, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[160741, 2742, 103, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[160847, 2747, 520, 10, 46, "Output",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[161404, 2762, 104, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[161511, 2767, 379, 7, 65, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[161905, 2777, 351, 6, 92, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[162281, 2787, 103, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[162387, 2792, 258, 5, 50, "Message",
  CellTags->"b:0.0"],
Cell[162648, 2799, 1102, 20, 141, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[163765, 2822, 201, 7, 42, "Text",
  CellTags->"b:0.0"],
Cell[163969, 2831, 1087, 25, 194, "DefinitionBox3Col",
  CellTags->"b:0.0"],
Cell[165059, 2858, 57, 1, 17, "Caption",
  CellTags->"b:0.0"],
Cell[165119, 2861, 218, 5, 59, "Text",
  CellTags->"b:0.0"],
Cell[165340, 2868, 1453, 40, 102, "DefinitionBox",
  CellTags->"b:0.0"],
Cell[166796, 2910, 86, 1, 17, "Caption",
  CellTags->"b:0.0"],
Cell[166885, 2913, 94, 1, 41, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[167004, 2918, 91, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[167098, 2923, 140, 4, 27, "Output",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[167275, 2932, 125, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[167403, 2937, 188, 4, 27, "Output",
  CellTags->"b:0.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[167628, 2946, 92, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[167723, 2951, 127, 3, 27, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[167865, 2957, 517, 10, 93, "Text",
  CellTags->{"i:9", "b:0.0"}],
Cell[168385, 2969, 5564, 143, 476, "DefinitionBox",
  CellTags->"b:0.0"],
Cell[173952, 3114, 77, 1, 17, "Caption",
  CellTags->"b:0.0"],
Cell[174032, 3117, 161, 6, 41, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[174218, 3127, 112, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[174333, 3132, 197, 4, 35, "Message",
  CellTags->"b:0.0"],
Cell[174533, 3138, 644, 12, 198, "Output",
  CellTags->"b:0.0"]
}, Open  ]],
Cell[175192, 3153, 143, 6, 41, "MathCaption",
  CellTags->"b:0.0"],

Cell[CellGroupData[{
Cell[175360, 3163, 108, 3, 29, "Input",
  CellTags->"b:0.0"],
Cell[175471, 3168, 258, 5, 50, "Message",
  CellTags->"b:0.0"],
Cell[175732, 3175, 560, 12, 141, "Output",
  CellTags->"b:0.0"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[176341, 3193, 62, 1, 40, "Subsection",
  CellTags->{"b:0.1", "c:3"}],
Cell[176406, 3196, 177, 4, 42, "Reference",
  CellTags->"b:0.1"],
Cell[176586, 3202, 302, 6, 76, "Reference",
  CellTags->"b:0.1"],
Cell[176891, 3210, 302, 6, 76, "Reference",
  CellTags->"b:0.1"],
Cell[177196, 3218, 315, 6, 76, "Reference",
  CellTags->"b:0.1"],
Cell[177514, 3226, 187, 4, 42, "Reference",
  CellTags->"b:0.1"],
Cell[177704, 3232, 182, 4, 42, "Reference",
  CellTags->"b:0.1"],
Cell[177889, 3238, 230, 5, 59, "Reference",
  CellTags->"b:0.1"],
Cell[178122, 3245, 294, 6, 76, "Reference",
  CellTags->"b:0.1"],
Cell[178419, 3253, 327, 6, 76, "Reference",
  CellTags->"b:0.1"],
Cell[178749, 3261, 184, 4, 42, "Reference",
  CellTags->"b:0.1"],
Cell[178936, 3267, 180, 4, 25, "Reference",
  CellTags->"b:0.1"],
Cell[179119, 3273, 274, 5, 42, "Reference",
  CellTags->"b:0.1"],
Cell[179396, 3280, 297, 6, 42, "Reference",
  CellTags->"b:0.1"],
Cell[179696, 3288, 179, 4, 25, "Reference",
  CellTags->"b:0.1"],
Cell[179878, 3294, 184, 6, 42, "Reference",
  CellTags->"b:0.1"],
Cell[180065, 3302, 121, 3, 25, "Reference",
  CellTags->"b:0.1"],
Cell[180189, 3307, 123, 3, 25, "Reference",
  CellTags->"b:0.1"],
Cell[180315, 3312, 208, 5, 59, "Reference",
  CellTags->"b:0.1"],
Cell[180526, 3319, 221, 5, 59, "Reference",
  CellTags->"b:0.1"],
Cell[180750, 3326, 257, 5, 59, "Reference",
  CellTags->"b:0.1"],
Cell[181010, 3333, 241, 5, 59, "Reference",
  CellTags->"b:0.1"],
Cell[181254, 3340, 172, 4, 42, "Reference",
  CellTags->"b:0.1"],
Cell[181429, 3346, 266, 9, 42, "Reference",
  CellTags->"b:0.1"],
Cell[181698, 3357, 268, 5, 59, "Reference",
  CellTags->"b:0.1"],
Cell[181969, 3364, 186, 4, 42, "Reference",
  CellTags->"b:0.1"],
Cell[182158, 3370, 191, 4, 42, "Reference",
  CellTags->"b:0.1"],
Cell[182352, 3376, 267, 5, 59, "Reference",
  CellTags->"b:0.1"],
Cell[182622, 3383, 148, 4, 42, "Reference",
  CellTags->"b:0.1"],
Cell[182773, 3389, 202, 4, 59, "Reference",
  CellTags->"b:0.1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[183024, 3399, 59, 1, 39, "Section",
  CellTags->"c:4"],

Cell[CellGroupData[{
Cell[183108, 3404, 64, 1, 40, "Subsection",
  CellTags->{"b:1.0", "c:5"}],
Cell[183175, 3407, 910, 20, 104, "Text",
  CellTags->"b:1.0"],
Cell[184088, 3429, 802, 17, 88, "Text",
  CellTags->"b:1.0"],
Cell[184893, 3448, 1186, 27, 136, "Text",
  CellTags->"b:1.0"],
Cell[186082, 3477, 216, 5, 40, "Text",
  CellTags->"b:1.0"]
}, Closed]],

Cell[CellGroupData[{
Cell[186335, 3487, 100, 1, 40, "Subsection",
  CellTags->{"i:10", "b:1.1", "c:6"}],
Cell[186438, 3490, 318, 10, 59, "Text",
  CellTags->"b:1.1"],
Cell[186759, 3502, 2386, 64, 244, "DefinitionBox",
  CellTags->"b:1.1"],
Cell[189148, 3568, 237, 8, 30, "SmallTextSans",
  CellTags->"b:1.1"],

Cell[CellGroupData[{
Cell[189410, 3580, 89, 2, 35, "Subsubsection",
  CellTags->"b:1.1"],
Cell[189502, 3584, 149, 4, 25, "Text",
  CellTags->"b:1.1"],
Cell[189654, 3590, 96, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[189753, 3595, 136338, 1964, 114, "DefinitionBox",
  CellTags->"b:1.1"],
Cell[326094, 5561, 227, 4, 42, "Print",
  CellTags->"b:1.1"],
Cell[326324, 5567, 433, 9, 59, "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{
Cell[326782, 5580, 191, 5, 29, "Input",
  CellTags->"b:1.1"],
Cell[326976, 5587, 187, 4, 27, "Output",
  CellTags->"b:1.1"]
}, Open  ]],
Cell[327178, 5594, 161, 6, 25, "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{
Cell[327364, 5604, 89, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[327456, 5609, 608, 14, 117, "Output",
  CellTags->"b:1.1"]
}, Open  ]],
Cell[328079, 5626, 187, 7, 25, "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{
Cell[328291, 5637, 90, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[328384, 5642, 140, 4, 27, "Output",
  CellTags->"b:1.1"]
}, Open  ]],
Cell[328539, 5649, 90, 1, 25, "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{
Cell[328654, 5654, 86, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[328743, 5659, 191, 4, 28, "Output",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[CellGroupData[{
Cell[328971, 5668, 91, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[329065, 5673, 129, 3, 27, "Output",
  CellTags->"b:1.1"]
}, Open  ]],
Cell[329209, 5679, 351, 10, 42, "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{
Cell[329585, 5693, 113, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[329701, 5698, 83, 3, 27, "Output",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[CellGroupData[{
Cell[329821, 5706, 113, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[329937, 5711, 84, 3, 27, "Output",
  CellTags->"b:1.1"]
}, Open  ]],
Cell[330036, 5717, 189, 6, 25, "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{
Cell[330250, 5727, 99, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[330352, 5732, 459, 11, 79, "Output",
  CellTags->"b:1.1"]
}, Open  ]],
Cell[330826, 5746, 129, 4, 25, "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{
Cell[330980, 5754, 89, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[331072, 5759, 321, 6, 46, "Output",
  CellTags->"b:1.1"]
}, Open  ]],
Cell[331408, 5768, 128, 4, 25, "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{
Cell[331561, 5776, 96, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[331660, 5781, 131, 3, 27, "Output",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[CellGroupData[{
Cell[331828, 5789, 92, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[331923, 5794, 132, 3, 27, "Output",
  CellTags->"b:1.1"]
}, Open  ]],
Cell[332070, 5800, 182, 4, 25, "Text",
  CellTags->"b:1.1"],

Cell[CellGroupData[{
Cell[332277, 5808, 80, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[332360, 5813, 188, 4, 27, "Output",
  CellTags->"b:1.1"]
}, Open  ]],

Cell[CellGroupData[{
Cell[332585, 5822, 86, 3, 29, "Input",
  CellTags->"b:1.1"],
Cell[332674, 5827, 269, 5, 35, "Message",
  CellTags->"b:1.1"],
Cell[332946, 5834, 181, 4, 27, "Output",
  CellTags->"b:1.1"]
}, Open  ]],
Cell[333142, 5841, 149, 4, 25, "Text",
  CellTags->"b:1.1"]
}, Closed]],

Cell[CellGroupData[{
Cell[333328, 5850, 94, 2, 35, "Subsubsection",
  CellTags->"b:1.1"],
Cell[333425, 5854, 631, 12, 93, "Text",
  CellTags->"b:1.1"],
Cell[334059, 5868, 89, 2, 25, "Text",
  CellTags->"b:1.1"],
Cell[334151, 5872, 523, 14, 42, "Text",
  CellTags->"b:1.1"],
Cell[334677, 5888, 529, 9, 32, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[335209, 5899, 529, 9, 32, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[335741, 5910, 559, 9, 32, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[336303, 5921, 286, 8, 26, "Text",
  CellTags->"b:1.1"],
Cell[336592, 5931, 366, 6, 43, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[336961, 5939, 418, 15, 25, "Text",
  CellTags->"b:1.1"],
Cell[337382, 5956, 67, 2, 25, "Text",
  CellTags->"b:1.1"],
Cell[337452, 5960, 185, 5, 25, "Text",
  CellTags->"b:1.1"],
Cell[337640, 5967, 540, 9, 32, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[338183, 5978, 373, 10, 42, "Text",
  CellTags->"b:1.1"],
Cell[338559, 5990, 353, 6, 32, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[338915, 5998, 531, 15, 59, "Text",
  CellTags->"b:1.1"],
Cell[339449, 6015, 251, 5, 42, "Text",
  CellTags->"b:1.1"],
Cell[339703, 6022, 70, 2, 25, "Text",
  CellTags->"b:1.1"],
Cell[339776, 6026, 128, 2, 25, "Text",
  CellTags->"b:1.1"],
Cell[339907, 6030, 280, 5, 39, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[340190, 6037, 235, 4, 31, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[340428, 6043, 225, 4, 31, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[340656, 6049, 235, 4, 31, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[340894, 6055, 290, 5, 39, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[341187, 6062, 299, 5, 32, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[341489, 6069, 406, 15, 27, "Text",
  CellTags->"b:1.1"],
Cell[341898, 6086, 66, 2, 25, "Text",
  CellTags->"b:1.1"],
Cell[341967, 6090, 333, 10, 25, "Text",
  CellTags->"b:1.1"],
Cell[342303, 6102, 723, 13, 55, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[343029, 6117, 556, 10, 47, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[343588, 6129, 729, 13, 48, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[344320, 6144, 570, 21, 27, "Text",
  CellTags->"b:1.1"],
Cell[344893, 6167, 75, 2, 25, "Text",
  CellTags->"b:1.1"],
Cell[344971, 6171, 274, 6, 42, "Text",
  CellTags->"b:1.1"],
Cell[345248, 6179, 283, 5, 31, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[345534, 6186, 325, 6, 33, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[345862, 6194, 335, 6, 34, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[346200, 6202, 449, 17, 26, "Text",
  CellTags->"b:1.1"],
Cell[346652, 6221, 66, 2, 25, "Text",
  CellTags->"b:1.1"],
Cell[346721, 6225, 332, 10, 25, "Text",
  CellTags->"b:1.1"],
Cell[347056, 6237, 422, 8, 32, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[347481, 6247, 128, 2, 25, "Text",
  CellTags->"b:1.1"],
Cell[347612, 6251, 812, 14, 64, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[348427, 6267, 812, 14, 64, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[349242, 6283, 852, 14, 64, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[350097, 6299, 570, 21, 27, "Text",
  CellTags->"b:1.1"],
Cell[350670, 6322, 75, 2, 25, "Text",
  CellTags->"b:1.1"],
Cell[350748, 6326, 167, 4, 25, "Text",
  CellTags->"b:1.1"],
Cell[350918, 6332, 573, 13, 60, "Text",
  CellTags->"b:1.1"],
Cell[351494, 6347, 282, 5, 31, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[351779, 6354, 436, 13, 42, "Text",
  CellTags->"b:1.1"],
Cell[352218, 6369, 576, 10, 48, "NumberedEquation",
  CellTags->"b:1.1"],
Cell[352797, 6381, 347, 15, 25, "Text",
  CellTags->"b:1.1"]
}, Closed]],

Cell[CellGroupData[{
Cell[353181, 6401, 96, 2, 35, "Subsubsection",
  CellTags->"b:1.1"],
Cell[353280, 6405, 241, 5, 42, "Text",
  CellTags->"b:1.1"],
Cell[353524, 6412, 727, 21, 59, "Text",
  CellTags->"b:1.1"],
Cell[354254, 6435, 139, 3, 42, "DefinitionBox",
  CellTags->"b:1.1"],
Cell[354396, 6440, 305, 6, 42, "Text",
  CellTags->"b:1.1"],
Cell[354704, 6448, 262, 6, 49, "Input",
  Evaluatable->False,
  CellTags->"b:1.1"],
Cell[354969, 6456, 145, 4, 29, "Input",
  Evaluatable->False,
  CellTags->"b:1.1"],
Cell[355117, 6462, 189, 4, 49, "Input",
  Evaluatable->False,
  CellTags->"b:1.1"],
Cell[355309, 6468, 233, 6, 49, "Input",
  Evaluatable->False,
  CellTags->"b:1.1"],
Cell[355545, 6476, 172, 4, 29, "Input",
  Evaluatable->False,
  CellTags->"b:1.1"],
Cell[355720, 6482, 126, 3, 29, "Input",
  Evaluatable->False,
  CellTags->"b:1.1"],
Cell[355849, 6487, 405, 11, 46, "Text",
  CellTags->"b:1.1"],
Cell[356257, 6500, 124, 3, 29, "Input",
  Evaluatable->False,
  CellTags->"b:1.1"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[356430, 6509, 82, 1, 40, "Subsection",
  CellTags->{"i:11", "b:1.2", "c:7"}],
Cell[356515, 6512, 225, 5, 59, "Text",
  CellTags->"b:1.2"],
Cell[356743, 6519, 4259, 113, 156, "DefinitionBox",
  CellTags->"b:1.2"],
Cell[361005, 6634, 243, 8, 30, "SmallTextSans",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[361273, 6646, 79, 2, 35, "Subsubsection",
  CellTags->"b:1.2"],
Cell[361355, 6650, 155, 4, 25, "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[361535, 6658, 80, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[361618, 6663, 188, 4, 27, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[361821, 6670, 381, 7, 59, "Text",
  CellTags->"b:1.2"],
Cell[362205, 6679, 100, 1, 33, "Commentary",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[362330, 6684, 96, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[362429, 6689, 536, 10, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[363002, 6704, 104, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[363109, 6709, 384, 7, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[363530, 6721, 104, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[363637, 6726, 540, 10, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[364214, 6741, 104, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[364321, 6746, 385, 7, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[364743, 6758, 232, 6, 30, "Input",
  CellTags->"b:1.2"],
Cell[364978, 6766, 538, 10, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[365553, 6781, 104, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[365660, 6786, 384, 7, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[366059, 6796, 92, 1, 33, "Commentary",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[366176, 6801, 117, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[366296, 6806, 353, 6, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[366686, 6817, 104, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[366793, 6822, 406, 8, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[367214, 6833, 113, 3, 25, "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[367352, 6840, 95, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[367450, 6845, 321, 6, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[367808, 6856, 122, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[367933, 6861, 131, 3, 27, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[368079, 6867, 387, 13, 42, "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[368491, 6884, 149, 4, 29, "Input",
  CellTags->"b:1.2"],
Cell[368643, 6890, 399, 7, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[369057, 6900, 124, 4, 25, "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[369206, 6908, 109, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[369318, 6913, 399, 7, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[369732, 6923, 458, 14, 42, "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[370215, 6941, 160, 4, 29, "Input",
  CellTags->"b:1.2"],
Cell[370378, 6947, 267, 5, 35, "Message",
  CellTags->"b:1.2"],
Cell[370648, 6954, 267, 5, 35, "Message",
  CellTags->"b:1.2"],
Cell[370918, 6961, 267, 5, 35, "Message",
  CellTags->"b:1.2"],
Cell[371188, 6968, 405, 7, 20, "Message",
  CellTags->"b:1.2"],
Cell[371596, 6977, 216, 5, 27, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[371827, 6985, 189, 6, 25, "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[372041, 6995, 101, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[372145, 7000, 93, 3, 27, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[372253, 7006, 173, 4, 25, "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[372451, 7014, 103, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[372557, 7019, 521, 10, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[373115, 7034, 104, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[373222, 7039, 378, 7, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[373615, 7049, 356, 7, 59, "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[373996, 7060, 103, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[374102, 7065, 258, 5, 35, "Message",
  CellTags->"b:1.2"],
Cell[374363, 7072, 961, 17, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[375361, 7094, 104, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[375468, 7099, 681, 12, 65, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[376164, 7114, 106, 3, 25, "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[376295, 7121, 93, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[376391, 7126, 303, 6, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[376731, 7137, 98, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[376832, 7142, 700, 13, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[377569, 7160, 104, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[377676, 7165, 624, 11, 65, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[378315, 7179, 223, 6, 25, "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[378563, 7189, 102, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[378668, 7194, 779, 14, 65, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[379484, 7213, 104, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[379591, 7218, 650, 11, 65, "Output",
  CellTags->"b:1.2"]
}, Open  ]],
Cell[380256, 7232, 411, 11, 42, "Text",
  CellTags->"b:1.2"],

Cell[CellGroupData[{
Cell[380692, 7247, 179, 5, 29, "Input",
  CellTags->"b:1.2"],
Cell[380874, 7254, 176, 4, 43, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[381087, 7263, 101, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[381191, 7268, 522, 10, 63, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[381750, 7283, 131, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[381884, 7288, 392, 8, 27, "Output",
  CellTags->"b:1.2"]
}, Open  ]],

Cell[CellGroupData[{
Cell[382313, 7301, 123, 3, 29, "Input",
  CellTags->"b:1.2"],
Cell[382439, 7306, 440, 9, 46, "Output",
  CellTags->"b:1.2"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[382928, 7321, 94, 2, 35, "Subsubsection",
  CellTags->"b:1.2"],
Cell[383025, 7325, 79, 1, 42, "FramedBox",
  CellTags->"b:1.2"],
Cell[383107, 7328, 580, 24, 26, "Text",
  CellTags->"b:1.2"],
Cell[383690, 7354, 484, 9, 48, "NumberedEquation",
  CellTags->"b:1.2"],
Cell[384177, 7365, 341, 15, 25, "Text",
  CellTags->"b:1.2"],
Cell[384521, 7382, 228, 4, 31, "NumberedEquation",
  CellTags->"b:1.2"],
Cell[384752, 7388, 406, 15, 25, "Text",
  CellTags->"b:1.2"],
Cell[385161, 7405, 369, 7, 33, "NumberedEquation",
  CellTags->"b:1.2"],
Cell[385533, 7414, 215, 5, 25, "Text",
  CellTags->"b:1.2"],
Cell[385751, 7421, 96, 2, 25, "Text",
  CellTags->"b:1.2"],
Cell[385850, 7425, 129, 2, 25, "Text",
  CellTags->"b:1.2"],
Cell[385982, 7429, 282, 5, 35, "NumberedEquation",
  CellTags->"b:1.2"],
Cell[386267, 7436, 102, 2, 25, "Text",
  CellTags->"b:1.2"],
Cell[386372, 7440, 1021, 17, 89, "NumberedEquation",
  CellTags->"b:1.2"],
Cell[387396, 7459, 96, 2, 25, "Text",
  CellTags->"b:1.2"],
Cell[387495, 7463, 129, 2, 25, "Text",
  CellTags->"b:1.2"],
Cell[387627, 7467, 263, 5, 34, "NumberedEquation",
  CellTags->"b:1.2"],
Cell[387893, 7474, 102, 2, 25, "Text",
  CellTags->"b:1.2"],
Cell[387998, 7478, 879, 15, 69, "NumberedEquation",
  CellTags->"b:1.2"],
Cell[388880, 7495, 96, 2, 25, "Text",
  CellTags->"b:1.2"],
Cell[388979, 7499, 129, 2, 25, "Text",
  CellTags->"b:1.2"],
Cell[389111, 7503, 308, 5, 34, "NumberedEquation",
  CellTags->"b:1.2"],
Cell[389422, 7510, 102, 2, 25, "Text",
  CellTags->"b:1.2"],
Cell[389527, 7514, 1086, 17, 79, "NumberedEquation",
  CellTags->"b:1.2"],
Cell[390616, 7533, 349, 12, 25, "Text",
  CellTags->"b:1.2"],
Cell[390968, 7547, 1173, 22, 119, "NumberedEquation",
  CellTags->"b:1.2"],
Cell[392144, 7571, 92, 1, 42, "FramedBox",
  CellTags->"b:1.2"],
Cell[392239, 7574, 451, 8, 76, "Text",
  CellTags->"b:1.2"],
Cell[392693, 7584, 82, 1, 42, "FramedBox",
  CellTags->"b:1.2"],
Cell[392778, 7587, 412, 9, 59, "Text",
  CellTags->"b:1.2"],
Cell[393193, 7598, 374, 7, 59, "Text",
  CellTags->"b:1.2"],
Cell[393570, 7607, 88, 2, 25, "Text",
  CellTags->"b:1.2"],
Cell[393661, 7611, 238, 7, 25, "Text",
  CellTags->"b:1.2"],
Cell[393902, 7620, 693, 17, 58, "NumberedEquation",
  CellTags->"b:1.2"],
Cell[394598, 7639, 972, 33, 44, "Text",
  CellTags->"b:1.2"],
Cell[395573, 7674, 88, 1, 42, "FramedBox",
  CellTags->"b:1.2"],
Cell[395664, 7677, 209, 5, 42, "Text",
  CellTags->"b:1.2"],
Cell[395876, 7684, 66, 2, 25, "Text",
  CellTags->"b:1.2"],
Cell[395945, 7688, 275, 8, 25, "Text",
  CellTags->"b:1.2"],
Cell[396223, 7698, 433, 7, 53, "NumberedEquation",
  CellTags->"b:1.2"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[396705, 7711, 99, 1, 40, "Subsection",
  CellTags->{"i:12", "b:1.3", "c:8"}],
Cell[396807, 7714, 343, 6, 76, "Text",
  CellTags->"b:1.3"],
Cell[397153, 7722, 3999, 97, 244, "DefinitionBox",
  CellTags->"b:1.3"],
Cell[401155, 7821, 248, 8, 30, "SmallTextSans",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[401428, 7833, 79, 2, 35, "Subsubsection",
  CellTags->"b:1.3"],
Cell[401510, 7837, 154, 4, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[401689, 7845, 80, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[401772, 7850, 188, 4, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[401975, 7857, 164, 4, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[402164, 7865, 176, 5, 29, "Input",
  CellTags->"b:1.3"],
Cell[402343, 7872, 218, 5, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[402576, 7880, 96, 1, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[402697, 7885, 113, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[402813, 7890, 87, 3, 40, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[402915, 7896, 243, 9, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[403183, 7909, 119, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[403305, 7914, 197, 4, 20, "Message",
  CellTags->"b:1.3"],
Cell[403505, 7920, 224, 5, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[403744, 7928, 79, 1, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[403848, 7933, 121, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[403972, 7938, 84, 3, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[CellGroupData[{
Cell[404093, 7946, 121, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[404217, 7951, 185, 4, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[404417, 7958, 130, 4, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[404572, 7966, 108, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[404683, 7971, 197, 4, 20, "Message",
  CellTags->"b:1.3"],
Cell[404883, 7977, 111, 3, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[405009, 7983, 117, 3, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[405151, 7990, 103, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[405257, 7995, 116, 3, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[405388, 8001, 255, 9, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[405668, 8014, 113, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[405784, 8019, 197, 4, 20, "Message",
  CellTags->"b:1.3"],
Cell[405984, 8025, 644, 12, 103, "Output",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[CellGroupData[{
Cell[406665, 8042, 103, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[406771, 8047, 258, 5, 35, "Message",
  CellTags->"b:1.3"],
Cell[407032, 8054, 558, 12, 84, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[407605, 8069, 150, 4, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[407780, 8077, 174, 5, 29, "Input",
  CellTags->"b:1.3"],
Cell[407957, 8084, 251, 5, 46, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[408223, 8092, 182, 6, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[408430, 8102, 116, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[408549, 8107, 84, 3, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[408648, 8113, 166, 4, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[408839, 8121, 103, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[408945, 8126, 273, 5, 46, "Output",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[CellGroupData[{
Cell[409255, 8136, 105, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[409363, 8141, 84, 3, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[409462, 8147, 295, 9, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[409782, 8160, 97, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[409882, 8165, 129, 3, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[410026, 8171, 312, 7, 42, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[410363, 8182, 104, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[410470, 8187, 84, 3, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[410569, 8193, 110, 3, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[410704, 8200, 171, 5, 29, "Input",
  CellTags->"b:1.3"],
Cell[410878, 8207, 263, 5, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[CellGroupData[{
Cell[411178, 8217, 96, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[411277, 8222, 313, 6, 46, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[411605, 8231, 143, 4, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[411773, 8239, 108, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[411884, 8244, 315, 6, 50, "Message",
  CellTags->"b:1.3"],
Cell[412202, 8252, 315, 6, 50, "Message",
  CellTags->"b:1.3"],
Cell[412520, 8260, 315, 6, 50, "Message",
  CellTags->"b:1.3"],
Cell[412838, 8268, 414, 7, 35, "Message",
  CellTags->"b:1.3"],
Cell[413255, 8277, 314, 7, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],
Cell[413584, 8287, 137, 4, 25, "Text",
  CellTags->"b:1.3"],

Cell[CellGroupData[{
Cell[413746, 8295, 184, 5, 29, "Input",
  CellTags->"b:1.3"],
Cell[413933, 8302, 263, 5, 27, "Output",
  CellTags->"b:1.3"]
}, Open  ]],

Cell[CellGroupData[{
Cell[414233, 8312, 95, 3, 29, "Input",
  CellTags->"b:1.3"],
Cell[414331, 8317, 440, 9, 46, "Output",
  CellTags->"b:1.3"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[414820, 8332, 94, 2, 35, "Subsubsection",
  CellTags->"b:1.3"],
Cell[414917, 8336, 114, 2, 42, "FramedBox",
  CellTags->"b:1.3"],
Cell[415034, 8340, 580, 18, 59, "Text",
  CellTags->"b:1.3"],
Cell[415617, 8360, 564, 11, 32, "NumberedEquation",
  CellTags->"b:1.3"],
Cell[416184, 8373, 833, 34, 42, "Text",
  CellTags->"b:1.3"],
Cell[417020, 8409, 293, 6, 42, "Text",
  CellTags->"b:1.3"],
Cell[417316, 8417, 675, 25, 42, "Text",
  CellTags->"b:1.3"],
Cell[417994, 8444, 323, 6, 31, "NumberedEquation",
  CellTags->"b:1.3"],
Cell[418320, 8452, 881, 35, 42, "Text",
  CellTags->"b:1.3"],
Cell[419204, 8489, 985, 33, 59, "Text",
  CellTags->"b:1.3"],
Cell[420192, 8524, 117, 2, 42, "FramedBox",
  CellTags->"b:1.3"],
Cell[420312, 8528, 658, 18, 59, "Text",
  CellTags->"b:1.3"],
Cell[420973, 8548, 156, 5, 25, "Text",
  CellTags->"b:1.3"],
Cell[421132, 8555, 339, 13, 25, "Text",
  CellTags->"b:1.3"],
Cell[421474, 8570, 311, 6, 33, "NumberedEquation",
  CellTags->"b:1.3"],
Cell[421788, 8578, 733, 23, 59, "Text",
  CellTags->"b:1.3"],
Cell[422524, 8603, 358, 7, 59, "Text",
  CellTags->"b:1.3"],
Cell[422885, 8612, 116, 2, 42, "FramedBox",
  CellTags->"b:1.3"],
Cell[423004, 8616, 963, 16, 110, "Text",
  CellTags->"b:1.3"],
Cell[423970, 8634, 111, 2, 25, "Text",
  CellTags->"b:1.3"],
Cell[424084, 8638, 433, 12, 25, "Text",
  CellTags->"b:1.3"],
Cell[424520, 8652, 663, 13, 93, "Text",
  CellTags->"b:1.3"],
Cell[425186, 8667, 483, 11, 59, "Text",
  CellTags->"b:1.3"],
Cell[425672, 8680, 119, 2, 42, "FramedBox",
  CellTags->"b:1.3"],
Cell[425794, 8684, 563, 10, 76, "Text",
  CellTags->"b:1.3"],
Cell[426360, 8696, 454, 9, 59, "Text",
  CellTags->"b:1.3"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[426863, 8711, 87, 2, 40, "Subsection",
  CellTags->{"b:1.4", "c:9"}],
Cell[426953, 8715, 177, 4, 42, "Reference",
  CellTags->"b:1.4"],
Cell[427133, 8721, 302, 6, 76, "Reference",
  CellTags->"b:1.4"],
Cell[427438, 8729, 302, 6, 76, "Reference",
  CellTags->"b:1.4"],
Cell[427743, 8737, 315, 6, 76, "Reference",
  CellTags->"b:1.4"],
Cell[428061, 8745, 187, 4, 42, "Reference",
  CellTags->"b:1.4"],
Cell[428251, 8751, 182, 4, 42, "Reference",
  CellTags->"b:1.4"],
Cell[428436, 8757, 230, 5, 59, "Reference",
  CellTags->"b:1.4"],
Cell[428669, 8764, 294, 6, 76, "Reference",
  CellTags->"b:1.4"],
Cell[428966, 8772, 327, 6, 59, "Reference",
  CellTags->"b:1.4"],
Cell[429296, 8780, 184, 4, 25, "Reference",
  CellTags->"b:1.4"],
Cell[429483, 8786, 180, 4, 25, "Reference",
  CellTags->"b:1.4"],
Cell[429666, 8792, 274, 5, 42, "Reference",
  CellTags->"b:1.4"],
Cell[429943, 8799, 297, 6, 42, "Reference",
  CellTags->"b:1.4"],
Cell[430243, 8807, 179, 4, 42, "Reference",
  CellTags->"b:1.4"],
Cell[430425, 8813, 121, 3, 25, "Reference",
  CellTags->"b:1.4"],
Cell[430549, 8818, 123, 3, 25, "Reference",
  CellTags->"b:1.4"],
Cell[430675, 8823, 208, 5, 59, "Reference",
  CellTags->"b:1.4"],
Cell[430886, 8830, 221, 5, 59, "Reference",
  CellTags->"b:1.4"],
Cell[431110, 8837, 257, 5, 59, "Reference",
  CellTags->"b:1.4"],
Cell[431370, 8844, 241, 5, 59, "Reference",
  CellTags->"b:1.4"],
Cell[431614, 8851, 172, 4, 42, "Reference",
  CellTags->"b:1.4"],
Cell[431789, 8857, 266, 9, 42, "Reference",
  CellTags->"b:1.4"],
Cell[432058, 8868, 268, 5, 59, "Reference",
  CellTags->"b:1.4"],
Cell[432329, 8875, 186, 4, 42, "Reference",
  CellTags->"b:1.4"],
Cell[432518, 8881, 191, 4, 42, "Reference",
  CellTags->"b:1.4"],
Cell[432712, 8887, 267, 5, 59, "Reference",
  CellTags->"b:1.4"],
Cell[432982, 8894, 160, 4, 42, "Reference",
  CellTags->"b:1.4"],
Cell[433145, 8900, 148, 4, 42, "Reference",
  CellTags->"b:1.4"],
Cell[433296, 8906, 202, 4, 59, "Reference",
  CellTags->"b:1.4"]
}, Closed]],

Cell[CellGroupData[{
Cell[433535, 8915, 69, 1, 40, "Subsection",
  CellTags->{"b:1.5", "c:10"}],
Cell[433607, 8918, 407, 9, 76, "Text",
  CellTags->"b:1.5"],
Cell[434017, 8929, 426, 11, 84, "Text",
  CellTags->"b:1.5"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[434492, 8946, 42, 0, 39, "Section"],

Cell[CellGroupData[{
Cell[434559, 8950, 131, 4, 40, "Subsection"],
Cell[434693, 8956, 432, 8, 56, "Text"],
Cell[435128, 8966, 191, 5, 24, "Text"],
Cell[435322, 8973, 196, 5, 41, "FramedBox"],
Cell[435521, 8980, 16, 0, 24, "Text"],
Cell[435540, 8982, 132, 3, 24, "Text"],

Cell[CellGroupData[{
Cell[435697, 8989, 74, 2, 26, "Input"],
Cell[435774, 8993, 217, 7, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[436028, 9005, 75, 2, 26, "Input"],
Cell[436106, 9009, 64, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[436207, 9016, 74, 2, 26, "Input"],
Cell[436284, 9020, 77, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[436398, 9027, 103, 2, 26, "Input"],
Cell[436504, 9031, 233, 7, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[436774, 9043, 130, 3, 26, "Input"],
Cell[436907, 9048, 233, 7, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[437177, 9060, 99, 2, 26, "Input"],
Cell[437279, 9064, 232, 7, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[437548, 9076, 127, 3, 26, "Input"],
Cell[437678, 9081, 231, 7, 38, "Output"]
}, Open  ]],
Cell[437924, 9091, 87, 2, 26, "Input"],

Cell[CellGroupData[{
Cell[438036, 9097, 80, 2, 26, "Input"],
Cell[438119, 9101, 83, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[438239, 9108, 73, 2, 26, "Input"],
Cell[438315, 9112, 116, 2, 27, "Output"]
}, Open  ]],
Cell[438446, 9117, 76, 2, 26, "Input"],

Cell[CellGroupData[{
Cell[438547, 9123, 71, 2, 26, "Input"],
Cell[438621, 9127, 109, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[438767, 9134, 84, 2, 26, "Input"],
Cell[438854, 9138, 250, 7, 38, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[439141, 9150, 86, 2, 26, "Input"],
Cell[439230, 9154, 250, 7, 38, "Output"]
}, Open  ]]
}, Open  ]],
Cell[439507, 9165, 66, 0, 40, "Subsection"]
}, Open  ]],

Cell[CellGroupData[{
Cell[439610, 9170, 54, 1, 65, "Section",
  CellTags->"c:11"],

Cell[CellGroupData[{
Cell[439689, 9175, 82, 1, 38, "ObjectName",
  CellTags->{"i:1", "b:2.0", "c:12"}],
Cell[439774, 9178, 1085, 38, 124, "Usage",
  CellTags->"b:2.0"],
Cell[440862, 9218, 280, 7, 40, "Notes",
  CellTags->"b:2.0"],
Cell[441145, 9227, 331, 10, 40, "Notes",
  CellTags->"b:2.0"],
Cell[441479, 9239, 556, 15, 56, "Notes",
  CellTags->"b:2.0"],
Cell[442038, 9256, 441, 8, 72, "Notes",
  CellTags->"b:2.0"],
Cell[442482, 9266, 222, 9, 24, "Notes",
  CellTags->"b:2.0"],
Cell[442707, 9277, 155, 6, 24, "Notes",
  CellTags->"b:2.0"],

Cell[CellGroupData[{
Cell[442887, 9287, 63, 1, 38, "ExampleSection",
  CellTags->"b:2.0"],
Cell[442953, 9290, 87, 1, 34, "ExampleText",
  CellTags->"b:2.0"],
Cell[443043, 9293, 96, 3, 26, "Input",
  CellTags->"b:2.0"],
Cell[443142, 9298, 92, 1, 34, "ExampleText",
  CellTags->"b:2.0"],

Cell[CellGroupData[{
Cell[443259, 9303, 197, 6, 26, "Input",
  CellTags->"b:2.0"],
Cell[443459, 9311, 501, 9, 66, "Output",
  CellTags->"b:2.0"]
}, Open  ]],
Cell[443975, 9323, 139, 4, 34, "ExampleText",
  CellTags->"b:2.0"],

Cell[CellGroupData[{
Cell[444139, 9331, 103, 3, 26, "Input",
  CellTags->"b:2.0"],
Cell[444245, 9336, 83, 3, 25, "Output",
  CellTags->"b:2.0"]
}, Open  ]],
Cell[444343, 9342, 203, 4, 50, "ExampleText",
  CellTags->"b:2.0"],

Cell[CellGroupData[{
Cell[444571, 9350, 116, 3, 26, "Input",
  CellTags->"b:2.0"],
Cell[444690, 9355, 83, 3, 25, "Output",
  CellTags->"b:2.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[444810, 9363, 90, 3, 26, "Input",
  CellTags->"b:2.0"],
Cell[444903, 9368, 272, 5, 47, "Output",
  CellTags->"b:2.0"]
}, Open  ]],

Cell[CellGroupData[{
Cell[445212, 9378, 104, 3, 26, "Input",
  CellTags->"b:2.0"],
Cell[445319, 9383, 83, 3, 25, "Output",
  CellTags->"b:2.0"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[445463, 9393, 80, 1, 42, "ObjectName",
  CellTags->{"i:13", "b:2.1", "c:13"}],
Cell[445546, 9396, 881, 40, 54, "Usage",
  CellTags->"b:2.1"],
Cell[446430, 9438, 278, 6, 40, "Notes",
  CellTags->"b:2.1"],
Cell[446711, 9446, 324, 6, 56, "Notes",
  CellTags->"b:2.1"],
Cell[447038, 9454, 222, 9, 24, "Notes",
  CellTags->"b:2.1"],
Cell[447263, 9465, 292, 12, 24, "Notes",
  CellTags->"b:2.1"],

Cell[CellGroupData[{
Cell[447580, 9481, 63, 1, 38, "ExampleSection",
  CellTags->"b:2.1"],
Cell[447646, 9484, 87, 1, 34, "ExampleText",
  CellTags->"b:2.1"],
Cell[447736, 9487, 96, 3, 26, "Input",
  CellTags->"b:2.1"],
Cell[447835, 9492, 83, 1, 34, "ExampleText",
  CellTags->"b:2.1"],

Cell[CellGroupData[{
Cell[447943, 9497, 170, 5, 26, "Input",
  CellTags->"b:2.1"],
Cell[448116, 9504, 188, 4, 28, "Output",
  CellTags->"b:2.1"]
}, Open  ]],

Cell[CellGroupData[{
Cell[448341, 9513, 172, 5, 31, "Input",
  CellTags->"b:2.1"],
Cell[448516, 9520, 168, 4, 28, "Output",
  CellTags->"b:2.1"]
}, Open  ]],
Cell[448699, 9527, 250, 9, 34, "ExampleText",
  CellTags->"b:2.1"],

Cell[CellGroupData[{
Cell[448974, 9540, 118, 3, 26, "Input",
  CellTags->"b:2.1"],
Cell[449095, 9545, 174, 4, 18, "Message",
  CellTags->"b:2.1"],
Cell[449272, 9551, 224, 5, 28, "Output",
  CellTags->"b:2.1"]
}, Open  ]],
Cell[449511, 9559, 230, 9, 34, "ExampleText",
  CellTags->"b:2.1"],

Cell[CellGroupData[{
Cell[449766, 9572, 124, 3, 26, "Input",
  CellTags->"b:2.1"],
Cell[449893, 9577, 84, 3, 25, "Output",
  CellTags->"b:2.1"]
}, Open  ]],
Cell[449992, 9583, 219, 9, 34, "ExampleText",
  CellTags->"b:2.1"],

Cell[CellGroupData[{
Cell[450236, 9596, 124, 3, 26, "Input",
  CellTags->"b:2.1"],
Cell[450363, 9601, 185, 4, 28, "Output",
  CellTags->"b:2.1"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[450609, 9612, 80, 1, 42, "ObjectName",
  CellTags->{"i:14", "b:2.2", "c:14"}],
Cell[450692, 9615, 878, 39, 54, "Usage",
  CellTags->"b:2.2"],
Cell[451573, 9656, 278, 6, 40, "Notes",
  CellTags->"b:2.2"],
Cell[451854, 9664, 324, 6, 56, "Notes",
  CellTags->"b:2.2"],
Cell[452181, 9672, 222, 9, 24, "Notes",
  CellTags->"b:2.2"],
Cell[452406, 9683, 292, 12, 24, "Notes",
  CellTags->"b:2.2"],

Cell[CellGroupData[{
Cell[452723, 9699, 63, 1, 38, "ExampleSection",
  CellTags->"b:2.2"],
Cell[452789, 9702, 162, 6, 34, "ExampleText",
  CellTags->"b:2.2"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[453000, 9714, 73, 1, 42, "ObjectName",
  CellTags->{"i:15", "b:2.3", "c:15"}],
Cell[453076, 9717, 287, 12, 32, "Usage",
  CellTags->"b:2.3"],
Cell[453366, 9731, 222, 9, 24, "Notes",
  CellTags->"b:2.3"],
Cell[453591, 9742, 150, 6, 24, "Notes",
  CellTags->"b:2.3"],

Cell[CellGroupData[{
Cell[453766, 9752, 63, 1, 38, "ExampleSection",
  CellTags->"b:2.3"],
Cell[453832, 9755, 87, 1, 34, "ExampleText",
  CellTags->"b:2.3"],
Cell[453922, 9758, 96, 3, 26, "Input",
  CellTags->"b:2.3"],
Cell[454021, 9763, 73, 1, 34, "ExampleText",
  CellTags->"b:2.3"],

Cell[CellGroupData[{
Cell[454119, 9768, 111, 3, 26, "Input",
  CellTags->"b:2.3"],
Cell[454233, 9773, 267, 8, 38, "Output",
  CellTags->"b:2.3"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[454561, 9788, 69, 1, 42, "ObjectName",
  CellTags->{"i:16", "b:2.4", "c:16"}],
Cell[454633, 9791, 750, 34, 54, "Usage",
  CellTags->"b:2.4"],
Cell[455386, 9827, 278, 6, 40, "Notes",
  CellTags->"b:2.4"],
Cell[455667, 9835, 177, 4, 24, "Notes",
  CellTags->"b:2.4"],
Cell[455847, 9841, 222, 9, 24, "Notes",
  CellTags->"b:2.4"],
Cell[456072, 9852, 381, 15, 24, "Notes",
  CellTags->"b:2.4"],

Cell[CellGroupData[{
Cell[456478, 9871, 63, 1, 38, "ExampleSection",
  CellTags->"b:2.4"],
Cell[456544, 9874, 87, 1, 34, "ExampleText",
  CellTags->"b:2.4"],
Cell[456634, 9877, 96, 3, 26, "Input",
  CellTags->"b:2.4"],
Cell[456733, 9882, 83, 1, 34, "ExampleText",
  CellTags->"b:2.4"],

Cell[CellGroupData[{
Cell[456841, 9887, 170, 5, 26, "Input",
  CellTags->"b:2.4"],
Cell[457014, 9894, 188, 4, 28, "Output",
  CellTags->"b:2.4"]
}, Open  ]],

Cell[CellGroupData[{
Cell[457239, 9903, 137, 3, 31, "Input",
  CellTags->"b:2.4"],
Cell[457379, 9908, 168, 4, 28, "Output",
  CellTags->"b:2.4"]
}, Open  ]],
Cell[457562, 9915, 161, 4, 34, "ExampleText",
  CellTags->"b:2.4"],

Cell[CellGroupData[{
Cell[457748, 9923, 121, 3, 26, "Input",
  CellTags->"b:2.4"],
Cell[457872, 9928, 89, 3, 43, "Output",
  CellTags->"b:2.4"]
}, Open  ]],
Cell[457976, 9934, 280, 6, 50, "ExampleText",
  CellTags->"b:2.4"],

Cell[CellGroupData[{
Cell[458281, 9944, 93, 3, 26, "Input",
  CellTags->"b:2.4"],
Cell[458377, 9949, 198, 5, 18, "Message",
  CellTags->"b:2.4"],
Cell[458578, 9956, 84, 3, 25, "Output",
  CellTags->"b:2.4"]
}, Open  ]],

Cell[CellGroupData[{
Cell[458699, 9964, 105, 3, 26, "Input",
  CellTags->"b:2.4"],
Cell[458807, 9969, 87, 3, 25, "Output",
  CellTags->"b:2.4"]
}, Open  ]],

Cell[CellGroupData[{
Cell[458931, 9977, 110, 3, 26, "Input",
  CellTags->"b:2.4"],
Cell[459044, 9982, 174, 4, 18, "Message",
  CellTags->"b:2.4"],
Cell[459221, 9988, 224, 5, 28, "Output",
  CellTags->"b:2.4"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[459506, 10000, 62, 1, 42, "ObjectName",
  CellTags->{"i:17", "b:2.5", "c:17"}],
Cell[459571, 10003, 117, 3, 24, "Notes",
  CellTags->"b:2.5"],
Cell[459691, 10008, 222, 9, 24, "Notes",
  CellTags->"b:2.5"],
Cell[459916, 10019, 150, 6, 24, "Notes",
  CellTags->"b:2.5"]
}, Closed]],

Cell[CellGroupData[{
Cell[460103, 10030, 68, 1, 42, "ObjectName",
  CellTags->{"i:18", "b:2.6", "c:18"}],
Cell[460174, 10033, 451, 21, 32, "Usage",
  CellTags->"b:2.6"],
Cell[460628, 10056, 278, 6, 40, "Notes",
  CellTags->"b:2.6"],
Cell[460909, 10064, 222, 9, 24, "Notes",
  CellTags->"b:2.6"],
Cell[461134, 10075, 209, 9, 24, "Notes",
  CellTags->"b:2.6"],

Cell[CellGroupData[{
Cell[461368, 10088, 63, 1, 38, "ExampleSection",
  CellTags->"b:2.6"],
Cell[461434, 10091, 87, 1, 34, "ExampleText",
  CellTags->"b:2.6"],
Cell[461524, 10094, 96, 3, 26, "Input",
  CellTags->"b:2.6"],
Cell[461623, 10099, 115, 3, 34, "ExampleText",
  CellTags->"b:2.6"],

Cell[CellGroupData[{
Cell[461763, 10106, 170, 5, 26, "Input",
  CellTags->"b:2.6"],
Cell[461936, 10113, 188, 4, 28, "Output",
  CellTags->"b:2.6"]
}, Open  ]],

Cell[CellGroupData[{
Cell[462161, 10122, 91, 3, 26, "Input",
  CellTags->"b:2.6"],
Cell[462255, 10127, 141, 4, 28, "Output",
  CellTags->"b:2.6"]
}, Open  ]],
Cell[462411, 10134, 213, 6, 34, "ExampleText",
  CellTags->"b:2.6"],

Cell[CellGroupData[{
Cell[462649, 10144, 114, 3, 26, "Input",
  CellTags->"b:2.6"],
Cell[462766, 10149, 84, 3, 25, "Output",
  CellTags->"b:2.6"]
}, Open  ]],

Cell[CellGroupData[{
Cell[462887, 10157, 114, 3, 26, "Input",
  CellTags->"b:2.6"],
Cell[463004, 10162, 85, 3, 25, "Output",
  CellTags->"b:2.6"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[463150, 10172, 67, 1, 42, "ObjectName",
  CellTags->{"i:19", "b:2.7", "c:19"}],
Cell[463220, 10175, 117, 3, 24, "Notes",
  CellTags->"b:2.7"],
Cell[463340, 10180, 222, 9, 24, "Notes",
  CellTags->"b:2.7"],
Cell[463565, 10191, 155, 6, 24, "Notes",
  CellTags->"b:2.7"]
}, Closed]],

Cell[CellGroupData[{
Cell[463757, 10202, 69, 1, 42, "ObjectName",
  CellTags->{"i:20", "b:2.8", "c:20"}],
Cell[463829, 10205, 117, 3, 24, "Notes",
  CellTags->"b:2.8"],
Cell[463949, 10210, 222, 9, 24, "Notes",
  CellTags->"b:2.8"],
Cell[464174, 10221, 157, 6, 24, "Notes",
  CellTags->"b:2.8"]
}, Closed]],

Cell[CellGroupData[{
Cell[464368, 10232, 70, 1, 42, "ObjectName",
  CellTags->{"i:21", "b:2.9", "c:21"}],
Cell[464441, 10235, 485, 21, 32, "Usage",
  CellTags->"b:2.9"],
Cell[464929, 10258, 147, 4, 24, "Notes",
  CellTags->"b:2.9"],

Cell[CellGroupData[{
Cell[465101, 10266, 63, 1, 38, "ExampleSection",
  CellTags->"b:2.9"],
Cell[465167, 10269, 67, 1, 34, "ExampleText",
  CellTags->"b:2.9"],
Cell[465237, 10272, 72, 2, 26, "Input",
  CellTags->"b:2.9"],
Cell[465312, 10276, 72, 1, 34, "ExampleText",
  CellTags->"b:2.9"],
Cell[465387, 10279, 149, 4, 26, "Input",
  CellTags->"b:2.9"],
Cell[465539, 10285, 70, 1, 34, "ExampleText",
  CellTags->"b:2.9"],
Cell[465612, 10288, 108, 3, 26, "Input",
  CellTags->"b:2.9"],
Cell[465723, 10293, 84, 1, 34, "ExampleText",
  CellTags->"b:2.9"],
Cell[465810, 10296, 72, 2, 26, "Input",
  CellTags->"b:2.9"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[465931, 10304, 68, 1, 42, "ObjectName",
  CellTags->{"i:22", "b:2.10", "c:22"}],
Cell[466002, 10307, 574, 23, 54, "Usage",
  CellTags->"b:2.10"],
Cell[466579, 10332, 237, 5, 40, "Notes",
  CellTags->"b:2.10"],
Cell[466819, 10339, 294, 6, 40, "Notes",
  CellTags->"b:2.10"],
Cell[467116, 10347, 223, 9, 24, "Notes",
  CellTags->"b:2.10"],
Cell[467342, 10358, 300, 12, 24, "Notes",
  CellTags->"b:2.10"],

Cell[CellGroupData[{
Cell[467667, 10374, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.10"],
Cell[467734, 10377, 88, 1, 34, "ExampleText",
  CellTags->"b:2.10"],
Cell[467825, 10380, 97, 3, 26, "Input",
  CellTags->"b:2.10"],
Cell[467925, 10385, 93, 1, 34, "ExampleText",
  CellTags->"b:2.10"],

Cell[CellGroupData[{
Cell[468043, 10390, 166, 5, 26, "Input",
  CellTags->"b:2.10"],
Cell[468212, 10397, 237, 5, 28, "Output",
  CellTags->"b:2.10"]
}, Open  ]],

Cell[CellGroupData[{
Cell[468486, 10407, 95, 3, 26, "Input",
  CellTags->"b:2.10"],
Cell[468584, 10412, 154, 4, 30, "Output",
  CellTags->"b:2.10"]
}, Open  ]],
Cell[468753, 10419, 166, 4, 34, "ExampleText",
  CellTags->"b:2.10"],

Cell[CellGroupData[{
Cell[468944, 10427, 93, 3, 26, "Input",
  CellTags->"b:2.10"],
Cell[469040, 10432, 311, 6, 66, "Output",
  CellTags->"b:2.10"]
}, Open  ]],

Cell[CellGroupData[{
Cell[469388, 10443, 97, 3, 26, "Input",
  CellTags->"b:2.10"],
Cell[469488, 10448, 625, 11, 105, "Output",
  CellTags->"b:2.10"]
}, Open  ]],
Cell[470128, 10462, 119, 3, 34, "ExampleText",
  CellTags->"b:2.10"],

Cell[CellGroupData[{
Cell[470272, 10469, 107, 3, 26, "Input",
  CellTags->"b:2.10"],
Cell[470382, 10474, 442, 9, 52, "Output",
  CellTags->"b:2.10"]
}, Open  ]],

Cell[CellGroupData[{
Cell[470861, 10488, 111, 3, 26, "Input",
  CellTags->"b:2.10"],
Cell[470975, 10493, 473, 10, 52, "Output",
  CellTags->"b:2.10"]
}, Open  ]],
Cell[471463, 10506, 155, 4, 34, "ExampleText",
  CellTags->"b:2.10"],

Cell[CellGroupData[{
Cell[471643, 10514, 95, 3, 26, "Input",
  CellTags->"b:2.10"],
Cell[471741, 10519, 293, 6, 44, "Message",
  CellTags->"b:2.10"],
Cell[472037, 10527, 293, 6, 44, "Message",
  CellTags->"b:2.10"],
Cell[472333, 10535, 293, 6, 44, "Message",
  CellTags->"b:2.10"],
Cell[472629, 10543, 392, 7, 31, "Message",
  CellTags->"b:2.10"],
Cell[473024, 10552, 442, 9, 52, "Output",
  CellTags->"b:2.10"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[473527, 10568, 72, 1, 42, "ObjectName",
  CellTags->{"i:23", "b:2.11", "c:23"}],
Cell[473602, 10571, 582, 23, 54, "Usage",
  CellTags->"b:2.11"],
Cell[474187, 10596, 237, 5, 40, "Notes",
  CellTags->"b:2.11"],
Cell[474427, 10603, 294, 6, 40, "Notes",
  CellTags->"b:2.11"],
Cell[474724, 10611, 223, 9, 24, "Notes",
  CellTags->"b:2.11"],
Cell[474950, 10622, 296, 12, 24, "Notes",
  CellTags->"b:2.11"],

Cell[CellGroupData[{
Cell[475271, 10638, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.11"],
Cell[475338, 10641, 150, 6, 34, "ExampleText",
  CellTags->"b:2.11"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[475537, 10653, 72, 1, 42, "ObjectName",
  CellTags->{"i:24", "b:2.12", "c:24"}],
Cell[475612, 10656, 285, 12, 32, "Usage",
  CellTags->"b:2.12"],
Cell[475900, 10670, 223, 9, 24, "Notes",
  CellTags->"b:2.12"],
Cell[476126, 10681, 153, 6, 24, "Notes",
  CellTags->"b:2.12"],

Cell[CellGroupData[{
Cell[476304, 10691, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.12"],
Cell[476371, 10694, 88, 1, 34, "ExampleText",
  CellTags->"b:2.12"],
Cell[476462, 10697, 97, 3, 26, "Input",
  CellTags->"b:2.12"],
Cell[476562, 10702, 73, 1, 34, "ExampleText",
  CellTags->"b:2.12"],

Cell[CellGroupData[{
Cell[476660, 10707, 110, 3, 26, "Input",
  CellTags->"b:2.12"],
Cell[476773, 10712, 268, 8, 38, "Output",
  CellTags->"b:2.12"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[477102, 10727, 68, 1, 42, "ObjectName",
  CellTags->{"i:25", "b:2.13", "c:25"}],
Cell[477173, 10730, 944, 41, 70, "Usage",
  CellTags->"b:2.13"],
Cell[478120, 10773, 248, 5, 40, "Notes",
  CellTags->"b:2.13"],
Cell[478371, 10780, 218, 5, 40, "Notes",
  CellTags->"b:2.13"],
Cell[478592, 10787, 223, 9, 24, "Notes",
  CellTags->"b:2.13"],
Cell[478818, 10798, 156, 6, 24, "Notes",
  CellTags->"b:2.13"],

Cell[CellGroupData[{
Cell[478999, 10808, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.13"],
Cell[479066, 10811, 88, 1, 34, "ExampleText",
  CellTags->"b:2.13"],
Cell[479157, 10814, 97, 3, 26, "Input",
  CellTags->"b:2.13"],
Cell[479257, 10819, 116, 3, 34, "ExampleText",
  CellTags->"b:2.13"],

Cell[CellGroupData[{
Cell[479398, 10826, 170, 5, 26, "Input",
  CellTags->"b:2.13"],
Cell[479571, 10833, 188, 4, 28, "Output",
  CellTags->"b:2.13"]
}, Open  ]],
Cell[479774, 10840, 126, 3, 34, "ExampleText",
  CellTags->"b:2.13"],

Cell[CellGroupData[{
Cell[479925, 10847, 107, 3, 26, "Input",
  CellTags->"b:2.13"],
Cell[480035, 10852, 474, 10, 41, "Output",
  CellTags->"b:2.13"]
}, Open  ]],

Cell[CellGroupData[{
Cell[480546, 10867, 93, 3, 26, "Input",
  CellTags->"b:2.13"],
Cell[480642, 10872, 377, 7, 52, "Output",
  CellTags->"b:2.13"]
}, Open  ]],
Cell[481034, 10882, 240, 5, 50, "ExampleText",
  CellTags->"b:2.13"],

Cell[CellGroupData[{
Cell[481299, 10891, 127, 3, 26, "Input",
  CellTags->"b:2.13"],
Cell[481429, 10896, 607, 11, 73, "Output",
  CellTags->"b:2.13"]
}, Open  ]],

Cell[CellGroupData[{
Cell[482073, 10912, 94, 3, 26, "Input",
  CellTags->"b:2.13"],
Cell[482170, 10917, 386, 7, 52, "Output",
  CellTags->"b:2.13"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[482617, 10931, 75, 1, 42, "ObjectName",
  CellTags->{"i:26", "b:2.14", "c:26"}],
Cell[482695, 10934, 1766, 63, 72, "Usage",
  CellTags->"b:2.14"],
Cell[484464, 10999, 253, 5, 40, "Notes",
  CellTags->"b:2.14"],
Cell[484720, 11006, 446, 8, 72, "Notes",
  CellTags->"b:2.14"],
Cell[485169, 11016, 223, 9, 24, "Notes",
  CellTags->"b:2.14"],
Cell[485395, 11027, 377, 15, 24, "Notes",
  CellTags->"b:2.14"],

Cell[CellGroupData[{
Cell[485797, 11046, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.14"],
Cell[485864, 11049, 88, 1, 34, "ExampleText",
  CellTags->"b:2.14"],
Cell[485955, 11052, 97, 3, 26, "Input",
  CellTags->"b:2.14"],
Cell[486055, 11057, 84, 1, 34, "ExampleText",
  CellTags->"b:2.14"],

Cell[CellGroupData[{
Cell[486164, 11062, 170, 5, 26, "Input",
  CellTags->"b:2.14"],
Cell[486337, 11069, 188, 4, 28, "Output",
  CellTags->"b:2.14"]
}, Open  ]],

Cell[CellGroupData[{
Cell[486562, 11078, 172, 5, 31, "Input",
  CellTags->"b:2.14"],
Cell[486737, 11085, 168, 4, 28, "Output",
  CellTags->"b:2.14"]
}, Open  ]],
Cell[486920, 11092, 106, 2, 34, "ExampleText",
  CellTags->"b:2.14"],

Cell[CellGroupData[{
Cell[487051, 11098, 121, 3, 26, "Input",
  CellTags->"b:2.14"],
Cell[487175, 11103, 89, 3, 43, "Output",
  CellTags->"b:2.14"]
}, Open  ]],
Cell[487279, 11109, 251, 9, 34, "ExampleText",
  CellTags->"b:2.14"],

Cell[CellGroupData[{
Cell[487555, 11122, 110, 3, 26, "Input",
  CellTags->"b:2.14"],
Cell[487668, 11127, 175, 4, 18, "Message",
  CellTags->"b:2.14"],
Cell[487846, 11133, 225, 5, 28, "Output",
  CellTags->"b:2.14"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[488132, 11145, 76, 1, 42, "ObjectName",
  CellTags->{"i:27", "b:2.15", "c:27"}],
Cell[488211, 11148, 558, 24, 54, "Usage",
  CellTags->"b:2.15"],
Cell[488772, 11174, 172, 4, 24, "Notes",
  CellTags->"b:2.15"],
Cell[488947, 11180, 525, 18, 40, "Notes",
  CellTags->"b:2.15"],
Cell[489475, 11200, 223, 9, 24, "Notes",
  CellTags->"b:2.15"],
Cell[489701, 11211, 145, 6, 24, "Notes",
  CellTags->"b:2.15"],

Cell[CellGroupData[{
Cell[489871, 11221, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.15"],
Cell[489938, 11224, 88, 1, 34, "ExampleText",
  CellTags->"b:2.15"],
Cell[490029, 11227, 97, 3, 26, "Input",
  CellTags->"b:2.15"],
Cell[490129, 11232, 107, 2, 34, "ExampleText",
  CellTags->"b:2.15"],

Cell[CellGroupData[{
Cell[490261, 11238, 100, 3, 26, "Input",
  CellTags->"b:2.15"],
Cell[490364, 11243, 83, 3, 32, "Output",
  CellTags->"b:2.15"]
}, Open  ]],
Cell[490462, 11249, 94, 1, 34, "ExampleText",
  CellTags->"b:2.15"],

Cell[CellGroupData[{
Cell[490581, 11254, 125, 3, 26, "Input",
  CellTags->"b:2.15"],
Cell[490709, 11259, 81, 3, 25, "Output",
  CellTags->"b:2.15"]
}, Open  ]],

Cell[CellGroupData[{
Cell[490827, 11267, 125, 3, 26, "Input",
  CellTags->"b:2.15"],
Cell[490955, 11272, 81, 3, 25, "Output",
  CellTags->"b:2.15"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[491097, 11282, 80, 1, 42, "ObjectName",
  CellTags->{"i:28", "b:2.16", "c:28"}],
Cell[491180, 11285, 539, 21, 48, "Usage",
  CellTags->"b:2.16"],
Cell[491722, 11308, 279, 6, 40, "Notes",
  CellTags->"b:2.16"],
Cell[492004, 11316, 194, 4, 40, "Notes",
  CellTags->"b:2.16"],
Cell[492201, 11322, 223, 9, 24, "Notes",
  CellTags->"b:2.16"],
Cell[492427, 11333, 315, 12, 24, "Notes",
  CellTags->"b:2.16"],

Cell[CellGroupData[{
Cell[492767, 11349, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.16"],
Cell[492834, 11352, 88, 1, 34, "ExampleText",
  CellTags->"b:2.16"],
Cell[492925, 11355, 97, 3, 26, "Input",
  CellTags->"b:2.16"],
Cell[493025, 11360, 118, 3, 34, "ExampleText",
  CellTags->"b:2.16"],

Cell[CellGroupData[{
Cell[493168, 11367, 171, 5, 26, "Input",
  CellTags->"b:2.16"],
Cell[493342, 11374, 189, 4, 28, "Output",
  CellTags->"b:2.16"]
}, Open  ]],

Cell[CellGroupData[{
Cell[493568, 11383, 102, 3, 26, "Input",
  CellTags->"b:2.16"],
Cell[493673, 11388, 124, 3, 28, "Output",
  CellTags->"b:2.16"]
}, Open  ]],
Cell[493812, 11394, 254, 9, 34, "ExampleText",
  CellTags->"b:2.16"],

Cell[CellGroupData[{
Cell[494091, 11407, 107, 3, 26, "Input",
  CellTags->"b:2.16"],
Cell[494201, 11412, 135, 3, 28, "Output",
  CellTags->"b:2.16"]
}, Open  ]],

Cell[CellGroupData[{
Cell[494373, 11420, 88, 3, 26, "Input",
  CellTags->"b:2.16"],
Cell[494464, 11425, 85, 3, 25, "Output",
  CellTags->"b:2.16"]
}, Open  ]],

Cell[CellGroupData[{
Cell[494586, 11433, 93, 3, 26, "Input",
  CellTags->"b:2.16"],
Cell[494682, 11438, 130, 3, 28, "Output",
  CellTags->"b:2.16"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[494873, 11448, 78, 1, 42, "ObjectName",
  CellTags->{"i:29", "b:2.17", "c:29"}],
Cell[494954, 11451, 1560, 59, 50, "Usage",
  CellTags->"b:2.17"],
Cell[496517, 11512, 279, 6, 40, "Notes",
  CellTags->"b:2.17"],
Cell[496799, 11520, 236, 5, 40, "Notes",
  CellTags->"b:2.17"],
Cell[497038, 11527, 183, 4, 24, "Notes",
  CellTags->"b:2.17"],
Cell[497224, 11533, 133, 4, 24, "Notes",
  CellTags->"b:2.17"],
Cell[497360, 11539, 223, 9, 24, "Notes",
  CellTags->"b:2.17"],
Cell[497586, 11550, 234, 9, 24, "Notes",
  CellTags->"b:2.17"],

Cell[CellGroupData[{
Cell[497845, 11563, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.17"],
Cell[497912, 11566, 88, 1, 34, "ExampleText",
  CellTags->"b:2.17"],
Cell[498003, 11569, 97, 3, 26, "Input",
  CellTags->"b:2.17"],
Cell[498103, 11574, 118, 3, 34, "ExampleText",
  CellTags->"b:2.17"],

Cell[CellGroupData[{
Cell[498246, 11581, 170, 5, 26, "Input",
  CellTags->"b:2.17"],
Cell[498419, 11588, 188, 4, 28, "Output",
  CellTags->"b:2.17"]
}, Open  ]],

Cell[CellGroupData[{
Cell[498644, 11597, 101, 3, 26, "Input",
  CellTags->"b:2.17"],
Cell[498748, 11602, 123, 3, 28, "Output",
  CellTags->"b:2.17"]
}, Open  ]],
Cell[498886, 11608, 267, 9, 34, "ExampleText",
  CellTags->"b:2.17"],

Cell[CellGroupData[{
Cell[499178, 11621, 108, 3, 26, "Input",
  CellTags->"b:2.17"],
Cell[499289, 11626, 200, 5, 30, "Output",
  CellTags->"b:2.17"]
}, Open  ]],

Cell[CellGroupData[{
Cell[499526, 11636, 97, 3, 26, "Input",
  CellTags->"b:2.17"],
Cell[499626, 11641, 92, 3, 25, "Output",
  CellTags->"b:2.17"]
}, Open  ]],

Cell[CellGroupData[{
Cell[499755, 11649, 102, 3, 26, "Input",
  CellTags->"b:2.17"],
Cell[499860, 11654, 189, 4, 30, "Output",
  CellTags->"b:2.17"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[500110, 11665, 81, 1, 42, "ObjectName",
  CellTags->{"i:30", "b:2.18", "c:30"}],
Cell[500194, 11668, 540, 21, 48, "Usage",
  CellTags->"b:2.18"],
Cell[500737, 11691, 279, 6, 40, "Notes",
  CellTags->"b:2.18"],
Cell[501019, 11699, 194, 4, 40, "Notes",
  CellTags->"b:2.18"],
Cell[501216, 11705, 223, 9, 24, "Notes",
  CellTags->"b:2.18"],
Cell[501442, 11716, 315, 12, 24, "Notes",
  CellTags->"b:2.18"],

Cell[CellGroupData[{
Cell[501782, 11732, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.18"],
Cell[501849, 11735, 88, 1, 34, "ExampleText",
  CellTags->"b:2.18"],
Cell[501940, 11738, 97, 3, 26, "Input",
  CellTags->"b:2.18"],
Cell[502040, 11743, 118, 3, 34, "ExampleText",
  CellTags->"b:2.18"],

Cell[CellGroupData[{
Cell[502183, 11750, 171, 5, 26, "Input",
  CellTags->"b:2.18"],
Cell[502357, 11757, 189, 4, 28, "Output",
  CellTags->"b:2.18"]
}, Open  ]],

Cell[CellGroupData[{
Cell[502583, 11766, 102, 3, 26, "Input",
  CellTags->"b:2.18"],
Cell[502688, 11771, 124, 3, 28, "Output",
  CellTags->"b:2.18"]
}, Open  ]],
Cell[502827, 11777, 255, 9, 34, "ExampleText",
  CellTags->"b:2.18"],

Cell[CellGroupData[{
Cell[503107, 11790, 108, 3, 26, "Input",
  CellTags->"b:2.18"],
Cell[503218, 11795, 128, 3, 28, "Output",
  CellTags->"b:2.18"]
}, Open  ]],

Cell[CellGroupData[{
Cell[503383, 11803, 88, 3, 26, "Input",
  CellTags->"b:2.18"],
Cell[503474, 11808, 85, 3, 25, "Output",
  CellTags->"b:2.18"]
}, Open  ]],

Cell[CellGroupData[{
Cell[503596, 11816, 93, 3, 26, "Input",
  CellTags->"b:2.18"],
Cell[503692, 11821, 130, 3, 28, "Output",
  CellTags->"b:2.18"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[503883, 11831, 76, 1, 42, "ObjectName",
  CellTags->{"i:2", "b:2.19", "c:31"}],
Cell[503962, 11834, 543, 23, 54, "Usage",
  CellTags->"b:2.19"],
Cell[504508, 11859, 244, 5, 40, "Notes",
  CellTags->"b:2.19"],
Cell[504755, 11866, 304, 10, 24, "Notes",
  CellTags->"b:2.19"],
Cell[505062, 11878, 523, 15, 56, "Notes",
  CellTags->"b:2.19"],
Cell[505588, 11895, 442, 8, 72, "Notes",
  CellTags->"b:2.19"],
Cell[506033, 11905, 223, 9, 24, "Notes",
  CellTags->"b:2.19"],
Cell[506259, 11916, 163, 6, 24, "Notes",
  CellTags->"b:2.19"],

Cell[CellGroupData[{
Cell[506447, 11926, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.19"],
Cell[506514, 11929, 88, 1, 34, "ExampleText",
  CellTags->"b:2.19"],
Cell[506605, 11932, 97, 3, 26, "Input",
  CellTags->"b:2.19"],
Cell[506705, 11937, 93, 1, 34, "ExampleText",
  CellTags->"b:2.19"],

Cell[CellGroupData[{
Cell[506823, 11942, 198, 6, 26, "Input",
  CellTags->"b:2.19"],
Cell[507024, 11950, 502, 9, 66, "Output",
  CellTags->"b:2.19"]
}, Open  ]],
Cell[507541, 11962, 293, 9, 34, "ExampleText",
  CellTags->"b:2.19"],

Cell[CellGroupData[{
Cell[507859, 11975, 97, 3, 26, "Input",
  CellTags->"b:2.19"],
Cell[507959, 11980, 119, 3, 25, "Output",
  CellTags->"b:2.19"]
}, Open  ]],
Cell[508093, 11986, 281, 6, 50, "ExampleText",
  CellTags->"b:2.19"],

Cell[CellGroupData[{
Cell[508399, 11996, 128, 3, 26, "Input",
  CellTags->"b:2.19"],
Cell[508530, 12001, 119, 3, 25, "Output",
  CellTags->"b:2.19"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[508710, 12011, 74, 1, 42, "ObjectName",
  CellTags->{"i:31", "b:2.20", "c:32"}],
Cell[508787, 12014, 755, 33, 54, "Usage",
  CellTags->"b:2.20"],
Cell[509545, 12049, 261, 5, 40, "Notes",
  CellTags->"b:2.20"],
Cell[509809, 12056, 223, 9, 24, "Notes",
  CellTags->"b:2.20"],
Cell[510035, 12067, 150, 6, 24, "Notes",
  CellTags->"b:2.20"],

Cell[CellGroupData[{
Cell[510210, 12077, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.20"],
Cell[510277, 12080, 88, 1, 34, "ExampleText",
  CellTags->"b:2.20"],
Cell[510368, 12083, 97, 3, 26, "Input",
  CellTags->"b:2.20"],
Cell[510468, 12088, 116, 3, 34, "ExampleText",
  CellTags->"b:2.20"],

Cell[CellGroupData[{
Cell[510609, 12095, 170, 5, 26, "Input",
  CellTags->"b:2.20"],
Cell[510782, 12102, 188, 4, 28, "Output",
  CellTags->"b:2.20"]
}, Open  ]],

Cell[CellGroupData[{
Cell[511007, 12111, 92, 3, 26, "Input",
  CellTags->"b:2.20"],
Cell[511102, 12116, 142, 4, 28, "Output",
  CellTags->"b:2.20"]
}, Open  ]],
Cell[511259, 12123, 115, 3, 34, "ExampleText",
  CellTags->"b:2.20"],

Cell[CellGroupData[{
Cell[511399, 12130, 113, 3, 26, "Input",
  CellTags->"b:2.20"],
Cell[511515, 12135, 189, 4, 28, "Output",
  CellTags->"b:2.20"]
}, Open  ]],

Cell[CellGroupData[{
Cell[511741, 12144, 93, 3, 26, "Input",
  CellTags->"b:2.20"],
Cell[511837, 12149, 123, 3, 28, "Output",
  CellTags->"b:2.20"]
}, Open  ]],
Cell[511975, 12155, 97, 1, 34, "ExampleText",
  CellTags->"b:2.20"],

Cell[CellGroupData[{
Cell[512097, 12160, 125, 3, 26, "Input",
  CellTags->"b:2.20"],
Cell[512225, 12165, 237, 8, 38, "Output",
  CellTags->"b:2.20"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[512523, 12180, 93, 1, 42, "ObjectName",
  CellTags->{"i:32", "b:2.21", "c:33"}],
Cell[512619, 12183, 324, 11, 48, "Usage",
  CellTags->"b:2.21"],
Cell[512946, 12196, 255, 5, 40, "Notes",
  CellTags->"b:2.21"],
Cell[513204, 12203, 223, 9, 24, "Notes",
  CellTags->"b:2.21"],
Cell[513430, 12214, 167, 6, 24, "Notes",
  CellTags->"b:2.21"],

Cell[CellGroupData[{
Cell[513622, 12224, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.21"],
Cell[513689, 12227, 88, 1, 34, "ExampleText",
  CellTags->"b:2.21"],
Cell[513780, 12230, 97, 3, 26, "Input",
  CellTags->"b:2.21"],
Cell[513880, 12235, 89, 1, 34, "ExampleText",
  CellTags->"b:2.21"],

Cell[CellGroupData[{
Cell[513994, 12240, 106, 3, 26, "Input",
  CellTags->"b:2.21"],
Cell[514103, 12245, 168, 4, 25, "Output",
  CellTags->"b:2.21"]
}, Open  ]],
Cell[514286, 12252, 348, 11, 50, "ExampleText",
  CellTags->"b:2.21"],

Cell[CellGroupData[{
Cell[514659, 12267, 114, 3, 26, "Input",
  CellTags->"b:2.21"],
Cell[514776, 12272, 170, 4, 25, "Output",
  CellTags->"b:2.21"]
}, Open  ]],

Cell[CellGroupData[{
Cell[514983, 12281, 94, 3, 26, "Input",
  CellTags->"b:2.21"],
Cell[515080, 12286, 202, 4, 30, "Output",
  CellTags->"b:2.21"]
}, Open  ]],
Cell[515297, 12293, 289, 8, 50, "ExampleText",
  CellTags->"b:2.21"],

Cell[CellGroupData[{
Cell[515611, 12305, 100, 3, 26, "Input",
  CellTags->"b:2.21"],
Cell[515714, 12310, 170, 4, 25, "Output",
  CellTags->"b:2.21"]
}, Open  ]],

Cell[CellGroupData[{
Cell[515921, 12319, 94, 3, 26, "Input",
  CellTags->"b:2.21"],
Cell[516018, 12324, 200, 4, 30, "Output",
  CellTags->"b:2.21"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[516279, 12335, 66, 1, 42, "ObjectName",
  CellTags->{"i:33", "b:2.22", "c:34"}],
Cell[516348, 12338, 607, 27, 54, "Usage",
  CellTags->"b:2.22"],
Cell[516958, 12367, 247, 5, 40, "Notes",
  CellTags->"b:2.22"],
Cell[517208, 12374, 563, 18, 56, "Notes",
  CellTags->"b:2.22"],
Cell[517774, 12394, 266, 7, 40, "Notes",
  CellTags->"b:2.22"],
Cell[518043, 12403, 231, 7, 24, "Notes",
  CellTags->"b:2.22"],
Cell[518277, 12412, 223, 9, 24, "Notes",
  CellTags->"b:2.22"],
Cell[518503, 12423, 410, 18, 24, "Notes",
  CellTags->"b:2.22"],

Cell[CellGroupData[{
Cell[518938, 12445, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.22"],
Cell[519005, 12448, 88, 1, 34, "ExampleText",
  CellTags->"b:2.22"],
Cell[519096, 12451, 97, 3, 26, "Input",
  CellTags->"b:2.22"],
Cell[519196, 12456, 116, 3, 34, "ExampleText",
  CellTags->"b:2.22"],

Cell[CellGroupData[{
Cell[519337, 12463, 170, 5, 26, "Input",
  CellTags->"b:2.22"],
Cell[519510, 12470, 188, 4, 28, "Output",
  CellTags->"b:2.22"]
}, Open  ]],
Cell[519713, 12477, 133, 4, 34, "ExampleText",
  CellTags->"b:2.22"],

Cell[CellGroupData[{
Cell[519871, 12485, 90, 3, 26, "Input",
  CellTags->"b:2.22"],
Cell[519964, 12490, 609, 14, 102, "Output",
  CellTags->"b:2.22"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[520634, 12511, 71, 1, 42, "ObjectName",
  CellTags->{"i:34", "b:2.23", "c:35"}],
Cell[520708, 12514, 533, 21, 54, "Usage",
  CellTags->"b:2.23"],
Cell[521244, 12537, 261, 5, 40, "Notes",
  CellTags->"b:2.23"],
Cell[521508, 12544, 223, 9, 24, "Notes",
  CellTags->"b:2.23"],
Cell[521734, 12555, 153, 6, 24, "Notes",
  CellTags->"b:2.23"],

Cell[CellGroupData[{
Cell[521912, 12565, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.23"],
Cell[521979, 12568, 88, 1, 34, "ExampleText",
  CellTags->"b:2.23"],
Cell[522070, 12571, 97, 3, 26, "Input",
  CellTags->"b:2.23"],
Cell[522170, 12576, 116, 3, 34, "ExampleText",
  CellTags->"b:2.23"],

Cell[CellGroupData[{
Cell[522311, 12583, 170, 5, 26, "Input",
  CellTags->"b:2.23"],
Cell[522484, 12590, 188, 4, 28, "Output",
  CellTags->"b:2.23"]
}, Open  ]],
Cell[522687, 12597, 98, 1, 34, "ExampleText",
  CellTags->"b:2.23"],

Cell[CellGroupData[{
Cell[522810, 12602, 91, 3, 26, "Input",
  CellTags->"b:2.23"],
Cell[522904, 12607, 141, 4, 28, "Output",
  CellTags->"b:2.23"]
}, Open  ]],
Cell[523060, 12614, 121, 3, 34, "ExampleText",
  CellTags->"b:2.23"],

Cell[CellGroupData[{
Cell[523206, 12621, 96, 3, 26, "Input",
  CellTags->"b:2.23"],
Cell[523305, 12626, 140, 4, 28, "Output",
  CellTags->"b:2.23"]
}, Open  ]],

Cell[CellGroupData[{
Cell[523482, 12635, 108, 3, 26, "Input",
  CellTags->"b:2.23"],
Cell[523593, 12640, 137, 3, 28, "Output",
  CellTags->"b:2.23"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[523791, 12650, 75, 1, 42, "ObjectName",
  CellTags->{"i:35", "b:2.24", "c:36"}],
Cell[523869, 12653, 520, 21, 48, "Usage",
  CellTags->"b:2.24"],
Cell[524392, 12676, 247, 5, 40, "Notes",
  CellTags->"b:2.24"],
Cell[524642, 12683, 339, 12, 40, "Notes",
  CellTags->"b:2.24"],
Cell[524984, 12697, 223, 9, 24, "Notes",
  CellTags->"b:2.24"],
Cell[525210, 12708, 401, 18, 24, "Notes",
  CellTags->"b:2.24"],

Cell[CellGroupData[{
Cell[525636, 12730, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.24"],
Cell[525703, 12733, 88, 1, 34, "ExampleText",
  CellTags->"b:2.24"],
Cell[525794, 12736, 97, 3, 26, "Input",
  CellTags->"b:2.24"],
Cell[525894, 12741, 116, 3, 34, "ExampleText",
  CellTags->"b:2.24"],

Cell[CellGroupData[{
Cell[526035, 12748, 170, 5, 26, "Input",
  CellTags->"b:2.24"],
Cell[526208, 12755, 188, 4, 28, "Output",
  CellTags->"b:2.24"]
}, Open  ]],
Cell[526411, 12762, 133, 4, 34, "ExampleText",
  CellTags->"b:2.24"],

Cell[CellGroupData[{
Cell[526569, 12770, 125, 3, 26, "Input",
  CellTags->"b:2.24"],
Cell[526697, 12775, 188, 4, 28, "Output",
  CellTags->"b:2.24"]
}, Open  ]],
Cell[526900, 12782, 89, 1, 34, "ExampleText",
  CellTags->"b:2.24"],

Cell[CellGroupData[{
Cell[527014, 12787, 91, 3, 26, "Input",
  CellTags->"b:2.24"],
Cell[527108, 12792, 141, 4, 28, "Output",
  CellTags->"b:2.24"]
}, Open  ]],

Cell[CellGroupData[{
Cell[527286, 12801, 92, 3, 26, "Input",
  CellTags->"b:2.24"],
Cell[527381, 12806, 128, 3, 28, "Output",
  CellTags->"b:2.24"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[527570, 12816, 71, 1, 42, "ObjectName",
  CellTags->{"i:36", "b:2.25", "c:37"}],
Cell[527644, 12819, 118, 3, 24, "Notes",
  CellTags->"b:2.25"],
Cell[527765, 12824, 223, 9, 24, "Notes",
  CellTags->"b:2.25"],
Cell[527991, 12835, 159, 6, 24, "Notes",
  CellTags->"b:2.25"]
}, Closed]],

Cell[CellGroupData[{
Cell[528187, 12846, 87, 1, 42, "ObjectName",
  CellTags->{"i:37", "b:2.26", "c:38"}],
Cell[528277, 12849, 297, 12, 32, "Usage",
  CellTags->"b:2.26"],
Cell[528577, 12863, 209, 5, 40, "Notes",
  CellTags->"b:2.26"],
Cell[528789, 12870, 139, 4, 24, "Notes",
  CellTags->"b:2.26"],
Cell[528931, 12876, 227, 5, 40, "Notes",
  CellTags->"b:2.26"],
Cell[529161, 12883, 223, 9, 24, "Notes",
  CellTags->"b:2.26"],

Cell[CellGroupData[{
Cell[529409, 12896, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.26"],
Cell[529476, 12899, 88, 1, 34, "ExampleText",
  CellTags->"b:2.26"],
Cell[529567, 12902, 97, 3, 26, "Input",
  CellTags->"b:2.26"],
Cell[529667, 12907, 106, 2, 34, "ExampleText",
  CellTags->"b:2.26"],

Cell[CellGroupData[{
Cell[529798, 12913, 163, 5, 26, "Input",
  CellTags->"b:2.26"],
Cell[529964, 12920, 189, 4, 28, "Output",
  CellTags->"b:2.26"]
}, Open  ]],

Cell[CellGroupData[{
Cell[530190, 12929, 115, 3, 26, "Input",
  CellTags->"b:2.26"],
Cell[530308, 12934, 308, 6, 25, "Output",
  CellTags->"b:2.26"]
}, Open  ]],
Cell[530631, 12943, 123, 3, 34, "ExampleText",
  CellTags->"b:2.26"],

Cell[CellGroupData[{
Cell[530779, 12950, 114, 3, 26, "Input",
  CellTags->"b:2.26"],
Cell[530896, 12955, 175, 4, 18, "Message",
  CellTags->"b:2.26"],
Cell[531074, 12961, 259, 6, 28, "Output",
  CellTags->"b:2.26"]
}, Open  ]],

Cell[CellGroupData[{
Cell[531370, 12972, 117, 3, 26, "Input",
  CellTags->"b:2.26"],
Cell[531490, 12977, 215, 5, 25, "Output",
  CellTags->"b:2.26"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[531766, 12989, 67, 1, 42, "ObjectName",
  CellTags->{"i:38", "b:2.27", "c:39"}],
Cell[531836, 12992, 324, 15, 32, "Usage",
  CellTags->"b:2.27"],
Cell[532163, 13009, 223, 9, 24, "Notes",
  CellTags->"b:2.27"],
Cell[532389, 13020, 207, 9, 24, "Notes",
  CellTags->"b:2.27"],

Cell[CellGroupData[{
Cell[532621, 13033, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.27"],
Cell[532688, 13036, 88, 1, 34, "ExampleText",
  CellTags->"b:2.27"],
Cell[532779, 13039, 97, 3, 26, "Input",
  CellTags->"b:2.27"],
Cell[532879, 13044, 116, 3, 34, "ExampleText",
  CellTags->"b:2.27"],

Cell[CellGroupData[{
Cell[533020, 13051, 170, 5, 26, "Input",
  CellTags->"b:2.27"],
Cell[533193, 13058, 188, 4, 28, "Output",
  CellTags->"b:2.27"]
}, Open  ]],
Cell[533396, 13065, 178, 5, 34, "ExampleText",
  CellTags->"b:2.27"],

Cell[CellGroupData[{
Cell[533599, 13074, 88, 3, 26, "Input",
  CellTags->"b:2.27"],
Cell[533690, 13079, 85, 3, 25, "Output",
  CellTags->"b:2.27"]
}, Open  ]],

Cell[CellGroupData[{
Cell[533812, 13087, 96, 3, 26, "Input",
  CellTags->"b:2.27"],
Cell[533911, 13092, 86, 3, 25, "Output",
  CellTags->"b:2.27"]
}, Open  ]],

Cell[CellGroupData[{
Cell[534034, 13100, 166, 5, 26, "Input",
  CellTags->"b:2.27"],
Cell[534203, 13107, 86, 3, 25, "Output",
  CellTags->"b:2.27"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[534350, 13117, 68, 1, 42, "ObjectName",
  CellTags->{"i:39", "b:2.28", "c:40"}],
Cell[534421, 13120, 286, 12, 32, "Usage",
  CellTags->"b:2.28"],
Cell[534710, 13134, 132, 4, 24, "Notes",
  CellTags->"b:2.28"],
Cell[534845, 13140, 223, 9, 24, "Notes",
  CellTags->"b:2.28"],
Cell[535071, 13151, 206, 9, 24, "Notes",
  CellTags->"b:2.28"],

Cell[CellGroupData[{
Cell[535302, 13164, 64, 1, 38, "ExampleSection",
  CellTags->"b:2.28"],
Cell[535369, 13167, 149, 6, 34, "ExampleText",
  CellTags->"b:2.28"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

