(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     11386,        499]*)
(*NotebookOutlinePosition[     16454,        660]*)
(*  CellTagsIndexPosition[     15304,        621]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["SNAP", "IndexSection",
  CellTags->"MasterIndexHeading"],

Cell[TextData[{
  "AbsolutelyIrreducibleQ",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:26"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.3",
    ButtonData:>{"SNAP1.3", "i:29"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.0",
    ButtonData:>{"SNAP2.0", "i:30"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"AbsolutelyIrreducibleQ"],

Cell[TextData[{
  "ApproximateDivisorQ",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:26"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.3",
    ButtonData:>{"SNAP1.3", "i:29"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.1",
    ButtonData:>{"SNAP2.1", "i:31"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ApproximateDivisorQ"],

Cell[TextData[{
  "ApproximateQuotient",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:26"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.3",
    ButtonData:>{"SNAP1.3", "i:29"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.2",
    ButtonData:>{"SNAP2.2", "i:32"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ApproximateQuotient"],

Cell[TextData[{
  "CeilingFloat",
  ", ",
  ButtonBox["SNAP2.3",
    ButtonData:>{"SNAP2.3", "i:33"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CeilingFloat"],

Cell[TextData[{
  "CoprimeQ",
  ", ",
  ButtonBox["SNAP1.3",
    ButtonData:>{"SNAP1.3", "i:29"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.4",
    ButtonData:>{"SNAP2.4", "i:34"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"CoprimeQ"],

Cell[TextData[{
  "D",
  ", ",
  ButtonBox["SNAP1.2",
    ButtonData:>{"SNAP1.2", "i:28"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.5",
    ButtonData:>{"SNAP2.5", "i:35"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"D"],

Cell[TextData[{
  "DefaultErrorScheme",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:24"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"DefaultErrorScheme"],

Cell[TextData[{
  "Element",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:23"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.1",
    ButtonData:>{"SNAP1.1", "i:27"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.6",
    ButtonData:>{"SNAP2.6", "i:36"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Element"],

Cell[TextData[{
  "Expand",
  ", ",
  ButtonBox["SNAP1.1",
    ButtonData:>{"SNAP1.1", "i:27"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.7",
    ButtonData:>{"SNAP2.7", "i:37"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Expand"],

Cell[TextData[{
  "Exponent",
  ", ",
  ButtonBox["SNAP2.8",
    ButtonData:>{"SNAP2.8", "i:38"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Exponent"],

Cell[TextData[{
  "ExportSWF",
  ", ",
  ButtonBox["SNAP2.9",
    ButtonData:>{"SNAP2.9", "i:39"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ExportSWF"],

Cell[TextData[{
  "Factor",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:26"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.3",
    ButtonData:>{"SNAP1.3", "i:29"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.10",
    ButtonData:>{"SNAP2.10", "i:40"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Factor"],

Cell[TextData[{
  "FactorList",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:26"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.3",
    ButtonData:>{"SNAP1.3", "i:29"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.11",
    ButtonData:>{"SNAP2.11", "i:41"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FactorList"],

Cell[TextData[{
  "FloorFloat",
  ", ",
  ButtonBox["SNAP2.12",
    ButtonData:>{"SNAP2.12", "i:42"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"FloorFloat"],

Cell[TextData[{
  "NearestSingularPolynomial",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:26"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.3",
    ButtonData:>{"SNAP1.3", "i:29"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.26",
    ButtonData:>{"SNAP2.26", "i:56"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NearestSingularPolynomial"],

Cell[TextData[{
  "Normal",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:23"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.1",
    ButtonData:>{"SNAP1.1", "i:27"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.28",
    ButtonData:>{"SNAP2.28", "i:58"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Normal"],

Cell[TextData[{
  "NotSNAPQ",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:23"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NotSNAPQ"],

Cell[TextData[{
  "NSolve",
  ", ",
  ButtonBox["SNAP1.2",
    ButtonData:>{"SNAP1.2", "i:28"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.13",
    ButtonData:>{"SNAP2.13", "i:43"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"NSolve"],

Cell[TextData[{
  "PolynomialGCD",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:26"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.3",
    ButtonData:>{"SNAP1.3", "i:29"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.14",
    ButtonData:>{"SNAP2.14", "i:44"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PolynomialGCD"],

Cell[TextData[{
  "PolynomialNorm",
  ", ",
  ButtonBox["SNAP2.15",
    ButtonData:>{"SNAP2.15", "i:45"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PolynomialNorm"],

Cell[TextData[{
  "PolynomialQuotient",
  ", ",
  ButtonBox["SNAP1.2",
    ButtonData:>{"SNAP1.2", "i:28"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.16",
    ButtonData:>{"SNAP2.16", "i:46"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PolynomialQuotient"],

Cell[TextData[{
  "PolynomialReduce",
  ", ",
  ButtonBox["SNAP1.2",
    ButtonData:>{"SNAP1.2", "i:28"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.17",
    ButtonData:>{"SNAP2.17", "i:47"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PolynomialReduce"],

Cell[TextData[{
  "PolynomialRemainder",
  ", ",
  ButtonBox["SNAP1.2",
    ButtonData:>{"SNAP1.2", "i:28"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.18",
    ButtonData:>{"SNAP2.18", "i:48"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"PolynomialRemainder"],

Cell[TextData[{
  "ReplaceAll",
  ", ",
  ButtonBox["SNAP1.1",
    ButtonData:>{"SNAP1.1", "i:27"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"ReplaceAll"],

Cell[TextData[{
  "SeparationBound",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:26"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.3",
    ButtonData:>{"SNAP1.3", "i:29"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.19",
    ButtonData:>{"SNAP2.19", "i:49"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SeparationBound"],

Cell[TextData[{
  "SetTolerance",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:25"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.1",
    ButtonData:>{"SNAP1.1", "i:27"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.20",
    ButtonData:>{"SNAP2.20", "i:50"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SetTolerance"],

Cell[TextData[{
  "SingularValueListWithErrorBound",
  ", ",
  ButtonBox["SNAP2.21",
    ButtonData:>{"SNAP2.21", "i:51"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SingularValueListWithErrorBound"],

Cell[TextData[{
  "SNAP",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:22"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.1",
    ButtonData:>{"SNAP1.1", "i:27"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.22",
    ButtonData:>{"SNAP2.22", "i:52"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SNAP"],

Cell[TextData[{
  "SNAPQ",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:23"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.1",
    ButtonData:>{"SNAP1.1", "i:27"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.27",
    ButtonData:>{"SNAP2.27", "i:57"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"SNAPQ"],

Cell[TextData[{
  "Tolerance",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:23"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.1",
    ButtonData:>{"SNAP1.1", "i:27"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.23",
    ButtonData:>{"SNAP2.23", "i:53"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Tolerance"],

Cell[TextData[{
  "TolerancePrecision",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:24"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TolerancePrecision"],

Cell[TextData[{
  "TransformSNAP",
  ", ",
  ButtonBox["SNAP0.0",
    ButtonData:>{"SNAP0.0", "i:25"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP1.1",
    ButtonData:>{"SNAP1.1", "i:27"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SNAP2.24",
    ButtonData:>{"SNAP2.24", "i:54"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"TransformSNAP"],

Cell[TextData[{
  "Variables",
  ", ",
  ButtonBox["SNAP2.25",
    ButtonData:>{"SNAP2.25", "i:55"},
    ButtonStyle->"AddOnsLink"]
}], "Index",
  CellTags->"Variables"]
},
FrontEndVersion->"5.0 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
WindowSize->{570, 600},
WindowMargins->{{Automatic, 349}, {191, Automatic}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "MasterIndexHeading"->{
    Cell[1754, 51, 62, 1, 41, "IndexSection",
      CellTags->"MasterIndexHeading"]},
  "AbsolutelyIrreducibleQ"->{
    Cell[1819, 54, 393, 15, 16, "Index",
      CellTags->"AbsolutelyIrreducibleQ"]},
  "ApproximateDivisorQ"->{
    Cell[2215, 71, 387, 15, 16, "Index",
      CellTags->"ApproximateDivisorQ"]},
  "ApproximateQuotient"->{
    Cell[2605, 88, 387, 15, 16, "Index",
      CellTags->"ApproximateQuotient"]},
  "CeilingFloat"->{
    Cell[2995, 105, 173, 7, 16, "Index",
      CellTags->"CeilingFloat"]},
  "CoprimeQ"->{
    Cell[3171, 114, 265, 11, 16, "Index",
      CellTags->"CoprimeQ"]},
  "D"->{
    Cell[3439, 127, 251, 11, 16, "Index",
      CellTags->"D"]},
  "DefaultErrorScheme"->{
    Cell[3693, 140, 185, 7, 16, "Index",
      CellTags->"DefaultErrorScheme"]},
  "Element"->{
    Cell[3881, 149, 363, 15, 16, "Index",
      CellTags->"Element"]},
  "Expand"->{
    Cell[4247, 166, 261, 11, 16, "Index",
      CellTags->"Expand"]},
  "Exponent"->{
    Cell[4511, 179, 165, 7, 16, "Index",
      CellTags->"Exponent"]},
  "ExportSWF"->{
    Cell[4679, 188, 167, 7, 16, "Index",
      CellTags->"ExportSWF"]},
  "Factor"->{
    Cell[4849, 197, 363, 15, 16, "Index",
      CellTags->"Factor"]},
  "FactorList"->{
    Cell[5215, 214, 371, 15, 16, "Index",
      CellTags->"FactorList"]},
  "FloorFloat"->{
    Cell[5589, 231, 171, 7, 16, "Index",
      CellTags->"FloorFloat"]},
  "NearestSingularPolynomial"->{
    Cell[5763, 240, 401, 15, 16, "Index",
      CellTags->"NearestSingularPolynomial"]},
  "Normal"->{
    Cell[6167, 257, 363, 15, 16, "Index",
      CellTags->"Normal"]},
  "NotSNAPQ"->{
    Cell[6533, 274, 165, 7, 16, "Index",
      CellTags->"NotSNAPQ"]},
  "NSolve"->{
    Cell[6701, 283, 263, 11, 16, "Index",
      CellTags->"NSolve"]},
  "PolynomialGCD"->{
    Cell[6967, 296, 377, 15, 16, "Index",
      CellTags->"PolynomialGCD"]},
  "PolynomialNorm"->{
    Cell[7347, 313, 179, 7, 16, "Index",
      CellTags->"PolynomialNorm"]},
  "PolynomialQuotient"->{
    Cell[7529, 322, 287, 11, 16, "Index",
      CellTags->"PolynomialQuotient"]},
  "PolynomialReduce"->{
    Cell[7819, 335, 283, 11, 16, "Index",
      CellTags->"PolynomialReduce"]},
  "PolynomialRemainder"->{
    Cell[8105, 348, 289, 11, 16, "Index",
      CellTags->"PolynomialRemainder"]},
  "ReplaceAll"->{
    Cell[8397, 361, 169, 7, 16, "Index",
      CellTags->"ReplaceAll"]},
  "SeparationBound"->{
    Cell[8569, 370, 381, 15, 16, "Index",
      CellTags->"SeparationBound"]},
  "SetTolerance"->{
    Cell[8953, 387, 375, 15, 16, "Index",
      CellTags->"SetTolerance"]},
  "SingularValueListWithErrorBound"->{
    Cell[9331, 404, 213, 7, 16, "Index",
      CellTags->"SingularValueListWithErrorBound"]},
  "SNAP"->{
    Cell[9547, 413, 359, 15, 16, "Index",
      CellTags->"SNAP"]},
  "SNAPQ"->{
    Cell[9909, 430, 361, 15, 16, "Index",
      CellTags->"SNAPQ"]},
  "Tolerance"->{
    Cell[10273, 447, 369, 15, 16, "Index",
      CellTags->"Tolerance"]},
  "TolerancePrecision"->{
    Cell[10645, 464, 185, 7, 16, "Index",
      CellTags->"TolerancePrecision"]},
  "TransformSNAP"->{
    Cell[10833, 473, 377, 15, 16, "Index",
      CellTags->"TransformSNAP"]},
  "Variables"->{
    Cell[11213, 490, 169, 7, 16, "Index",
      CellTags->"Variables"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"MasterIndexHeading", 12015, 515},
  {"AbsolutelyIrreducibleQ", 12131, 518},
  {"ApproximateDivisorQ", 12243, 521},
  {"ApproximateQuotient", 12352, 524},
  {"CeilingFloat", 12454, 527},
  {"CoprimeQ", 12545, 530},
  {"D", 12626, 533},
  {"DefaultErrorScheme", 12717, 536},
  {"Element", 12813, 539},
  {"Expand", 12898, 542},
  {"Exponent", 12984, 545},
  {"ExportSWF", 13072, 548},
  {"Factor", 13158, 551},
  {"FactorList", 13246, 554},
  {"FloorFloat", 13338, 557},
  {"NearestSingularPolynomial", 13444, 560},
  {"Normal", 13547, 563},
  {"NotSNAPQ", 13633, 566},
  {"NSolve", 13718, 569},
  {"PolynomialGCD", 13809, 572},
  {"PolynomialNorm", 13908, 575},
  {"PolynomialQuotient", 14011, 578},
  {"PolynomialReduce", 14117, 581},
  {"PolynomialRemainder", 14224, 584},
  {"ReplaceAll", 14325, 587},
  {"SeparationBound", 14421, 590},
  {"SetTolerance", 14520, 593},
  {"SingularValueListWithErrorBound", 14635, 596},
  {"SNAP", 14741, 599},
  {"SNAPQ", 14822, 602},
  {"Tolerance", 14908, 605},
  {"TolerancePrecision", 15008, 608},
  {"TransformSNAP", 15111, 611},
  {"Variables", 15206, 614}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 62, 1, 41, "IndexSection",
  CellTags->"MasterIndexHeading"],
Cell[1819, 54, 393, 15, 16, "Index",
  CellTags->"AbsolutelyIrreducibleQ"],
Cell[2215, 71, 387, 15, 16, "Index",
  CellTags->"ApproximateDivisorQ"],
Cell[2605, 88, 387, 15, 16, "Index",
  CellTags->"ApproximateQuotient"],
Cell[2995, 105, 173, 7, 16, "Index",
  CellTags->"CeilingFloat"],
Cell[3171, 114, 265, 11, 16, "Index",
  CellTags->"CoprimeQ"],
Cell[3439, 127, 251, 11, 16, "Index",
  CellTags->"D"],
Cell[3693, 140, 185, 7, 16, "Index",
  CellTags->"DefaultErrorScheme"],
Cell[3881, 149, 363, 15, 16, "Index",
  CellTags->"Element"],
Cell[4247, 166, 261, 11, 16, "Index",
  CellTags->"Expand"],
Cell[4511, 179, 165, 7, 16, "Index",
  CellTags->"Exponent"],
Cell[4679, 188, 167, 7, 16, "Index",
  CellTags->"ExportSWF"],
Cell[4849, 197, 363, 15, 16, "Index",
  CellTags->"Factor"],
Cell[5215, 214, 371, 15, 16, "Index",
  CellTags->"FactorList"],
Cell[5589, 231, 171, 7, 16, "Index",
  CellTags->"FloorFloat"],
Cell[5763, 240, 401, 15, 16, "Index",
  CellTags->"NearestSingularPolynomial"],
Cell[6167, 257, 363, 15, 16, "Index",
  CellTags->"Normal"],
Cell[6533, 274, 165, 7, 16, "Index",
  CellTags->"NotSNAPQ"],
Cell[6701, 283, 263, 11, 16, "Index",
  CellTags->"NSolve"],
Cell[6967, 296, 377, 15, 16, "Index",
  CellTags->"PolynomialGCD"],
Cell[7347, 313, 179, 7, 16, "Index",
  CellTags->"PolynomialNorm"],
Cell[7529, 322, 287, 11, 16, "Index",
  CellTags->"PolynomialQuotient"],
Cell[7819, 335, 283, 11, 16, "Index",
  CellTags->"PolynomialReduce"],
Cell[8105, 348, 289, 11, 16, "Index",
  CellTags->"PolynomialRemainder"],
Cell[8397, 361, 169, 7, 16, "Index",
  CellTags->"ReplaceAll"],
Cell[8569, 370, 381, 15, 16, "Index",
  CellTags->"SeparationBound"],
Cell[8953, 387, 375, 15, 16, "Index",
  CellTags->"SetTolerance"],
Cell[9331, 404, 213, 7, 16, "Index",
  CellTags->"SingularValueListWithErrorBound"],
Cell[9547, 413, 359, 15, 16, "Index",
  CellTags->"SNAP"],
Cell[9909, 430, 361, 15, 16, "Index",
  CellTags->"SNAPQ"],
Cell[10273, 447, 369, 15, 16, "Index",
  CellTags->"Tolerance"],
Cell[10645, 464, 185, 7, 16, "Index",
  CellTags->"TolerancePrecision"],
Cell[10833, 473, 377, 15, 16, "Index",
  CellTags->"TransformSNAP"],
Cell[11213, 490, 169, 7, 16, "Index",
  CellTags->"Variables"]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

