(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    300501,       6879]*)
(*NotebookOutlinePosition[    301435,       6911]*)
(*  CellTagsIndexPosition[    301345,       6905]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["SNAP`", "Subsection"],

Cell["\<\
\:3053\:306e\:30d1\:30c3\:30b1\:30fc\:30b8\:306f\:ff0c\:591a\:9805\
\:5f0f\:306b\:95a2\:3059\:308b\:6570\:5024\:30fb\:6570\:5f0f\:878d\:5408\:4ee3\
\:6570\:8a08\:7b97\:306e\:6a5f\:80fd\:3092\:63d0\:4f9b\:3057\:307e\:3059\:ff0e\
\:306a\:304a\:ff0c\:3053\:306e\:30d1\:30c3\:30b1\:30fc\:30b8\:306e\:8457\:4f5c\
\:6a29\:306f\:9577\:5742\:8015\:4f5c\:304c\:4fdd\:6301\:3057\:ff0c\:307e\:305f\
\:305d\:306e\:7814\:7a76\:958b\:767a\:306b\:3042\:305f\:3063\:3066\:306f\:ff0c\
\:65e5\:672c\:306e\:6587\:90e8\:79d1\:5b66\:7701\:306e\:79d1\:5b66\:7814\:7a76\
\:8cbb\:88dc\:52a9\:91d1\:306b\:3088\:308b\:52a9\:6210\:3092\:53d7\:3051\:3066\
\:3044\:307e\:3059\:ff0e\
\>", "Text"],

Cell["\:307e\:305a\:ff0c\:6b21\:306e\:30b3\:30de\:30f3\:30c9\:3067\:30d1\:30c3\
\:30b1\:30fc\:30b8\:3092\:8aad\:307f\:8fbc\:307f\:307e\:3059\:ff0e", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Needs["\<SNAP`\>"]\)], "Input",
  CellLabel->"In[1]:="],

Cell[BoxData[
    \("CGS package includes routines which calculate comprehensive Groebner \
System and related features for polynomials whose coefficients have unknown \
parameters. All Rights Reserved, Copyright (C)Kosaku Nagasaka, Kobe \
University 2006-2007. Kousaku Nagasaka makes no warranty of this software,and \
takes no responsibility to any result arising from your use of this \
software."\)], "Print",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[1]:="]
}, Open  ]],

Cell[TextData[Cell[BoxData[GridBox[{
        {Cell[GraphicsData["PostScript", "\<\
%!
                      %%Creator: Mathematica
                      %%AspectRatio: .40092 
                      %%ImageSize: 218 88 
                      MathPictureStart
                      /Mabs {
                      Mgmatrix idtransform
                      Mtmatrix dtransform
                      } bind def
                      /Mabsadd { Mabs
                      3 -1 roll add
                      3 1 roll add
                      exch } bind def
                      %% Graphics
                      %%IncludeResource: font Courier
                      %%IncludeFont: Courier
                      /Courier findfont 10  scalefont  setfont
                      % Scaling calculations
                      4.33681e-19 0.00460829 -0.00460829 0.00460829 [
                      [ 0 0 0 0 ]
                      [ 1 .40092 0 0 ]
                      ] MathScale
                      % Start of Graphics
                      1 setlinecap
                      1 setlinejoin
                      newpath
                      0 0 m
                      1 0 L
                      1 .40092 L
                      0 .40092 L
                      closepath
                      clip
                      newpath
                      % Start of colorimage (RGB)
                      p
                      0 -0.00461 translate
                      1.00461 .40553 scale
                      654 string
                      218 88 8 [218 0 0 88 0 0] {
                      \tcurrentfile
                      \t1 index
                      \treadhexstring
                      \tpop
                      }  false 3 Mcolorimage
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF4040FF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F\
7FFF7F7FFF7F7FFF
                      7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF2020FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF1010FF4040FF4040FF4040FF4040FF40\
40FF1010FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF2020FF
                      7070FF9999FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFEFEFFF
                      BFBFFF8F8FFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF7F\
7FFFAFAFFFBFBFFF
                      EFEFFFFFFFFFFFFFFFFFFFFFCCCCFFBFBFFF8F8FFF6666FF2020FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF66\
66FFDFDFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF9999FF3333FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF\
DFFF8F8FFF2020FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF3333FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      BFBFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F8FFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFBFBFFF2020FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCC\
CCFF1010FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFEFEFFF3333FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAFAFFF1010FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFCCCCFF
                      1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      AFAFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF10\
10FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFEFEFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF99\
99FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFF6666FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFDFDFFF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFEFEFFF1010FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFF9999FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFFFFFFFFFFFFF
                      FFFFFFEFEFFFBFBFFFBFBFFFBFBFFFCCCCFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFDFDFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FFFF\
FFFFFFFFFFEFEFFF
                      BFBFFFBFBFFFBFBFFFBFBFFFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      EFEFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF80\
80FFDFDFFF7070FF
                      2020FF0000FF0000FF0000FF0000FF0000FF1010FF7070FFEFEFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF8F\
8FFF3333FF0000FF
                      0000FF0000FF0000FF0000FF0000FF3333FF9999FFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF10\
10FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFCC\
CCFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFDFDFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF8F8FFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF10\
10FFEFEFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F\
7FFF7F7FFF7F7FFF
                      7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F7FFF7F\
7FFF7F7FFF7F7FFF
                      DFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FFEF\
EFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFCCCCFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF8F8FFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF40\
40FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF8080FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FFCCCCFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF8080FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFEFEFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF7070FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FFCCCCFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF4040FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF20\
20FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF8F8FFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF3333FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFAF\
AFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF5050FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF2020FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF4040FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF7070FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF4040FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2020FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF6666FFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFF8F8FFF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF2020FFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFF5050FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      BFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFAFAFFF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF9999FFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF\
DFFF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2020FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      BFBFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF6666FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF33\
33FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF2020FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8080FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      7070FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      DFDFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFDFDFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF9999FFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF5050FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFDF\
DFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6666FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFCCCCFF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF1010FF
                      EFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF2020FFCCCCFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF3333FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF10\
10FF9999FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF3333FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FFAFAFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF1010FF7070FFAFAFFFBF\
BFFFBFBFFF7070FF
                      1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFEFEFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF1010FF
                      6666FF8080FF9999FF8080FF8080FF3333FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF8F8FFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF4040FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF5050FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      6666FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF1010FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF10\
10FFDFDFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFCCCCFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8F8FFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      BFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF8F\
8FFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF1010FFEFEFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF4040FF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF3333FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FFCCCCFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFBFBFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF7070FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF3333FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF33\
33FFEFEFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      CCCCFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF1010FFEFEFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF3333FFEFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF1010FFCC\
CCFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      8F8FFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF7070FFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFEFEFFF1010FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF1010FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8F8FFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFAFAFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF99\
99FF1010FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF9999FFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF3333FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFEFEFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFEF\
EFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFCCCCFF1010FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF1010FFBFBFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFDFDFFF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF3333FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF1010FFBFBFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FFBF\
BFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFEFEFFF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFDFDFFF
                      4040FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF3333FFDFDFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFBFBFFF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF66\
66FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF40\
40FFDFDFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF1010FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF70\
70FFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFAFAFFF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF8F8FFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF1010FF7F7FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFBFBFFF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF8080FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFBFBFFF3333FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF2020FF9999FFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF10\
10FFEFEFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFF4040FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFEFEFFF6666FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF6666FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFBFBFFF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      BFBFFF5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF3333FF9999FFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF5050FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFF9999FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF3333FFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFDFDFFF7F7FFF2020FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF2020FF7F7FFF
                      DFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFBFBFFF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFEFEFFF9999FF6666FF3333FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF2020FF5050FF8F8FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFF9999FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF6666FF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF99\
99FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF6666FFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF8F8FFF40\
40FF2020FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF2020FF5050FF7F7FFFCC\
CCFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFBFBFFF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF1010FFBFBFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFFBF\
BFFFBFBFFFDFDFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFDFDFFF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      2020FFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF6666FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFBFBFFFBFBFFFBFBFFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FFAF\
AFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFBFBFFF7070FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2020FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF1010FF4040FF4040FF4040FF2020FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      2020FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7070FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF4040FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      6666FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDFDFFF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      AFAFFF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5050FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF2020FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6666FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF3333FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFDFDFFF1010FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF1010FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FFCCCCFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF8080FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBFBFFF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      8F8FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFF3333FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF99\
99FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF6666FF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFCCCCFF1010FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFF7070FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF3333FFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFBFBFFF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFF6666FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF33\
33FFEFEFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9999FF1010FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      9999FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF6666FFEF\
EFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF2020FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFBFBFFF2020FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF7F7FFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFF6666FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFEFEFFF6666FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF3333FFCCCCFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF\
BFFF4040FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFCCCCFF4040FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF2020FF9999FFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFBFBFFF
                      5050FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FFBFBFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCCCCFF6666FF1010FF00\
00FF0000FF0000FF
                      0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF5050FFAFAFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFEFEFFFAFAFFF6666FF4040FF0000FF0000FF0000FF0000FF00\
00FF0000FF0000FF
                      0000FF1010FF4040FF7F7FFFDFDFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF\
BFFF7F7FFF4040FF
                      1010FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF0000FF40\
40FF7070FFAFAFFF
                      EFEFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFEFFFBFBFFFBFBFFFBF\
BFFFBFBFFFBFBFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFCCCCFFBFBFFFBFBFFFBFBFFFBFBFFFEFEFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\
FFFFFFFFFFFFFFFF
                      FFFFFFFFFFFF
                      pop
                      P
                      % End of image
                      % End of Graphics
                      MathPictureEnd
                      \
\>"], "Graphics",
            ImageSize->{218, 88},
            ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003J0000F2000`400?l00000o`00003ofP000?l0
0=X0003o003J0000o`00fP000?l009h0003o00<0@43o07moo`1oOol03@1oOol00`0P8?l0003o0000
o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o02T0003o002N0000
o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0:@000?l009h0003o00<0P83o0?ooo`3o
ool03@3oool00`10@?l0003o0000o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`030410
o`000?l0003o02T0003o002N0000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0:@00
0?l009h0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0Y0000o`00WP000?l00`20
P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o02T0003o002N0000o`030820o`3oool0oooo00d0
oooo00<0@43o0000o`000?l0:@000?l009h0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o
0000o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o02T0003o002N
0000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0:@000?l009h0003o00<0P83o0?oo
o`3oool03@3oool00`10@?l0003o0000o`0Y0000o`00WP000?l00`20P?l0oooo0?ooo`0=0?ooo`03
0410o`000?l0003o02T0003o002N0000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l0
:@000?l009h0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0Y0000o`0040000?l0
0`0@4?l0@43o0410o`030410o`03010@o`000?l0003o08D0003o00<0P83o0?ooo`3oool03@3oool0
0`10@?l0003o0000o`0Y0000o`002`000?l0100P8?l0L73o09VIo`3<c?l80?ooo`040>o_o`2o_ol0
Shoo051@oh<0003o00<0P83o0?ooo`3oool03@3oool01`10@?l0003o0000o`1oOol0[joo0;noo`3_
kol00`3oool01@3<c?l0_koo08n?o`1VI_l0823o01d0003o00090000o`0306IVo`3Ogol0oooo0100
oooo00<0VIWo03<co`000?l04@000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0
003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0
oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0
003o0000o`0<0?ooo`030=oOo`2?Sol0823o01X0003o00090000o`030820o`3oool0oooo0180oooo
00<0_koo03<co`000?l03`000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o
3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo
0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o
0000o`0?0?ooo`030;noo`10@?l0003o01L0003o00090000o`030820o`3oool0oooo01@0oooo00<0
Shoo0000o`000?l03@000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3o
ool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?oo
o`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000
o`0A0?ooo`030;noo`0P8?l0003o01D0003o00090000o`030820o`3oool0oooo01D0oooo00<0c<co
010@o`000?l030000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool0
0`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>
0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0C
0?ooo`03071`o`000?l0003o01<0003o00090000o`030820o`3oool0oooo01H0oooo00<0knoo03<c
o`000?l02`000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o
_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?oo
o`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0D0?oo
o`030:n_o`0@4?l0003o0180003o00090000o`030820o`3oool0oooo01L0oooo00<0c<co010@o`00
0?l02P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0
003o0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`03
0820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0E0?ooo`03
0<c<o`0@4?l0003o0140003o00090000o`030820o`3oool0oooo01P0oooo00<0[joo0000o`000?l0
2@000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o
0000o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820
o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0F0?ooo`030<c<
o`0@4?l0003o0100003o00090000o`030820o`3oool0oooo01T0oooo00<0IVKo0000o`000?l02000
0?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000
o`060000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`00
0?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0G0?ooo`030<c<o`0@
4?l0003o00l0003o00090000o`030820o`3oool0oooo01T0oooo00<0knoo010@o`000?l020000?l0
0`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`06
0000o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0
003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0H0?ooo`0309VIo`000?l0
003o00h0003o00090000o`030820o`3oool0oooo01X0oooo00<0P83o0000o`000?l01`000?l00`20
P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000
o`030410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o
00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0I0?ooo`0306IVo`000?l0003o
00d0003o00090000o`030820o`3oool0oooo01X0oooo00<0gmoo0000o`000?l01`000?l00`20P?l0
oooo0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`03
0410o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0
003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0I0?ooo`030>o_o`0@4?l0003o00d0
003o00090000o`030820o`3oool0oooo01/0oooo00<0<c?o0000o`000?l01P000?l00`20P?l0oooo
0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410
o`3oool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o
00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0J0?ooo`0309VIo`000?l0003o00`0003o
00090000o`030820o`3oool0oooo01/0oooo00<0P83o0000o`000?l01P000?l00`20P?l0oooo0?oo
o`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3o
ool0oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0
P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0K0?ooo`03020Po`000?l0003o00/0003o0009
0000o`030820o`3oool0oooo01/0oooo00<0_koo0000o`000?l01P000?l00`20P?l0oooo0?ooo`0=
0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0
oooo00l0oooo3`000?l00`2o_ol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o
0?ooo`3oool03@3oool00`10@?l0003o0000o`0K0?ooo`0309VIo`000?l0003o00/0003o00090000
o`050820o`3oool0oooo0?ooo`3_kol00`2o_ol00`3<c?l0oooo0?ooo`0C0?ooo`030=oOo`000?l0
003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`080000o`l0oooo00<0_koo
0000o`000?l01P000?l00`10@?l0oooo0?ooo`0?0?ooo`l0003o00<0_koo0?ooo`3oool03P3oool0
0`20P?l0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l00P3oool0
0`3_kol0_koo0;noo`020;noo`030>o_o`3oool0oooo0140oooo00<0knoo0000o`000?l02`000?l0
00T0003o00@0P83o0=oOo`1`L?l0823o1@000?l00`0@4?l0L73o0>o_o`0C0?ooo`P0003o00<0P83o
0?ooo`3oool03@3oool00`10@?l0003o0000o`080000o`l0oooo00<0_koo0000o`000?l01P000?l0
0`10@?l0oooo0?ooo`0?0?ooo`l0003o00<0_koo0?ooo`3oool03P3oool00`20P?l0003o0000o`06
0000o`030820o`3oool0oooo00d0oooo00D0@43o0000o`000?l0Shoo03<co`060000o`0303<co`2I
VOl0oooo0140oooo00<0D53o0000o`000?l02P000?l000T0003o00<0413o0000o`000?l020000?l0
0`0@4?l0c<co0?ooo`0A0?ooo`P0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`08
0000o`l0oooo00<0_koo0000o`000?l01P000?l00`10@?l0oooo0?ooo`0?0?ooo`l0003o00<0_koo
0?ooo`3oool03P3oool00`20P?l0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o
0000o`000?l02P000?l00`0c<ol0gmoo0?ooo`0?0?ooo`0308n?o`000?l0003o00X0003o000E0000
o`03010@o`3_kol0oooo0100oooo20000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o
00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo00l0oooo3`1oOol00`3O
gol0oooo0?ooo`0>0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10
@?l0003o0000o`0;0000o`03020Po`3_kol0oooo00h0oooo00<0c<co0000o`000?l02P000?l001H0
003o00<0Shoo0?ooo`3oool03`3oool80000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`00
0?l020000?l?0?ooo`030;noo`000?l0003o00H0003o00<0@43o0?ooo`3oool0;`3oool00`20P?l0
003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l030000?l00`10@?l0
oooo0?ooo`0>0?ooo``0003o000F0000o`030820o`3oool0oooo00l0oooo20000?l00`20P?l0oooo
0?ooo`0=0?ooo`030410o`000?l0003o00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410
o`3oool0oooo02l0oooo00<0P83o0000o`000?l01P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410
o`000?l0003o00d0003o00<0c<co0?ooo`3oool03@3oool00`10@?l0003o0000o`090000o`005P00
0?l00`20P?l0oooo0?ooo`0>0?ooo`030>o_o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3o
ool00`10@?l0003o0000o`080000o`l0oooo00<0_koo0000o`000?l01P000?l00`10@?l0oooo0?oo
o`0_0?ooo`030820o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000
o`0=0000o`03071`o`3oool0oooo00d0oooo00<0@43o0000o`000?l02@000?l001H0003o00<0c<co
0?ooo`3oool03P3oool00`2o_ol0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o
0000o`000?l020000?l?0?ooo`030;noo`000?l0003o00H0003o00<0@43o0?ooo`3oool0;`3oool0
0`20P?l0003o0000o`060000o`030820o`3oool0oooo00d0oooo00<0@43o0000o`000?l03@000?l0
0`10@?l0oooo0?ooo`0=0?ooo`0306IVo`000?l0003o00T0003o000E0000o`03020Po`3oool0oooo
00l0oooo00<0Shoo0000o`000?l01P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o
00P0003o3`3oool00`2o_ol0003o0000o`060000o`030410o`3oool0oooo02l0oooo00<0P83o0000
o`000?l01P000?l00`20P?l0oooo0?ooo`0=0?ooo`030410o`000?l0003o00d0003o00<0<c?o0?oo
o`3oool03@3oool00`20P?l0003o0000o`090000o`005@000?l00`2_[ol0oooo0?ooo`0?0?ooo`03
051@o`000?l0003o00H0003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`080000o`l0
oooo00<0_koo0000o`000?l01P000?l00`10@?l0oooo0?ooo`0_0?ooo`030820o`000?l0003o00H0
003o00<0P83o0?ooo`3oool03@3oool00`10@?l0003o0000o`0=0000o`03020Po`3oool0oooo00d0
oooo00<0P83o0000o`000?l02@000?l001@0003o00<0@43o0?ooo`3oool0403oool90000o`030820
o`3oool0oooo00d0oooo00<0@43o0000o`000?l020000?l?0?ooo`030;noo`000?l0003o00H0003o
00<0@43o0?ooo`3oool0;`3oool00`20P?l0003o0000o`060000o`03071`o`3oool0oooo00d0oooo
00<0L73o0000o`000?l03@000?l00`10@?l0oooo0?ooo`0=0?ooo`030820o`000?l0003o00T0003o
000D0?ooo`03020Po`000?l0003o00l0003o00<0IVKo0?ooo`3oool01`3oool00`20P?l0003o0000
o`0=0000o`030;noo`3oool0oooo00P0oooo3`000?l00`10@?l0oooo0?ooo`060?ooo`030;noo`00
0?l0003o02l0003o00<0P83o0?ooo`3oool01P3oool00`2o_ol0003o0000o`0=0000o`0306IVo`3o
ool0oooo00d0oooo00<0Shoo0000o`000?l03@000?l00`2_[ol0oooo0?ooo`090?ooo`004`3oool0
0`1`L?l0003o0000o`0@0000o`030;noo`3oool0oooo00L0oooo00<0VIWo0000o`000?l03@000?l0
0`2o_ol0oooo0?ooo`080?ooo`l0003o00<0P83o0?ooo`3oool01P3oool00`2o_ol0003o0000o`0_
0000o`030820o`3oool0oooo00H0oooo00<0_koo0000o`000?l03@000?l00`0P8?l0oooo0?ooo`0=
0?ooo`03051@o`000?l0003o00d0003o00<0_koo0?ooo`3oool02@3oool00180oooo00<0_koo0000
o`000?l040000?l00`10@?l0oooo0?ooo`080?ooo`030;noo`000?l0003o00d0003o00<0P83o0?oo
o`3oool01`3oool00`2_[ol0003o0000o`0=0000o`030820o`3oool0oooo00H0oooo00<0_koo0000
o`000?l0;`000?l00`20P?l0oooo0?ooo`070?oooa00003o00<0VIWo0?ooo`3oool02`3oool00`3O
gol0003o0000o`0>0000o`030>o_o`3oool0oooo00T0oooo000B0?ooo`03020Po`000?l0003o0100
003o00<0gmoo0?ooo`3oool0203oool00`2o_ol0003o0000o`0=0000o`030410o`3oool0oooo00L0
oooo00<0IVKo0000o`000?l03@000?l00`20P?l0oooo0?ooo`060?ooo`030;noo`000?l0003o02l0
003o00<0P83o0?ooo`3oool01`3oool00`0P8?l0003o0000o`0=0000o`03010@o`3oool0oooo00/0
oooo00<0<c?o0000o`000?l03@000?l00`0P8?l0oooo0?ooo`0:0?ooo`004@3oool00`20P?l0003o
0000o`0@0000o`03071`o`3oool0oooo00T0oooo00<0gmoo0000o`000?l03P000?l00`2o_ol0oooo
0?ooo`050?ooo`030=oOo`0@4?l0003o00h0003o00<0VIWo0?ooo`3oool01P3oool00`2o_ol0003o
0000o`0_0000o`030820o`3oool0oooo00L0oooo00<0D53o0000o`000?l03P000?l00`0c<ol0gmoo
0?ooo`090?ooo`0306IVo`000?l0003o00h0003o00<0IVKo0?ooo`3oool02P3oool00100oooo00<0
c<co0000o`000?l040000?l00`0@4?l0knoo0?ooo`0;0?oooa00003o00<0823o0<c<o`3oool01@3o
ool00`0c<ol0003o0000o`0>0000o`030;noo`3oool0oooo00H0oooo00<0_koo0000o`000?l0;`00
0?l00`20P?l0oooo0?ooo`070?ooo`0309VIo`000?l0003o00l0003o00<0413o09VIo`3oool01P3o
ool00`2o_ol0<c?o0000o`0@0000o`0309VIo`3oool0oooo00X0oooo000@0?ooo`0303<co`000?l0
003o0100003o00<0[joo0?ooo`3oool02`3oool00`10@?l0003o0000o`0>0000o`03010@o`1`L?l0
[joo0080_koo00<0L73o010@o`000?l040000?l90?ooo`030;noo`000?l0003o02l0003o00<0P83o
0?ooo`3oool01`3oool00`3_kol0003o0000o`0A0000o`04010@o`1VI_l0P83o09VIo`80P83o00<0
<c?o0000o`000?l04@000?l00`3_kol0oooo0?ooo`0:0?ooo`003`3oool00`2?Sol0003o0000o`0@
0000o`030410o`3oool0oooo00`0oooo00<0P83o0000o`000?l09@000?l00`10@?l0oooo0?ooo`07
0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0
oooo00P0oooo00<0D53o0000o`000?l0:@000?l00`1VI_l0oooo0?ooo`0;0?ooo`003`3oool00`0@
4?l0003o0000o`0?0000o`03010@o`3Ogol0oooo00d0oooo00<0c<co0000o`000?l09@000?l00`2?
Sol0oooo0?ooo`070?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000
o`030820o`3oool0oooo00P0oooo00<0_koo0000o`000?l0:@000?l00`2o_ol0oooo0?ooo`0;0?oo
o`003P3oool00`20P?l0003o0000o`0@0000o`0308n?o`3oool0oooo00h0oooo00<0823o0000o`00
0?l08`000?l00`0@4?l0knoo0?ooo`080?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0
003o0000o`0>0000o`030820o`3oool0oooo00T0oooo00<0<c?o0000o`000?l09`000?l00`10@?l0
oooo0?ooo`0<0?ooo`003P3oool00`0@4?l0003o0000o`0?0000o`0303<co`3oool0oooo00l0oooo
00<0VIWo0000o`000?l08`000?l00`1VI_l0oooo0?ooo`080?ooo`030;noo`000?l0003o00l0003o
3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0oooo00T0oooo00<0_koo0000o`000?l0
9`000?l00`3<c?l0oooo0?ooo`0<0?ooo`003@3oool00`2IVOl0003o0000o`0@0000o`030;noo`3o
ool0oooo0100oooo00<0823o0000o`000?l08P000?l00`3Ogol0oooo0?ooo`080?ooo`030;noo`00
0?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0oooo00X0oooo00<0
L73o0000o`000?l09@000?l00`1`L?l0oooo0?ooo`0=0?ooo`003@3oool00`0P8?l0003o0000o`0?
0000o`0306IVo`3oool0oooo0140oooo00<0VIWo0000o`000?l08@000?l00`20P?l0oooo0?ooo`09
0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000o`030820o`3oool0
oooo00X0oooo00<0knoo03<co`000?l090000?l00`0c<ol0knoo0?ooo`0>0?ooo`00303oool00`3<
c?l0003o0000o`0?0000o`03010@o`3_kol0oooo01<0oooo00<0@43o0000o`000?l07`000?l00`0c
<ol0knoo0?ooo`0:0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0003o0000o`0>0000
o`030820o`3oool0oooo00/0oooo00<0c<co010@o`000?l08P000?l00`0@4?l0c<co0?ooo`0?0?oo
o`00303oool00`2?Sol0003o0000o`0?0000o`03071`o`3oool0oooo01<0oooo00<0knoo010@o`00
0?l07P000?l00`0@4?l0c<co0?ooo`0;0?ooo`030;noo`000?l0003o00l0003o3`3oool00`10@?l0
003o0000o`0>0000o`0308n?o`3oool0oooo00`0oooo00<0_koo0000o`000?l08@000?l00`2_[ol0
oooo0?ooo`0?0?ooo`00303oool00`10@?l0003o0000o`0?0000o`030=oOo`3oool0oooo01@0oooo
00<0c<co010@o`000?l07@000?l00`2IVOl0oooo0?ooo`0;0?ooo`030;noo`000?l0003o00l0003o
3`3oool00`10@?l0003o0000o`0>0000o`030;noo`3oool0oooo00d0oooo00<0VIWo010@o`000?l0
7`000?l00`2IVOl0oooo0?ooo`0@0?ooo`00303ooolA0000o`0303<co`3oool0oooo01H0oooo00<0
c<co010@o`000?l06`000?l00`2IVOl0oooo0?ooo`0<0?ooo`030>o_o`000?l0003o00l0003o00<0
knoo0?ooo`3oool0303oool00`0@4?l0003o0000o`0>0000o`030;noo`3oool0oooo00h0oooo00<0
c<co010@o`000?l070000?l00`0@4?l0_koo0?ooo`0B0?ooo`002`3oool00`3Ogol0003o0000o`0?
0000o`030820o`3oool0oooo01L0oooo00<0c<co03<co`000?l060000?l00`0@4?l0_koo0?ooo`0?
0?oooa40003o00<0_koo0?ooo`3oool02`3oool00`3_kol0003o0000o`0?0000o`030;noo`3oool0
oooo00l0oooo00<0gmoo0410o`000?l06P000?l00`0c<ol0gmoo0?ooo`0C0?ooo`002`3oool00`2o
_ol0003o0000o`0?0000o`030820o`3oool0oooo01P0oooo00<0knoo06IVo`000?l05P000?l00`10
@?l0gmoo0?ooo`0@0?ooo`03010@o`000?l0003o00h0003o00<0L73o0?ooo`3oool02`3oool00`2_
[ol0003o0000o`0?0000o`030=oOo`3oool0oooo0140oooo00<0Shoo010@o`000?l05P000?l00`0@
4?l0Ogoo0?ooo`0E0?ooo`002`3oool00`2o_ol0003o0000o`0?0000o`030820o`3oool0oooo01X0
oooo00<0_koo03<co`000?l04P000?l00`0P8?l0VIWo0?ooo`0B0?ooo`030410o`000?l0003o00h0
003o00<0413o0>o_o`3oool02`3oool00`10@?l0003o0000o`0?0000oaD0oooo00<0knoo06IVo`00
0?l050000?l00`1VI_l0gmoo0?ooo`0F0?ooo`002`3oool00`2o_ol0003o0000o`0?0000o`030410
o`3oool0oooo01`0oooo00<0_koo051@o`000?l03P000?l00`0c<ol0VIWo0?ooo`0D0?ooo`03071`
o`000?l0003o00l0003o00<0D53o0?ooo`3oool02@3oool00`2IVOl0003o0000o`0?0000o`0303<c
o`3oool0oooo01D0oooo00<0gmoo07moo`0P8?l03`000?l00`0P8?l0Ogoo0=oOo`0I0?ooo`002`3o
ool00`2o_ol0003o0000o`0@0000o`030;noo`3oool0oooo01d0oooo00@0knoo09VIo`1VI_l0<c?o
1`000?l0100P8?l0D53o08n?o`3OgolG0?ooo`0309VIo`000?l0003o0100003o00<0IVKo0?ooo`3o
ool01`3oool00`2IVOl0003o0000o`0@0000o`0306IVo`3oool0oooo01P0oooo00@0c<co08n?o`10
@?l0823o1`000?l0100P8?l0D53o07moo`3<c?lL0?ooo`002`3oool00`2o_ol0003o0000o`0@0000
o`03010@o`2o_ol0oooo02<0oooo00@0c<co0;noo`2o_ol0gmoo703oool00`3Ogol0003o0000o`0A
0000o`03020Po`2_[ol0oooo00@0oooo00<0gmoo06IVo`000?l04P000?l00`2IVOl0oooo0?ooo`0N
0?ooo`<0_koo00<0gmoo0?ooo`3oool07`3oool000`0oooo50000?l00`1VI_l0[joo0?ooo`030?oo
o`030;noo`1`L?l0c<co03`0oooo00<0823o0000o`000?l04P000?l01@0@4?l0@43o0410o`10@?l0
823o01D0003o00<0gmoo0?ooo`3oool0@`3oool000`0oooo00<0823o0000o`000?l06@000?l00`2o
_ol0oooo0?ooo`0j0?ooo`03071`o`000?l0003o02/0003o00<0@43o0?ooo`3oool0A03oool000`0
oooo00<0IVKo0000o`000?l06@000?l00`2o_ol0oooo0?ooo`0j0?ooo`030=oOo`000?l0003o02/0
003o00<0VIWo0?ooo`3oool0A03oool000`0oooo00<0[joo0000o`000?l06@000?l00`2o_ol0oooo
0?ooo`0k0?ooo`03051@o`000?l0003o02T0003o00<0823o0?ooo`3oool0A@3oool000d0oooo00<0
413o0000o`000?l060000?l00`2o_ol0oooo0?ooo`0k0?ooo`030;noo`000?l0003o02T0003o00<0
VIWo0?ooo`3oool0A@3oool000d0oooo00<0P83o0000o`000?l060000?l00`2o_ol0oooo0?ooo`0l
0?ooo`0306IVo`000?l0003o02L0003o00<0<c?o0?ooo`3oool0AP3oool000d0oooo00<0gmoo010@
o`000?l060000?l00`2o_ol0oooo0?ooo`0l0?ooo`030>o_o`0@4?l0003o02L0003o00<0c<co0?oo
o`3oool0AP3oool000h0oooo00<0P83o0000o`000?l05`000?l00`2o_ol0oooo0?ooo`0m0?ooo`03
0;noo`000?l0003o02D0003o00<0Shoo0?ooo`3oool0A`3oool000l0oooo00<0<c?o0000o`000?l0
5P000?l00`2o_ol0oooo0?ooo`0n0?ooo`0309VIo`000?l0003o02<0003o00<0IVKo0?ooo`3oool0
B03oool000l0oooo00<0c<co010@o`000?l05P000?l00`2o_ol0oooo0?ooo`0o0?ooo`03071`o`00
0?l0003o0240003o00<0<c?o0?ooo`3oool0B@3oool00100oooo00<0_koo0000o`000?l05@000?l0
0`2o_ol0oooo0?ooo`100?ooo`0306IVo`000?l0003o01l0003o00<0<c?o0>o_o`3oool0BP3oool0
0140oooo00<0VIWo010@o`000?l050000?l00`2o_ol0oooo0?ooo`110?ooo`0309VIo`000?l0003o
01d0003o00<0IVKo0>o_o`3oool0B`3oool00180oooo00<0c<co020Po`000?l04`000?l00`2o_ol0
oooo0?ooo`120?ooo`030;noo`0P8?l0003o01/0003o00<0Ogoo0?ooo`3oool0C03oool001<0oooo
00<0knoo06IVo`000?l04P000?l00`2o_ol0oooo0?ooo`130?ooo`030>o_o`1VI_l0003o01P0003o
00<0<c?o0<c<o`3oool0CP3oool001D0oooo00<0_koo0410o`000?l040000?l00`2o_ol0oooo0?oo
o`150?ooo`030<c<o`10@?l0003o01@0003o00<0823o09VIo`3oool0D03oool001L0oooo00<0_koo
051@o`000?l03P000?l00`2o_ol0oooo0?ooo`170?ooo`030<c<o`1VI_l0413o0100003o00<0D53o
0:n_o`3oool0DP3oool001T0oooo00@0knoo0:n_o`1VI_l0@43o20000?l0100@4?l0@43o07moo`3O
gom<0?ooo`040;noo`1oOol0@43o010@o`P0003o00@0@43o071`o`2_[ol0knooE@3oool001h0oooo
00<0knoo0;noo`2o_ol00`2o_omF0?ooo`030<c<o`2o_ol0_koo0080_koo00<0knoo0?ooo`3oool0
F03oool00001\
\>"],
            ImageRangeCache->{{{0, 217}, {87, 0}} -> {-0.00108501, 0.999385, 
            1.00001, 
            1.00001}}], \(SNAP\ package\ includes\ routines\ which\ provide\ \
SNAP\ functionalities . \ The\ version\ of\ this\ package\ is\ 0.9  .0 . \ 
              All\ Rights\ Reserved, \ Copyright\ \((C)\) Kosaku\ Nagasaka, \ 
          Kobe\ University\ 2004 - 
            2007. \ Kousaku\ Nagasaka\ makes\ no\ warranty\ of\ this\ \
software, 
          and\ takes\ no\ responsibility\ to\ any\ result\ arising\ from\ \
your\ use\ of\ this\ \(\(software\)\(.\)\)\)}
        },
      RowAlignments->Top,
      ColumnAlignments->{Right, Left}]]]], "DefinitionBox",
  GeneratedCell->True,
  CellAutoOverwrite->True,
  Background->GrayLevel[1]],

Cell[TextData[{
  "\:3053\:306e\:30d1\:30c3\:30b1\:30fc\:30b8\:3067\:306f\:ff0c\:57fa\:672c\
\:7684\:306b\:6b21\:306e\:3088\:3046\:306a\:591a\:9805\:5f0f\:96c6\:5408\:3092\
\:53d6\:308a\:6271\:3044\:307e\:3059\:ff0e\:591a\:9805\:5f0f\:96c6\:5408\:306f\
\:ff0c\:4ee3\:8868\:5143\:306e\:591a\:9805\:5f0f ",
  Cell[BoxData[
      \(TraditionalForm\`f\)]],
  " \:3068\:305d\:306e\:591a\:9805\:5f0f\:304b\:3089\:306e\:8a31\:5bb9\:3055\
\:308c\:308b\:5909\:52d5\:306e\:5927\:304d\:3055 ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  " \:3067\:5b9a\:7fa9\:3055\:308c\:307e\:3059\:ff0e\:3053\:306e\:30d1\:30c3\
\:30b1\:30fc\:30b8\:306b\:304a\:3044\:3066\:ff0c\:3053\:306e\:7a2e\:306e\:591a\
\:9805\:5f0f\:96c6\:5408\:306f\:982d\:90e8\:ff08",
  ButtonBox["Head",
    ButtonStyle->"RefGuideLink"],
  "\:ff09\:3068\:3057\:3066",
  StyleBox["SNAP",
    FontFamily->"Courier"],
  "\:3092\:6301\:3064\:306e\:3067\:ff0c\:3053\:308c\:3092",
  StyleBox["SNAP",
    FontFamily->"Courier"],
  "\:96c6\:5408\:3068\:4fbf\:5b9c\:4e0a\:547c\:3073\:307e\:3059\:ff0e"
}], "Text"],

Cell[BoxData[
    \(TextForm\`\(\({f\&_ | 
        f\&_ \[Element] \[DoubleStruckCapitalC][u\_1, \ \[Ellipsis], \ 
            u\_r], \ \(deg\_u\) f\&_ = \(deg\_u\) 
          f\ \((\[ForAll] u \[Element] {u\_1, \ \[Ellipsis], \ 
                  u\_r})\), \ \(\(\[DoubleVerticalBar]\)\(f - 
          f\&_\)\(\[DoubleVerticalBar]\)\(\[LessEqual]\)\(\[Epsilon]\)\)}\)\(,\
\)\)\)], "DisplayMath",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[{
  "\:3053\:3053\:3067\:ff0c",
  Cell[BoxData[
      \(TraditionalForm\`\(\(\[DoubleVerticalBar]\)\(p\)\(\[DoubleVerticalBar]\
\)\)\)]],
  " \:306f\:591a\:9805\:5f0f ",
  Cell[BoxData[
      \(TraditionalForm\`p\)]],
  " \:306e\:30ce\:30eb\:30e0\:3092\:8868\:3057\:3066\:3044\:307e\:3059\:ff0e\
\:73fe\:6642\:70b9\:3067\:5bfe\:5fdc\:3057\:3066\:3044\:308b\:8aa4\:5dee\:8a55\
\:4fa1\:306e\:65b9\:6cd5\:ff08\:8a31\:5bb9\:3055\:308c\:308b\:5909\:52d5\:306e\
\:5927\:304d\:3055\:306e\:8a08\:308a\:65b9\:ff09\:306f\:ff0c\:591a\:9805\:5f0f\
\:30ce\:30eb\:30e0\:306e\:307f\:3067\:ff0c",
  Cell[BoxData[
      \(TraditionalForm\`1, \ 2, \ \[Infinity]\)]],
  " \:306e\:4e09\:7a2e\:985e\:306e\:30ce\:30eb\:30e0\:306b\:306a\:308a\:307e\
\:3059\:ff0e"
}], "Text"],

Cell[TextData[{
  "\:901a\:5e38\:306e\:591a\:9805\:5f0f\:3092",
  StyleBox["SNAP",
    FontFamily->"Courier"],
  "\:96c6\:5408\:306b\:5909\:63db\:3059\:308b\:306b\:306f\:ff0c\:6b21\:306e\
\:95a2\:6570\:3092\:4f7f\:3044\:307e\:3059\:ff0e"
}], "Text"],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          RowBox[{"SNAP", "[", " ", 
            StyleBox["polynomial",
              FontSlant->"Italic"], "]"}], 
          RowBox[{
          "\:30c7\:30d5\:30a9\:30eb\:30c8\:306e\:8aa4\:5dee\:8a55\:4fa1\:65b9\
\:6cd5\:3067", ",", 
            RowBox[{"\:6307\:5b9a\:3055\:308c\:305f\:591a\:9805\:5f0f", " ", 
              StyleBox["polynomial",
                FontSlant->"Italic"], " ", 
              "\:304b\:3089\:8a31\:5bb9\:5ea6\:3084\:6b21\:6570\:3084\:5909\
\:6570\:306a\:3069\:3092\:81ea\:52d5\:7684\:306b\:53d6\:5f97\:3057"}], 
            ",", \(\(\:305d\:308c\:306b\:5bfe\:5fdc\:3059\:308bSNAP\:96c6\
\:5408\:3092\:8fd4\:3057\:307e\:3059\)\(.\)\)}]},
        {
          RowBox[{"SNAP", "[", " ", 
            RowBox[{
              StyleBox["polynomial",
                FontSlant->"Italic"], 
              StyleBox[",",
                FontWeight->"Plain",
                FontSlant->"Plain",
                FontTracking->"Plain",
                FontVariations->{"Underline"->False,
                "Outline"->False,
                "Shadow"->False,
                "StrikeThrough"->False,
                "Masked"->False,
                "CompatibilityType"->0,
                "RotationAngle"->0}], 
              StyleBox[" ",
                FontSlant->"Italic"], 
              StyleBox[\(error\ bound\),
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
          "\:30c7\:30d5\:30a9\:30eb\:30c8\:306e\:8aa4\:5dee\:8a55\:4fa1\:65b9\
\:6cd5\:3067", ",", 
            RowBox[{"\:6307\:5b9a\:3055\:308c\:305f\:591a\:9805\:5f0f", " ", 
              StyleBox["polynomial",
                FontSlant->"Italic"], " ", 
              "\:304b\:3089\:6b21\:6570\:3084\:5909\:6570\:306a\:3069\:3092\
\:81ea\:52d5\:7684\:306b\:53d6\:5f97\:3057"}], ",", 
            RowBox[{"\:6307\:5b9a\:3055\:308c\:305f\:8a31\:5bb9\:5ea6", " ", 
              StyleBox["error",
                FontSlant->"Italic"], 
              StyleBox[" ",
                FontSlant->"Italic"], 
              StyleBox["bound",
                FontSlant->"Italic"], 
              " ", \(\(\:3092\:6301\:3064SNAP\:96c6\:5408\:3092\:8fd4\:3057\
\:307e\:3059\)\(.\)\)}]}]},
        {
          RowBox[{"SNAP", "[", " ", 
            RowBox[{
              StyleBox["polynomial",
                FontSlant->"Italic"], ",", " ", 
              StyleBox[\(error\ bound\),
                FontSlant->"Italic"], ",", " ", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{
                      StyleBox["var1",
                        FontSlant->"Italic"], ",", " ", 
                      StyleBox["deg1",
                        FontSlant->"Italic"]}], 
                    StyleBox["}",
                      FontSlant->"Italic"]}], ",", "\[Ellipsis]", ",", 
                  RowBox[{"{", 
                    RowBox[{
                      StyleBox["varr",
                        FontSlant->"Italic"], ",", 
                      StyleBox["degr",
                        FontSlant->"Italic"]}], "}"}]}], "}"}]}], "]"}], 
          RowBox[{
          "\:30c7\:30d5\:30a9\:30eb\:30c8\:306e\:8aa4\:5dee\:8a55\:4fa1\:65b9\
\:6cd5\:3067", ",", 
            RowBox[{"\:6307\:5b9a\:3055\:308c\:305f\:591a\:9805\:5f0f", " ", 
              StyleBox["polynomial",
                FontSlant->"Italic"], " ", "\:3092\:4e2d\:5fc3\:306b"}], ",", 
            "\:6307\:5b9a\:3055\:308c\:305f\:5909\:6570\:3068\:305d\:306e\
\:6b21\:6570\:3092\:6301\:3061", 
            ",", \(\(\:6307\:5b9a\:3055\:308c\:305f\:8a31\:5bb9\:5ea6\:3092\
\:6301\:3064SNAP\:96c6\:5408\:3092\:8fd4\:3057\:307e\:3059\)\(.\)\)}]},
        {
          RowBox[{"SNAP", "[", " ", 
            RowBox[{
              StyleBox["polynomial",
                FontSlant->"Italic"], ",", " ", 
              StyleBox[\(error\ bound\),
                FontSlant->"Italic"], ",", " ", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{
                      StyleBox["var1",
                        FontSlant->"Italic"], ",", " ", 
                      StyleBox["deg1",
                        FontSlant->"Italic"]}], 
                    StyleBox["}",
                      FontSlant->"Italic"]}], ",", "\[Ellipsis]", ",", 
                  RowBox[{"{", 
                    RowBox[{
                      StyleBox["varr",
                        FontSlant->"Italic"], ",", 
                      StyleBox["degr",
                        FontSlant->"Italic"]}], "}"}]}], "}"}], 
              StyleBox[",",
                FontVariations->{"CompatibilityType"->0}], 
              StyleBox[" ",
                FontVariations->{"CompatibilityType"->0}], 
              StyleBox[\(error\ scheme\),
                FontSlant->"Italic",
                FontVariations->{"CompatibilityType"->0}]}], 
            StyleBox["]",
              FontVariations->{"CompatibilityType"->0}]}], 
          RowBox[{
          "\:6307\:5b9a\:3055\:308c\:305f\:8aa4\:5dee\:8a55\:4fa1\:65b9\:6cd5\
\:3067", ",", 
            RowBox[{"\:6307\:5b9a\:3055\:308c\:305f\:591a\:9805\:5f0f", " ", 
              StyleBox["polynomial",
                FontSlant->"Italic"], " ", "\:3092\:4e2d\:5fc3\:306b"}], ",", 
            "\:6307\:5b9a\:3055\:308c\:305f\:5909\:6570\:3068\:305d\:306e\
\:6b21\:6570\:3092\:6301\:3061", 
            ",", \(\(\:6307\:5b9a\:3055\:308c\:305f\:8a31\:5bb9\:5ea6\:3092\
\:6301\:3064SNAP\:96c6\:5408\:3092\:8fd4\:3057\:307e\:3059\)\(.\)\)}]}
        }]]]], "DefinitionBox"],

Cell[TextData[{
  StyleBox["SNAP",
    FontFamily->"Courier"],
  " \:96c6\:5408\:3092\:5b9a\:7fa9\:3059\:308b\:95a2\:6570\:ff0e"
}], "Caption"],

Cell[TextData[{
  "\:3053\:308c\:306b\:3088\:308a\:ff0c\:6b21\:306e\:591a\:9805\:5f0f\:306b\
\:5bfe\:3059\:308b",
  StyleBox["SNAP",
    FontFamily->"Courier"],
  "\:96c6\:5408\:3092 ",
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  " \:306b\:5272\:308a\:5f53\:3066\:307e\:3059\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 
      SNAP[x^5 + 5.503  x^4 + 9.765  x^3 + 7.647  x^2 + 2.762  x + 
          0.37725]\)], "Input",
  CellLabel->"In[11]:="],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[11]="]
}, Open  ]],

Cell[TextData[{
  "\:7d44\:307f\:8fbc\:307f\:95a2\:6570\:306e ",
  ButtonBox["FullForm",
    ButtonStyle->"RefGuideLink"],
  " \:3092\:4f7f\:3046\:3053\:3068\:3067\:ff0c",
  StyleBox["SNAP",
    FontFamily->"Courier"],
  "\:96c6\:5408\:306e\:5185\:90e8\:8868\:73fe\:3092\:78ba\:8a8d\:3067\:304d\
\:307e\:3059\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FullForm[g]\)], "Input",
  CellLabel->"In[12]:="],

Cell[BoxData[
    TagBox[
      StyleBox[\(SNAP[
          Plus[Rational[3397965918851039, 9007199254740992], 
            Times[Rational[6219471085398655, 2251799813685248], x], 
            Times[Rational[4304878293812773, 562949953421312], Power[x, 2]], 
            Times[Rational[687150786894889, 70368744177664], Power[x, 3]], 
            Times[Rational[387239199209685, 70368744177664], Power[x, 4]], 
            Power[x, 5]], 
          Times[Rational[1, 18014398509481984], Power[1601, Rational[1, 2]]], 
          List[List[x, 5]], AbsolutePolynomial2Norm]\),
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[12]//FullForm="]
}, Open  ]],

Cell[TextData[{
  "\:3053\:306e\:30d1\:30c3\:30b1\:30fc\:30b8\:3067\:63d0\:4f9b\:3059\:308b\
\:3059\:3079\:3066\:306e\:95a2\:6570\:306f\:57fa\:672c\:7684\:306b",
  StyleBox["SNAP",
    FontFamily->"Courier"],
  "\:96c6\:5408\:306e\:5404\:8981\:7d20\:306b\:95a2\:3059\:308b\:5305\:542b\
\:95a2\:4fc2\:3092\:6e80\:305f\:3057\:307e\:3059\:ff0e\:5f93\:3063\:3066\:ff0c\
\:5f53\:7136\:3067\:3059\:304c\:ff0c\:96c6\:5408\:306e\:5927\:304d\:3055\:306f\
\:6f14\:7b97\:5f8c\:306b\:306f\:5927\:304d\:304f\:306a\:308a\:307e\:3059\:ff0e\
"
}], "Text"],

Cell["\<\
\[ForAll]g\[Element]G and \[ForAll]h\[Element]H, \[Exists]f\
\[Element]F s.t. f=g\[CenterDot]h where F, G and H satisfying \
F=G\[CenterDot]H as SNAP structures.\
\>", "FramedBox",
  TextAlignment->Center,
  TextJustification->0],

Cell[TextData[StyleBox["Tolerance \:95a2\:6570\:3067\:ff0cSNAP\:96c6\:5408\
\:306e\:8a31\:5bb9\:5ea6\:3092\:53d6\:308a\:51fa\:305b\:307e\:3059\:ff0e",
  FontFamily->"Courier"]], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g]\)], "Input",
  CellLabel->"In[13]:="],

Cell[BoxData[
    \(2.2211398302543545`*^-15\)], "Output",
  CellLabel->"Out[13]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(SNAPQ[g]\)], "Input",
  CellLabel->"In[14]:="],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[14]="]
}, Open  ]],

Cell["\:6f14\:7b97\:5f8c\:306b\:306f\:8a31\:5bb9\:5ea6\:306e\:5927\:304d\:3055\
\:306f\:5927\:304d\:304f\:306a\:308a\:307e\:3059\:ff0e", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2 = g*g\)], "Input",
  CellLabel->"In[15]:="],

Cell[BoxData[
    \(\((\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + \
9.765`\ x\^3 + 5.503`\ x\^4 + x\^5)\)\^2\)], "Output",
  CellLabel->"Out[15]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g2]\)], "Input",
  CellLabel->"In[16]:="],

Cell[BoxData[
    \(1.5112337861931826`*^-13\)], "Output",
  CellLabel->"Out[16]="]
}, Open  ]],

Cell[TextData[{
  "\:95a2\:6570 ",
  StyleBox["Element ",
    FontFamily->"Courier"],
  "\:3092\:4f7f\:3046\:3053\:3068\:3067\:ff0c",
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:306b\:6307\:5b9a\:3055\:308c\:305f\:591a\:9805\:5f0f\:304c\
\:542b\:307e\:308c\:308b\:304b\:3069\:3046\:304b\:3092\:78ba\:8a8d\:3059\:308b\
\:3053\:3068\:304c\:51fa\:6765\:307e\:3059\:ff0e\:4e0b\:8a18\:3067\:78ba\:8a8d\
\:3057\:3066\:3044\:308b",
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:306e\:8a31\:5bb9\:5ea6\:306e\:5927\:304d\:3055\:306f\:ff0c  \
",
  Cell[BoxData[
      \(1.5379125945029852`*^-15\)]],
  " \:7a0b\:5ea6\:306a\:306e\:3067\:ff0c\:6b21\:306e\:3088\:3046\:306a\:7d50\
\:679c\:306b\:306a\:308a\:307e\:3059\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g]\)], "Input",
  CellLabel->"In[17]:="],

Cell[BoxData[
    \(2.2211398302543545`*^-15\)], "Output",
  CellLabel->"Out[17]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Element[Normal[g] + 2.2*^-15, g]\)], "Input",
  CellLabel->"In[18]:="],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[18]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Element[Normal[g] + 2.3*^-15, g]\)], "Input",
  CellLabel->"In[19]:="],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[19]="]
}, Open  ]],

Cell[TextData[{
  "\:4e0a\:3084\:4e0b\:306e\:4f8b\:304b\:3089\:308f\:304b\:308b\:3088\:3046\
\:306b\:ff0c\:95a2\:6570 ",
  StyleBox["Normal",
    FontFamily->"Courier"],
  " \:3092\:4f7f\:3046\:3053\:3068\:3067\:ff0c ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " \:672c\:6765\:306e\:591a\:9805\:5f0f\:8868\:73fe\:3092\:53d6\:308a\:51fa\
\:3059\:3053\:3068\:304c\:51fa\:6765\:307e\:3059\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(N@Normal[g]\)], "Input",
  CellLabel->"In[20]:="],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[20]="]
}, Open  ]],

Cell[TextData[{
  "\:307e\:3068\:3081\:308b\:3068\:ff0c",
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:306b\:95a2\:3057\:3066\:ff0c\:3053\:306e\:30d1\:30c3\:30b1\
\:30fc\:30b8\:306f\:6b21\:306e\:3088\:3046\:306a\:95a2\:6570\:3092\:63d0\:4f9b\
\:3057\:3066\:3044\:307e\:3059\:ff0e"
}], "Text"],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          RowBox[{"Tolerance", "[", " ", 
            StyleBox["expr",
              FontSlant->"Italic"], "]"}], 
          RowBox[{
            StyleBox["expr",
              FontSlant->"Italic"], 
            StyleBox[" ",
              FontSlant->"Italic"], 
            "\:306e\:8a31\:5bb9\:5ea6", \((\:7d76\:5bfe\:8aa4\:5dee\:306e\
\:5927\:304d\:3055)\), \(\(\:3092\:4e0e\:3048\:307e\:3059\)\(.\)\)}]},
        {
          RowBox[{"Element", "[", " ", 
            RowBox[{
              StyleBox["expr",
                FontSlant->"Italic"], ",", " ", 
              StyleBox["stru",
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
            StyleBox["expr",
              FontSlant->"Italic"], " ", "\:304c", " ", 
            StyleBox["stru",
              FontSlant->"Italic"], " ", 
            "\:306b\:542b\:307e\:308c\:3066\:3044\:308c\:3070", " ", "True", 
            " ", "\:3092\:305d\:3046\:3067\:306a\:3044\:5834\:5408\:306f", 
            " ", "False", 
            " ", \(\(\:3092\:8fd4\:3057\:307e\:3059\)\(.\)\)}]},
        {
          RowBox[{"Normal", "[", " ", 
            StyleBox["stru",
              FontSlant->"Italic"], "]"}], 
          RowBox[{
            StyleBox["stru",
              FontSlant->"Italic"], 
            StyleBox[" ",
              
              FontSlant->
                "Italic"], \(\(\:306e\:4ee3\:8868\:5143\:3068\:306a\:308b\
\:591a\:9805\:5f0f\:3092\:901a\:5e38\:306e\:5f62\:5f0f\:3067\:4e0e\:3048\:307e\
\:3059\)\(.\)\)}]},
        {
          RowBox[{
            RowBox[{"SNAPQ", "[", " ", 
              StyleBox["expr",
                FontSlant->"Italic"], "]"}], " ", "and", " ", 
            RowBox[{"NotSNAPQ", "[", " ", 
              StyleBox["expr",
                FontSlant->"Italic"], "]"}]}], 
          RowBox[{"\:305d\:308c\:305e\:308c", " ", 
            StyleBox["expr",
              FontSlant->"Italic"], " ", "\:304c", 
            
            " ", \(\(SNAP\:96c6\:5408\:3067\:3042\:308b\:304b\:305d\:3046\
\:3067\:306a\:3044\:304b\:306e\:5224\:5b9a\:3092\:3057\:307e\:3059\)\(.\)\)}]}\

        }]]]], "DefinitionBox"],

Cell["SNAP\:96c6\:5408\:306b\:95a2\:3059\:308b\:57fa\:672c\:7684\:306a\:95a2\
\:6570\:ff0e", "Caption"],

Cell[TextData[{
  "\:3053\:306e\:30d1\:30c3\:30b1\:30fc\:30b8\:3067\:306f\:ff0c\:4e0b\:8a18\
\:306e\:7d44\:307f\:8fbc\:307f\:95a2\:6570\:3092",
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:3092\:6271\:3048\:308b\:3088\:3046\:306b\:62e1\:5f35\:3057\
\:3066\:3044\:307e\:3059\:ff0e"
}], "Text"],

Cell[TextData[StyleBox["Expand, NSolve, PolynomialQuotient, \
PolynomialRemainder, Normal, ReplaceAll, D, PolynomialReduce",
  FontFamily->"Courier"]], "FramedBox"],

Cell["SNAP\:96c6\:5408\:4e92\:63db\:306e\:7d44\:307f\:8fbc\:307f\:95a2\:6570\
\:ff0e", "Caption"],

Cell[TextData[{
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:540c\:58eb\:306e\:7a4d\:3092\:5c55\:958b\:3057\:307e\:3059\
\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2\)], "Input",
  CellLabel->"In[21]:="],

Cell[BoxData[
    \(\((\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + \
9.765`\ x\^3 + 5.503`\ x\^4 + x\^5)\)\^2\)], "Output",
  CellLabel->"Out[21]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Expand[g2]\)], "Input",
  CellLabel->"In[22]:="],

Cell[BoxData[
    \(\(\(0.1423175625`\)\(\[InvisibleSpace]\)\) + 2.083929`\ x + 
      13.3983055`\ x\^2 + 49.6097205`\ x\^3 + 116.57048250000001`\ x\^4 + 
      180.498982`\ x\^5 + 185.04210700000002`\ x\^6 + 
      122.76759000000001`\ x\^7 + 49.813009`\ x\^8 + 11.006`\ x\^9 + 
      x\^10\)], "Output",
  CellLabel->"Out[22]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(SNAPQ[%]\)], "Input",
  CellLabel->"In[23]:="],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[23]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g /. x \[Rule] 1\)], "Input",
  CellLabel->"In[24]:="],

Cell[BoxData[
    \(Interval[{243683020437576491\/9007199254740992 - \(3\ \
\@1601\)\/9007199254740992, 
        243683020437576491\/9007199254740992 + \(3\ \
\@1601\)\/9007199254740992}]\)], "Output",
  CellLabel->"Out[24]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Interval2Float[%]\)], "Input",
  CellLabel->"In[25]:="],

Cell[BoxData[
    \(27.0542500000000009086065233532`15.006478352738144\)], "Output",
  CellLabel->"Out[25]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g /. x \[Rule] 1.2\)], "Input",
  CellLabel->"In[26]:="],

Cell[BoxData[
    \(Interval[{45.47659079999994973315459984418210175953`25.48512639269522, 
        45.47659080000004345132658417232987297698`25.485126392695225}]\)], \
"Output",
  CellLabel->"Out[26]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Interval2Float[%]\)], "Input",
  CellLabel->"In[27]:="],

Cell[BoxData[
    \(45.4765907999999965922405913226`14.685964090982692\)], "Output",
  CellLabel->"Out[27]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(FullForm[%]\)], "Input",
  CellLabel->"In[28]:="],

Cell[BoxData[
    TagBox[
      StyleBox["45.4765907999999965922405913226`14.685964090982692",
        ShowSpecialCharacters->False,
        ShowStringCharacters->True,
        NumberMarks->True],
      FullForm]], "Output",
  CellLabel->"Out[28]//FullForm="]
}, Open  ]],

Cell[TextData[{
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:306b\:5bfe\:3057\:3066 ",
  ButtonBox["NSolve",
    ButtonStyle->"RefGuideLink"],
  " \:3092\:4f7f\:7528\:3059\:308b\:3068\:ff0c",
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:304b\:3089\:3069\:306e\:8981\:7d20\:3092\:53d6\:3063\:3066\
\:304d\:3066\:3082\:6839\:306b\:306a\:3063\:3066\:3044\:308b\:3088\:3046\:306a\
\:6839\:3092\:8a08\:7b97\:3057\:307e\:3059\:ff0e\:5373\:3061\:ff0c\:6c42\:307e\
\:3063\:305f\:6839\:306e\:6709\:52b9\:6841\:306e\:7bc4\:56f2\:306b\:3042\:308b\
\:90e8\:5206\:306f\:ff0c\:3069\:306e\:8981\:7d20\:3092\:6301\:3063\:3066\:304d\
\:3066\:3082\:ff0c\:6839\:306b\:5171\:901a\:3059\:308b\:90e8\:5206\:306b\:306a\
\:308a\:307e\:3059\:ff0e\:7d44\:307f\:8fbc\:307f\:95a2\:6570\:306e ",
  StyleBox["NSolve",
    FontFamily->"Courier New"],
  " \:306f\:4fc2\:6570\:90e8\:306b\:542b\:307e\:308c\:308b\:8aa4\:5dee\:3092\
\:305d\:306e\:3088\:3046\:306b\:53d6\:308a\:6271\:308f\:306a\:3044\:305f\:3081\
\:ff0c",
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:306b\:5bfe\:3057\:3066 ",
  StyleBox["NSolve",
    FontFamily->"Courier New"],
  " \:3092\:4f7f\:3046\:3068\:ff0c ",
  StyleBox["Normal",
    FontFamily->"Courier New"],
  " \:3092\:9069\:7528\:3057\:305f\:3082\:306e\:306b ",
  StyleBox["NSolve",
    FontFamily->"Courier New"],
  " \:3092\:4f7f\:3063\:3066\:6c42\:3081\:305f\:6839\:306b\:6bd4\:3079\:3066\
\:8aa4\:5dee\:306e\:5927\:304d\:3055\:304c\:5927\:304d\:304f\:6b63\:3057\:304f\
\:8a55\:4fa1\:3055\:308c\:307e\:3059\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g == 0, x]\)], "Input",
  CellLabel->"In[29]:="],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323220438282532996`12.815835180381182\) + 
            0``12.338703490974202\ \[ImaginaryI]}, {x \[Rule] \
\(-0.9989903848991342760754719166`12.050538702420925\) + 
            0``12.050977394180272\ \[ImaginaryI]}, {x \[Rule] \
\(-0.5412151824480371242742648909`10.565558360172346\) + 
            0``10.832188389022596\ \[ImaginaryI]}, {x \[Rule] \
\(-0.481361175760253112709818879`10.661053888809242\) - 
            0.0294645370012485696697979165`9.447882450612196\ \[ImaginaryI]}, \
{x \[Rule] \(-0.481361175760253112709818879`10.661053888809242\) + 
            0.0294645370012485696697979165`9.447882450612196\ \[ImaginaryI]}}\
\)], "Output",
  CellLabel->"Out[29]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[30]:="],

Cell[BoxData[
    \({6.431098710768743`*^-13, 1.2862197421537486`*^-12, 
      3.253907165344266`*^-11, 2.0579515874459978`*^-11, 
      2.0579515874459978`*^-11}\)], "Output",
  CellLabel->"Out[30]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?ResultInFloat\)\)], "Input",
  CellLabel->"In[31]:="],

Cell[BoxData[
    \("NSolve and Solve output interval numbers instead of floating-point \
numbers if this option is False."\)], "Print",
  CellTags->"Info3382346076-3433425"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g == 0, x, ResultInFloat \[Rule] False]\)], "Input",
  CellLabel->"In[32]:="],

Cell[BoxData[
    \({{x \[Rule] 
          ComplexInterval[
            Interval[{\(-\(226679037474133488775313\/75557863725914323419136\)\
\), \(-\(226679037474098848911215\/75557863725914323419136\)\)}], 
            Interval[{\(-\(17319932049\/75557863725914323419136\)\), 
                17319932049\/75557863725914323419136}]]}, {x \[Rule] 
          ComplexInterval[
            Interval[{\(-\(37740789682870540311831\/37778931862957161709568\)\
\), \(-\(37740789682836945494761\/37778931862957161709568\)\)}], 
            Interval[{\(-\(16797408535\/37778931862957161709568\)\), 
                16797408535\/37778931862957161709568}]]}, {x \[Rule] 
          ComplexInterval[
            Interval[{\(-\(41874496514417284459921407\/\
77371252455336267181195264\)\), \
\(-\(319477054697255187001\/590295810358705651712\)\)}], 
            Interval[{\(-\(1138652589326335\/154742504910672534362390528\)\), 
                1138652589326335\/154742504910672534362390528}]]}, {x \[Rule] 
          ComplexInterval[
            Interval[{\(-\(2273163882589749045723\/4722366482869645213696\)\),\
 \(-\(2273163882540138173989\/4722366482869645213696\)\)}], 
            Interval[{\(-\(139142341992774167003\/4722366482869645213696\)\), \
\(-\(139142341943163295269\/4722366482869645213696\)\)}]]}, {x \[Rule] 
          ComplexInterval[
            Interval[{\(-\(2273163882589749045723\/4722366482869645213696\)\),\
 \(-\(2273163882540138173989\/4722366482869645213696\)\)}], 
            Interval[{139142341943163295269\/4722366482869645213696, 
                139142341992774167003\/4722366482869645213696}]]}}\)], \
"Output",
  CellLabel->"Out[32]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`NSolve[Normal[g] \[Equal] 0, x]\)], "Input",
  CellLabel->"In[33]:="],

Cell[BoxData[
    \({{x \[Rule] \(-3.000072081132322`\)}, {x \[Rule] \(-0.9989903848991343`\
\)}, {x \[Rule] \(-0.5412151824480371`\)}, {x \[Rule] \
\(-0.4813611757602531`\) - 
            0.02946453700124857`\ \[ImaginaryI]}, {x \[Rule] \
\(-0.4813611757602531`\) + 0.02946453700124857`\ \[ImaginaryI]}}\)], "Output",\

  CellLabel->"Out[33]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[34]:="],

Cell[BoxData[
    \({4.440892098500626`*^-16, 1.1102230246251565`*^-16, 
      1.1102230246251565`*^-16, 5.561946577567963`*^-17, 
      5.561946577567963`*^-17}\)], "Output",
  CellLabel->"Out[34]="]
}, Open  ]],

Cell[TextData[{
  "\:4ee5\:4e0b\:306e\:4f8b\:3067\:306f\:ff0c PolynomialRemainder g\:306f\
\:307b\:307c\:30bc\:30ed\:3092\:8fd4\:3057\:307e\:3059\:ff0e\:3068\:3044\:3046\
\:306e\:306f\:ff0c ",
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  " \:306f ",
  Cell[BoxData[
      \(TraditionalForm\`g2\)]],
  " \:3092\:5272\:308a\:5207\:308b\:304b\:3089\:3067\:3059\:ff0e\:3057\:304b\
\:3057\:ff0c",
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:3092\:4f7f\:3063\:305f\:6f14\:7b97\:306e\:305f\:3081\:ff0c\
\:96c6\:5408\:306b\:542b\:307e\:308c\:308b\:8981\:7d20\:306b\:3088\:3063\:3066\
\:306f\:5fc5\:305a\:3057\:3082\:30bc\:30ed\:306b\:306a\:308b\:3068\:306f\:9650\
\:308a\:307e\:305b\:3093\:ff0e\:3053\:308c\:3092\:30bc\:30ed\:3068\:3059\:308b\
\:304b\:306f\:975e\:5e38\:306b\:96e3\:3057\:3044\:554f\:984c\:3067\:3059\:304c\
\:ff0c\:6271\:3044\:3092\:76f4\:611f\:7684\:306b\:3059\:308b\:305f\:3081\:306b\
\:ff0c\:4e3b\:4fc2\:6570\:306e\:5927\:304d\:3055\:304c\:8aa4\:5dee\:3088\:308a\
\:3082\:5c0f\:3055\:304f\:306a\:3063\:305f\:5834\:5408\:306f\:6b21\:6570\:3092\
\:843d\:3068\:3059\:3088\:3046\:306a\:51e6\:7406\:3092\:8b66\:544a\:8868\:793a\
\:3068\:3068\:3082\:306b\:884c\:3063\:3066\:3044\:307e\:3059\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \({g3, g4} = {PolynomialQuotient[g2, g, x], 
        PolynomialRemainder[g2, g, x]}\)], "Input",
  CellLabel->"In[35]:="],

Cell[BoxData[
    \(SNAP::"invalid2" \(\(:\)\(\ \)\) 
      "Tolerance is larger than the representative leading coefficient: \
\!\(0.`\) \[LessEqual] \!\(1.4864519194430032`*^-6\)."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[35]:="],

Cell[BoxData[
    \(SNAP::"invalid2" \(\(:\)\(\ \)\) 
      "Tolerance is larger than the representative leading coefficient: \
\!\(0.`\) \[LessEqual] \!\(1.4864519194430032`*^-6\)."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[35]:="],

Cell[BoxData[
    \(SNAP::"invalid2" \(\(:\)\(\ \)\) 
      "Tolerance is larger than the representative leading coefficient: \
\!\(0.`\) \[LessEqual] \!\(1.4864519194430032`*^-6\)."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[35]:="],

Cell[BoxData[
    RowBox[{\(General::"stop"\), \(\(:\)\(\ \)\), "\<\"\:8a08\:7b97\:4e2d\
\:ff0c\\!\\(SNAP :: \\\"invalid2\\\"\\)\:306e\:3053\:308c\:4ee5\:4e0a\:306e\
\:51fa\:529b\:306f\:8868\:793a\:3055\:308c\:307e\:305b\:3093\:ff0e \
\\!\\(\\*ButtonBox[\\\"\:8a73\:7d30\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::stop\\\"]\\)\"\>"}]], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[35]:="],

Cell[BoxData[
    \({\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
        9.765`\ x\^3 + 5.503`\ x\^4 + x\^5, 
      Interval[{\(-\(877446340346861\/590295810358705651712\)\), 
          877446340346861\/590295810358705651712}]}\)], "Output",
  CellLabel->"Out[35]="]
}, Open  ]],

Cell[TextData[{
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:306b\:5bfe\:5fdc\:3057\:305f\:95a2\:6570\:306e\:51fa\:529b\
\:306b\:304a\:3044\:3066\:5b9a\:6570\:9805\:306e\:307f\:306e\:591a\:9805\:5f0f\
\:3068\:306a\:3063\:305f\:5834\:5408\:ff0c\:81ea\:52d5\:7684\:306b ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " \:306e\:901a\:5e38\:306e\:6570\:306e\:8868\:73fe\:306b\:5909\:63db\:3055\
\:308c\:307e\:3059\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \({SNAPQ[g3], SNAPQ[g4]}\)], "Input",
  CellLabel->"In[36]:="],

Cell[BoxData[
    \({True, False}\)], "Output",
  CellLabel->"Out[36]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({Tolerance[g3], Tolerance[g4]}\)], "Input",
  CellLabel->"In[37]:="],

Cell[BoxData[
    \({4.3694325665527665`*^-8, 1.4864519194430032`*^-6}\)], "Output",
  CellLabel->"Out[37]="]
}, Open  ]],

Cell["\<\
\:6f14\:7b97\:3092\:91cd\:306d\:308b\:3054\:3068\:306b\:96c6\:5408\
\:306b\:542b\:307e\:308c\:308b\:591a\:9805\:5f0f\:306e\:7bc4\:56f2\:306f\:5927\
\:304d\:304f\:306a\:308b\:305f\:3081\:ff0c\:305d\:308c\:3089\:306e\:6839\:3092\
\:6c42\:3081\:308b\:3068\:3088\:308a\:4e00\:5c64\:8aa4\:5dee\:304c\:5927\:304d\
\:304f\:306a\:308a\:307e\:3059\:ff0e\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g3 \[Equal] 0, x]\)], "Input",
  CellLabel->"In[38]:="],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323220438`5.769972334067041\) + 
            0``5.292840644660061\ \[ImaginaryI]}, {x \[Rule] \
\(-0.9989903848991342761`4.973440592803405\) + 
            0``4.973879284562753\ \[ImaginaryI]}, {x \[Rule] \
\(-0.5412151824480371243`3.4654179740328814\) + 
            0``3.7320480028831318\ \[ImaginaryI]}, {x \[Rule] \
\(-0.4813611757602531127`3.472125392979037\) - 
            0.0294645370012485697`2.2589539547819917\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611757602531127`3.472125392979037\) + 
            0.0294645370012485697`2.2589539547819917\ \[ImaginaryI]}}\)], \
"Output",
  CellLabel->"Out[38]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[39]:="],

Cell[BoxData[
    \({8.529922399520072`*^-6, 0.000010789593218788873`, 
      0.00034526698300124393`, 0.00017263349150062197`, 
      0.00017263349150062197`}\)], "Output",
  CellLabel->"Out[39]="]
}, Open  ]],

Cell[TextData[{
  StyleBox["NSolve",
    FontFamily->"Courier New"],
  " \:3092",
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:306b\:62e1\:5f35\:3057\:305f\:6a5f\:80fd\:306f\:ff0c\:4ee3\
\:8868\:5143\:3067\:3042\:308b\:591a\:9805\:5f0f\:304c\:591a\:91cd\:6839\:3092\
\:6301\:3064\:5834\:5408\:306b\:306f\:5229\:7528\:3059\:308b\:3053\:3068\:304c\
\:51fa\:6765\:307e\:305b\:3093\:ff0e\:5f93\:3063\:3066\:ff0c\:4e0b\:8a18\:306e\
\:4f8b\:3067\:306f\:8a08\:7b97\:3055\:308c\:305f\:6839\:306e\:8aa4\:5dee\:304c\
\:6b63\:3057\:304f\:306a\:3044\:65e8\:306e\:8b66\:544a\:304c\:8868\:793a\:3055\
\:308c\:3066\:3044\:307e\:3059\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g2 \[Equal] 0, x]\)], "Input",
  CellLabel->"In[40]:="],

Cell[BoxData[
    \(SNAP::"multipleroots" \(\(:\)\(\ \)\) 
      "The given representative polynomial has multiple roots. Tolerances of \
the roots can not be computed. A workaround for this situation is exist and \
will be implemented in the future release."\)], "Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[40]:="],

Cell[BoxData[
    \({{x \[Rule] \(-3.000072081132322`\)}, {x \[Rule] \
\(-3.000072081132322`\)}, {x \[Rule] \(-0.9989903848991343`\)}, {x \[Rule] \
\(-0.9989903848991343`\)}, {x \[Rule] \(-0.5412151824480371`\)}, {x \[Rule] \
\(-0.5412151824480371`\)}, {x \[Rule] \(-0.4813611757602531`\) - 
            0.02946453700124857`\ \[ImaginaryI]}, {x \[Rule] \
\(-0.4813611757602531`\) - 
            0.02946453700124857`\ \[ImaginaryI]}, {x \[Rule] \
\(-0.4813611757602531`\) + 
            0.02946453700124857`\ \[ImaginaryI]}, {x \[Rule] \
\(-0.4813611757602531`\) + 0.02946453700124857`\ \[ImaginaryI]}}\)], "Output",\

  CellLabel->"Out[40]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[D[g2, x] \[Equal] 0, x]\)], "Input",
  CellLabel->"In[41]:="],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323220438`9.861744504234291\) + 
            0``9.384612814827314\ \[ImaginaryI]}, {x \[Rule] \
\(-2.5308272775510292085`9.734910920957676\) + 
            0``9.331648414268853\ \[ImaginaryI]}, {x \[Rule] \
\(-0.9989903848991342761`8.65055621417121\) + 
            0``8.650994905930558\ \[ImaginaryI]}, {x \[Rule] \
\(-0.8692254815392287393`8.233368482814843\) + 
            0``8.294236033539956\ \[ImaginaryI]}, {x \[Rule] \
\(-0.5412151824480371243`5.661958871051061\) + 
            0``5.928588899901309\ \[ImaginaryI]}, {x \[Rule] \
\(-0.5094234012658132027`4.850289389133601\) + 
            0``5.143210497961874\ \[ImaginaryI]}, {x \[Rule] \
\(-0.492923839643929329`4.853870259696997\) + 
            0``5.16109043692584\ \[ImaginaryI]}, {x \[Rule] \
\(-0.4813611757602531127`5.68424278163534\) - 
            0.0294645370012485697`4.471071343438294\ \[ImaginaryI]}, {x \
\[Rule] \(-0.4813611757602531127`5.68424278163534\) + 
            0.0294645370012485697`4.471071343438294\ \[ImaginaryI]}}\)], \
"Output",
  CellLabel->"Out[41]="]
}, Open  ]],

Cell[TextData[{
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:306b\:95a2\:3059\:308b\:30aa\:30d7\:30b7\:30e7\:30f3\:3068\
\:3057\:3066\:6b21\:306e\:3082\:306e\:304c\:3042\:308a\:307e\:3059\:ff0e\:3053\
\:308c\:3089\:306f ",
  ButtonBox["SetOptions",
    ButtonStyle->"RefGuideLink"],
  StyleBox[" \:3067\:5229\:7528\:3055\:308c\:308b\:3053\:3068\:3092\:60f3\
\:5b9a\:3057\:3066\:3044\:307e\:3059\:ff0e",
    FontFamily->"Courier"]
}], "Text"],

Cell[BoxData[
    FormBox[GridBox[{
          {Cell[BoxData[
                FormBox[
                  RowBox[{
                    StyleBox["\<\"option name\"\>",
                      "TI"], "\<\" \"\>"}], TraditionalForm]]], Cell[BoxData[
                FormBox[
                  RowBox[{
                    StyleBox["\<\"default value\"\>",
                      "TI"], "\<\" \"\>"}], TraditionalForm]]], Cell[BoxData[
                \(TraditionalForm\`\[Null]\)]]},
          {"DefaultErrorScheme", 
            "AbsolutePolynomial2Norm", \(\:8a31\:5bb9\:5ea6\:3084\:8aa4\:5dee\
\:306e\:8a08\:7b97\:306e\:305f\:3081\:306e\:591a\:9805\:5f0f\:30ce\:30eb\:30e0\
\:306e\:8a08\:7b97\:65b9\:6cd5\:3067, \:73fe\:6642\:70b9\:3067\:306f\:6b21\
\:306e3\:3064\:306b\:5bfe\:5fdc\:3057\:3066\:3044\:307e\:3059 . \ 
              AbsolutePolynomial2Norm, \ 
            AbsolutePolynomial1Norm, \ \
\(\(AbsolutePolynomialiNorm\)\(.\)\)\)},
          {"TolerancePrecision", 
            "MachinePrecision", \
\(\(\:8a31\:5bb9\:5ea6\:306a\:3069\:3092\:8868\:73fe\:3059\:308b\:305f\:3081\
\:306e\:6570\:5024\:7cbe\:5ea6\)\(.\)\)}
          },
        ColumnAlignments->{Left}], TraditionalForm]], "DefinitionBox3Col",
  GridBoxOptions->{RowSpacings->0.4,
  RowLines->{True, False}}],

Cell["SNAP\:96c6\:5408\:306b\:5bfe\:3059\:308b\:30aa\:30d7\:30b7\:30e7\:30f3\
\:ff0e", "Caption"],

Cell["\<\
\:591a\:9805\:5f0f\:306e\:5b58\:5728\:3059\:308b\:7bc4\:56f2\:3092\
\:5224\:65ad\:3059\:308b\:306e\:306b\:4f7f\:3046\:65b9\:6cd5\:3092\:9078\:629e\
\:3059\:308b\:306e\:306f\:91cd\:8981\:3067\:3042\:308a\:ff0c\:95a2\:9023\:3059\
\:308b\:95a2\:6570\:3068\:3057\:3066\:6b21\:306e\:3088\:3046\:306a\:3082\:306e\
\:3082\:4f7f\:3046\:3053\:3068\:304c\:51fa\:6765\:307e\:3059\:ff0e\
\>", \
"Text"],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          RowBox[{"SetTolerance", "[", " ", 
            RowBox[{
              StyleBox["stru",
                FontSlant->"Italic"], ",", " ", 
              StyleBox[\(error\ bound\),
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
            StyleBox["stru",
              FontSlant->"Italic"], " ", "\:306e\:8a31\:5bb9\:5ea6\:3092", 
            " ", 
            StyleBox["error",
              FontSlant->"Italic"], 
            StyleBox[" ",
              FontSlant->"Italic"], 
            StyleBox["bound",
              FontSlant->"Italic"], 
            StyleBox[" ",
              
              FontSlant->
                "Italic"], \(\(\:306b\:5909\:66f4\:3057\:305fSNAP\:96c6\:5408\
\:3092\:8fd4\:3057\:307e\:3059\)\(.\)\)}]},
        {
          RowBox[{"TransformSNAP", "[", " ", 
            RowBox[{
              StyleBox["stru",
                FontSlant->"Italic"], ",", " ", 
              StyleBox[\(error\ scheme\),
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
            StyleBox["stru",
              FontSlant->"Italic"], " ", 
            "\:306e\:8a31\:5bb9\:5ea6\:306e\:8a08\:7b97\:65b9\:6cd5\:3092", 
            " ", 
            StyleBox["error",
              FontSlant->"Italic"], 
            StyleBox[" ",
              FontSlant->"Italic"], 
            StyleBox["scheme",
              FontSlant->"Italic"], 
            StyleBox[" ",
              
              FontSlant->
                "Italic"], \(\(\:306b\:5909\:66f4\:3057\:305fSNAP\:96c6\:5408\
\:3092\:8fd4\:3057\:307e\:3059\)\(.\)\)}]}
        }]]]], "DefinitionBox"],

Cell["SNAP\:96c6\:5408\:306e\:8a31\:5bb9\:5ea6\:306b\:95a2\:3059\:308b\:95a2\
\:6570\:ff0e", "Caption"],

Cell["\<\
\:57fa\:672c\:7684\:306b\:ff0c\:8a31\:5bb9\:5ea6\:306e\:8a08\:7b97\
\:65b9\:6cd5\:3092\:5909\:66f4\:3059\:308b\:3068\:8a31\:5bb9\:5ea6\:306f\:5927\
\:304d\:304f\:306a\:308a\:307e\:3059\:ff0e\:3053\:308c\:306f\:ff0c\:96c6\:5408\
\:306b\:542b\:307e\:308c\:308b\:591a\:9805\:5f0f\:3092\:7dad\:6301\:3059\:308b\
\:305f\:3081\:3067\:3059\:ff0e\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g]\)], "Input",
  CellLabel->"In[42]:="],

Cell[BoxData[
    \(2.2211398302543545`*^-15\)], "Output",
  CellLabel->"Out[42]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g1 = TransformSNAP[g, AbsolutePolynomial1Norm]\)], "Input",
  CellLabel->"In[43]:="],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[43]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance[g1]\)], "Input",
  CellLabel->"In[44]:="],

Cell[BoxData[
    \(5.440659231495211`*^-15\)], "Output",
  CellLabel->"Out[44]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g, x]\)], "Input",
  CellLabel->"In[45]:="],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323220438282532996`12.815835180381182\) + 
            0``12.338703490974202\ \[ImaginaryI]}, {x \[Rule] \
\(-0.9989903848991342760754719166`12.050538702420925\) + 
            0``12.050977394180272\ \[ImaginaryI]}, {x \[Rule] \
\(-0.5412151824480371242742648909`10.565558360172346\) + 
            0``10.832188389022596\ \[ImaginaryI]}, {x \[Rule] \
\(-0.481361175760253112709818879`10.661053888809242\) - 
            0.0294645370012485696697979165`9.447882450612196\ \[ImaginaryI]}, \
{x \[Rule] \(-0.481361175760253112709818879`10.661053888809242\) + 
            0.0294645370012485696697979165`9.447882450612196\ \[ImaginaryI]}}\
\)], "Output",
  CellLabel->"Out[45]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[46]:="],

Cell[BoxData[
    \({6.431098710768743`*^-13, 1.2862197421537486`*^-12, 
      3.253907165344266`*^-11, 2.0579515874459978`*^-11, 
      2.0579515874459978`*^-11}\)], "Output",
  CellLabel->"Out[46]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[g1, x]\)], "Input",
  CellLabel->"In[47]:="],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323220438282532996`12.556027282847799\) + 
            0``12.078895593440821\ \[ImaginaryI]}, {x \[Rule] \
\(-0.9989903848991342760754719166`11.776389555000947\) + 
            0``11.776828246760298\ \[ImaginaryI]}, {x \[Rule] \
\(-0.5412151824480371242742648909`10.280471361137263\) + 
            0``10.547101389987512\ \[ImaginaryI]}, {x \[Rule] \
\(-0.481361175760253112709818879`10.330965161845718\) - 
            0.0294645370012485696697979165`9.117793723648672\ \[ImaginaryI]}, \
{x \[Rule] \(-0.481361175760253112709818879`10.330965161845718\) + 
            0.0294645370012485696697979165`9.117793723648672\ \[ImaginaryI]}}\
\)], "Output",
  CellLabel->"Out[47]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[48]:="],

Cell[BoxData[
    \({1.2862197421537486`*^-12, 2.5724394843074972`*^-12, 
      6.507814330688532`*^-11, 4.1159031748919956`*^-11, 
      4.1159031748919956`*^-11}\)], "Output",
  CellLabel->"Out[48]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(gint = TransformSNAP[g, IntervalForm]\)], "Input",
  CellLabel->"In[49]:="],

Cell[BoxData[
    \(Interval[{0.3772499999999977`, 0.37725000000000225`}] + 
      x\^5\ Interval[{0.9999999999999977`, 1.0000000000000024`}] + 
      x\ Interval[{2.7619999999999973`, 2.7620000000000027`}] + 
      x\^4\ Interval[{5.502999999999997`, 5.503000000000004`}] + 
      x\^2\ Interval[{7.646999999999997`, 7.647000000000004`}] + 
      x\^3\ Interval[{9.764999999999997`, 9.765000000000004`}]\)], "Output",
  CellLabel->"Out[49]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[gint, x]\)], "Input",
  CellLabel->"In[50]:="],

Cell[BoxData[
    \({{x \[Rule] \(-3.0000720811323220438282532996`12.815835180406253\) + 
            0``12.338703490999276\ \[ImaginaryI]}, {x \[Rule] \
\(-0.9989903848991342760754719166`12.050538702433851\) + 
            0``12.0509773941932\ \[ImaginaryI]}, {x \[Rule] \
\(-0.5412151824480371242742648909`10.565558360184845\) + 
            0``10.832188389035096\ \[ImaginaryI]}, {x \[Rule] \
\(-0.481361175760253112709818879`10.662237015763164\) - 
            0.0294645370012485696697979165`9.44906557756612\ \[ImaginaryI]}, \
{x \[Rule] \(-0.481361175760253112709818879`10.662237015763164\) + 
            0.0294645370012485696697979165`9.44906557756612\ \
\[ImaginaryI]}}\)], "Output",
  CellLabel->"Out[50]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Tolerance /@ \((x /. %)\)\)], "Input",
  CellLabel->"In[51]:="],

Cell[BoxData[
    \({6.431098710768743`*^-13, 1.2862197421537486`*^-12, 
      3.253907165344266`*^-11, 2.0579515874459978`*^-11, 
      2.0579515874459978`*^-11}\)], "Output",
  CellLabel->"Out[51]="]
}, Open  ]],

Cell[TextData[{
  "\:5b9f\:9a13\:30c7\:30fc\:30bf\:306a\:3069\:3092\:6271\:3046\:305f\:3081\
\:306b\:ff0c\:8fd1\:4f3c\:4ee3\:6570\:6f14\:7b97\:3092\:5fc5\:8981\:3059\:308b\
\:30e6\:30fc\:30b6\:306b\:5bfe\:3057\:3066\:ff0c\:3053\:306e\:30d1\:30c3\:30b1\
\:30fc\:30b8\:306f\:4e0b\:8a18\:306e\:95a2\:6570\:3092\:63d0\:4f9b\:3057\:307e\
\:3059\:ff0e\:3053\:308c\:3089\:306f\:ff0c\:5b9f\:9a13\:7684\:306a\:5b9f\:88c5\
\:306b\:306a\:3063\:3066\:3044\:308b\:3082\:306e\:3084\:5fc5\:305a\:3057\:3082\
",
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:3092\:8fd4\:3055\:306a\:3044\:306a\:3069\:306e\:9055\:3044\
\:304c\:3042\:308b\:306e\:3067\:ff0c\:5229\:7528\:306b\:3042\:305f\:3063\:3066\
\:306f\:6ce8\:610f\:3057\:3066\:304f\:3060\:3055\:3044\:ff0e\:305f\:3060\:3057\
\:ff0c",
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:3092\:8fd4\:3055\:306a\:3044\:6f14\:7b97\:306f\:ff0c\:3082\
\:3068\:3082\:3068\:306e\:64cd\:4f5c\:304c",
  StyleBox["SNAP",
    FontFamily->"Courier New"],
  "\:96c6\:5408\:306b\:5bfe\:3057\:3066\:4f55\:304b\:306e\:53b3\:5bc6\:306a\
\:591a\:9805\:5f0f\:3092\:6c42\:3081\:308b\:6f14\:7b97\:3067\:3042\:308b\:3053\
\:3068\:306b\:3082\:7559\:610f\:3057\:3066\:304f\:3060\:3055\:3044\:ff0e"
}], "Text"],

Cell[TextData[Cell[BoxData[GridBox[{
        {
          RowBox[{"NearestSingularPolynomial", "[", " ", 
            StyleBox["expr",
              FontSlant->"Italic"], "]"}], 
          RowBox[{
            StyleBox["expr",
              FontSlant->"Italic"], 
            " ", \(\(\:306e\:591a\:9805\:5f0f2\:30ce\:30eb\:30e0\:3067\:306e\
\:6700\:8fd1\:7279\:7570\:591a\:9805\:5f0f\:3092\:8fd4\:3057\:307e\:3059\)\(.\
\)\)}]},
        {
          RowBox[{"PolynomialGCD", "[", " ", 
            RowBox[{
              StyleBox["g",
                FontSlant->"Italic"], ",", " ", 
              StyleBox["h",
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
            RowBox[{
              StyleBox["g",
                FontSlant->"Italic"], " ", "\:304b", " ", 
              StyleBox["h",
                FontSlant->"Italic"], " ", 
              "\:306e\:3044\:305a\:308c\:304b\:304cSNAP\:96c6\:5408\:3067\
\:3042\:308b\:304b"}], ",", 
            "\:7b2c\:4e09\:5f15\:6570\:3068\:3057\:3066\:8a31\:5bb9\:5ea6\
\:3092\:6307\:5b9a\:3059\:308b\:3068", 
            ",", \(\:305d\:308c\:3089\:306e\[Epsilon] - \(\(GCD\:3092\:8a08\
\:7b97\:3057\:307e\:3059\)\(.\)\)\)}]},
        {
          RowBox[{"ApproximateQuotient", "[", " ", 
            RowBox[{
              StyleBox["g",
                FontSlant->"Italic"], ",", " ", 
              StyleBox["h",
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
            StyleBox["g",
              FontSlant->"Italic"], " ", "\:306e", " ", 
            StyleBox["h",
              FontSlant->"Italic"], 
            " ", \(\(\:306b\:3088\:308b\:8fd1\:4f3c\:5546\:3092CGTW95\:306e\
\:5b9a\:7fa9\:306b\:5f93\:3063\:3066\:8a08\:7b97\:3057\:307e\:3059\)\(.\)\)}]}\
,
        {
          RowBox[{"ApproximateDivisorQ", "[", " ", 
            RowBox[{
              StyleBox["g",
                FontSlant->"Italic"], ",", " ", 
              StyleBox["h",
                FontSlant->"Italic"]}], "]"}], 
          RowBox[{
            StyleBox["h",
              FontSlant->"Italic"], " ", "\:304c", " ", 
            StyleBox["g",
              FontSlant->"Italic"], 
            " ", \(\(\:3092\:8fd1\:4f3c\:7684\:306b\:5272\:308a\:5207\:308b\
\:304b\:306e\:5224\:5b9a\:3092CGTW95\:306e\:5b9a\:7fa9\:306b\:5f93\:3063\:3066\
\:884c\:3044\:307e\:3059\)\(.\)\)}]},
        {
          RowBox[{
            FormBox[
              StyleBox["AbsolutelyIrreducibleQ",
                FontFamily->"Courier"],
              "TraditionalForm"], "[", " ", 
            RowBox[{
              StyleBox["g",
                FontSlant->"Italic"], ",", " ", 
              StyleBox["\[Epsilon]",
                FontSlant->"Italic"]}], "]"}], 
          FormBox[
            RowBox[{
            "\:4e8c\:5909\:6570\:591a\:9805\:5f0f", Cell[TextData[StyleBox[
              "g",
                FontSlant->"Italic"]]], " ", "\:304c\:8a31\:5bb9\:5ea6", " ", 
              Cell[TextData[StyleBox["\[Epsilon]",
                
                FontSlant->
                  "Italic"]]], \(\(\:3067\:7d76\:5bfe\:65e2\:7d04\:3067\:3042\
\:308b\:304b\:3092\:5224\:5b9a\:3057\:307e\:3059\)\(.\)\)}],
            "TraditionalForm"]},
        {
          RowBox[{
            FormBox[
              StyleBox["SeparationBound",
                FontFamily->"Courier"],
              "TraditionalForm"], "[", " ", 
            StyleBox["g",
              FontSlant->"Italic"], "]"}], 
          RowBox[{"\:4e8c\:5909\:6570\:591a\:9805\:5f0f", " ", 
            StyleBox["g",
              FontSlant->"Italic"], " ", 
            "\:306e\:7d76\:5bfe\:65e2\:7d04\:534a\:5f84", \((\:5206\:96e2\
\:7cbe\:5ea6)\), \(\(\:3092\:8a08\:7b97\:3057\:307e\:3059\)\(.\)\)}]},
        {
          RowBox[{
            FormBox[
              StyleBox["Factor",
                FontFamily->"Courier"],
              "TraditionalForm"], "[", " ", 
            StyleBox["g",
              FontSlant->"Italic"], 
            "]"}], \(\(\:591a\:5909\:6570\:591a\:9805\:5f0f\:306e\:8fd1\:4f3c\
\:56e0\:6570\:5206\:89e3\:3092\:884c\:3044\:307e\:3059\)\(.\)\)},
        {
          FormBox[
            StyleBox[\(FactorList[\ g]\),
              FontFamily->"Courier"],
            
            "TraditionalForm"], \
\(\(\:591a\:5909\:6570\:591a\:9805\:5f0f\:306e\:8fd1\:4f3c\:56e0\:5b50\:306e\
\:30ea\:30b9\:30c8\:3092\:8fd4\:3057\:307e\:3059\)\(.\)\)}
        }]]]], "DefinitionBox"],

Cell["\:8fd1\:4f3c\:4ee3\:6570\:306b\:95a2\:3059\:308b\:95a2\:6570\:ff0c", \
"Caption"],

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`g\)]],
  " \:304c\:3069\:306e\:3088\:3046\:306a\:591a\:9805\:5f0f\:3060\:3063\:305f\
\:304b\:78ba\:8a8d\:3057\:307e\:3059\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g\)], "Input",
  CellLabel->"In[52]:="],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[52]="]
}, Open  ]],

Cell["\<\
\:4ed6\:306b\:3082\:3046\:4e00\:3064\:591a\:9805\:5f0f\:3092\:5b9a\
\:7fa9\:3057\:307e\:3059\:ff0e\:3053\:306e\:30d1\:30c3\:30b1\:30fc\:30b8\:306e\
\:95a2\:6570\:306f\:ff0cSNAP\:96c6\:5408\:3068\:901a\:5e38\:306e\:591a\:9805\
\:5f0f\:306e\:7d44\:307f\:5408\:308f\:305b\:3067\:3082\:52d5\:4f5c\:3057\:307e\
\:3059\:ff0e\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(h = 
      1.3883`16\[InvisibleSpace] + 4.417`16\ x + 3.8861`16\ x\^2 + 
        0.85593`16\ x\^3\)], "Input",
  CellLabel->"In[53]:="],

Cell[BoxData[
    \(1.3883`16.000000000000004 + 4.417`16.000000000000004\ x + 
      3.8861`16.000000000000004\ x\^2 + 
      0.85593`16.000000000000004\ x\^3\)], "Output",
  CellLabel->"Out[53]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ApproximateDivisorQ[g, h, 0.0001]\)], "Input",
  CellLabel->"In[54]:="],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[54]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(N@ApproximateQuotient[g, h, 0.0001]\)], "Input",
  CellLabel->"In[55]:="],

Cell[BoxData[
    \(\(\(0.2716982054190293`\)\(\[InvisibleSpace]\)\) + 
      1.1250329893982267`\ x + 1.1682982206523567`\ x\^2\)], "Output",
  CellLabel->"Out[55]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Expand[%*h]\)], "Input",
  CellLabel->"In[56]:="],

Cell[BoxData[
    \(\(\(0.3771986185832384`\)\(\[InvisibleSpace]\)\) + 
      2.761974272517411`\ x + 7.647065529982523`\ x\^2 + 
      9.764918585686218`\ x\^3 + 5.5030732018927475`\ x\^4 + 
      0.9999814960029716`\ x\^5\)], "Output",
  CellLabel->"Out[56]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g\)], "Input",
  CellLabel->"In[57]:="],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 2.762`\ x + 7.647`\ x\^2 + 
      9.765`\ x\^3 + 5.503`\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[57]="]
}, Open  ]],

Cell["\<\
\:7d44\:307f\:8fbc\:307f\:95a2\:6570\:306f\:ff0c\:3053\:308c\:3089\
\:306e\:591a\:9805\:5f0f\:306f\:4e92\:3044\:306b\:7d20\:3067\:3042\:308b\:3068\
\:5224\:5b9a\:3057\:307e\:3059\:ff0e\:6570\:5b66\:7684\:306b\:306f\:6b63\:3057\
\:3044\:52d5\:4f5c\:3067\:3059\:ff0e\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`PolynomialGCD[Normal[g], h]\)], "Input",
  CellLabel->"In[58]:="],

Cell[BoxData[
    \(1\/9007199254740992\)], "Output",
  CellLabel->"Out[58]="]
}, Open  ]],

Cell[TextData[{
  "\:3053\:306e\:30d1\:30c3\:30b1\:30fc\:30b8\:306e\:95a2\:6570\:3092\:4f7f\
\:3046\:3068",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon]\)]],
  "-GCD \:3092\:8a08\:7b97\:3059\:308b\:3053\:3068\:304c\:51fa\:6765\:307e\
\:3059\:ff0e\:3053\:306e\:4f8b\:3067\:306f\:ff0c\:8a31\:5bb9\:5ea6\:3068\:3057\
\:3066 ",
  Cell[BoxData[
      \(TraditionalForm\`\[Epsilon] = 0.0001\)]],
  "\:3092\:4f7f\:3063\:3066\:3044\:307e\:3059\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(gcdofgh = PolynomialGCD[g, h, 0.0001]\)], "Input",
  CellLabel->"In[59]:="],

Cell[BoxData[
    \(\(\(0.37725`\)\(\[InvisibleSpace]\)\) + 1.2002544478859036`\ x + 
      1.055990221854066`\ x\^2 + 0.23258632320103723`\ x\^3\)], "Output",
  CellLabel->"Out[59]="]
}, Open  ]],

Cell["\<\
\:305d\:306e\:4ed6\:ff0c\:8a31\:5bb9\:5ea6\:5185\:3067\:306e\:5272\
\:308a\:5207\:308c\:308b\:591a\:9805\:5f0f\:304c\:5b58\:5728\:3059\:308b\:304b\
\:78ba\:8a8d\:3057\:305f\:308a\:ff0c\:305d\:306e\:3068\:304d\:306e\:5546\:3092\
\:6c42\:3081\:308b\:3053\:3068\:3082\:51fa\:6765\:307e\:3059\:ff0e\
\>", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ApproximateDivisorQ[g, gcdofgh, 0.0001]\)], "Input",
  CellLabel->"In[60]:="],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[60]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(N@ApproximateQuotient[g, gcdofgh, 0.0001]\)], "Input",
  CellLabel->"In[61]:="],

Cell[BoxData[
    \(\(\(0.9998638000881077`\)\(\[InvisibleSpace]\)\) + 
      4.140181044881532`\ x + 4.299399389613435`\ x\^2\)], "Output",
  CellLabel->"Out[61]="]
}, Open  ]],

Cell["\<\
\:8a31\:5bb9\:5ea6\:3092\:6307\:5b9a\:3057\:306a\:304b\:3063\:305f\
\:3068\:304d\:306f\:ff0c\:81ea\:52d5\:7684\:306b\:4fc2\:6570\:306e\:7cbe\:5ea6\
\:304b\:3089\:8a08\:7b97\:3055\:308c\:ff0c\:5927\:304d\:3044\:307b\:3046\:306e\
\:8a31\:5bb9\:5ea6\:304c\:4f7f\:308f\:308c\:307e\:3059\:ff0e\
\>", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolynomialGCD[g, h] // Timing\)], "Input",
  CellLabel->"In[62]:="],

Cell[BoxData[
    \(SNAP::"toleranceadjusted" \(\(:\)\(\ \)\) 
      "The given different tolerances adjusted into their maximum."\)], \
"Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[62]:="],

Cell[BoxData[
    \({0.4000000000000001`\ Second, 1}\)], "Output",
  CellLabel->"Out[62]="]
}, Open  ]],

Cell["\<\
\:8a31\:5bb9\:5ea6\:306e\:7bc4\:56f2\:3067\:4e92\:3044\:306b\:7d20\
\:3067\:3042\:308b\:304b\:3092\:78ba\:8a8d\:3059\:308b\:3060\:3051\:3067\:3042\
\:308c\:3070\:ff0c\:6b21\:306e\:95a2\:6570\:306e\:307b\:3046\:304c\:901f\:304f\
\:30c1\:30a7\:30c3\:30af\:3067\:304d\:307e\:3059\:ff0e\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(CoprimeQ[g, h] // Timing\)], "Input",
  CellLabel->"In[63]:="],

Cell[BoxData[
    \(SNAP::"toleranceadjusted" \(\(:\)\(\ \)\) 
      "The given different tolerances adjusted into their maximum."\)], \
"Message",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[63]:="],

Cell[BoxData[
    \({0.12999999999999973`\ Second, True}\)], "Output",
  CellLabel->"Out[63]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(CoprimeQ[N[Normal[g]], N[Normal[g]]]\)], "Input",
  CellLabel->"In[64]:="],

Cell[BoxData[
    \($Failed\)], "Output",
  CellLabel->"Out[64]="]
}, Open  ]],

Cell["\<\
\:6700\:8fd1\:7279\:7570\:591a\:9805\:5f0f\:3092\:6c42\:3081\:307e\
\:3059\:ff0e\:7d50\:679c\:306e\:591a\:9805\:5f0f\:306f\:5f93\:3063\:3066\:91cd\
\:6839\:3092\:6301\:3061\:307e\:3059\:ff0e\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[Evaluate[Normal@g], {x, \(-0.55\), \(-0.45\)}, 
      PlotRange \[Rule] {Automatic, {\(-0.0001\), 0.0001}}]\)], "Input",
  CellLabel->"In[65]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
5.26191 9.52381 0.309017 3090.17 [
[.11905 .29652 -15 -9 ]
[.11905 .29652 15 0 ]
[.30952 .29652 -15 -9 ]
[.30952 .29652 15 0 ]
[.69048 .29652 -15 -9 ]
[.69048 .29652 15 0 ]
[.88095 .29652 -15 -9 ]
[.88095 .29652 15 0 ]
[.4875 0 -42 -4.5 ]
[.4875 0 0 4.5 ]
[.4875 .07725 -54 -4.5 ]
[.4875 .07725 0 4.5 ]
[.4875 .15451 -48 -4.5 ]
[.4875 .15451 0 4.5 ]
[.4875 .23176 -54 -4.5 ]
[.4875 .23176 0 4.5 ]
[.4875 .38627 -48 -4.5 ]
[.4875 .38627 0 4.5 ]
[.4875 .46353 -42 -4.5 ]
[.4875 .46353 0 4.5 ]
[.4875 .54078 -48 -4.5 ]
[.4875 .54078 0 4.5 ]
[.4875 .61803 -36 -4.5 ]
[.4875 .61803 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.11905 .30902 m
.11905 .31527 L
s
[(-0.54)] .11905 .29652 0 1 Mshowa
.30952 .30902 m
.30952 .31527 L
s
[(-0.52)] .30952 .29652 0 1 Mshowa
.69048 .30902 m
.69048 .31527 L
s
[(-0.48)] .69048 .29652 0 1 Mshowa
.88095 .30902 m
.88095 .31527 L
s
[(-0.46)] .88095 .29652 0 1 Mshowa
.125 Mabswid
.16667 .30902 m
.16667 .31277 L
s
.21429 .30902 m
.21429 .31277 L
s
.2619 .30902 m
.2619 .31277 L
s
.35714 .30902 m
.35714 .31277 L
s
.40476 .30902 m
.40476 .31277 L
s
.45238 .30902 m
.45238 .31277 L
s
.54762 .30902 m
.54762 .31277 L
s
.59524 .30902 m
.59524 .31277 L
s
.64286 .30902 m
.64286 .31277 L
s
.7381 .30902 m
.7381 .31277 L
s
.78571 .30902 m
.78571 .31277 L
s
.83333 .30902 m
.83333 .31277 L
s
.07143 .30902 m
.07143 .31277 L
s
.02381 .30902 m
.02381 .31277 L
s
.92857 .30902 m
.92857 .31277 L
s
.97619 .30902 m
.97619 .31277 L
s
.25 Mabswid
0 .30902 m
1 .30902 L
s
.5 0 m
.50625 0 L
s
[(-0.0001)] .4875 0 1 0 Mshowa
.5 .07725 m
.50625 .07725 L
s
[(-0.000075)] .4875 .07725 1 0 Mshowa
.5 .15451 m
.50625 .15451 L
s
[(-0.00005)] .4875 .15451 1 0 Mshowa
.5 .23176 m
.50625 .23176 L
s
[(-0.000025)] .4875 .23176 1 0 Mshowa
.5 .38627 m
.50625 .38627 L
s
[(0.000025)] .4875 .38627 1 0 Mshowa
.5 .46353 m
.50625 .46353 L
s
[(0.00005)] .4875 .46353 1 0 Mshowa
.5 .54078 m
.50625 .54078 L
s
[(0.000075)] .4875 .54078 1 0 Mshowa
.5 .61803 m
.50625 .61803 L
s
[(0.0001)] .4875 .61803 1 0 Mshowa
.125 Mabswid
.5 .01545 m
.50375 .01545 L
s
.5 .0309 m
.50375 .0309 L
s
.5 .04635 m
.50375 .04635 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .10816 m
.50375 .10816 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .13906 m
.50375 .13906 L
s
.5 .16996 m
.50375 .16996 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .20086 m
.50375 .20086 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .26266 m
.50375 .26266 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .29357 m
.50375 .29357 L
s
.5 .32447 m
.50375 .32447 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .35537 m
.50375 .35537 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .41717 m
.50375 .41717 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .44807 m
.50375 .44807 L
s
.5 .47898 m
.50375 .47898 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .50988 m
.50375 .50988 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .57168 m
.50375 .57168 L
s
.5 .58713 m
.50375 .58713 L
s
.5 .60258 m
.50375 .60258 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .1424 m
.06244 .22716 L
.10458 .30428 L
.14415 .36319 L
.18221 .40852 L
.22272 .44571 L
.26171 .47189 L
.28302 .48264 L
.30316 .49073 L
.32313 .49694 L
.34157 .50122 L
.36029 .50429 L
.37094 .50552 L
.38092 .50637 L
.38588 .50668 L
.3913 .50695 L
.39378 .50705 L
.39642 .50714 L
.39889 .50721 L
.40117 .50726 L
.40357 .5073 L
.40483 .50732 L
.40617 .50733 L
.40733 .50734 L
.40842 .50734 L
.40961 .50735 L
.41088 .50735 L
.41202 .50734 L
.41325 .50734 L
.41441 .50733 L
.41549 .50732 L
.41753 .5073 L
.41969 .50726 L
.42458 .50715 L
.42906 .50701 L
.43916 .50659 L
.44807 .50611 L
.45744 .50551 L
.49555 .50252 L
.5168 .50085 L
.53611 .49962 L
.54575 .49916 L
.55118 .49897 L
.55377 .49889 L
.5562 .49884 L
.55849 .49879 L
.56058 .49876 L
.56169 .49874 L
.56291 .49873 L
.56419 .49872 L
Mistroke
.56541 .49871 L
.56669 .49871 L
.56786 .49871 L
.5685 .49871 L
.5692 .49871 L
.57047 .49872 L
.57166 .49873 L
.57291 .49874 L
.57516 .49877 L
.57771 .49883 L
.58013 .49889 L
.58466 .49905 L
.58954 .49929 L
.59483 .49962 L
.60437 .50043 L
.61318 .50143 L
.62283 .50285 L
.63188 .5045 L
.6525 .50954 L
.67272 .51642 L
.69124 .52464 L
.71181 .53617 L
.73092 .54938 L
.76908 .5839 L
Mfstroke
.76908 .5839 m
.79671 .61803 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[65]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00JP3oool2000000@0oooo00<000000?ooo`3oool00`3oool2000000@0
oooo0P0000040?ooo`8000000`3oool4000009D0oooo001Y0?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo000000@0oooo00<000000?ooo`3oool0U03oool006T0oooo00@000000?ooo`3oool00000203o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool00000103oool00`000000oooo0?ooo`030?ooo`<00000SP3oool006<0oooo100000020?ooo`04
0000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`2>0?ooo`00J@3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool0SP3oool006T0oooo00@000000?ooo`3oool00000203oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool3000000D0oooo00<000000?ooo`3oool0SP3oool006X0oooo0P00000:0?ooo`800000
103oool2000000@0oooo0P0000050?ooo`030000003oool0oooo00<0oooo0P00002?0?ooo`00S`3o
ool00`000000oooo0?ooo`2>0?ooo`00S`3oool00`000000oooo0?ooo`2>0?ooo`00S`3oool00`00
0000oooo0?ooo`2>0?ooo`00S`3oool2000008l0oooo002?0?ooo`030000003oool0oooo08h0oooo
002?0?ooo`030000003oool0oooo08h0oooo002?0?ooo`030000003oool0oooo08h0oooo002?0?oo
o`030000003oool0oooo08h0oooo002?0?ooo`800000S`3oool008l0oooo00<000000?ooo`3oool0
SP3oool008l0oooo00<000000?ooo`3oool0SP3oool008l0oooo00<000000?ooo`3oool0SP3oool0
08l0oooo0P00002?0?ooo`00S`3oool00`000000oooo0?ooo`2>0?ooo`00GP3oool2000000@0oooo
00<000000?ooo`3oool00`3oool2000000@0oooo0P0000040?ooo`800000103oool2000000@0oooo
00<000000?ooo`3oool00P3oool3000000D0oooo00<000000?ooo`3oool0SP3oool005d0oooo00@0
00000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`2>0?ooo`00G@3oool0
10000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`<00000SP3oool005L0oooo100000020?oo
o`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool01000
0000oooo0?ooo`3oool3000000D0oooo00<000000?ooo`3oool0SP3oool005d0oooo00@000000?oo
o`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000050?ooo`040000003oool0oooo
000000L0oooo00<000000?ooo`3oool0SP3oool005d0oooo00@000000?ooo`3oool00000203oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`2>0?ooo`00GP3oool2000000X0oooo0P0000040?oo
o`800000103oool2000000@0oooo0P0000030?ooo`@000000P3oool4000000@0oooo0P00002?0?oo
o`00S`3oool00`000000oooo0?ooo`2>0?ooo`00S`3oool00`000000oooo0?ooo`2>0?ooo`00S`3o
ool00`000000oooo0?ooo`2>0?ooo`00S`3oool2000008l0oooo002?0?ooo`030000003oool0oooo
08h0oooo002?0?ooo`030000003oool0oooo08h0oooo002?0?ooo`030000003oool0oooo08h0oooo
002?0?ooo`030000003oool0oooo08h0oooo002?0?ooo`800000S`3oool008l0oooo00<000000?oo
o`3oool0SP3oool008l0oooo00<000000?ooo`3oool0SP3oool008l0oooo00<000000?ooo`3oool0
SP3oool008l0oooo0P00002?0?ooo`003P3oool00`000000oooo0?ooo`1n0?ooo`030000003oool0
oooo08h0oooo000>0?ooo`030000003oool0oooo05<0oooo0P0000040?ooo`030000003oool0oooo
00<0oooo0P0000040?ooo`800000103oool2000000@0oooo0P0000030?ooo`<000001@3oool00`00
0000oooo0?ooo`2>0?ooo`003`3oool00`000000oooo0?ooo`1A0?ooo`040000003oool0oooo0000
00P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo08h0oooo000?0?ooo`030000003oool0oooo0540oooo00@000000?ooo`3oool0
0000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo0080oooo
0`00002>0?ooo`00403oool00`000000oooo0?ooo`1:0?ooo`@000000P3oool010000000oooo0?oo
o`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo0`0000050?ooo`030000003o
ool0oooo08h0oooo000@0?ooo`030000003oool0oooo0500oooo00@000000?ooo`3oool00000203o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0SP3oool00140oooo00<000000?ooo`3oool0C`3oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`2>0?ooo`004@3oool00`000000oooo0?ooo`1@0?ooo`8000002P3oool2000000@0
oooo0P0000040?ooo`800000103oool2000000<0oooo100000040?ooo`800000S`3oool00140oooo
00<000000?ooo`3oool0N`3oool00`000000oooo0?ooo`2>0?ooo`004P3oool00`000000oooo0?oo
o`1j0?ooo`030000003oool0oooo08h0oooo000B0?ooo`030000003oool0oooo07X0oooo00<00000
0?ooo`3oool0SP3oool001<0oooo00<000000?ooo`3oool0N@3oool2000008l0oooo000C0?ooo`03
0000003oool0oooo07T0oooo00<000000?ooo`3oool0SP3oool001@0oooo00<000000?ooo`3oool0
N03oool00`000000oooo0?ooo`2>0?ooo`00503oool00`000000oooo0?ooo`1h0?ooo`030000003o
ool0oooo08h0oooo000E0?ooo`030000003oool0oooo07L0oooo00<000000?ooo`3oool0SP3oool0
01D0oooo00<000000?ooo`3oool0M`3oool2000008l0oooo000E0?ooo`030000003oool0oooo07L0
oooo00<000000?ooo`3oool0SP3oool001H0oooo00<000000?ooo`3oool0MP3oool00`000000oooo
0?ooo`2>0?ooo`005P3oool00`000000oooo0?ooo`1f0?ooo`030000003oool0oooo08h0oooo000G
0?ooo`030000003oool0oooo07D0oooo0P00002?0?ooo`005`3oool00`000000oooo0?ooo`1e0?oo
o`030000003oool0oooo08h0oooo000H0?ooo`030000003oool0oooo04<0oooo0P0000040?ooo`03
0000003oool0oooo00<0oooo0P0000040?ooo`800000103oool2000000@0oooo0P0000030?ooo`@0
00000P3oool3000000D0oooo00<000000?ooo`3oool0SP3oool001P0oooo00<000000?ooo`3oool0
@P3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo08h0oooo
000I0?ooo`030000003oool0oooo0440oooo00@000000?ooo`3oool00000203oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`0000030?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00P3o
ool3000008h0oooo000I0?ooo`030000003oool0oooo03/0oooo100000020?ooo`040000003oool0
oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool010000000oooo0?ooo`3o
ool3000000D0oooo00<000000?ooo`3oool0SP3oool001X0oooo00<000000?ooo`3oool0@03oool0
10000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000D0oooo00@00000
0?ooo`3oool000001`3oool00`000000oooo0?ooo`2>0?ooo`006P3oool00`000000oooo0?ooo`10
0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`0000020?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0SP3o
ool001/0oooo00<000000?ooo`3oool0@03oool2000000X0oooo0P0000040?ooo`800000103oool2
000000@0oooo0P0000040?ooo`8000000`3oool4000000@0oooo0P00002?0?ooo`006`3oool00`00
0000oooo0?ooo`1a0?ooo`030000003oool0oooo08h0oooo000L0?ooo`030000003oool0oooo0700
oooo00<000000?ooo`3oool0SP3oool001d0oooo00<000000?ooo`3oool0K`3oool00`000000oooo
0?ooo`2>0?ooo`007@3oool00`000000oooo0?ooo`1_0?ooo`800000S`3oool001h0oooo00<00000
0?ooo`3oool0KP3oool00`000000oooo0?ooo`2>0?ooo`007P3oool00`000000oooo0?ooo`1^0?oo
o`030000003oool0oooo08h0oooo000O0?ooo`<00000103oool00`000000oooo0?ooo`020?ooo`<0
00001@3oool00`000000oooo0?ooo`0N0?ooo`800000103oool00`000000oooo0?ooo`020?ooo`<0
00000`3oool4000002H0oooo00<000000?ooo`3oool0:P3oool2000000@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`020?ooo`800000803oool2000000@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`020?ooo`800000703oool001l0oooo00@000000?ooo`3oool0
00002`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo01d0oooo00@000000?ooo`3o
ool000002`3oool010000000oooo0?ooo`00000Y0?ooo`030000003oool0oooo02T0oooo00@00000
0?ooo`3oool000002P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0
703oool010000000oooo0?ooo`00000:0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`00
0000oooo0?ooo`0I0?ooo`007`3oool2000000030?ooo`000000oooo00X0oooo00<000000?ooo`00
00001000000N0?ooo`040000003oool0oooo000000/0oooo00D000000?ooo`3oool0oooo0000000X
0?ooo`800000:P3oool010000000oooo0?ooo`0000070?ooo`D000000P3oool010000000oooo0?oo
o`00000N0?ooo`040000003oool0oooo000000L0oooo1@0000020?ooo`040000003oool0oooo0000
01/0oooo000I0?ooo`@000000P3oool010000000oooo0000000000080?ooo`<000000P3oool01000
0000oooo0?ooo`00000I0?ooo`@000000P3oool010000000oooo0?ooo`0000080?ooo`<000001@3o
ool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo02<0oooo100000020?ooo`040000003o
ool0oooo000000L0oooo00@000000?ooo`3oool00000103oool2000001T0oooo100000020?ooo`04
0000003oool0oooo000000L0oooo00@000000?ooo`3oool000000`3oool3000001`0oooo000O0?oo
o`040000003oool00000000000P0oooo00<000000?ooo`3oool00`3oool00`000000oooo0000000O
0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`0T0?ooo`030000003oool0oooo02T0oooo00@000000?ooo`3oool00000203oool00`000000oooo
000000030?ooo`040000003oool0oooo000001h0oooo00@000000?ooo`3oool00000203oool00`00
0000oooo000000030?ooo`030000003oool0oooo01`0oooo000O0?ooo`040000003oool0oooo0000
00P0oooo00<000000?ooo`3oool0103oool2000001l0oooo00@000000?ooo`3oool00000203oool0
0`000000oooo0?ooo`030?ooo`040000003oool0oooo000002H0oooo00<000000?ooo`3oool0:@3o
ool010000000oooo0?ooo`0000090?ooo`8000000`3oool010000000oooo0?ooo`00000N0?ooo`04
0000003oool0oooo000000T0oooo0P0000030?ooo`030000003oool0oooo01`0oooo000P0?ooo`<0
0000203oool4000000@0oooo00<000000?ooo`3oool07P3oool2000000T0oooo100000030?ooo`80
00009`3oool2000002/0oooo0P00000;0?ooo`030000003oool0oooo0080oooo0P00000P0?ooo`80
00002`3oool00`000000oooo0?ooo`020?ooo`<000006`3oool002<0oooo00<000000?ooo`3oool0
J@3oool00`000000oooo0?ooo`2>0?ooo`008`3oool00`000000oooo0?ooo`1Y0?ooo`030000003o
ool0oooo08h0oooo000T0?ooo`030000003oool0oooo06P0oooo00<000000?ooo`3oool0SP3oool0
00L0ooooo`00000B000000P0oooo000>0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3o
ool01`3oool00`000000oooo0000000<0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`0=0?ooo`009P3oool2000003<0oooo00<000000?ooo`3oool0
<@3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0340oooo00<000000?ooo`3oool0
9P3oool002H0oooo00<000000?ooo`3oool0IP3oool00`000000oooo0?ooo`2>0?ooo`009`3oool0
0`000000oooo0?ooo`1U0?ooo`800000S`3oool002P0oooo00<000000?ooo`3oool0I03oool00`00
0000oooo0?ooo`2>0?ooo`00:03oool00`000000oooo0?ooo`1T0?ooo`030000003oool0oooo08h0
oooo000Y0?ooo`030000003oool0oooo06<0oooo00<000000?ooo`3oool0SP3oool002X0oooo00<0
00000?ooo`3oool0HP3oool2000008l0oooo000Z0?ooo`030000003oool0oooo0680oooo00<00000
0?ooo`3oool0SP3oool002/0oooo00<000000?ooo`3oool0H@3oool00`000000oooo0?ooo`2>0?oo
o`00:`3oool00`000000oooo0?ooo`1Q0?ooo`030000003oool0oooo08h0oooo000/0?ooo`030000
003oool0oooo0600oooo00<000000?ooo`3oool0SP3oool002d0oooo00<000000?ooo`3oool0G`3o
ool2000008l0oooo000]0?ooo`030000003oool0oooo05l0oooo00<000000?ooo`3oool0SP3oool0
02h0oooo00<000000?ooo`3oool0GP3oool00`000000oooo0?ooo`2>0?ooo`00;`3oool00`000000
oooo0?ooo`1M0?ooo`030000003oool0oooo08h0oooo000`0?ooo`030000003oool0oooo05`0oooo
0P00002?0?ooo`00<@3oool00`000000oooo0?ooo`1K0?ooo`030000003oool0oooo08h0oooo000b
0?ooo`030000003oool0oooo02T0oooo0P0000040?ooo`030000003oool0oooo00<0oooo0P000004
0?ooo`800000103oool2000000@0oooo0P0000030?ooo`@000000P3oool3000000D0oooo00<00000
0?ooo`3oool0SP3oool003<0oooo00<000000?ooo`3oool09`3oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo08h0oooo000c0?ooo`030000003oool0oooo02L0
oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool00P3oool3000008h0oooo000d0?ooo`030000
003oool0oooo02H0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`0000040?ooo`040000003oool0oooo0?ooo`<000001@3oool00`000000oooo0?ooo`2>0?ooo`00
=@3oool00`000000oooo0?ooo`0U0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool000001@3oool010000000oooo0?ooo`0000070?ooo`030000003oool0oooo08h0
oooo000f0?ooo`030000003oool0oooo02@0oooo00@000000?ooo`3oool00000203oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3o
ool01@3oool00`000000oooo0?ooo`2>0?ooo`00=`3oool00`000000oooo0?ooo`0T0?ooo`800000
2P3oool2000000@0oooo0P0000040?ooo`800000103oool2000000@0oooo0P0000030?ooo`@00000
103oool2000008l0oooo000h0?ooo`030000003oool0oooo05@0oooo00<000000?ooo`3oool0SP3o
ool003T0oooo00<000000?ooo`3oool0D`3oool00`000000oooo0?ooo`2>0?ooo`00>P3oool00`00
0000oooo0?ooo`1B0?ooo`030000003oool0oooo08h0oooo000k0?ooo`030000003oool0oooo0540
oooo0P00002?0?ooo`00?03oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo08h0oooo
000m0?ooo`030000003oool0oooo04l0oooo00<000000?ooo`3oool0SP3oool003h0oooo0P00001?
0?ooo`030000003oool0oooo08h0oooo00100?ooo`030000003oool0oooo04`0oooo00<000000?oo
o`3oool0SP3oool00440oooo00<000000?ooo`3oool0B`3oool2000008l0oooo00120?ooo`030000
003oool0oooo04X0oooo00<000000?ooo`3oool0SP3oool004<0oooo00<000000?ooo`3oool0B@3o
ool00`000000oooo0?ooo`2>0?ooo`00A03oool00`000000oooo0?ooo`180?ooo`030000003oool0
oooo08h0oooo00150?ooo`800000B03oool2000008l0oooo00170?ooo`030000003oool0oooo04D0
oooo00<000000?ooo`3oool0SP3oool004P0oooo0P00000J0?ooo`800000103oool00`000000oooo
0?ooo`030?ooo`800000103oool2000000@0oooo0P0000040?ooo`8000000`3oool3000000D0oooo
00<000000?ooo`3oool0SP3oool004X0oooo00<000000?ooo`3oool05P3oool010000000oooo0?oo
o`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`2>0?ooo`00B`3oool00`000000oooo0?ooo`0E0?ooo`040000003oool0
oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`02
0?ooo`<00000SP3oool004`0oooo0P00000E0?ooo`040000003oool0oooo000000P0oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000000P3oool3000000D0oooo00<000000?ooo`3oool0SP3oool004h0
oooo0P00000C0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo08h0oooo001@0?ooo`800000
4@3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2>0?ooo`00DP3oool200000100oooo0P00
000:0?ooo`800000103oool2000000@0oooo0P0000040?ooo`8000000`3oool4000000@0oooo0P00
002?0?ooo`00E03oool2000003T0oooo00<000000?ooo`3oool0SP3oool005H0oooo0`00000f0?oo
o`030000003oool0oooo08h0oooo001I0?ooo`<00000<`3oool00`000000oooo0?ooo`2>0?ooo`00
G03oool200000340oooo0P00002?0?ooo`00GP3oool4000002d0oooo00<000000?ooo`3oool0SP3o
ool00680oooo1@00000X0?ooo`030000003oool0000001h00000L03oool006L0oooo1`00000D0?oo
o`l000007`3oool5000006/0oooo001^0?oooa@000003@3oool00`000000oooo0?ooo`0S0?ooo`80
0000J@3oool008l0oooo0P00000V0?ooo`D00000I03oool008l0oooo00<000000?ooo`3oool0:P3o
ool300000640oooo002?0?ooo`030000003oool0oooo02d0oooo0P00001O0?ooo`00S`3oool00`00
0000oooo0?ooo`0_0?ooo`800000G@3oool008l0oooo0P00000b0?ooo`800000F`3oool008l0oooo
00<000000?ooo`3oool0<`3oool2000005T0oooo001N0?ooo`800000103oool00`000000oooo0?oo
o`030?ooo`800000103oool2000000@0oooo0P0000040?ooo`800000103oool00`000000oooo0?oo
o`020?ooo`<000001@3oool00`000000oooo0?ooo`0e0?ooo`800000E`3oool005d0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0g0?ooo`030000003oool0
oooo05@0oooo001M0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool00000103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo0`00000h0?oo
o`800000E03oool005d0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000040?ooo`040000003oool0oooo0?ooo`<000001@3oool00`000000oooo0?ooo`0j0?oo
o`800000DP3oool005d0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`000002
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000050?ooo`040000003oool0oooo000000L0oooo00<000000?ooo`3oool0?03oool00`00
0000oooo0?ooo`1?0?ooo`00G@3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`050?oo
o`030000003oool0oooo03d0oooo00<000000?ooo`3oool0CP3oool005h0oooo0P00000:0?ooo`80
0000103oool2000000@0oooo0P0000040?ooo`8000000`3oool400000080oooo100000040?ooo`80
0000?`3oool00`000000oooo0?ooo`1=0?ooo`00S`3oool00`000000oooo0?ooo`0o0?ooo`030000
003oool0oooo04`0oooo002?0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0B`3o
ool008l0oooo00<000000?ooo`3oool0@@3oool00`000000oooo0?ooo`1:0?ooo`00S`3oool20000
04<0oooo00<000000?ooo`3oool0B@3oool008l0oooo00<000000?ooo`3oool0@`3oool00`000000
oooo0?ooo`180?ooo`00S`3oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo04L0oooo
002?0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0AP3oool008l0oooo00<00000
0?ooo`3oool0AP3oool00`000000oooo0?ooo`150?ooo`00S`3oool2000004P0oooo00<000000?oo
o`3oool0A03oool008l0oooo00<000000?ooo`3oool0B03oool00`000000oooo0?ooo`130?ooo`00
S`3oool00`000000oooo0?ooo`190?ooo`030000003oool0oooo0480oooo002?0?ooo`030000003o
ool0oooo04X0oooo00<000000?ooo`3oool0@@3oool008l0oooo0P00001;0?ooo`030000003oool0
oooo0440oooo002?0?ooo`030000003oool0oooo04/0oooo00<000000?ooo`3oool0@03oool006X0
oooo0P0000040?ooo`030000003oool0oooo00<0oooo0P0000040?ooo`800000103oool2000000<0
oooo100000040?ooo`030000003oool0oooo04`0oooo00<000000?ooo`3oool0?`3oool006T0oooo
00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`030?ooo`030000003o
ool0oooo04d0oooo00<000000?ooo`3oool0?P3oool006T0oooo00@000000?ooo`3oool00000203o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool00000103oool00`000000oooo0?ooo`030?ooo`<00000CP3oool00`000000oooo0?ooo`0m0?oo
o`00J@3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo09@0oooo
001Y0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0U03oool0
06T0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000000P3oool3000009H0oooo001Z0?ooo`800000
2P3oool2000000@0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`2D0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.555451, -0.00010536, \
0.000386416, 1.19092*^-6}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  CellLabel->"Out[65]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(nsg = NearestSingularPolynomial[g]\)], "Input",
  CellLabel->"In[66]:="],

Cell[BoxData[
    \(0.3772035197483813700307508848955442017102541628567314682946321698175323\
5337256`62.374049442815455 + 
      2.7620229415240444315303070382405650180578819809622566240388908014525707\
2971408`63.545344543423376\ x + 
      7.6469886766205616053603818731903677808646062210363433129328519061817029\
7583366`64.29425126464145\ x\^2 + 
      9.7650055889452538595315055292472379839756311026019265251000759526391837\
5426321`64.70707686939433\ x\^3 + 
      5.5029972414322762675312423809858196068735170387488238990427954790796881\
6471494`64.76464722399172\ x\^4 + x\^5\)], "Output",
  CellLabel->"Out[66]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Plot[nsg, {x, \(-0.55\), \(-0.45\)}, 
      PlotRange \[Rule] {Automatic, {\(-0.0001\), 0.0001}}]\)], "Input",
  CellLabel->"In[67]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
5.26191 9.52381 0.309017 3090.17 [
[.11905 .29652 -15 -9 ]
[.11905 .29652 15 0 ]
[.30952 .29652 -15 -9 ]
[.30952 .29652 15 0 ]
[.69048 .29652 -15 -9 ]
[.69048 .29652 15 0 ]
[.88095 .29652 -15 -9 ]
[.88095 .29652 15 0 ]
[.4875 0 -42 -4.5 ]
[.4875 0 0 4.5 ]
[.4875 .07725 -54 -4.5 ]
[.4875 .07725 0 4.5 ]
[.4875 .15451 -48 -4.5 ]
[.4875 .15451 0 4.5 ]
[.4875 .23176 -54 -4.5 ]
[.4875 .23176 0 4.5 ]
[.4875 .38627 -48 -4.5 ]
[.4875 .38627 0 4.5 ]
[.4875 .46353 -42 -4.5 ]
[.4875 .46353 0 4.5 ]
[.4875 .54078 -48 -4.5 ]
[.4875 .54078 0 4.5 ]
[.4875 .61803 -36 -4.5 ]
[.4875 .61803 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.11905 .30902 m
.11905 .31527 L
s
[(-0.54)] .11905 .29652 0 1 Mshowa
.30952 .30902 m
.30952 .31527 L
s
[(-0.52)] .30952 .29652 0 1 Mshowa
.69048 .30902 m
.69048 .31527 L
s
[(-0.48)] .69048 .29652 0 1 Mshowa
.88095 .30902 m
.88095 .31527 L
s
[(-0.46)] .88095 .29652 0 1 Mshowa
.125 Mabswid
.16667 .30902 m
.16667 .31277 L
s
.21429 .30902 m
.21429 .31277 L
s
.2619 .30902 m
.2619 .31277 L
s
.35714 .30902 m
.35714 .31277 L
s
.40476 .30902 m
.40476 .31277 L
s
.45238 .30902 m
.45238 .31277 L
s
.54762 .30902 m
.54762 .31277 L
s
.59524 .30902 m
.59524 .31277 L
s
.64286 .30902 m
.64286 .31277 L
s
.7381 .30902 m
.7381 .31277 L
s
.78571 .30902 m
.78571 .31277 L
s
.83333 .30902 m
.83333 .31277 L
s
.07143 .30902 m
.07143 .31277 L
s
.02381 .30902 m
.02381 .31277 L
s
.92857 .30902 m
.92857 .31277 L
s
.97619 .30902 m
.97619 .31277 L
s
.25 Mabswid
0 .30902 m
1 .30902 L
s
.5 0 m
.50625 0 L
s
[(-0.0001)] .4875 0 1 0 Mshowa
.5 .07725 m
.50625 .07725 L
s
[(-0.000075)] .4875 .07725 1 0 Mshowa
.5 .15451 m
.50625 .15451 L
s
[(-0.00005)] .4875 .15451 1 0 Mshowa
.5 .23176 m
.50625 .23176 L
s
[(-0.000025)] .4875 .23176 1 0 Mshowa
.5 .38627 m
.50625 .38627 L
s
[(0.000025)] .4875 .38627 1 0 Mshowa
.5 .46353 m
.50625 .46353 L
s
[(0.00005)] .4875 .46353 1 0 Mshowa
.5 .54078 m
.50625 .54078 L
s
[(0.000075)] .4875 .54078 1 0 Mshowa
.5 .61803 m
.50625 .61803 L
s
[(0.0001)] .4875 .61803 1 0 Mshowa
.125 Mabswid
.5 .01545 m
.50375 .01545 L
s
.5 .0309 m
.50375 .0309 L
s
.5 .04635 m
.50375 .04635 L
s
.5 .0618 m
.50375 .0618 L
s
.5 .09271 m
.50375 .09271 L
s
.5 .10816 m
.50375 .10816 L
s
.5 .12361 m
.50375 .12361 L
s
.5 .13906 m
.50375 .13906 L
s
.5 .16996 m
.50375 .16996 L
s
.5 .18541 m
.50375 .18541 L
s
.5 .20086 m
.50375 .20086 L
s
.5 .21631 m
.50375 .21631 L
s
.5 .24721 m
.50375 .24721 L
s
.5 .26266 m
.50375 .26266 L
s
.5 .27812 m
.50375 .27812 L
s
.5 .29357 m
.50375 .29357 L
s
.5 .32447 m
.50375 .32447 L
s
.5 .33992 m
.50375 .33992 L
s
.5 .35537 m
.50375 .35537 L
s
.5 .37082 m
.50375 .37082 L
s
.5 .40172 m
.50375 .40172 L
s
.5 .41717 m
.50375 .41717 L
s
.5 .43262 m
.50375 .43262 L
s
.5 .44807 m
.50375 .44807 L
s
.5 .47898 m
.50375 .47898 L
s
.5 .49443 m
.50375 .49443 L
s
.5 .50988 m
.50375 .50988 L
s
.5 .52533 m
.50375 .52533 L
s
.5 .55623 m
.50375 .55623 L
s
.5 .57168 m
.50375 .57168 L
s
.5 .58713 m
.50375 .58713 L
s
.5 .60258 m
.50375 .60258 L
s
.25 Mabswid
.5 0 m
.5 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.04848 0 m
.06244 .03083 L
.10458 .10852 L
.14415 .16797 L
.18221 .21382 L
.22272 .25154 L
.26171 .27824 L
.28302 .28928 L
.30316 .29764 L
.32313 .30411 L
.34157 .30864 L
.36029 .31195 L
.37094 .31332 L
.38092 .3143 L
.38588 .31468 L
.3913 .31502 L
.39642 .31528 L
.40117 .31546 L
.40359 .31553 L
.40587 .31559 L
.40794 .31563 L
.41013 .31566 L
.41127 .31568 L
.41252 .31569 L
.41366 .3157 L
.41473 .3157 L
.41598 .31571 L
.41712 .31571 L
.41844 .3157 L
.41969 .3157 L
.42083 .31569 L
.42206 .31568 L
.42428 .31566 L
.42692 .31562 L
.42935 .31557 L
.43434 .31544 L
.4396 .31527 L
.4484 .3149 L
.45802 .31441 L
.49858 .31173 L
.51732 .31052 L
.52718 .30997 L
.53763 .3095 L
.54292 .30932 L
.54572 .30924 L
.54873 .30916 L
.5515 .30911 L
.55402 .30907 L
.55524 .30905 L
.55656 .30904 L
Mistroke
.55781 .30903 L
.55897 .30902 L
.56024 .30902 L
.56096 .30902 L
.56161 .30902 L
.56282 .30902 L
.5641 .30903 L
.56524 .30903 L
.56631 .30904 L
.56873 .30908 L
.57008 .3091 L
.57136 .30912 L
.57375 .30918 L
.57913 .30936 L
.58373 .30957 L
.5888 .30987 L
.59907 .3107 L
.60859 .31175 L
.61751 .31302 L
.63773 .31699 L
.65625 .32214 L
.67521 .32914 L
.69592 .33902 L
.71722 .3519 L
.73654 .36625 L
.77563 .40402 L
.81567 .4566 L
.85419 .52256 L
.89516 .61162 L
Mfstroke
.89516 .61162 m
.89753 .61803 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"\\:6B21\\:3088\\:308A\\:FF1AIn[67]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00JP3oool2000000@0oooo00<000000?ooo`3oool00`3oool2000000@0
oooo0P0000040?ooo`8000000`3oool4000009D0oooo001Y0?ooo`040000003oool0oooo000000P0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo000000@0oooo00<000000?ooo`3oool0U03oool001@0oooo00<000000?ooo`3oool0DP3oool0
10000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00<0oooo0`00002>0?oo
o`00503oool00`000000oooo0?ooo`1<0?ooo`@000000P3oool010000000oooo0?ooo`0000080?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`0000040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0SP3oool001D0oooo00<0
00000?ooo`3oool0D@3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool0SP3oool001D0oooo00<000000?ooo`3oool0D@3oool01000
0000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000020?ooo`<000001@3oool00`000000oooo0?ooo`2>0?ooo`00
5P3oool00`000000oooo0?ooo`1A0?ooo`8000002P3oool2000000@0oooo0P0000040?ooo`800000
1@3oool00`000000oooo0?ooo`030?ooo`800000S`3oool001H0oooo00<000000?ooo`3oool0MP3o
ool00`000000oooo0?ooo`2>0?ooo`005`3oool00`000000oooo0?ooo`1e0?ooo`030000003oool0
oooo08h0oooo000G0?ooo`030000003oool0oooo07D0oooo00<000000?ooo`3oool0SP3oool001P0
oooo00<000000?ooo`3oool0M03oool2000008l0oooo000I0?ooo`030000003oool0oooo07<0oooo
00<000000?ooo`3oool0SP3oool001T0oooo00<000000?ooo`3oool0L`3oool00`000000oooo0?oo
o`2>0?ooo`006P3oool00`000000oooo0?ooo`1b0?ooo`030000003oool0oooo08h0oooo000J0?oo
o`030000003oool0oooo0780oooo00<000000?ooo`3oool0SP3oool001/0oooo00<000000?ooo`3o
ool0L@3oool2000008l0oooo000K0?ooo`030000003oool0oooo0740oooo00<000000?ooo`3oool0
SP3oool001`0oooo00<000000?ooo`3oool0L03oool00`000000oooo0?ooo`2>0?ooo`00703oool0
0`000000oooo0?ooo`1`0?ooo`030000003oool0oooo08h0oooo000M0?ooo`030000003oool0oooo
06l0oooo0P00002?0?ooo`007@3oool00`000000oooo0?ooo`1_0?ooo`030000003oool0oooo08h0
oooo000N0?ooo`030000003oool0oooo03d0oooo0P0000040?ooo`030000003oool0oooo00<0oooo
0P0000040?ooo`800000103oool2000000@0oooo0P0000040?ooo`030000003oool0oooo0080oooo
0`0000050?ooo`030000003oool0oooo08h0oooo000O0?ooo`030000003oool0oooo03/0oooo00@0
00000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo0000
0080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`030000003o
ool0oooo00D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`2>0?ooo`007`3oool0
0`000000oooo0?ooo`0k0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool00000103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo0`00002>
0?ooo`00803oool00`000000oooo0?ooo`0d0?ooo`@000000P3oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00@000000?ooo`3oool0oooo0`000005
0?ooo`030000003oool0oooo08h0oooo000P0?ooo`030000003oool0oooo03X0oooo00@000000?oo
o`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000050?ooo`040000003oool0oooo
000000L0oooo00<000000?ooo`3oool0SP3oool00240oooo00<000000?ooo`3oool0>@3oool01000
0000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000000P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo08h0oooo000Q0?oo
o`030000003oool0oooo03X0oooo0P00000:0?ooo`800000103oool2000000@0oooo0P0000040?oo
o`8000000`3oool400000080oooo100000040?ooo`800000S`3oool00280oooo00<000000?ooo`3o
ool0JP3oool00`000000oooo0?ooo`2>0?ooo`008P3oool00`000000oooo0?ooo`1Z0?ooo`030000
003oool0oooo08h0oooo000S0?ooo`030000003oool0oooo06T0oooo00<000000?ooo`3oool0SP3o
ool002<0oooo00<000000?ooo`3oool0J@3oool2000008l0oooo000T0?ooo`030000003oool0oooo
06P0oooo00<000000?ooo`3oool0SP3oool002D0oooo00<000000?ooo`3oool0I`3oool00`000000
oooo0?ooo`2>0?ooo`009@3oool00`000000oooo0?ooo`1W0?ooo`030000003oool0oooo08h0oooo
000V0?ooo`030000003oool0oooo06H0oooo00<000000?ooo`3oool0SP3oool002H0oooo00<00000
0?ooo`3oool0IP3oool2000008l0oooo000W0?ooo`030000003oool0oooo06D0oooo00<000000?oo
o`3oool0SP3oool002P0oooo00<000000?ooo`3oool0I03oool00`000000oooo0?ooo`2>0?ooo`00
:03oool00`000000oooo0?ooo`1T0?ooo`030000003oool0oooo08h0oooo000Y0?ooo`030000003o
ool0oooo06<0oooo0P00002?0?ooo`00:P3oool00`000000oooo0?ooo`1R0?ooo`030000003oool0
oooo08h0oooo000Z0?ooo`030000003oool0oooo03L0oooo0P0000040?ooo`030000003oool0oooo
00<0oooo0P0000040?ooo`800000103oool2000000@0oooo0P0000030?ooo`<000001@3oool00`00
0000oooo0?ooo`2>0?ooo`00:`3oool00`000000oooo0?ooo`0e0?ooo`040000003oool0oooo0000
00P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo08h0oooo000[0?ooo`030000003oool0oooo03D0oooo00@000000?ooo`3oool0
0000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo0080oooo
0`00002>0?ooo`00;03oool00`000000oooo0?ooo`0^0?ooo`@000000P3oool010000000oooo0?oo
o`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo0`0000050?ooo`030000003o
ool0oooo08h0oooo000]0?ooo`030000003oool0oooo03<0oooo00@000000?ooo`3oool00000203o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0SP3oool002d0oooo00<000000?ooo`3oool0<`3oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`2>0?ooo`00;P3oool00`000000oooo0?ooo`0c0?ooo`8000002P3oool2000000@0
oooo0P0000040?ooo`800000103oool2000000<0oooo100000040?ooo`800000S`3oool002l0oooo
00<000000?ooo`3oool0G@3oool00`000000oooo0?ooo`2>0?ooo`00<03oool00`000000oooo0?oo
o`1L0?ooo`030000003oool0oooo08h0oooo000a0?ooo`030000003oool0oooo05/0oooo00<00000
0?ooo`3oool0SP3oool00380oooo00<000000?ooo`3oool0FP3oool2000008l0oooo000c0?ooo`03
0000003oool0oooo05T0oooo00<000000?ooo`3oool0SP3oool003<0oooo00<000000?ooo`3oool0
F@3oool00`000000oooo0?ooo`2>0?ooo`00=03oool00`000000oooo0?ooo`1H0?ooo`030000003o
ool0oooo08h0oooo000e0?ooo`030000003oool0oooo05L0oooo00<000000?ooo`3oool0SP3oool0
03H0oooo00<000000?ooo`3oool0EP3oool2000008l0oooo000g0?ooo`030000003oool0oooo05D0
oooo00<000000?ooo`3oool0SP3oool003P0oooo00<000000?ooo`3oool0E03oool00`000000oooo
0?ooo`2>0?ooo`00>@3oool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo08h0oooo000j
0?ooo`030000003oool0oooo0580oooo0P00002?0?ooo`00>`3oool00`000000oooo0?ooo`1A0?oo
o`030000003oool0oooo08h0oooo000l0?ooo`030000003oool0oooo01l0oooo0P0000040?ooo`03
0000003oool0oooo00<0oooo0P0000040?ooo`800000103oool2000000@0oooo0P0000030?ooo`@0
00000P3oool3000000D0oooo00<000000?ooo`3oool0SP3oool003d0oooo00<000000?ooo`3oool0
7@3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?oo
o`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo08h0oooo
000n0?ooo`8000007@3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo000000<0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`020?ooo`<00000SP3o
ool00400oooo00<000000?ooo`3oool0503oool400000080oooo00@000000?ooo`3oool00000203o
ool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000040?ooo`040000003oool0oooo0?ooo`<000001@3o
ool00`000000oooo0?ooo`2>0?ooo`00@@3oool00`000000oooo0?ooo`0I0?ooo`040000003oool0
oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000001@3oool010000000oooo0?ooo`00
00070?ooo`030000003oool0oooo08h0oooo00120?ooo`030000003oool0oooo01P0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`2>0?ooo`00@`3oool0
0`000000oooo0?ooo`0H0?ooo`8000002P3oool2000000@0oooo0P0000040?ooo`800000103oool2
000000@0oooo0P0000030?ooo`@00000103oool2000008l0oooo00140?ooo`030000003oool0oooo
04P0oooo00<000000?ooo`3oool0SP3oool004D0oooo00<000000?ooo`3oool0A`3oool00`000000
oooo0?ooo`2>0?ooo`00AP3oool2000004L0oooo00<000000?ooo`3oool0SP3oool004P0oooo00<0
00000?ooo`3oool0A03oool2000008l0oooo00190?ooo`030000003oool0oooo04<0oooo00<00000
0?ooo`3oool0SP3oool004X0oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`2>0?oo
o`00803oool2000000@0oooo00<000000?ooo`3oool00P3oool3000000D0oooo00<000000?ooo`3o
ool05@3oool2000000L0oooo0P0000040?ooo`030000003oool0oooo0080oooo0`0000030?ooo`@0
00009P3oool00`000000oooo0?ooo`0Z0?ooo`800000103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo0P00000P0?ooo`800000103oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo0P00000L0?ooo`007`3oool010000000oooo0?ooo`00000;0?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`030?ooo`04
0000003oool0oooo000000/0oooo00@000000?ooo`3oool00000:@3oool00`000000oooo0?ooo`0Y
0?ooo`040000003oool0oooo000000X0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000
003oool0oooo01`0oooo00@000000?ooo`3oool000002P3oool01@000000oooo0?ooo`3oool00000
0080oooo00<000000?ooo`3oool06@3oool001l0oooo00@000000?ooo`3oool000002`3oool00`00
0000oooo00000004000001T0oooo0P0000030?ooo`040000003oool0oooo000000/0oooo00D00000
0?ooo`3oool0oooo0000000X0?ooo`800000:P3oool010000000oooo0?ooo`0000070?ooo`D00000
0P3oool010000000oooo0?ooo`00000N0?ooo`040000003oool0oooo000000L0oooo1@0000020?oo
o`040000003oool0oooo000001/0oooo000I0?ooo`@000000P3oool010000000oooo0?ooo`000008
0?ooo`<000000P3oool010000000oooo0?ooo`00000I0?ooo`D0000000D0oooo0000003oool0oooo
000000080?ooo`<000001@3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo02<0oooo
100000020?ooo`040000003oool0oooo000000L0oooo00@000000?ooo`3oool00000103oool20000
01T0oooo100000020?ooo`040000003oool0oooo000000L0oooo00@000000?ooo`3oool000000`3o
ool3000001`0oooo000O0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0000000N0?ooo`8000000P3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool0903oool00`000000oooo0?ooo`0Y0?ooo`040000003o
ool0oooo000000P0oooo00<000000?ooo`0000000`3oool010000000oooo0?ooo`00000N0?ooo`04
0000003oool0oooo000000P0oooo00<000000?ooo`0000000`3oool00`000000oooo0?ooo`0L0?oo
o`007`3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00@0oooo0P00000O0?oo
o`@00000203oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo000002H0oooo00<00000
0?ooo`3oool0:@3oool010000000oooo0?ooo`0000090?ooo`8000000`3oool010000000oooo0?oo
o`00000N0?ooo`040000003oool0oooo000000T0oooo0P0000030?ooo`030000003oool0oooo01`0
oooo000P0?ooo`8000002@3oool4000000@0oooo00<000000?ooo`3oool07P3oool5000000H0oooo
100000030?ooo`8000009`3oool2000002/0oooo0P00000;0?ooo`030000003oool0oooo0080oooo
0P00000P0?ooo`8000002`3oool00`000000oooo0?ooo`020?ooo`<000006`3oool005T0oooo0`00
000c0?ooo`030000003oool0oooo08h0oooo001L0?ooo`800000<@3oool00`000000oooo0?ooo`2>
0?ooo`00GP3oool4000002d0oooo00<000000?ooo`3oool0SP3oool000L0ooooo`00000B000000P0
oooo000>0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo00T0oooo2@0000050?ooo`030000003oool0oooo00X0oooo
4000000:0?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool01P0000040?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`090?ooo`030000
003oool0oooo00X0oooo00<000000?ooo`3oool03@3oool002L0oooo00<000000?ooo`3oool0<@3o
ool00`000000oooo0?ooo`0B0?oooa<00000303oool00`000000oooo0?ooo`0P0?ooo`@000003@3o
ool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo02H0oooo002?0?ooo`030000003oool0
oooo02@0oooo0P00001X0?ooo`00S`3oool2000002L0oooo1@00001S0?ooo`00S`3oool00`000000
oooo0?ooo`0[0?ooo`<00000H03oool008l0oooo00<000000?ooo`3oool0;P3oool2000005h0oooo
002?0?ooo`030000003oool0oooo0300oooo0P00001L0?ooo`00S`3oool2000003<0oooo00<00000
0?ooo`3oool0F@3oool008l0oooo00<000000?ooo`3oool0<`3oool2000005T0oooo002?0?ooo`03
0000003oool0oooo03D0oooo00<000000?ooo`3oool0EP3oool008l0oooo00<000000?ooo`3oool0
=P3oool2000005H0oooo002?0?ooo`030000003oool0oooo03P0oooo00<000000?ooo`3oool0D`3o
ool008l0oooo0P00000j0?ooo`030000003oool0oooo0580oooo002?0?ooo`030000003oool0oooo
03X0oooo0P00001B0?ooo`00S`3oool00`000000oooo0?ooo`0l0?ooo`030000003oool0oooo04l0
oooo002?0?ooo`030000003oool0oooo03d0oooo00<000000?ooo`3oool0CP3oool008l0oooo0P00
000o0?ooo`030000003oool0oooo04d0oooo002?0?ooo`030000003oool0oooo03l0oooo00<00000
0?ooo`3oool0C03oool005h0oooo0P0000040?ooo`030000003oool0oooo00<0oooo0P0000040?oo
o`800000103oool2000000@0oooo0P0000030?ooo`@000000P3oool3000000D0oooo00<000000?oo
o`3oool0@03oool00`000000oooo0?ooo`1;0?ooo`00G@3oool010000000oooo0?ooo`0000080?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo0440oooo00<000000?ooo`3oool0BP3oool005d0oooo
00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool00P3oool300000480oooo0P00001:0?ooo`00G@3o
ool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3o
ool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00@0
00000?ooo`3oool0oooo0`0000050?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0
A`3oool005d0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
00050?ooo`040000003oool0oooo000000L0oooo00<000000?ooo`3oool0A@3oool00`000000oooo
0?ooo`160?ooo`00G@3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo04H0oooo00<000000?ooo`3oool0A@3oool005h0oooo0P00000:0?ooo`800000103o
ool2000000@0oooo0P0000040?ooo`800000103oool2000000<0oooo100000040?ooo`800000B03o
ool00`000000oooo0?ooo`140?ooo`00S`3oool00`000000oooo0?ooo`180?ooo`030000003oool0
oooo04<0oooo002?0?ooo`030000003oool0oooo04T0oooo00<000000?ooo`3oool0@P3oool008l0
oooo00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`110?ooo`00S`3oool2000004/0oooo
00<000000?ooo`3oool0@@3oool008l0oooo00<000000?ooo`3oool0B`3oool00`000000oooo0?oo
o`100?ooo`00S`3oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo03l0oooo002?0?oo
o`030000003oool0oooo04d0oooo00<000000?ooo`3oool0?P3oool008l0oooo00<000000?ooo`3o
ool0C@3oool00`000000oooo0?ooo`0n0?ooo`00S`3oool2000004l0oooo00<000000?ooo`3oool0
?@3oool008l0oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`0l0?ooo`00S`3oool0
0`000000oooo0?ooo`1@0?ooo`030000003oool0oooo03/0oooo002?0?ooo`030000003oool0oooo
0540oooo00<000000?ooo`3oool0>P3oool008l0oooo0P00001B0?ooo`030000003oool0oooo03X0
oooo002?0?ooo`030000003oool0oooo0580oooo00<000000?ooo`3oool0>@3oool006@0oooo0P00
00040?ooo`030000003oool0oooo00<0oooo0P0000040?ooo`800000103oool2000000@0oooo0P00
00030?ooo`<000001@3oool00`000000oooo0?ooo`1C0?ooo`030000003oool0oooo03P0oooo001S
0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo
0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000001@3oool0
0`000000oooo0?ooo`020?ooo`030000003oool0oooo05@0oooo00<000000?ooo`3oool0=`3oool0
06<0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003o
ool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000050?oo
o`030000003oool0oooo0080oooo0`00001D0?ooo`030000003oool0oooo03L0oooo001S0?ooo`04
0000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool3000000D0
oooo00<000000?ooo`3oool0E@3oool00`000000oooo0?ooo`0f0?ooo`00H`3oool010000000oooo
0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool0
10000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`1E0?ooo`030000003oool0oooo03H0oooo001S0?ooo`040000003o
ool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo05H0oooo00<000000?ooo`3oool0=@3oool006@0oooo0P00000:
0?ooo`800000103oool2000000@0oooo0P0000040?ooo`8000000`3oool4000000@0oooo0P00001G
0?ooo`030000003oool0oooo03D0oooo002?0?ooo`030000003oool0oooo05L0oooo00<000000?oo
o`3oool0=03oool008l0oooo00<000000?ooo`3oool0E`3oool00`000000oooo0?ooo`0d0?ooo`00
S`3oool00`000000oooo0?ooo`1H0?ooo`030000003oool0oooo03<0oooo002?0?ooo`800000FP3o
ool00`000000oooo0?ooo`0b0?ooo`00S`3oool00`000000oooo0?ooo`1I0?ooo`030000003oool0
oooo0380oooo002?0?ooo`030000003oool0oooo05X0oooo00<000000?ooo`3oool0<@3oool008l0
oooo00<000000?ooo`3oool0FP3oool00`000000oooo0?ooo`0a0?ooo`00S`3oool00`000000oooo
0?ooo`1K0?ooo`030000003oool0oooo0300oooo002?0?ooo`800000G03oool00`000000oooo0?oo
o`0`0?ooo`00S`3oool00`000000oooo0?ooo`1L0?ooo`030000003oool0oooo02l0oooo002?0?oo
o`030000003oool0oooo05`0oooo00<000000?ooo`3oool0;`3oool008l0oooo00<000000?ooo`3o
ool0G@3oool00`000000oooo0?ooo`0^0?ooo`00S`3oool2000005h0oooo00<000000?ooo`3oool0
;P3oool008l0oooo00<000000?ooo`3oool0GP3oool00`000000oooo0?ooo`0]0?ooo`00GP3oool2
000000@0oooo00<000000?ooo`3oool00`3oool2000000@0oooo0P0000040?ooo`800000103oool2
000000@0oooo00<000000?ooo`3oool00P3oool3000000D0oooo00<000000?ooo`3oool0GP3oool0
0`000000oooo0?ooo`0]0?ooo`00G@3oool010000000oooo0?ooo`0000080?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`04
0000003oool0oooo000000<0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo05l0oooo00<000000?ooo`3oool0;03oool005d0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@0
00000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool00P3oool3000005l0oooo00<000000?ooo`3oool0;03oool005d0oooo
00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`040000
003oool0oooo0?ooo`<000001@3oool00`000000oooo0?ooo`1P0?ooo`030000003oool0oooo02/0
oooo001M0?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool01000
0000oooo0?ooo`0000020?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000
1@3oool010000000oooo0?ooo`0000070?ooo`030000003oool0oooo0600oooo00<000000?ooo`3o
ool0:`3oool005d0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo00000080oooo00@000000?ooo`3oool000000P3oool010000000oooo0?oo
o`0000020?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`1Q0?ooo`030000003oool0oooo02X0oooo001N0?ooo`8000002P3oool2000000@0oooo
0P0000040?ooo`800000103oool2000000<0oooo100000020?ooo`@00000103oool200000680oooo
00<000000?ooo`3oool0:P3oool008l0oooo00<000000?ooo`3oool0HP3oool00`000000oooo0?oo
o`0Y0?ooo`00S`3oool00`000000oooo0?ooo`1R0?ooo`030000003oool0oooo02T0oooo002?0?oo
o`030000003oool0oooo0680oooo00<000000?ooo`3oool0:@3oool008l0oooo0P00001T0?ooo`03
0000003oool0oooo02P0oooo002?0?ooo`030000003oool0oooo06<0oooo00<000000?ooo`3oool0
:03oool008l0oooo00<000000?ooo`3oool0I03oool00`000000oooo0?ooo`0W0?ooo`00S`3oool0
0`000000oooo0?ooo`1T0?ooo`030000003oool0oooo02L0oooo002?0?ooo`030000003oool0oooo
06D0oooo00<000000?ooo`3oool09P3oool008l0oooo0P00001V0?ooo`030000003oool0oooo02H0
oooo002?0?ooo`030000003oool0oooo06H0oooo00<000000?ooo`3oool09@3oool008l0oooo00<0
00000?ooo`3oool0IP3oool00`000000oooo0?ooo`0U0?ooo`00S`3oool00`000000oooo0?ooo`1W
0?ooo`030000003oool0oooo02@0oooo002?0?ooo`800000J03oool00`000000oooo0?ooo`0T0?oo
o`00S`3oool00`000000oooo0?ooo`1X0?ooo`030000003oool0oooo02<0oooo001Z0?ooo`800000
103oool00`000000oooo0?ooo`030?ooo`800000103oool2000000@0oooo0P0000030?ooo`@00000
103oool00`000000oooo0?ooo`1X0?ooo`030000003oool0oooo02<0oooo001Y0?ooo`040000003o
ool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?oo
o`040000003oool0oooo000000@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`1X
0?ooo`030000003oool0oooo02<0oooo001Y0?ooo`040000003oool0oooo000000P0oooo00@00000
0?ooo`3oool000000P3oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0
oooo00<000000?ooo`3oool00`3oool3000006T0oooo00<000000?ooo`3oool08P3oool006T0oooo
00@000000?ooo`3oool00000203oool010000000oooo0?ooo`0000020?ooo`040000003oool0oooo
00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`2D0?ooo`00J@3oool0
10000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo09@0oooo001Y0?ooo`04
0000003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`00
00020?ooo`040000003oool0oooo00000080oooo0`00002F0?ooo`00JP3oool2000000X0oooo0P00
00040?ooo`800000103oool2000000D0oooo00<000000?ooo`3oool0U03oool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.555451, -0.00010536, \
0.000386416, 1.19092*^-6}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  CellLabel->"Out[67]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(x /. NSolve[nsg == 0, x]\)], "Input",
  CellLabel->"In[68]:="],

Cell[BoxData[
    \({\(-3.0000531306509481410671469348`13.148247478827942\) + 
        0``12.67111853272688\ \[ImaginaryI], \
\(-0.9993512817134628800630480328`12.427211881911152\) + 
        0``12.427493708106095\ \[ImaginaryI], \
\(-0.516441372459230496616555677`10.123298036551015\) + 
        0``10.410277009945364\ \[ImaginaryI], \
\(-0.4935757283090927428`2.678816028731897\) + 
        0``2.9854622337046917\ \[ImaginaryI], \
\(-0.4935757283090927428`2.678816028731897\) + 
        0``2.9854622337046917\ \[ImaginaryI]}\)], "Output",
  CellLabel->"Out[68]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(x /. System`NSolve[nsg == 0, x]\)], "Input",
  CellLabel->"In[69]:="],

Cell[BoxData[
    \({\(-3.\
00005313065094556513611897380913635794814112778668721561168980285767336778897`\
61.148328853077196\), \
\(-0.9993512817134668686421147681487292982388468352605733308101368071840984914\
6008`60.04230433292408\), \
\(-0.5164413724592130904948405503752761817081742355326347264525539111918578149\
614`57.799477509050824\), \
\(-0.493575728304325371629084044326339980934705954902`29.586709859516382\), \
\(-0.493575728304325371629084044326337985044209023828`29.586709859516382\)}\)]\
, "Output",
  CellLabel->"Out[69]="]
}, Open  ]],

Cell["\:7d76\:5bfe\:65e2\:7d04\:6027\:306b\:95a2\:3059\:308b\:4f8b\:7528\:306b\
\:6b21\:306e\:591a\:9805\:5f0f\:3092\:5b9a\:7fa9\:3057\:307e\:3059\:ff0e", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(f = 
      Expand[\((x^2 + y*x + 2  y - 1)\) \((x^3 + y^2\ x - y + 7)\) + 
          0.2`16  x]\)], "Input",
  CellLabel->"In[70]:="],

Cell[BoxData[
    \(\(-7\) + 0.2`16. \ x + 7\ x\^2 - x\^3 + x\^5 + 15\ y + 7\ x\ y - 
      x\^2\ y + 2\ x\^3\ y + x\^4\ y - 2\ y\^2 - 2\ x\ y\^2 + x\^3\ y\^2 + 
      2\ x\ y\^3 + x\^2\ y\^3\)], "Output",
  CellLabel->"Out[70]="]
}, Open  ]],

Cell["\<\
\:8a31\:5bb9\:5ea6\:306e\:7bc4\:56f2\:306b\:542b\:307e\:308c\:308b\
\:3069\:306e\:591a\:9805\:5f0f\:3082\:7d76\:5bfe\:65e2\:7d04\:3067\:3042\:308b\
\:3053\:3068\:304c\:308f\:304b\:308a\:307e\:3059\:ff0e\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(AbsolutelyIrreducibleQ[f, 0.00001]\)], "Input",
  CellLabel->"In[71]:="],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[71]="]
}, Open  ]],

Cell["\<\
SNAP\:96c6\:5408\:306b\:5bfe\:3057\:3066\:306f\:ff0c\:8a31\:5bb9\
\:5ea6\:3092\:6307\:5b9a\:3059\:308b\:5fc5\:8981\:306f\:3042\:308a\:307e\:305b\
\:3093\:ff0e\:81ea\:52d5\:7684\:306b\:305d\:306e\:5168\:3066\:306e\:8981\:7d20\
\:306b\:5bfe\:3057\:3066\:306e\:8a08\:7b97\:304c\:884c\:308f\:308c\:307e\:3059\
\:ff0e\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(fs = SNAP[f, 0.00001]\)], "Input",
  CellLabel->"In[72]:="],

Cell[BoxData[
    \(\(-7.`\) + x\^5 + 15.`\ y + x\^4\ y - 2.`\ y\^2 + 
      x\^3\ \((\(-1.`\) + 2.`\ y + y\^2)\) + 
      x\^2\ \((\(\(7.`\)\(\[InvisibleSpace]\)\) - 1.`\ y + y\^3)\) + 
      x\ \((\(\(0.19999999999999998`\)\(\[InvisibleSpace]\)\) + 7.`\ y - 
            2.`\ y\^2 + 2.`\ y\^3)\)\)], "Output",
  CellLabel->"Out[72]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(AbsolutelyIrreducibleQ[fs]\)], "Input",
  CellLabel->"In[73]:="],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[73]="]
}, Open  ]],

Cell[TextData[{
  "\:7d76\:5bfe\:65e2\:7d04\:534a\:5f84\:3092\:8a08\:7b97\:3059\:308b\:3053\
\:3068\:3082\:51fa\:6765\:307e\:3059\:ff0e\:5373\:3061\:ff0c ",
  Cell[BoxData[
      \(TraditionalForm\`\(P\_2\)(f, 0.0000398792)\)]],
  " \:306b\:542b\:307e\:308c\:308b\:3069\:306e\:591a\:9805\:5f0f\:3082\:7d76\
\:5bfe\:65e2\:7d04\:3067\:3042\:308b\:3053\:3068\:304c\:4fdd\:8a3c\:3055\:308c\
\:307e\:3059\:ff0e"
}], "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(SeparationBound[f] // Timing\)], "Input",
  CellLabel->"In[74]:="],

Cell[BoxData[
    \({2.0999999999999996`\ Second, 
      0.00076773397483841714460418042412287145`19.99348031907}\)], "Output",
  CellLabel->"Out[74]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(SeparationBound[f, Adaptive \[Rule] True] // Timing\)], "Input",
  CellLabel->"In[75]:="],

Cell[BoxData[
    \({56.18`\ Second, 
      0.00079162156784317122175139952503281496`19.99348031907}\)], "Output",
  CellLabel->"Out[75]="]
}, Open  ]],

Cell["\<\
\:8a31\:5bb9\:5ea6\:3092\:4e0e\:3048\:305a\:306b\:ff0c\:901a\:5e38\
\:306e\:591a\:9805\:5f0f\:306e\:5224\:5b9a\:3092\:884c\:3063\:305f\:5834\:5408\
\:ff0c\:5404\:4fc2\:6570\:306e\:7cbe\:5ea6\:306e\:7bc4\:56f2\:306b\:542b\:307e\
\:308c\:308b\:3069\:306e\:3088\:3046\:306a\:591a\:9805\:5f0f\:3082\:7d76\:5bfe\
\:65e2\:7d04\:3067\:3042\:308b\:304b\:3092\:5224\:5b9a\:3057\:307e\:3059\:ff0e\
\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(AbsolutelyIrreducibleQ[f]\)], "Input",
  CellLabel->"In[76]:="],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[76]="]
}, Open  ]],

Cell["\<\
\:8fd1\:4f3c\:6570\:3092\:4fc2\:6570\:90e8\:306b\:6301\:3064\:591a\
\:9805\:5f0f\:3092\:7d44\:307f\:8fbc\:307f\:95a2\:6570\:3067\:56e0\:6570\:5206\
\:89e3\:3059\:308b\:3053\:3068\:306f\:51fa\:6765\:307e\:305b\:3093\:ff0e\
\>",\
 "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(f2 = 
      N@Expand[\((x^2 + y*x + 2  y - 1)\) \((x^3 + y^2\ x - y + 
                7)\)]\)], "Input",
  CellLabel->"In[77]:="],

Cell[BoxData[
    \(\(-7.`\) + 7.`\ x\^2 - 1.`\ x\^3 + x\^5 + 15.`\ y + 7.`\ x\ y - 
      1.`\ x\^2\ y + 2.`\ x\^3\ y + x\^4\ y - 2.`\ y\^2 - 2.`\ x\ y\^2 + 
      x\^3\ y\^2 + 2.`\ x\ y\^3 + x\^2\ y\^3\)], "Output",
  CellLabel->"Out[77]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`Factor[f2]\)], "Input",
  CellLabel->"In[78]:="],

Cell[BoxData[
    \(1.`\ \((\(-7.`\) + 7.`\ x\^2 - 1.`\ x\^3 + 1.`\ x\^5 + 15.`\ y + 
          7.`\ x\ y - 1.`\ x\^2\ y + 2.`\ x\^3\ y + 1.`\ x\^4\ y - 
          2.`\ y\^2 - 2.`\ x\ y\^2 + 1.`\ x\^3\ y\^2 + 2.`\ x\ y\^3 + 
          1.`\ x\^2\ y\^3)\)\)], "Output",
  CellLabel->"Out[78]="]
}, Open  ]],

Cell["\<\
\:3053\:306e\:30d1\:30c3\:30b1\:30fc\:30b8\:3067\:306f\:ff0c\:8a31\
\:5bb9\:5ea6\:306e\:7bc4\:56f2\:5185\:3067\:56e0\:6570\:5206\:89e3\:3092\:8a66\
\:307f\:307e\:3059\:ff0e\:8a31\:5bb9\:5ea6\:306e\:7bc4\:56f2\:3067\:3042\:308b\
\:304b\:306b\:3064\:3044\:3066\:306f\:ff0c\:5f8c\:9000\:8aa4\:5dee\:3068\:3057\
\:3066\:78ba\:8a8d\:3059\:308b\:305f\:3081\:ff0c\:56e0\:6570\:5206\:89e3\:3055\
\:308c\:306a\:304b\:3063\:305f\:304b\:3089\:3068\:3044\:3063\:3066\:ff0c\:305d\
\:306e\:8a31\:5bb9\:5ea6\:306e\:7bc4\:56f2\:5185\:3067\:7d76\:5bfe\:65e2\:7d04\
\:3067\:3042\:308b\:3053\:3068\:306f\:610f\:5473\:3057\:307e\:305b\:3093\:ff0e\
\
\>", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Chop@Factor[f2, 0.000001]\)], "Input",
  CellLabel->"In[79]:="],

Cell[BoxData[
    \(\((\(-1.`14.317629257483443\) + 
          x\^2 + \((2.0000000000000000000069174357`13.08383575699799 + 
                1.0000000000000000000023999267`12.796603394378215\ x)\)\ y)\)\
\ \((7.`14.422591735417836 + x\^3 - 
          1.0000000000000000002183012924`12.049626634797134\ y + 
          0.9999999999999999998041428575`11.022861312999117\ x\ y\^2)\)\)], \
"Output",
  CellLabel->"Out[79]="]
}, Open  ]],

Cell["SNAP\:96c6\:5408\:306b\:5bfe\:3057\:3066\:306f\:ff0c\:8a31\:5bb9\:5ea6\
\:3092\:6307\:5b9a\:3059\:308b\:5fc5\:8981\:306f\:3042\:308a\:307e\:305b\:3093\
\:ff0e", "MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(f2s = 
      SNAP[N@Expand[\((x^2 + y*x + 2  y - 1)\) \((x^3 + y^2\ x - y + 7)\)], 
        0.000001]\)], "Input",
  CellLabel->"In[80]:="],

Cell[BoxData[
    \(\(-7.`\) + x\^5 + 15.`\ y + x\^4\ y - 2.`\ y\^2 + 
      x\^3\ \((\(-1.`\) + 2.`\ y + y\^2)\) + 
      x\^2\ \((\(\(7.`\)\(\[InvisibleSpace]\)\) - 1.`\ y + y\^3)\) + 
      x\ \((7.`\ y - 2.`\ y\^2 + 2.`\ y\^3)\)\)], "Output",
  CellLabel->"Out[80]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Chop@Factor[f2s]\)], "Input",
  CellLabel->"In[81]:="],

Cell[BoxData[
    \(\((\(-1.`14.317629257483443\) + 
          x\^2 + \((2.0000000000000000000069174357`13.08383575699799 + 
                1.0000000000000000000023999267`12.796603394378215\ x)\)\ y)\)\
\ \((7.`14.422591735417836 + x\^3 - 
          1.0000000000000000002183012924`12.049626634797134\ y + 
          0.9999999999999999998041428575`11.022861312999117\ x\ y\^2)\)\)], \
"Output",
  CellLabel->"Out[81]="]
}, Open  ]],

Cell["\<\
\:5909\:6570\:304c\:8907\:6570\:3042\:308b\:9023\:7acb\:65b9\:7a0b\
\:5f0f\:306b\:5bfe\:3057\:3066\:306e\:6c42\:6839\:306e\:5834\:5408\:3082\:8a31\
\:5bb9\:5ea6\:304c\:8003\:616e\:3055\:308c\:307e\:3059\:ff0e\:5185\:90e8\:3067\
\:306fCGS\:30d1\:30c3\:30b1\:30fc\:30b8\:3092\:5229\:7528\:3057\:3066\:304a\
\:308a\:ff0c\:6b8b\:5ff5\:306a\:304c\:3089\:975e\:5e38\:306b\:9045\:3044\:3067\
\:3059\:3057\:ff0c\:975e\:5e38\:306b\:4f4e\:3044\:6b21\:6570\:306e\:3082\:306e\
\:306b\:3057\:304b\:9069\:7528\:3067\:304d\:307e\:305b\:3093\:ff0e\
\>", \
"MathCaption"],

Cell[CellGroupData[{

Cell[BoxData[
    \(f = 2.0\ x - 3  y + 1.0\)], "Input",
  CellLabel->"In[82]:="],

Cell[BoxData[
    \(\(\(1.`\)\(\[InvisibleSpace]\)\) + 2.`\ x - 3\ y\)], "Output",
  CellLabel->"Out[82]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = 1.0  x - 1.0  y + 1.0\)], "Input",
  CellLabel->"In[83]:="],

Cell[BoxData[
    \(\(\(1.`\)\(\[InvisibleSpace]\)\) + 1.`\ x - 1.`\ y\)], "Output",
  CellLabel->"Out[83]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(System`NSolve[{f, g}, {x, y}]\)], "Input",
  CellLabel->"In[84]:="],

Cell[BoxData[
    \({{x \[Rule] \(-2.`\), y \[Rule] \(-1.`\)}}\)], "Output",
  CellLabel->"Out[84]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(NSolve[{f, g}, {x, y}]\)], "Input",
  CellLabel->"In[85]:="],

Cell[BoxData[
    \({{{x \[Rule] \(-1.9999999999999999999999999742`12.767069049354603\) + 
              0``12.466039053690622\ \[ImaginaryI], 
          y \[Rule] \(-0.9999999999999999999999999871`14.049226280845037\) + 
              0``14.049226280845037\ \[ImaginaryI]}}}\)], "Output",
  CellLabel->"Out[85]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(f /. %\)], "Input",
  CellLabel->"In[86]:="],

Cell[BoxData[
    \({{\(\(0.`\)\(\[InvisibleSpace]\)\) + 0.`\ \[ImaginaryI]}}\)], "Output",
  CellLabel->"Out[86]="]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g /. %%\)], "Input",
  CellLabel->"In[87]:="],

Cell[BoxData[
    \({{\(\(0.`\)\(\[InvisibleSpace]\)\) + 0.`\ \[ImaginaryI]}}\)], "Output",
  CellLabel->"Out[87]="]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.2 for X",
ScreenRectangle->{{0, 2560}, {0, 1024}},
WindowToolbars->{},
Evaluator->"\:65b0\:3057\:3044\:30ab\:30fc\:30cd\:30eb",
WindowSize->{1016, 666},
WindowMargins->{{207, Automatic}, {Automatic, 36}},
ShowSelection->True,
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Info3382346076-3433425"->{
    Cell[203591, 4321, 174, 3, 21, "Print",
      CellTags->"Info3382346076-3433425"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Info3382346076-3433425", 301232, 6898}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 27, 0, 40, "Subsection"],
Cell[1806, 55, 676, 10, 40, "Text"],
Cell[2485, 67, 165, 2, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[2675, 73, 75, 2, 26, "Input"],
Cell[2753, 77, 465, 7, 53, "Print"]
}, Open  ]],
Cell[3233, 87, 177599, 3551, 114, "DefinitionBox"],
Cell[180835, 3640, 1069, 23, 40, "Text"],
Cell[181907, 3665, 445, 9, 34, "DisplayMath"],
Cell[182355, 3676, 766, 17, 40, "Text"],
Cell[183124, 3695, 249, 6, 24, "Text"],
Cell[183376, 3703, 5613, 127, 216, "DefinitionBox"],
Cell[188992, 3832, 143, 4, 16, "Caption"],
Cell[189138, 3838, 306, 9, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[189469, 3851, 149, 4, 26, "Input"],
Cell[189621, 3857, 167, 3, 27, "Output"]
}, Open  ]],
Cell[189803, 3863, 334, 9, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[190162, 3876, 69, 2, 26, "Input"],
Cell[190234, 3880, 736, 15, 86, "Output"]
}, Open  ]],
Cell[190985, 3898, 539, 10, 40, "Text"],
Cell[191527, 3910, 239, 6, 41, "FramedBox"],
Cell[191769, 3918, 192, 2, 39, "MathCaption"],

Cell[CellGroupData[{
Cell[191986, 3924, 70, 2, 26, "Input"],
Cell[192059, 3928, 83, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[192179, 3935, 66, 2, 26, "Input"],
Cell[192248, 3939, 63, 2, 25, "Output"]
}, Open  ]],
Cell[192326, 3944, 151, 1, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[192502, 3949, 66, 2, 26, "Input"],
Cell[192571, 3953, 171, 3, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[192779, 3961, 71, 2, 26, "Input"],
Cell[192853, 3965, 83, 2, 27, "Output"]
}, Open  ]],
Cell[192951, 3970, 776, 19, 56, "MathCaption"],

Cell[CellGroupData[{
Cell[193752, 3993, 70, 2, 26, "Input"],
Cell[193825, 3997, 83, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[193945, 4004, 90, 2, 26, "Input"],
Cell[194038, 4008, 63, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[194138, 4015, 90, 2, 26, "Input"],
Cell[194231, 4019, 64, 2, 25, "Output"]
}, Open  ]],
Cell[194310, 4024, 424, 10, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[194759, 4038, 69, 2, 26, "Input"],
Cell[194831, 4042, 167, 3, 27, "Output"]
}, Open  ]],
Cell[195013, 4048, 315, 7, 24, "Text"],
Cell[195331, 4057, 2175, 56, 108, "DefinitionBox"],
Cell[197509, 4115, 103, 1, 16, "Caption"],
Cell[197615, 4118, 315, 7, 24, "Text"],
Cell[197933, 4127, 164, 2, 40, "FramedBox"],
Cell[198100, 4131, 97, 1, 16, "Caption"],
Cell[198200, 4134, 170, 5, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[198395, 4143, 60, 2, 26, "Input"],
Cell[198458, 4147, 171, 3, 28, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[198666, 4155, 68, 2, 26, "Input"],
Cell[198737, 4159, 331, 6, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[199105, 4170, 66, 2, 26, "Input"],
Cell[199174, 4174, 63, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[199274, 4181, 74, 2, 26, "Input"],
Cell[199351, 4185, 226, 5, 46, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[199614, 4195, 75, 2, 26, "Input"],
Cell[199692, 4199, 109, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[199838, 4206, 76, 2, 26, "Input"],
Cell[199917, 4210, 203, 4, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[200157, 4219, 75, 2, 26, "Input"],
Cell[200235, 4223, 109, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[200381, 4230, 69, 2, 26, "Input"],
Cell[200453, 4234, 259, 7, 38, "Output"]
}, Open  ]],
Cell[200727, 4244, 1600, 35, 72, "MathCaption"],

Cell[CellGroupData[{
Cell[202352, 4283, 75, 2, 26, "Input"],
Cell[202430, 4287, 721, 12, 45, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[203188, 4304, 83, 2, 26, "Input"],
Cell[203274, 4308, 201, 4, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[203512, 4317, 76, 2, 26, "Input"],
Cell[203591, 4321, 174, 3, 21, "Print",
  CellTags->"Info3382346076-3433425"]
}, Open  ]],

Cell[CellGroupData[{
Cell[203802, 4329, 104, 2, 26, "Input"],
Cell[203909, 4333, 1658, 29, 366, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[205604, 4367, 96, 2, 26, "Input"],
Cell[205703, 4371, 345, 7, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[206085, 4383, 83, 2, 26, "Input"],
Cell[206171, 4387, 200, 4, 27, "Output"]
}, Open  ]],
Cell[206386, 4394, 1251, 23, 72, "MathCaption"],

Cell[CellGroupData[{
Cell[207662, 4421, 139, 3, 26, "Input"],
Cell[207804, 4426, 250, 4, 18, "Message"],
Cell[208057, 4432, 250, 4, 18, "Message"],
Cell[208310, 4438, 250, 4, 18, "Message"],
Cell[208563, 4444, 448, 7, 19, "Message"],
Cell[209014, 4453, 290, 5, 42, "Output"]
}, Open  ]],
Cell[209319, 4461, 468, 10, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[209812, 4475, 80, 2, 26, "Input"],
Cell[209895, 4479, 72, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[210004, 4486, 88, 2, 26, "Input"],
Cell[210095, 4490, 109, 2, 27, "Output"]
}, Open  ]],
Cell[210219, 4495, 375, 6, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[210619, 4505, 82, 2, 26, "Input"],
Cell[210704, 4509, 656, 12, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[211397, 4526, 83, 2, 26, "Input"],
Cell[211483, 4530, 198, 4, 27, "Output"]
}, Open  ]],
Cell[211696, 4537, 666, 13, 56, "MathCaption"],

Cell[CellGroupData[{
Cell[212387, 4554, 82, 2, 26, "Input"],
Cell[212472, 4558, 327, 5, 31, "Message"],
Cell[212802, 4565, 642, 12, 41, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[213481, 4582, 88, 2, 26, "Input"],
Cell[213572, 4586, 1091, 20, 63, "Output"]
}, Open  ]],
Cell[214678, 4609, 464, 11, 24, "Text"],
Cell[215145, 4622, 1275, 27, 112, "DefinitionBox3Col"],
Cell[216423, 4651, 97, 1, 16, "Caption"],
Cell[216523, 4654, 400, 7, 24, "Text"],
Cell[216926, 4663, 1661, 46, 62, "DefinitionBox"],
Cell[218590, 4711, 103, 1, 16, "Caption"],
Cell[218696, 4714, 369, 6, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[219090, 4724, 70, 2, 26, "Input"],
Cell[219163, 4728, 83, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[219283, 4735, 104, 2, 26, "Input"],
Cell[219390, 4739, 167, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[219594, 4747, 71, 2, 26, "Input"],
Cell[219668, 4751, 82, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[219787, 4758, 70, 2, 26, "Input"],
Cell[219860, 4762, 721, 12, 45, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[220618, 4779, 83, 2, 26, "Input"],
Cell[220704, 4783, 201, 4, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[220942, 4792, 71, 2, 26, "Input"],
Cell[221016, 4796, 721, 12, 45, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[221774, 4813, 83, 2, 26, "Input"],
Cell[221860, 4817, 202, 4, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[222099, 4826, 95, 2, 26, "Input"],
Cell[222197, 4830, 443, 7, 45, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[222677, 4842, 73, 2, 26, "Input"],
Cell[222753, 4846, 717, 12, 45, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[223507, 4863, 83, 2, 26, "Input"],
Cell[223593, 4867, 201, 4, 27, "Output"]
}, Open  ]],
Cell[223809, 4874, 1259, 23, 56, "Text"],
Cell[225071, 4899, 4425, 113, 222, "DefinitionBox"],
Cell[229499, 5014, 87, 1, 16, "Caption"],
Cell[229589, 5017, 204, 5, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[229818, 5026, 59, 2, 26, "Input"],
Cell[229880, 5030, 167, 3, 27, "Output"]
}, Open  ]],
Cell[230062, 5036, 349, 6, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[230436, 5046, 155, 4, 28, "Input"],
Cell[230594, 5052, 197, 4, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[230828, 5061, 91, 2, 26, "Input"],
Cell[230922, 5065, 63, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[231022, 5072, 93, 2, 26, "Input"],
Cell[231118, 5076, 167, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[231322, 5084, 69, 2, 26, "Input"],
Cell[231394, 5088, 262, 5, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[231693, 5098, 59, 2, 26, "Input"],
Cell[231755, 5102, 167, 3, 27, "Output"]
}, Open  ]],
Cell[231937, 5108, 295, 5, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[232257, 5117, 92, 2, 26, "Input"],
Cell[232352, 5121, 78, 2, 42, "Output"]
}, Open  ]],
Cell[232445, 5126, 468, 11, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[232938, 5141, 95, 2, 26, "Input"],
Cell[233036, 5145, 184, 3, 27, "Output"]
}, Open  ]],
Cell[233235, 5151, 327, 6, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[233587, 5161, 97, 2, 26, "Input"],
Cell[233687, 5165, 63, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[233787, 5172, 99, 2, 26, "Input"],
Cell[233889, 5176, 165, 3, 27, "Output"]
}, Open  ]],
Cell[234069, 5182, 321, 6, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[234415, 5192, 87, 2, 26, "Input"],
Cell[234505, 5196, 200, 4, 18, "Message"],
Cell[234708, 5202, 91, 2, 25, "Output"]
}, Open  ]],
Cell[234814, 5207, 313, 5, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[235152, 5216, 82, 2, 26, "Input"],
Cell[235237, 5220, 200, 4, 18, "Message"],
Cell[235440, 5226, 95, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[235572, 5233, 94, 2, 26, "Input"],
Cell[235669, 5237, 66, 2, 25, "Output"]
}, Open  ]],
Cell[235750, 5242, 221, 4, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[235996, 5250, 170, 3, 26, "Input"],
Cell[236169, 5255, 25584, 606, 184, 4794, 345, "GraphicsData", "PostScript", \
"Graphics"],
Cell[261756, 5863, 155, 4, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[261948, 5872, 92, 2, 26, "Input"],
Cell[262043, 5876, 624, 11, 95, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[262704, 5892, 155, 3, 26, "Input"],
Cell[262862, 5897, 26861, 626, 184, 4864, 350, "GraphicsData", "PostScript", \
"Graphics"],
Cell[289726, 6525, 155, 4, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[289918, 6534, 82, 2, 26, "Input"],
Cell[290003, 6538, 565, 11, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[290605, 6554, 89, 2, 26, "Input"],
Cell[290697, 6558, 542, 11, 57, "Output"]
}, Open  ]],
Cell[291254, 6572, 171, 2, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[291450, 6578, 153, 4, 26, "Input"],
Cell[291606, 6584, 230, 4, 27, "Output"]
}, Open  ]],
Cell[291851, 6591, 233, 4, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[292109, 6599, 92, 2, 26, "Input"],
Cell[292204, 6603, 63, 2, 25, "Output"]
}, Open  ]],
Cell[292282, 6608, 343, 6, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[292650, 6618, 79, 2, 26, "Input"],
Cell[292732, 6622, 336, 6, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[293105, 6633, 84, 2, 26, "Input"],
Cell[293192, 6637, 63, 2, 25, "Output"]
}, Open  ]],
Cell[293270, 6642, 425, 8, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[293720, 6654, 86, 2, 26, "Input"],
Cell[293809, 6658, 152, 3, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[293998, 6666, 109, 2, 26, "Input"],
Cell[294110, 6670, 139, 3, 25, "Output"]
}, Open  ]],
Cell[294264, 6676, 419, 7, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[294708, 6687, 83, 2, 26, "Input"],
Cell[294794, 6691, 63, 2, 25, "Output"]
}, Open  ]],
Cell[294872, 6696, 253, 5, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[295150, 6705, 150, 4, 26, "Input"],
Cell[295303, 6711, 242, 4, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[295582, 6720, 75, 2, 26, "Input"],
Cell[295660, 6724, 292, 5, 27, "Output"]
}, Open  ]],
Cell[295967, 6732, 659, 10, 56, "MathCaption"],

Cell[CellGroupData[{
Cell[296651, 6746, 83, 2, 26, "Input"],
Cell[296737, 6750, 419, 8, 27, "Output"]
}, Open  ]],
Cell[297171, 6761, 181, 2, 40, "MathCaption"],

Cell[CellGroupData[{
Cell[297377, 6767, 159, 4, 26, "Input"],
Cell[297539, 6773, 271, 5, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[297847, 6783, 74, 2, 26, "Input"],
Cell[297924, 6787, 419, 8, 27, "Output"]
}, Open  ]],
Cell[298358, 6798, 564, 9, 56, "MathCaption"],

Cell[CellGroupData[{
Cell[298947, 6811, 81, 2, 26, "Input"],
Cell[299031, 6815, 107, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[299175, 6822, 83, 2, 26, "Input"],
Cell[299261, 6826, 109, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[299407, 6833, 87, 2, 26, "Input"],
Cell[299497, 6837, 101, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[299635, 6844, 80, 2, 26, "Input"],
Cell[299718, 6848, 314, 5, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[300069, 6858, 64, 2, 26, "Input"],
Cell[300136, 6862, 116, 2, 25, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[300289, 6869, 65, 2, 26, "Input"],
Cell[300357, 6873, 116, 2, 25, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

